# Awesome Go

[Awesome]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.4.1/docs/awesome.svg "star > 2000"
[G]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Green.svg "There was an update last week"
[Y]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Yellow.svg "It hasn't been updated in recent three years"
[CN]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Cn.svg "Contains Chinese documents"
[Archived]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.2.1/docs/archived.svg "The project has been archived"
[D]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/DOC.svg "godoc document links"

**This project is [awesome-go](https://awesome-go.com/) Chinese version, last sync time : 2022-10-05 07:28:24(Synchronize every day)**

[![english](https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/chinese.svg)](README.md) [![Build Status](https://travis-ci.org/avelino/awesome-go.svg?branch=master)](https://travis-ci.org/avelino/awesome-go) [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome) [![Slack Widget](https://img.shields.io/badge/join-us%20on%20slack-gray.svg?longCache=true&logo=slack&colorB=red)](http://gophers.slack.com/messages/awesome) [![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)

[![patreon avelino](https://c5.patreon.com/external/logo/become_a_patron_button@2x.png)](https://www.patreon.com/avelinosource) financial support to Awesome Go

A curated list of awesome Go frameworks, libraries and software. Inspired by [awesome-python](https://github.com/vinta/awesome-python)。

**Icon** :


Icon | State  
:-:|-
![There was an update last week][G] | There was an update last week。You can basically determine that the current library is in an actively maintained state。
![Not updated in recent three year][Y] | Not updated in recent three year。Reflects that the maintenance of the library is not high enthusiasm, use should be careful。
![Archived][Archived] | The project has been archived。
![Contains Chinese documents][CN] | This project contains Chinese documents。
![godoc document][D] | godoc document links。

### Explain

[中文](README.md)  | [English](README_EN.md)
 
[![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)
[![Track Awesome List](https://www.trackawesomelist.com/badge.svg)](https://www.trackawesomelist.com/avelino/awesome-go/)

We use the _[Golang Bridge](https://github.com/gobridge/about-us/blob/master/README.md)_ community slack for instant communication, follow the [form here to join](https://invite.slack.golangbridge.org/).

<a href="https://www.producthunt.com/posts/awesome-go?utm_source=badge-featured&utm_medium=badge&utm_souce=badge-awesome-go" target="_blank"><img src="https://api.producthunt.com/widgets/embed-image/v1/featured.svg?post_id=291535&theme=light" alt="awesome-go - Curated list awesome Go frameworks, libraries and software | Product Hunt" style="width: 250px; height: 54px;" width="250" height="54" /></a>

**Sponsorships:**

_Special thanks to_

<div align="center">
<table cellpadding="5">
<tbody align="center">
<tr>
<td style="width:50%">
<a href="https://bit.ly/awesome-go-doppler">
<img src="https://avelino.run/sponsors/doppler-logo.png" width="200" alt="Doppler"><br/>
<b>Quit struggling with scattered API keys and access controls.</b><br/>
<sub>Keep your secrets in sync across environments, servers, and teams with Doppler.</sub>
</a>
</td>
<td>
<a href="https://bit.ly/awesome-go-xteam">
<img src="https://avelino.run/sponsors/xteam-logo.png" width="200" alt="x-team"><br/>
<b>Work from anywhere in the world with top tech companies like Riot Games, Coinbase, and Google.</b>
</a>
</td>
</tr>
<tr>
<td>
<a href="https://bit.ly/awesome-go-workos">
<img src="https://avelino.run/sponsors/workos-logo-white-bg.svg" width="200" alt="WorkOS"><br/>
<b>Your app, enterprise-ready.</b><br/>
<sub>Start selling to enterprise customers with just a few lines of code.</sub><br/>
<sup>Add Single Sign-On (and more) in minutes instead of months.</sup>
</a>
</td>
<td>
<a href="https://bit.ly/awesome-go-keygen">
<img src="https://avelino.run/sponsors/keygen-logo.png" width="200" alt="keygen"><br/>
<b>A dead-simple software licensing and distribution API built for developers</b><br/>
<sub>Securely license and distribute Go applications with a single API.</sub><br>
<sup>Add auto updates with only a few lines of code.</sup>
</a>
</td>
</tr>
<tr>
<td colspan="2">
<a href="https://bit.ly/awesome-go-digitalocean">
<img src="https://avelino.run/sponsors/do_logo_horizontal_blue-210.png" width="200" alt="Digital Ocean">
</a>
</td>
</tr>
</tbody>
</table>
</div>

**Awesome Go has no monthly fee**_, but we have employees who **work hard** to keep it running, with money raised we can repay the effort of each person involved! You can see how we calculate our billing and distribution as it is open to the entire community. Want to be a supporter of the project click [here](mailto:avelinorun+oss@gmail.com?subject=awesome-go%3A%20project%20support)._

> A curated list of awesome Go frameworks, libraries and software. Inspired by [awesome-python](https://github.com/vinta/awesome-python).

**Contributing:**

Please take a quick gander at the [contribution guidelines](https://github.com/avelino/awesome-go/blob/master/CONTRIBUTING.md) first. Thanks to all [contributors](https://github.com/avelino/awesome-go/graphs/contributors); you rock!

> _If you see a package or project here that is no longer maintained or is not a good fit, please submit a pull request to improve this file. Thank you!_

## Contents

- [Awesome Go](#awesome-go)
  - [Contents](#contents)
  - [Audio and Music](#audio-and-music)
  - [Authentication and OAuth](#authentication-and-oauth)
  - [Blockchain](#blockchain)
  - [Bot Building](#bot-building)
  - [Build Automation](#build-automation)
  - [Command Line](#command-line)
    - [Advanced Console UIs](#advanced-console-uis)
    - [Standard CLI](#standard-cli)
  - [Configuration](#configuration)
  - [Continuous Integration](#continuous-integration)
  - [CSS Preprocessors](#css-preprocessors)
  - [Data Structures and Algorithms](#data-structures-and-algorithms)
    - [Bit-packing and Compression](#bit-packing-and-compression)
    - [Bit Sets](#bit-sets)
    - [Bloom and Cuckoo Filters](#bloom-and-cuckoo-filters)
    - [Data Structure and Algorithm Collections](#data-structure-and-algorithm-collections)
    - [Iterators](#iterators)
    - [Maps](#maps)
    - [Miscellaneous Data Structures and Algorithms](#miscellaneous-data-structures-and-algorithms)
    - [Nullable Types](#nullable-types)
    - [Queues](#queues)
    - [Sets](#sets)
    - [Text Analysis](#text-analysis)
    - [Trees](#trees)
    - [Pipes](#pipes)
  - [Database](#database)
    - [Caches](#caches)
    - [Databases Implemented in Go](#databases-implemented-in-go)
    - [Database Schema Migration](#database-schema-migration)
    - [Database Tools](#database-tools)
    - [SQL Query Builders](#sql-query-builders)
  - [Database Drivers](#database-drivers)
    - [Interfaces to Multiple Backends](#interfaces-to-multiple-backends)
    - [Relational Database Drivers](#relational-database-drivers)
    - [NoSQL Database Drivers](#nosql-database-drivers)
    - [Search and Analytic Databases](#search-and-analytic-databases)
  - [Date and Time](#date-and-time)
  - [Distributed Systems](#distributed-systems)
  - [Dynamic DNS](#dynamic-dns)
  - [Email](#email)
  - [Embeddable Scripting Languages](#embeddable-scripting-languages)
  - [Error Handling](#error-handling)
  - [File Handling](#file-handling)
  - [Financial](#financial)
  - [Forms](#forms)
  - [Functional](#functional)
  - [Game Development](#game-development)
  - [Generators](#generators)
  - [Geographic](#geographic)
  - [Go Compilers](#go-compilers)
  - [Goroutines](#goroutines)
  - [GUI](#gui)
  - [Hardware](#hardware)
  - [Images](#images)
  - [IoT (Internet of Things)](#iot-internet-of-things)
  - [Job Scheduler](#job-scheduler)
  - [JSON](#json)
  - [Logging](#logging)
  - [Machine Learning](#machine-learning)
  - [Messaging](#messaging)
  - [Microsoft Office](#microsoft-office)
    - [Microsoft Excel](#microsoft-excel)
  - [Miscellaneous](#miscellaneous)
    - [Dependency Injection](#dependency-injection)
    - [Project Layout](#project-layout)
    - [Strings](#strings)
    - [Uncategorized](#uncategorized)
  - [Natural Language Processing](#natural-language-processing)
    - [Language Detection](#language-detection)
    - [Morphological Analyzers](#morphological-analyzers)
    - [Slugifiers](#slugifiers)
    - [Tokenizers](#tokenizers)
    - [Translation](#translation)
    - [Transliteration](#transliteration)
  - [Networking](#networking)
    - [HTTP Clients](#http-clients)
  - [OpenGL](#opengl)
  - [ORM](#orm)
  - [Package Management](#package-management)
  - [Performance](#performance)
  - [Query Language](#query-language)
  - [Resource Embedding](#resource-embedding)
  - [Science and Data Analysis](#science-and-data-analysis)
  - [Security](#security)
  - [Serialization](#serialization)
  - [Server Applications](#server-applications)
  - [Stream Processing](#stream-processing)
  - [Template Engines](#template-engines)
  - [Testing](#testing)
  - [Text Processing](#text-processing)
    - [Formatters](#formatters)
    - [Markup Languages](#markup-languages)
    - [Parsers/Encoders/Decoders](#parsersencodersdecoders)
    - [Regular Expressions](#regular-expressions)
    - [Sanitation](#sanitation)
    - [Scrapers](#scrapers)
    - [RSS](#rss)
    - [Utility/Miscellaneous](#utilitymiscellaneous)
  - [Third-party APIs](#third-party-apis)
  - [Utilities](#utilities)
  - [UUID](#uuid)
  - [Validation](#validation)
  - [Version Control](#version-control)
  - [Video](#video)
  - [Web Frameworks](#web-frameworks)
    - [Middlewares](#middlewares)
      - [Actual middlewares](#actual-middlewares)
      - [Libraries for creating HTTP middlewares](#libraries-for-creating-http-middlewares)
    - [Routers](#routers)
  - [WebAssembly](#webassembly)
  - [Windows](#windows)
  - [XML](#xml)
  - [Zero Trust](#zero-trust)
  - [Code Analysis](#code-analysis)
  - [Editor Plugins](#editor-plugins)
  - [Go Generate Tools](#go-generate-tools)
  - [Go Tools](#go-tools)
  - [Software Packages](#software-packages)
    - [DevOps Tools](#devops-tools)
    - [Other Software](#other-software)
- [Resources](#resources)
  - [Benchmarks](#benchmarks)
  - [Conferences](#conferences)
  - [E-Books](#e-books)
    - [E-books for purchase](#e-books-for-purchase)
    - [Free e-books](#free-e-books)
  - [Gophers](#gophers)
  - [Meetups](#meetups)
  - [Style Guides](#style-guides)
  - [Social Media](#social-media)
    - [Twitter](#twitter)
    - [Reddit](#reddit)
  - [Websites](#websites)
    - [Tutorials](#tutorials)

**[⬆ back to top](#contents)**

## Audio and Music

_Libraries for manipulating audio._

- [Oto](https://github.com/hajimehoshi/oto) **star:1070** A low-level library to play sound on multiple platforms.   [![There was an update last month][G]](https://github.com/hajimehoshi/oto)   [![godoc][D]](https://godoc.org/github.com/hajimehoshi/oto)
- [PortAudio](https://github.com/gordonklaus/portaudio) **star:535** Go bindings for the PortAudio audio I/O library.   [![godoc][D]](https://godoc.org/github.com/gordonklaus/portaudio)
- [music-theory](https://github.com/go-music-theory/music-theory) **star:409** Music theory models in Go.   [![godoc][D]](https://godoc.org/github.com/go-music-theory/music-theory)
- [id3v2](https://github.com/bogem/id3v2) **star:262** ID3 decoding and encoding library for Go.   [![godoc][D]](https://godoc.org/github.com/bogem/id3v2)
- [GoAudio](https://github.com/DylanMeeus/GoAudio) **star:251** Native Go Audio Processing Library.   [![godoc][D]](https://godoc.org/github.com/DylanMeeus/GoAudio)
- [flac](https://github.com/mewkiz/flac) **star:223** Native Go FLAC encoder/decoder with support for FLAC streams.   [![There was an update last month][G]](https://github.com/mewkiz/flac)   [![godoc][D]](https://godoc.org/github.com/mewkiz/flac)
- [malgo](https://github.com/gen2brain/malgo) **star:199** Mini audio library.
- [gaad](https://github.com/Comcast/gaad) **star:105** Native Go AAC bitstream parser.   [![godoc][D]](https://godoc.org/github.com/Comcast/gaad)
- [minimp3](https://github.com/tosone/minimp3) **star:89** Lightweight MP3 decoder library.
- [gosamplerate](https://github.com/dh1tw/gosamplerate) **star:23** libsamplerate bindings for go.   [![godoc][D]](https://godoc.org/github.com/dh1tw/gosamplerate)

**[⬆ back to top](#contents)**

## Authentication and OAuth

_Libraries for implementing authentications schemes._

- [casbin](https://github.com/casbin/casbin) **star:12919** Authorization library that supports access control models like ACL, RBAC, ABAC.   [![godoc][D]](https://godoc.org/github.com/casbin/casbin)
- [oauth2](https://github.com/golang/oauth2) **star:4343** Successor of goauth2. Generic OAuth 2.0 package that comes with JWT, Google APIs, Compute Engine and App Engine support.   [![There was an update last month][G]](https://github.com/golang/oauth2)   [![godoc][D]](https://godoc.org/github.com/golang/oauth2)
- [goth](https://github.com/markbates/goth) **star:3857** provides a simple, clean, and idiomatic way to use OAuth and OAuth2. Handles multiple providers out of the box.   [![godoc][D]](https://godoc.org/github.com/markbates/goth)
- [keto](https://github.com/ory/keto) **star:3607** Open Source (Go) implementation of "Zanzibar: Google's Consistent, Global Authorization System". Ships gRPC, REST APIs, newSQL, and an easy and granular permission language. Supports ACL, RBAC, and other access models.   [![There was an update last month][G]](https://github.com/ory/keto)   [![godoc][D]](https://godoc.org/github.com/ory/keto)
- [authboss](https://github.com/volatiletech/authboss) **star:3227** Modular authentication system for the web. It tries to remove as much boilerplate and "hard things" as possible so that each time you start a new web project in Go, you can plug it in, configure, and start building your app without having to build an authentication system each time.   [![godoc][D]](https://godoc.org/github.com/volatiletech/authboss)
- [go-jose](https://github.com/square/go-jose) **star:1953** Fairly complete implementation of the JOSE working group's JSON Web Token, JSON Web Signatures, and JSON Web Encryption specs.
- [loginsrv](https://github.com/tarent/loginsrv) **star:1866** JWT login microservice with plugable backends such as OAuth2 (Github), htpasswd, osiam.   [![godoc][D]](https://godoc.org/github.com/tarent/loginsrv)
- [osin](https://github.com/openshift/osin) **star:1771** Golang OAuth2 server library.   [![godoc][D]](https://godoc.org/github.com/openshift/osin)
- [gologin](https://github.com/dghubble/gologin) **star:1559** chainable handlers for login with OAuth1 and OAuth2 authentication providers.   [![There was an update last month][G]](https://github.com/dghubble/gologin)   [![godoc][D]](https://godoc.org/github.com/dghubble/gologin)
- [gorbac](https://github.com/mikespook/gorbac) **star:1336** provides a lightweight role-based access control (RBAC) implementation in Golang.   [![godoc][D]](https://godoc.org/github.com/mikespook/gorbac)
- [gosession](http://github.com/Kwynto/gosession)  This is quick session for net/http in GoLang. This package is perhaps the best implementation of the session mechanism, at least it tries to become one.
- [scs](https://github.com/alexedwards/scs) **star:1217** Session Manager for HTTP servers.   [![godoc][D]](https://godoc.org/github.com/alexedwards/scs)
- [paseto](https://github.com/o1egl/paseto) **star:632** Golang implementation of Platform-Agnostic Security Tokens (PASETO).   [![godoc][D]](https://godoc.org/github.com/o1egl/paseto)
- [jwt](https://github.com/cristalhq/jwt) **star:567** Safe, simple and fast JSON Web Tokens for Go.   [![godoc][D]](https://godoc.org/github.com/cristalhq/jwt)
- [permissions2](https://github.com/xyproto/permissions2) **star:465** Library for keeping track of users, login states and permissions. Uses secure cookies and bcrypt.   [![godoc][D]](https://godoc.org/github.com/xyproto/permissions2)
- [go-guardian](https://github.com/shaj13/go-guardian) **star:401** Go-Guardian is a golang library that provides a simple, clean, and idiomatic way to create powerful modern API and web authentication that supports LDAP, Basic, Bearer token and Certificate based authentication.   [![godoc][D]](https://godoc.org/github.com/shaj13/go-guardian)
- [jwt](https://github.com/pascaldekloe/jwt) **star:297** Lightweight JSON Web Token (JWT) library.   [![godoc][D]](https://godoc.org/github.com/pascaldekloe/jwt)
- [jeff](https://github.com/abraithwaite/jeff) **star:240** Simple, flexible, secure and idiomatic web session management with pluggable backends.   [![godoc][D]](https://godoc.org/github.com/abraithwaite/jeff)
- [jwt-auth](https://github.com/adam-hanna/jwt-auth) **star:221** JWT middleware for Golang http servers with many configuration options.   [![godoc][D]](https://godoc.org/github.com/adam-hanna/jwt-auth)
- [otpgen](https://github.com/grijul/otpgen) **star:121** Library to generate TOTP/HOTP codes.   [![godoc][D]](https://godoc.org/github.com/grijul/otpgen)
- [sessionup](https://github.com/swithek/sessionup) **star:119** Simple, yet effective HTTP session management and identification package.   [![godoc][D]](https://godoc.org/github.com/swithek/sessionup)
- [session](https://github.com/icza/session) **star:109** Go session management for web servers (including support for Google App Engine - GAE).   [![godoc][D]](https://godoc.org/github.com/icza/session)
- [sjwt](https://github.com/brianvoe/sjwt) **star:105** Simple jwt generator and parser.   [![godoc][D]](https://godoc.org/github.com/brianvoe/sjwt)
- [sessions](https://github.com/adam-hanna/sessions) **star:68** Dead simple, highly performant, highly customizable sessions service for go http servers.   [![godoc][D]](https://godoc.org/github.com/adam-hanna/sessions)
- [securecookie](https://github.com/chmike/securecookie) **star:61** Efficient secure cookie encoding/decoding.   [![godoc][D]](https://godoc.org/github.com/chmike/securecookie)
- [branca](https://github.com/essentialkaos/branca) **star:44** branca token [specification implementation](https://github.com/tuupola/branca-spec) for Golang 1.15+.   [![godoc][D]](https://godoc.org/github.com/essentialkaos/branca)
- [otpgo](https://github.com/jltorresm/otpgo) **star:40** Time-Based One-Time Password (TOTP) and HMAC-Based One-Time Password (HOTP) library for Go.   [![godoc][D]](https://godoc.org/github.com/jltorresm/otpgo)
- [scope](https://github.com/SonicRoshan/scope) **star:24** Easily Manage OAuth2 Scopes In Go.   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/scope)
- [cookiestxt](https://github.com/mengzhuo/cookiestxt) **star:14** provides parser of cookies.txt file format.   [![godoc][D]](https://godoc.org/github.com/mengzhuo/cookiestxt)

**[⬆ back to top](#contents)**

## Blockchain

_Tools for building blockchains._

- [go-ethereum](https://github.com/ethereum/go-ethereum) **star:39591** Official Go implementation of the Ethereum protocol.   [![There was an update last month][G]](https://github.com/ethereum/go-ethereum)   [![godoc][D]](https://godoc.org/github.com/ethereum/go-ethereum)
- [tendermint](https://github.com/tendermint/tendermint) **star:5186** High-performance middleware for transforming a state machine written in any programming language into a Byzantine Fault Tolerant replicated state machine using the Tendermint consensus and blockchain protocols.   [![There was an update last month][G]](https://github.com/tendermint/tendermint)   [![godoc][D]](https://godoc.org/github.com/tendermint/tendermint)
- [cosmos-sdk](https://github.com/cosmos/cosmos-sdk) **star:4528** A Framework for Building Public Blockchains in the Cosmos Ecosystem.   [![There was an update last month][G]](https://github.com/cosmos/cosmos-sdk)   [![godoc][D]](https://godoc.org/github.com/cosmos/cosmos-sdk)
- [solana-go](https://github.com/gagliardetto/solana-go) **star:370** Go library to interface with Solana JSON RPC and WebSocket interfaces.   [![There was an update last month][G]](https://github.com/gagliardetto/solana-go)   [![godoc][D]](https://godoc.org/github.com/gagliardetto/solana-go)
- [gossamer](https://github.com/ChainSafe/gossamer) **star:357** A Go implementation of the Polkadot Host.   [![There was an update last month][G]](https://github.com/ChainSafe/gossamer)   [![godoc][D]](https://godoc.org/github.com/ChainSafe/gossamer)

**[⬆ back to top](#contents)**

## Bot Building

_Libraries for building and working with bots._

- [telegram-bot-api](https://github.com/Syfaro/telegram-bot-api) **star:4011** Simple and clean Telegram bot client.   [![godoc][D]](https://godoc.org/github.com/Syfaro/telegram-bot-api)
- [olivia](https://github.com/olivia-ai/olivia) **star:3325** A chatbot built with an artificial neural network.   [![godoc][D]](https://godoc.org/github.com/olivia-ai/olivia)
- [telebot](https://github.com/tucnak/telebot) **star:2743** Telegram bot framework written in Go.   [![There was an update last month][G]](https://github.com/tucnak/telebot)   [![godoc][D]](https://godoc.org/github.com/tucnak/telebot)
- [Kelp](https://github.com/stellar/kelp) **star:927** official trading and market-making bot for the [Stellar](https://www.stellar.org/) DEX. Works out-of-the-box, written in Golang, compatible with centralized exchanges and custom trading strategies.   [![godoc][D]](https://godoc.org/github.com/stellar/kelp)
- [Golang CryptoTrading Bot](https://github.com/saniales/golang-crypto-trading-bot) **star:831** A golang implementation of a console-based trading bot for cryptocurrency exchanges.   [![godoc][D]](https://godoc.org/github.com/saniales/golang-crypto-trading-bot)
- [go-chat-bot](https://github.com/go-chat-bot/bot) **star:761** IRC, Slack & Telegram bot written in Go.   [![godoc][D]](https://godoc.org/github.com/go-chat-bot/bot)
- [go-joe](https://joe-bot.net)  A general-purpose bot library inspired by Hubot but written in Go.
- [slacker](https://github.com/shomali11/slacker) **star:692** Easy to use framework to create Slack bots.   [![godoc][D]](https://godoc.org/github.com/shomali11/slacker)
- [tbot](https://github.com/yanzay/tbot) **star:329** Telegram bot server with API similar to net/http.   [![godoc][D]](https://godoc.org/github.com/yanzay/tbot)
- [wayback](https://github.com/wabarc/wayback) **star:324** A bot for Telegram, Mastodon, Slack, and other messaging platforms archives webpages.   [![There was an update last month][G]](https://github.com/wabarc/wayback)   [![godoc][D]](https://godoc.org/github.com/wabarc/wayback)
- [go-twitch-irc](https://github.com/gempir/go-twitch-irc) **star:258** Library to write bots for twitch.tv chat   [![godoc][D]](https://godoc.org/github.com/gempir/go-twitch-irc)
- [go-sarah](https://github.com/oklahomer/go-sarah) **star:250** Framework to build bot for desired chat services including LINE, Slack, Gitter and more.   [![godoc][D]](https://godoc.org/github.com/oklahomer/go-sarah)
- [echotron](https://github.com/NicoNex/echotron) **star:190** An elegant and concurrent library for Telegram Bots in Go.   [![godoc][D]](https://godoc.org/github.com/NicoNex/echotron)
- [Tenyks](https://github.com/kyleterry/tenyks) **star:174** Service oriented IRC bot using Redis and JSON for messaging.   [![It hasn't been updated in recent three years][Y]](https://github.com/kyleterry/tenyks)   [![godoc][D]](https://godoc.org/github.com/kyleterry/tenyks)
- [hanu](https://github.com/sbstjn/hanu) **star:141** Framework for writing Slack bots.   [![godoc][D]](https://godoc.org/github.com/sbstjn/hanu)
- [go-tgbot](https://github.com/olebedev/go-tgbot) **star:116** Pure Golang Telegram Bot API wrapper, generated from swagger file, session-based router and middleware.   [![It hasn't been updated in recent three years][Y]](https://github.com/olebedev/go-tgbot)   [![godoc][D]](https://godoc.org/github.com/olebedev/go-tgbot)
- [slack-bot](https://github.com/innogames/slack-bot) **star:114** Ready to use Slack Bot for lazy developers: Custom commands, Jenkins, Jira, Bitbucket, Github...   [![There was an update last month][G]](https://github.com/innogames/slack-bot)   [![godoc][D]](https://godoc.org/github.com/innogames/slack-bot)
- [telego](https://github.com/mymmrac/telego) **star:103** Telegram Bot API library for Golang with full one-to-one API implementation.   [![godoc][D]](https://godoc.org/github.com/mymmrac/telego)
- [larry](https://github.com/ezeoleaf/larry) **star:84** Larry 🐦 is a really simple Twitter bot generator that tweets random repositories from Github built in Go.   [![There was an update last month][G]](https://github.com/ezeoleaf/larry)   [![godoc][D]](https://godoc.org/github.com/ezeoleaf/larry)
- [margelet](https://github.com/zhulik/margelet) **star:75** Framework for building Telegram bots.   [![godoc][D]](https://godoc.org/github.com/zhulik/margelet)
- [ephemeral-roles](https://github.com/ewohltman/ephemeral-roles) **star:68** A Discord bot for managing ephemeral roles based upon voice channel member presence.   [![godoc][D]](https://godoc.org/github.com/ewohltman/ephemeral-roles)
- [slackscot](https://github.com/alexandre-normand/slackscot) **star:53** Another framework for building Slack bots.   [![godoc][D]](https://godoc.org/github.com/alexandre-normand/slackscot)
- [govkbot](https://github.com/nikepan/govkbot) **star:41** Simple Go [VK](https://vk.com) bot library.   [![godoc][D]](https://godoc.org/github.com/nikepan/govkbot)
- [micha](https://github.com/onrik/micha) **star:23** Go Library for Telegram bot api.   [![godoc][D]](https://godoc.org/github.com/onrik/micha)
- [teleterm](https://github.com/alfiankan/teleterm) **star:12** Telegram Bot Exec Terminal Command.   [![godoc][D]](https://godoc.org/github.com/alfiankan/teleterm)

**[⬆ back to top](#contents)**

## Build Automation

_Libraries and tools helping with build automation._

- [Task](https://github.com/go-task/task) **star:5840** simple "Make" alternative.   [![There was an update last month][G]](https://github.com/go-task/task)   [![godoc][D]](https://godoc.org/github.com/go-task/task)
- [realize](https://github.com/tockins/realize) **star:4305** Go build system with file watchers and live reload. Run, build and watch file changes with custom paths.   [![godoc][D]](https://godoc.org/github.com/tockins/realize)
- [mage](https://github.com/magefile/mage) **star:3217** Mage is a make/rake-like build tool using Go.   [![godoc][D]](https://godoc.org/github.com/magefile/mage)
- [mmake](https://github.com/tj/mmake) **star:1616** Modern Make.   [![godoc][D]](https://godoc.org/github.com/tj/mmake)
- [goyek](https://github.com/goyek/goyek) **star:308** Create build pipelines in Go.   [![There was an update last month][G]](https://github.com/goyek/goyek)   [![godoc][D]](https://godoc.org/github.com/goyek/goyek)
- [taskctl](https://github.com/taskctl/taskctl) **star:216** Concurrent task runner.   [![godoc][D]](https://godoc.org/github.com/taskctl/taskctl)
- [1build](https://github.com/gopinath-langote/1build) **star:184** Command line tool to frictionlessly manage project-specific commands.   [![godoc][D]](https://godoc.org/github.com/gopinath-langote/1build)
- [gaper](https://github.com/maxcnunes/gaper) **star:59** Builds and restarts a Go project when it crashes or some watched file changes.   [![godoc][D]](https://godoc.org/github.com/maxcnunes/gaper)
- [gilbert](https://go-gilbert.github.io)  Build system and task runner for Go projects.
- [anko](https://github.com/GuilhermeCaruso/anko) **star:28** Simple application watcher for multiple programming languages.   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/anko)

**[⬆ back to top](#contents)**

## Command Line

### Advanced Console UIs

_Libraries for building Console Applications and Console User Interfaces._

- [termui](https://github.com/gizak/termui) **star:12111** Go terminal dashboard based on **termbox-go** and inspired by [blessed-contrib](https://github.com/yaronn/blessed-contrib).   [![There was an update last month][G]](https://github.com/gizak/termui)   [![godoc][D]](https://godoc.org/github.com/gizak/termui)
- [gocui](https://github.com/jroimartin/gocui) **star:8532** Minimalist Go library aimed at creating Console User Interfaces.   [![godoc][D]](https://godoc.org/github.com/jroimartin/gocui)
- [gommon/color](https://github.com/labstack/gommon/tree/master/color)  Style terminal text.
- [go-prompt](https://github.com/c-bata/go-prompt) **star:4637** Library for building a powerful interactive prompt, inspired by [python-prompt-toolkit](https://github.com/jonathanslenders/python-prompt-toolkit).   [![godoc][D]](https://godoc.org/github.com/c-bata/go-prompt)
- [termbox-go](https://github.com/nsf/termbox-go) **star:4411** Termbox is a library for creating cross-platform text-based interfaces.   [![godoc][D]](https://godoc.org/github.com/nsf/termbox-go)
- [pterm](https://github.com/pterm/pterm) **star:2986** A library to beautify console output on every platform with many combinable components.   [![There was an update last month][G]](https://github.com/pterm/pterm)   [![godoc][D]](https://godoc.org/github.com/pterm/pterm)
- [progressbar](https://github.com/schollz/progressbar) **star:2831** Basic thread-safe progress bar that works in every OS.   [![There was an update last month][G]](https://github.com/schollz/progressbar)   [![godoc][D]](https://godoc.org/github.com/schollz/progressbar)
- [termdash](https://github.com/mum4k/termdash) **star:2086** Go terminal dashboard based on **termbox-go** and inspired by [termui](https://github.com/gizak/termui).   [![godoc][D]](https://godoc.org/github.com/mum4k/termdash)
- [asciigraph](https://github.com/guptarohit/asciigraph) **star:2042** Go package to make lightweight ASCII line graph ╭┈╯ in command line apps with no other dependencies.   [![godoc][D]](https://godoc.org/github.com/guptarohit/asciigraph)
- [uiprogress](https://github.com/gosuri/uiprogress) **star:1970** Flexible library to render progress bars in terminal applications.   [![godoc][D]](https://godoc.org/github.com/gosuri/uiprogress)
- [spinner](https://github.com/briandowns/spinner) **star:1898** Go package to easily provide a terminal spinner with options.   [![godoc][D]](https://godoc.org/github.com/briandowns/spinner)
- [mpb](https://github.com/vbauerster/mpb) **star:1865** Multi progress bar for terminal applications.   [![godoc][D]](https://godoc.org/github.com/vbauerster/mpb)
- [uilive](https://github.com/gosuri/uilive) **star:1502** Library for updating terminal output in realtime.   [![godoc][D]](https://godoc.org/github.com/gosuri/uilive)
- [aurora](https://github.com/logrusorgru/aurora) **star:1230** ANSI terminal colors that supports fmt.Printf/Sprintf.   [![godoc][D]](https://godoc.org/github.com/logrusorgru/aurora)
- [termenv](https://github.com/muesli/termenv) **star:1190** Advanced ANSI style & color support for your terminal applications.   [![There was an update last month][G]](https://github.com/muesli/termenv)   [![godoc][D]](https://godoc.org/github.com/muesli/termenv)
- [gookit/color](https://github.com/gookit/color) **star:1184** Terminal color rendering tool library, support 16 colors, 256 colors, RGB color rendering output, compatible with Windows.   [![godoc][D]](https://godoc.org/github.com/gookit/color)   [![Contains Chinese documents][CN]](https://github.com/gookit/color)
- [uitable](https://github.com/gosuri/uitable) **star:660** Library to improve readability in terminal apps using tabular data.   [![godoc][D]](https://godoc.org/github.com/gosuri/uitable)
- [go-colorable](https://github.com/mattn/go-colorable) **star:645** Colorable writer for windows.   [![godoc][D]](https://godoc.org/github.com/mattn/go-colorable)
- [go-isatty](https://github.com/mattn/go-isatty) **star:645** isatty for golang.   [![godoc][D]](https://godoc.org/github.com/mattn/go-isatty)
- [chalk](https://github.com/ttacon/chalk) **star:410** Intuitive package for prettifying terminal/console output.   [![It hasn't been updated in recent three years][Y]](https://github.com/ttacon/chalk)   [![godoc][D]](https://godoc.org/github.com/ttacon/chalk)
- [simpletable](https://github.com/alexeyco/simpletable) **star:388** Simple tables in terminal with Go.   [![godoc][D]](https://godoc.org/github.com/alexeyco/simpletable)
- [yacspin](https://github.com/theckman/yacspin) **star:372** Yet Another CLi Spinner package, for working with terminal spinners.   [![godoc][D]](https://godoc.org/github.com/theckman/yacspin)
- [tabby](https://github.com/cheynewallace/tabby) **star:321** A tiny library for super simple Golang tables.   [![godoc][D]](https://godoc.org/github.com/cheynewallace/tabby)
- [box-cli-maker](https://github.com/Delta456/box-cli-maker) **star:241** Make Highly Customized Boxes for your CLI.   [![There was an update last month][G]](https://github.com/Delta456/box-cli-maker)   [![godoc][D]](https://godoc.org/github.com/Delta456/box-cli-maker)
- [go-colortext](https://github.com/daviddengcn/go-colortext) **star:214** Go library for color output in terminals.   [![godoc][D]](https://godoc.org/github.com/daviddengcn/go-colortext)
- [cfmt](https://github.com/mingrammer/cfmt) **star:89** Contextual fmt inspired by bootstrap color classes.   [![It hasn't been updated in recent three years][Y]](https://github.com/mingrammer/cfmt)   [![godoc][D]](https://godoc.org/github.com/mingrammer/cfmt)
- [tabular](https://github.com/InVisionApp/tabular) **star:65** Print ASCII tables from command line utilities without the need to pass large sets of data to the API.   [![It hasn't been updated in recent three years][Y]](https://github.com/InVisionApp/tabular)   [![godoc][D]](https://godoc.org/github.com/InVisionApp/tabular)
- [cfmt](https://github.com/i582/cfmt) **star:49** Simple and convenient formatted stylized output fully compatible with fmt library.   [![godoc][D]](https://godoc.org/github.com/i582/cfmt)
- [ctc](https://github.com/wzshiming/ctc) **star:41** The non-invasive cross-platform terminal color library does not need to modify the Print method.   [![godoc][D]](https://godoc.org/github.com/wzshiming/ctc)   [![Contains Chinese documents][CN]](https://github.com/wzshiming/ctc)
- [table](https://github.com/tomlazar/table) **star:36** Small library for terminal color based tables .   [![godoc][D]](https://godoc.org/github.com/tomlazar/table)
- [marker](https://github.com/cyucelen/marker) **star:32** Easiest way to match and mark strings for colorful terminal outputs.   [![godoc][D]](https://godoc.org/github.com/cyucelen/marker)
- [colourize](https://github.com/TreyBastian/colourize) **star:26** Go library for ANSI colour text in terminals.   [![godoc][D]](https://godoc.org/github.com/TreyBastian/colourize)   [![Archived][Archived]](https://github.com/TreyBastian/colourize)
- [go-ataman](https://github.com/workanator/go-ataman) **star:13** Go library for rendering ANSI colored text templates in terminals.   [![godoc][D]](https://godoc.org/github.com/workanator/go-ataman)
- [crab-config-files-templating](https://github.com/alfiankan/crab-config-files-templating) **star:5** Dynamic configuration file templating tool for kubernetes manifest or general configuration files.   [![godoc][D]](https://godoc.org/github.com/alfiankan/crab-config-files-templating)

**[⬆ back to top](#contents)**

### Standard CLI

_Libraries for building standard or basic Command Line applications._

- [cobra](https://github.com/spf13/cobra) **star:28851** Commander for modern Go CLI interactions.   [![There was an update last month][G]](https://github.com/spf13/cobra)   [![godoc][D]](https://godoc.org/github.com/spf13/cobra)
- [urfave/cli](https://github.com/urfave/cli) **star:19077** Simple, fast, and fun package for building command line apps in Go (formerly codegangsta/cli).   [![There was an update last month][G]](https://github.com/urfave/cli)   [![godoc][D]](https://godoc.org/github.com/urfave/cli)
- [elvish](https://github.com/elves/elvish) **star:4848** An expressive programming language and a versatile interactive shell.   [![There was an update last month][G]](https://github.com/elves/elvish)   [![godoc][D]](https://godoc.org/github.com/elves/elvish)
- [kingpin](https://github.com/alecthomas/kingpin) **star:3262** Command line and flag parser supporting sub commands (superseded by `kong`; see below).   [![godoc][D]](https://godoc.org/github.com/alecthomas/kingpin)
- [Dnote](https://github.com/dnote/dnote) **star:2378** A simple command line notebook with multi-device sync.   [![godoc][D]](https://godoc.org/github.com/dnote/dnote)
- [go-flags](https://github.com/jessevdk/go-flags) **star:2312** go command line option parser.   [![godoc][D]](https://godoc.org/github.com/jessevdk/go-flags)
- [pflag](https://github.com/spf13/pflag) **star:1928** Drop-in replacement for Go's flag package, implementing POSIX/GNU-style --flags.   [![godoc][D]](https://godoc.org/github.com/spf13/pflag)
- [mitchellh/cli](https://github.com/mitchellh/cli) **star:1592** Go library for implementing command-line interfaces.   [![There was an update last month][G]](https://github.com/mitchellh/cli)   [![godoc][D]](https://godoc.org/github.com/mitchellh/cli)
- [go-arg](https://github.com/alexflint/go-arg) **star:1449** Struct-based argument parsing in Go.   [![There was an update last month][G]](https://github.com/alexflint/go-arg)   [![godoc][D]](https://godoc.org/github.com/alexflint/go-arg)
- [ops](https://github.com/nanovms/ops) **star:1033** Unikernel Builder/Orchestrator.   [![There was an update last month][G]](https://github.com/nanovms/ops)   [![godoc][D]](https://godoc.org/github.com/nanovms/ops)
- [liner](https://github.com/peterh/liner) **star:926** Go readline-like library for command-line interfaces.   [![godoc][D]](https://godoc.org/github.com/peterh/liner)
- [complete](https://github.com/posener/complete) **star:861** Write bash completions in Go + Go command bash completion.   [![godoc][D]](https://godoc.org/github.com/posener/complete)
- [mow.cli](https://github.com/jawher/mow.cli) **star:830** Go library for building CLI applications with sophisticated flag and argument parsing and validation.   [![godoc][D]](https://godoc.org/github.com/jawher/mow.cli)
- [flaggy](https://github.com/integrii/flaggy) **star:814** A robust and idiomatic flags package with excellent subcommand support.   [![godoc][D]](https://godoc.org/github.com/integrii/flaggy)
- [cli](https://github.com/mkideal/cli) **star:670** Feature-rich and easy to use command-line package based on golang struct tags.   [![godoc][D]](https://godoc.org/github.com/mkideal/cli)
- [argparse](https://github.com/akamensky/argparse) **star:462** Command line argument parser inspired by Python's argparse module.   [![godoc][D]](https://godoc.org/github.com/akamensky/argparse)
- [climax](https://github.com/tucnak/climax) **star:200** Alternative CLI with "human face", in spirit of Go command.   [![godoc][D]](https://godoc.org/github.com/tucnak/climax)
- [wmenu](https://github.com/dixonwille/wmenu) **star:177** Easy to use menu structure for cli applications that prompts users to make choices.   [![godoc][D]](https://godoc.org/github.com/dixonwille/wmenu)
- [commandeer](https://github.com/jaffee/commandeer) **star:160** Dev-friendly CLI apps: sets up flags, defaults, and usage based on struct fields and tags.   [![godoc][D]](https://godoc.org/github.com/jaffee/commandeer)
- [sflags](https://github.com/octago/sflags) **star:141** Struct based flags generator for flag, urfave/cli, pflag, cobra, kingpin and other libraries.   [![godoc][D]](https://godoc.org/github.com/octago/sflags)
- [clîr](https://github.com/leaanthony/clir) **star:126** A Simple and Clear CLI library. Dependency free.   [![godoc][D]](https://godoc.org/github.com/leaanthony/clir)
- [flag](https://github.com/cosiner/flag) **star:123** Simple but powerful command line option parsing library for Go supporting subcommand.   [![godoc][D]](https://godoc.org/github.com/cosiner/flag)
- [job](https://github.com/liujianping/job) **star:121** JOB, make your short-term command as a long-term job.
- [ukautz/clif](https://github.com/ukautz/clif) **star:118** Small command line interface framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/ukautz/clif)   [![godoc][D]](https://godoc.org/github.com/ukautz/clif)
- [cli](https://github.com/teris-io/cli) **star:116** Simple and complete API for building command line interfaces in Go.   [![godoc][D]](https://godoc.org/github.com/teris-io/cli)
- [cmdr](https://github.com/hedzr/cmdr) **star:114** A POSIX/GNU style, getopt-like command-line UI Go library.   [![godoc][D]](https://godoc.org/github.com/hedzr/cmdr)
- [env](https://github.com/codingconcepts/env) **star:98** Tag-based environment configuration for structs.   [![godoc][D]](https://godoc.org/github.com/codingconcepts/env)
- [carapace-bin](https://github.com/rsteube/carapace-bin) **star:89** Multi-shell multi-command argument completer.   [![There was an update last month][G]](https://github.com/rsteube/carapace-bin)   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace-bin)
- [acmd](https://github.com/cristalhq/acmd) **star:61** Simple, useful and opinionated CLI package in Go.   [![godoc][D]](https://godoc.org/github.com/cristalhq/acmd)
- [gocmd](https://github.com/devfacet/gocmd) **star:60** Go library for building command line applications.   [![godoc][D]](https://godoc.org/github.com/devfacet/gocmd)
- [hiboot cli](https://github.com/hidevopsio/hiboot/tree/master/pkg/app/cli)  cli application framework with auto configuration and dependency injection.
- [wlog](https://github.com/dixonwille/wlog) **star:59** Simple logging interface that supports cross-platform color and concurrency.   [![godoc][D]](https://godoc.org/github.com/dixonwille/wlog)
- [carapace](https://github.com/rsteube/carapace) **star:53** Command argument completion generator for spf13/cobra.   [![There was an update last month][G]](https://github.com/rsteube/carapace)   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace)
- [strumt](https://github.com/antham/strumt) **star:49** Library to create prompt chain.   [![godoc][D]](https://godoc.org/github.com/antham/strumt)
- [go-getoptions](https://github.com/DavidGamba/go-getoptions) **star:46** Go option parser inspired on the flexibility of Perl’s GetOpt::Long.   [![godoc][D]](https://godoc.org/github.com/DavidGamba/go-getoptions)
- [flagvar](https://github.com/sgreben/flagvar) **star:41** A collection of flag argument types for Go's standard `flag` package.   [![godoc][D]](https://godoc.org/github.com/sgreben/flagvar)
- [argv](https://github.com/cosiner/argv) **star:35** Go library to split command line string as arguments array using the bash syntax.   [![godoc][D]](https://godoc.org/github.com/cosiner/argv)
- [cmd](https://github.com/posener/cmd) **star:35** Extends the standard `flag` package to support sub commands and more in idiomatic way.   [![godoc][D]](https://godoc.org/github.com/posener/cmd)
- [command-chain](https://github.com/rainu/go-command-chain) **star:32** A go library for configure and run command chains - such like pipelining in unix shells.   [![godoc][D]](https://godoc.org/github.com/rainu/go-command-chain)
- [go-commander](https://github.com/yitsushi/go-commander) **star:30** Go library to simplify CLI workflow.   [![godoc][D]](https://godoc.org/github.com/yitsushi/go-commander)
- [sand](https://github.com/Zaba505/sand) **star:19** Simple API for creating interpreters and so much more.   [![It hasn't been updated in recent three years][Y]](https://github.com/Zaba505/sand)   [![godoc][D]](https://godoc.org/github.com/Zaba505/sand)
- [go-andotp](https://github.com/grijul/go-andotp) **star:18** A CLI program to encrypt/decrypt [andOTP](https://github.com/andOTP/andOTP) files. Can be used as library as well.   [![godoc][D]](https://godoc.org/github.com/grijul/go-andotp)
- [ts](https://github.com/liujianping/ts) **star:16** Timestamp convert & compare tool.   [![It hasn't been updated in recent three years][Y]](https://github.com/liujianping/ts)   [![godoc][D]](https://godoc.org/github.com/liujianping/ts)
- [mcli](https://github.com/jxskiss/mcli) **star:6** A minimal but very powerful cli library for Go.   [![godoc][D]](https://godoc.org/github.com/jxskiss/mcli)
- [carapace-spec](https://github.com/rsteube/carapace-spec) **star:3** Define simple completions using a spec file.   [![There was an update last month][G]](https://github.com/rsteube/carapace-spec)   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace-spec)
- [subcmd](https://github.com/bobg/subcmd) **star:3** Another approach to parsing and running subcommands. Works alongside the standard `flag` package.   [![godoc][D]](https://godoc.org/github.com/bobg/subcmd)

**[⬆ back to top](#contents)**

## Configuration

_Libraries for configuration parsing._

- [viper](https://github.com/spf13/viper) **star:20777** Go configuration with fangs.   [![There was an update last month][G]](https://github.com/spf13/viper)   [![godoc][D]](https://godoc.org/github.com/spf13/viper)
- [godotenv](https://github.com/joho/godotenv) **star:5362** Go port of Ruby's dotenv library (Loads environment variables from `.env`).   [![There was an update last month][G]](https://github.com/joho/godotenv)   [![godoc][D]](https://godoc.org/github.com/joho/godotenv)
- [kelseyhightower/envconfig](https://github.com/kelseyhightower/envconfig) **star:4278** Go library for managing configuration data from environment variables.   [![godoc][D]](https://godoc.org/github.com/kelseyhightower/envconfig)
- [ini](https://github.com/go-ini/ini) **star:3078** Go package to read and write INI files.   [![godoc][D]](https://godoc.org/github.com/go-ini/ini)
- [env](https://github.com/caarlos0/env) **star:2725** Parse environment variables to Go structs (with defaults).   [![godoc][D]](https://godoc.org/github.com/caarlos0/env)
- [koanf](https://github.com/knadh/koanf) **star:1191** Light weight, extensible library for reading config in Go applications. Built in support for JSON, TOML, YAML, env, command line.   [![There was an update last month][G]](https://github.com/knadh/koanf)   [![godoc][D]](https://godoc.org/github.com/knadh/koanf)
- [kong](https://github.com/alecthomas/kong) **star:1111** Command-line parser with support for arbitrarily complex command-line structures and additional sources of configuration such as YAML, JSON, TOML, etc (successor to `kingpin`).   [![godoc][D]](https://godoc.org/github.com/alecthomas/kong)
- [cleanenv](https://github.com/ilyakaznacheev/cleanenv) **star:742** Minimalistic configuration reader (from files, ENV, and wherever you want).   [![There was an update last month][G]](https://github.com/ilyakaznacheev/cleanenv)   [![godoc][D]](https://godoc.org/github.com/ilyakaznacheev/cleanenv)
- [konfig](https://github.com/lalamove/konfig) **star:633** Composable, observable and performant config handling for Go for the distributed processing era.   [![godoc][D]](https://godoc.org/github.com/lalamove/konfig)
- [confita](https://github.com/heetch/confita) **star:457** Load configuration in cascade from multiple backends into a struct.   [![godoc][D]](https://godoc.org/github.com/heetch/confita)
- [gookit/config](https://github.com/gookit/config) **star:400** application config manage(load,get,set). support JSON, YAML, TOML, INI, HCL. multi file load, data override merge.   [![There was an update last month][G]](https://github.com/gookit/config)   [![godoc][D]](https://godoc.org/github.com/gookit/config)   [![Contains Chinese documents][CN]](https://github.com/gookit/config)
- [aconfig](https://github.com/cristalhq/aconfig) **star:397** Simple, useful and opinionated config loader.   [![godoc][D]](https://godoc.org/github.com/cristalhq/aconfig)
- [config](https://github.com/JeremyLoy/config) **star:318** Cloud native application configuration. Bind ENV to structs in only two lines.   [![godoc][D]](https://godoc.org/github.com/JeremyLoy/config)
- [GoLobby/Config](https://github.com/golobby/config) **star:293** GoLobby Config is a lightweight yet powerful configuration manager for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/config)
- [gone/jconf](https://github.com/One-com/gone/tree/master/jconf)  Modular JSON configuration. Keep you config structs along with the code they configure and delegate parsing to submodules without sacrificing full config serialization.
- [hjson](https://github.com/hjson/hjson-go) **star:280** Human JSON, a configuration file format for humans. Relaxed syntax, fewer mistakes, more comments.   [![godoc][D]](https://godoc.org/github.com/hjson/hjson-go)
- [xdg](https://github.com/adrg/xdg) **star:270** Go implementation of the [XDG Base Directory Specification](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html) and [XDG user directories](https://wiki.archlinux.org/index.php/XDG_user_directories).   [![godoc][D]](https://godoc.org/github.com/adrg/xdg)
- [store](https://github.com/tucnak/store) **star:263** Lightweight configuration manager for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/tucnak/store)   [![godoc][D]](https://godoc.org/github.com/tucnak/store)
- [config](https://github.com/olebedev/config) **star:254** JSON or YAML configuration wrapper with environment variables and flags parsing.   [![godoc][D]](https://godoc.org/github.com/olebedev/config)
- [fig](https://github.com/kkyr/fig) **star:233** Tiny library for reading configuration from a file and from environment variables (with validation & defaults).   [![godoc][D]](https://godoc.org/github.com/kkyr/fig)
- [envconfig](https://github.com/vrischmann/envconfig) **star:228** Read your configuration from environment variables.   [![godoc][D]](https://godoc.org/github.com/vrischmann/envconfig)
- [joshbetz/config](https://github.com/joshbetz/config) **star:216** Small configuration library for Go that parses environment variables, JSON files, and reloads automatically on SIGHUP.   [![godoc][D]](https://godoc.org/github.com/joshbetz/config)
- [gcfg](https://github.com/go-gcfg/gcfg) **star:163** read INI-style configuration files into Go structs; supports user-defined types and subsections.   [![godoc][D]](https://godoc.org/github.com/go-gcfg/gcfg)
- [harvester](https://github.com/beatlabs/harvester) **star:119** Harvester, a easy to use static and dynamic configuration package supporting seeding, env vars and Consul integration.   [![godoc][D]](https://godoc.org/github.com/beatlabs/harvester)
- [onion](https://github.com/goraz/onion) **star:109** Layer based configuration for Go, Supports JSON, TOML, YAML, properties, etcd, env, and encryption using PGP.   [![godoc][D]](https://godoc.org/github.com/goraz/onion)
- [envcfg](https://github.com/tomazk/envcfg) **star:99** Un-marshaling environment variables to Go structs.   [![It hasn't been updated in recent three years][Y]](https://github.com/tomazk/envcfg)   [![godoc][D]](https://godoc.org/github.com/tomazk/envcfg)
- [envh](https://github.com/antham/envh) **star:96** Helpers to manage environment variables.   [![godoc][D]](https://godoc.org/github.com/antham/envh)
- [configuro](https://github.com/sherifabdlnaby/configuro) **star:81** opinionated configuration loading & validation framework from ENV and Files focused towards 12-Factor compliant applications.   [![godoc][D]](https://godoc.org/github.com/sherifabdlnaby/configuro)
- [configuration](https://github.com/BoRuDar/configuration) **star:80** Library for initializing configuration structs from env variables, files, flags and 'default' tag.   [![godoc][D]](https://godoc.org/github.com/BoRuDar/configuration)
- [xdg](https://github.com/OpenPeeDeeP/xdg) **star:71** Cross platform package that follows the [XDG Standard](https://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html).   [![godoc][D]](https://godoc.org/github.com/OpenPeeDeeP/xdg)
- [gofigure](https://github.com/ian-kent/gofigure) **star:65** Go application configuration made easy.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/gofigure)   [![godoc][D]](https://godoc.org/github.com/ian-kent/gofigure)
- [configure](https://github.com/paked/configure) **star:57** Provides configuration through multiple sources, including JSON, flags and environment variables.   [![It hasn't been updated in recent three years][Y]](https://github.com/paked/configure)   [![godoc][D]](https://godoc.org/github.com/paked/configure)
- [uConfig](https://github.com/omeid/uconfig) **star:52** Lightweight, zero-dependency, and extendable configuration management.   [![godoc][D]](https://godoc.org/github.com/omeid/uconfig)
- [go-aws-ssm](https://github.com/PaddleHQ/go-aws-ssm) **star:51** Go package that fetches parameters from AWS System Manager - Parameter Store.   [![godoc][D]](https://godoc.org/github.com/PaddleHQ/go-aws-ssm)
- [hocon](https://github.com/gurkankaymak/hocon) **star:49** Configuration library for working with the HOCON(a human-friendly JSON superset) format, supports features like environment variables, referencing other values, comments and multiple files.   [![godoc][D]](https://godoc.org/github.com/gurkankaymak/hocon)
- [go-up](https://github.com/ufoscout/go-up) **star:38** A simple configuration library with recursive placeholders resolution and no magic.   [![godoc][D]](https://godoc.org/github.com/ufoscout/go-up)
- [ingo](https://github.com/schachmat/ingo) **star:36** Flags persisted in an ini-like config file.   [![It hasn't been updated in recent three years][Y]](https://github.com/schachmat/ingo)   [![godoc][D]](https://godoc.org/github.com/schachmat/ingo)
- [mini](https://github.com/sasbury/mini) **star:32** Golang package for parsing ini-style configuration files.   [![It hasn't been updated in recent three years][Y]](https://github.com/sasbury/mini)   [![godoc][D]](https://godoc.org/github.com/sasbury/mini)
- [genv](https://github.com/sakirsensoy/genv) **star:29** Read environment variables easily with dotenv support.   [![It hasn't been updated in recent three years][Y]](https://github.com/sakirsensoy/genv)   [![godoc][D]](https://godoc.org/github.com/sakirsensoy/genv)
- [config](https://github.com/num30/config) **star:26** configure you app using file, environment variables, or flags in two lines of code   [![godoc][D]](https://godoc.org/github.com/num30/config)
- [conflate](https://github.com/the4thamigo-uk/conflate) **star:26** Library/tool to merge multiple JSON/YAML/TOML files from arbitrary URLs, validation against a JSON schema, and application of default values defined in the schema.   [![godoc][D]](https://godoc.org/github.com/the4thamigo-uk/conflate)
- [env](https://github.com/junk1tm/env) **star:25** A lightweight package for loading environment variables into structs.   [![There was an update last month][G]](https://github.com/junk1tm/env)   [![godoc][D]](https://godoc.org/github.com/junk1tm/env)
- [go-ssm-config](https://github.com/ianlopshire/go-ssm-config) **star:17** Go utility for loading configuration parameters from AWS SSM (Parameter Store).   [![godoc][D]](https://godoc.org/github.com/ianlopshire/go-ssm-config)
- [envconf](https://github.com/ian-kent/envconf) **star:11** Configuration from environment.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/envconf)   [![godoc][D]](https://godoc.org/github.com/ian-kent/envconf)
- [ini](https://github.com/wlevene/ini) **star:10** INI Parser & Write Library, Unmarshal to Struct,Marshal to Json,Write File,watch file.   [![godoc][D]](https://godoc.org/github.com/wlevene/ini)
- [nasermirzaei89/env](https://github.com/nasermirzaei89/env) **star:9** Simple useful package for read environment variables.   [![godoc][D]](https://godoc.org/github.com/nasermirzaei89/env)
- [typenv](https://github.com/diegomarangoni/typenv) **star:9** Minimalistic, zero dependency, typed environment variables library.   [![godoc][D]](https://godoc.org/github.com/diegomarangoni/typenv)
- [go-ini](https://github.com/subpop/go-ini) **star:8** A Go package that marshals and unmarshals INI-files.   [![godoc][D]](https://godoc.org/github.com/subpop/go-ini)
- [piper](https://github.com/Yiling-J/piper) **star:7** Viper wrapper with config inheritance and key generation.   [![godoc][D]](https://godoc.org/github.com/Yiling-J/piper)
- [swap](https://github.com/oblq/swap) **star:7** Instantiate/configure structs recursively, based on build environment. (YAML, TOML, JSON and env).   [![godoc][D]](https://godoc.org/github.com/oblq/swap)
- [go-conf](https://github.com/ThomasObenaus/go-conf) **star:5** Simple library for application configuration based on annotated structs. It supports reading the configuration from environment variables, config files and command line parameters.   [![godoc][D]](https://godoc.org/github.com/ThomasObenaus/go-conf)
- [gonfig](https://github.com/milad-abbasi/gonfig) **star:5** Tag-based configuration parser which loads values from different providers into typesafe struct.   [![godoc][D]](https://godoc.org/github.com/milad-abbasi/gonfig)
- [nfigure](https://github.com/muir/nfigure) **star:3** Per-library struct-tag based configuration from command lines (Posix & Go-style); environment, JSON, YAML   [![godoc][D]](https://godoc.org/github.com/muir/nfigure)
- [goConfig](https://github.com/crgimenes/goConfig) **star:1** Parses a struct as input and populates the fields of this struct with parameters from command line, environment variables and configuration file.   [![godoc][D]](https://godoc.org/github.com/crgimenes/goConfig)

**[⬆ back to top](#contents)**

## Continuous Integration

_Tools for help with continuous integration._

- [drone](https://github.com/drone/drone) **star:25815** Drone is a Continuous Integration platform built on Docker, written in Go.   [![There was an update last month][G]](https://github.com/drone/drone)   [![godoc][D]](https://godoc.org/github.com/drone/drone)
- [CDS](https://github.com/ovh/cds) **star:3984** Enterprise-Grade CI/CD and DevOps Automation Open Source Platform.   [![There was an update last month][G]](https://github.com/ovh/cds)   [![godoc][D]](https://godoc.org/github.com/ovh/cds)
- [woodpecker](https://github.com/woodpecker-ci/woodpecker) **star:1504** Woodpecker is a community fork of the Drone CI system.    [![There was an update last month][G]](https://github.com/woodpecker-ci/woodpecker)   [![godoc][D]](https://godoc.org/github.com/woodpecker-ci/woodpecker)
- [goveralls](https://github.com/mattn/goveralls) **star:740** Go integration for Coveralls.io continuous code coverage tracking system.   [![godoc][D]](https://godoc.org/github.com/mattn/goveralls)
- [gotestfmt](https://github.com/haveyoudebuggedit/gotestfmt) **star:324** go test output for humans.   [![godoc][D]](https://godoc.org/github.com/haveyoudebuggedit/gotestfmt)
- [overalls](https://github.com/go-playground/overalls) **star:112** Multi-Package go project coverprofile for tools like goveralls.   [![godoc][D]](https://godoc.org/github.com/go-playground/overalls)
- [duci](https://github.com/duck8823/duci) **star:76** A simple ci server no needs domain specific languages.   [![godoc][D]](https://godoc.org/github.com/duck8823/duci)
- [gomason](https://github.com/nikogura/gomason) **star:54** Test, Build, Sign, and Publish your go binaries from a clean workspace.   [![godoc][D]](https://godoc.org/github.com/nikogura/gomason)
- [roveralls](https://github.com/LawrenceWoodman/roveralls) **star:19** Recursive coverage testing tool.   [![It hasn't been updated in recent three years][Y]](https://github.com/LawrenceWoodman/roveralls)   [![godoc][D]](https://godoc.org/github.com/LawrenceWoodman/roveralls)
- [go-fuzz-action](https://github.com/jidicula/go-fuzz-action) **star:6** Use Go 1.18's built-in fuzz testing in GitHub Actions.

**[⬆ back to top](#contents)**

## CSS Preprocessors

_Libraries for preprocessing CSS files._

- [gcss](https://github.com/yosssi/gcss) **star:464** Pure Go CSS Preprocessor.   [![It hasn't been updated in recent three years][Y]](https://github.com/yosssi/gcss)   [![godoc][D]](https://godoc.org/github.com/yosssi/gcss)
- [go-libsass](https://github.com/wellington/go-libsass) **star:190** Go wrapper to the 100% Sass compatible libsass project.

**[⬆ back to top](#contents)**

## Data Structures and Algorithms

### Bit-packing and Compression

- [roaring](https://github.com/RoaringBitmap/roaring) **star:1783** Go package implementing compressed bitsets.   [![godoc][D]](https://godoc.org/github.com/RoaringBitmap/roaring)
- [binpacker](https://github.com/zhuangsirui/binpacker) **star:194** Binary packer and unpacker helps user build custom binary stream.   [![godoc][D]](https://godoc.org/github.com/zhuangsirui/binpacker)
- [bit](https://github.com/yourbasic/bit) **star:136** Golang set data structure with bonus bit-twiddling functions.   [![It hasn't been updated in recent three years][Y]](https://github.com/yourbasic/bit)   [![godoc][D]](https://godoc.org/github.com/yourbasic/bit)
- [crunch](https://github.com/superwhiskers/crunch) **star:61** Go package implementing buffers for handling various datatypes easily.   [![godoc][D]](https://godoc.org/github.com/superwhiskers/crunch)
- [go-ef](https://github.com/amallia/go-ef) **star:25** A Go implementation of the Elias-Fano encoding.   [![It hasn't been updated in recent three years][Y]](https://github.com/amallia/go-ef)   [![godoc][D]](https://godoc.org/github.com/amallia/go-ef)
- [bingo](https://github.com/iancmcc/bingo) **star:14** Fast, zero-allocation, lexicographical-order-preserving packing of native types to bytes.   [![godoc][D]](https://godoc.org/github.com/iancmcc/bingo)

### Bit Sets

- [bitset](https://github.com/bits-and-blooms/bitset) **star:977** Go package implementing bitsets.   [![godoc][D]](https://godoc.org/github.com/bits-and-blooms/bitset)
- [bitmap](https://github.com/kelindar/bitmap) **star:168** Dense, zero-allocation, SIMD-enabled bitmap/bitset in Go.   [![godoc][D]](https://godoc.org/github.com/kelindar/bitmap)

### Bloom and Cuckoo Filters

- [bloom](https://github.com/bits-and-blooms/bloom) **star:1690** Go package implementing Bloom filters.   [![godoc][D]](https://godoc.org/github.com/bits-and-blooms/bloom)
- [boomfilters](https://github.com/tylertreat/BoomFilters) **star:1480** Probabilistic data structures for processing continuous, unbounded streams.   [![godoc][D]](https://godoc.org/github.com/tylertreat/BoomFilters)
- [cuckoofilter](https://github.com/seiflotfy/cuckoofilter) **star:932** Cuckoo filter: a good alternative to a counting bloom filter implemented in Go.   [![godoc][D]](https://godoc.org/github.com/seiflotfy/cuckoofilter)
- [cuckoo-filter](https://github.com/linvon/cuckoo-filter) **star:229** Cuckoo filter: a comprehensive cuckoo filter, which is configurable and space optimized compared with other implements, and all features mentioned in original paper is available.   [![godoc][D]](https://godoc.org/github.com/linvon/cuckoo-filter)   [![Contains Chinese documents][CN]](https://github.com/linvon/cuckoo-filter)
- [bloom](https://github.com/zhenjl/bloom) **star:148** Bloom filters implemented in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/zhenjl/bloom)   [![godoc][D]](https://godoc.org/github.com/zhenjl/bloom)
- [ring](https://github.com/TheTannerRyan/ring) **star:128** Go implementation of a high performance, thread safe bloom filter.   [![godoc][D]](https://godoc.org/github.com/TheTannerRyan/ring)
- [bloom](https://github.com/yourbasic/bloom) **star:74** Golang Bloom filter implementation.   [![It hasn't been updated in recent three years][Y]](https://github.com/yourbasic/bloom)   [![godoc][D]](https://godoc.org/github.com/yourbasic/bloom)
- [bloomfilter](https://github.com/OldPanda/bloomfilter) **star:10** Yet another Bloomfilter implementation in Go, compatible with Java's Guava library.   [![There was an update last month][G]](https://github.com/OldPanda/bloomfilter)   [![godoc][D]](https://godoc.org/github.com/OldPanda/bloomfilter)

### Data Structure and Algorithm Collections

- [gods](https://github.com/emirpasic/gods) **star:12615** Go Data Structures. Containers, Sets, Lists, Stacks, Maps, BidiMaps, Trees, HashSet etc.   [![godoc][D]](https://godoc.org/github.com/emirpasic/gods)
- [go-datastructures](https://github.com/Workiva/go-datastructures) **star:6660** Collection of useful, performant, and thread-safe data structures.   [![godoc][D]](https://godoc.org/github.com/Workiva/go-datastructures)
- [gostl](https://github.com/liyue201/gostl) **star:722** Data structure and algorithm library for go, designed to provide functions similar to C++ STL.   [![godoc][D]](https://godoc.org/github.com/liyue201/gostl)
- [algorithms](https://github.com/shady831213/algorithms) **star:673** Algorithms and data structures.CLRS study.   [![godoc][D]](https://godoc.org/github.com/shady831213/algorithms)

### Iterators

- [iter](https://github.com/disksing/iter) **star:166** Go implementation of C++ STL iterators and algorithms.   [![godoc][D]](https://godoc.org/github.com/disksing/iter)   [![Contains Chinese documents][CN]](https://github.com/disksing/iter)
- [goterator](https://github.com/yaa110/goterator) **star:11** Iterator implementation to provide map and reduce functionalities.   [![godoc][D]](https://godoc.org/github.com/yaa110/goterator)

### Maps

See also [Database](#database) for more complex key-value stores, and [Trees](#trees) for
additional ordered map implementations.

- [cmap](https://github.com/lrita/cmap) **star:37** a thread-safe concurrent map for go, support using `interface{}` as key and auto scale up shards.   [![godoc][D]](https://godoc.org/github.com/lrita/cmap)
- [dict](https://github.com/srfrog/dict) **star:32** Python-like dictionaries (dict) for Go.   [![godoc][D]](https://godoc.org/github.com/srfrog/dict)
- [goradd/maps](https://github.com/goradd/maps) **star:12** Go 1.18+ generic map interface for maps; safe maps; ordered maps; ordered, safe maps; etc.   [![godoc][D]](https://godoc.org/github.com/goradd/maps)

### Miscellaneous Data Structures and Algorithms

- [gota](https://github.com/kniren/gota) **star:2390** Implementation of dataframes, series, and data wrangling methods for Go.   [![godoc][D]](https://godoc.org/github.com/kniren/gota)
- [hyperloglog](https://github.com/axiomhq/hyperloglog) **star:801** HyperLogLog implementation with Sparse, LogLog-Beta bias correction and TailCut space reduction.   [![godoc][D]](https://godoc.org/github.com/axiomhq/hyperloglog)
- [go-geoindex](https://github.com/hailocab/go-geoindex) **star:340** In-memory geo index.   [![It hasn't been updated in recent three years][Y]](https://github.com/hailocab/go-geoindex)   [![godoc][D]](https://godoc.org/github.com/hailocab/go-geoindex)
- [hilbert](https://github.com/google/hilbert) **star:255** Go package for mapping values to and from space-filling curves, such as Hilbert and Peano curves.   [![godoc][D]](https://godoc.org/github.com/google/hilbert)
- [go-rquad](https://github.com/aurelien-rainone/go-rquad) **star:122** Region quadtrees with efficient point location and neighbour finding.   [![godoc][D]](https://godoc.org/github.com/aurelien-rainone/go-rquad)
- [conjungo](https://github.com/InVisionApp/conjungo) **star:108** A small, powerful and flexible merge library.   [![godoc][D]](https://godoc.org/github.com/InVisionApp/conjungo)
- [go-rampart](https://github.com/francesconi/go-rampart) **star:84** Determine how intervals relate to each other.   [![godoc][D]](https://godoc.org/github.com/francesconi/go-rampart)
- [count-min-log](https://github.com/seiflotfy/count-min-log) **star:58** Go implementation Count-Min-Log sketch: Approximately counting with approximate counters (Like Count-Min sketch but using less memory).   [![It hasn't been updated in recent three years][Y]](https://github.com/seiflotfy/count-min-log)   [![godoc][D]](https://godoc.org/github.com/seiflotfy/count-min-log)
- [hide](https://github.com/emvi/hide) **star:51** ID type with marshalling to/from hash to prevent sending IDs to clients.   [![godoc][D]](https://godoc.org/github.com/emvi/hide)
- [concurrent-writer](https://github.com/free/concurrent-writer) **star:46** Highly concurrent drop-in replacement for `bufio.Writer`.   [![It hasn't been updated in recent three years][Y]](https://github.com/free/concurrent-writer)   [![godoc][D]](https://godoc.org/github.com/free/concurrent-writer)
- [go-tuple](https://github.com/barweiss/go-tuple) **star:36** Generic tuple implementation for Go 1.18+.   [![godoc][D]](https://godoc.org/github.com/barweiss/go-tuple)
- [fsm](https://github.com/cocoonspace/fsm) **star:31** Finite-State Machine package.   [![godoc][D]](https://godoc.org/github.com/cocoonspace/fsm)
- [genfuncs](https://github.com/nwillc/genfuncs) **star:31** Go 1.18+ generics package inspired by Kotlin's Sequence and Map.   [![godoc][D]](https://godoc.org/github.com/nwillc/genfuncs)
- [go18ds](https://github.com/daichi-m/go18ds) **star:28** Go Data Structures using Go 1.18 generics.   [![godoc][D]](https://godoc.org/github.com/daichi-m/go18ds)
- [gofal](https://github.com/xxjwxc/gofal) **star:17** fractional api for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/xxjwxc/gofal)   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gofal)   [![Contains Chinese documents][CN]](https://github.com/xxjwxc/gofal)
- [quadtree](https://github.com/s0rg/quadtree) **star:15** Generic, zero-alloc, 100%-test covered quadtree.   [![godoc][D]](https://godoc.org/github.com/s0rg/quadtree)
- [slices](https://github.com/twharmon/slices) **star:12** Pure, generic functions for slices.   [![godoc][D]](https://godoc.org/github.com/twharmon/slices)
- [slices](https://github.com/srfrog/slices) **star:8** Functions that operate on slices; like `package strings` but adapted to work with slices.   [![godoc][D]](https://godoc.org/github.com/srfrog/slices)
- [go-generics](https://github.com/bobg/go-generics) **star:7** Generic slice, map, set, iterator, and goroutine utilities.   [![godoc][D]](https://godoc.org/github.com/bobg/go-generics)

### Nullable Types

- [nan](https://github.com/kak-tus/nan) **star:57** Zero allocation Nullable structures in one library with handy conversion functions, marshallers and unmarshallers.   [![godoc][D]](https://godoc.org/github.com/kak-tus/nan)
- [typ](https://github.com/gurukami/typ) **star:33** Null Types, Safe primitive type conversion and fetching value from complex structures.   [![godoc][D]](https://godoc.org/github.com/gurukami/typ)
- [null](https://github.com/emvi/null) **star:28** Nullable Go types that can be marshalled/unmarshalled to/from JSON.   [![godoc][D]](https://godoc.org/github.com/emvi/null)

### Queues

- [deque](https://github.com/gammazero/deque) **star:387** Fast ring-buffer deque (double-ended queue).   [![godoc][D]](https://godoc.org/github.com/gammazero/deque)
- [goconcurrentqueue](https://github.com/enriquebris/goconcurrentqueue) **star:213** Concurrent FIFO queue.   [![godoc][D]](https://godoc.org/github.com/enriquebris/goconcurrentqueue)
- [deque](https://github.com/edwingeng/deque) **star:68** A highly optimized double-ended queue.   [![godoc][D]](https://godoc.org/github.com/edwingeng/deque)
- [memlog](https://github.com/embano1/memlog) **star:62** An easy to use, lightweight, thread-safe and append-only in-memory data structure inspired by Apache Kafka.   [![godoc][D]](https://godoc.org/github.com/embano1/memlog)

### Sets

- [golang-set](https://github.com/deckarep/golang-set) **star:2716** Thread-Safe and Non-Thread-Safe high-performance sets for Go.   [![godoc][D]](https://godoc.org/github.com/deckarep/golang-set)
- [goset](https://github.com/zoumo/goset) **star:50** A useful Set collection implementation for Go.   [![godoc][D]](https://godoc.org/github.com/zoumo/goset)
- [set](https://github.com/StudioSol/set) **star:22** Simple set data structure implementation in Go using LinkedHashMap.   [![godoc][D]](https://godoc.org/github.com/StudioSol/set)
- [dsu](https://github.com/ihebu/dsu) **star:8** Disjoint Set data structure implementation in Go.   [![godoc][D]](https://godoc.org/github.com/ihebu/dsu)

### Text Analysis

- [bleve](https://github.com/blevesearch/bleve) **star:8640** Modern text indexing library for go.   [![There was an update last month][G]](https://github.com/blevesearch/bleve)   [![godoc][D]](https://godoc.org/github.com/blevesearch/bleve)
- [trie](https://github.com/derekparker/trie) **star:608** Trie implementation in Go.   [![godoc][D]](https://godoc.org/github.com/derekparker/trie)
- [go-edlib](https://github.com/hbollon/go-edlib) **star:361** Go string comparison and edit distance algorithms library (Levenshtein, LCS, Hamming, Damerau levenshtein, Jaro-Winkler, etc.) compatible with Unicode.   [![godoc][D]](https://godoc.org/github.com/hbollon/go-edlib)
- [go-adaptive-radix-tree](https://github.com/plar/go-adaptive-radix-tree) **star:247** Go implementation of Adaptive Radix Tree.   [![godoc][D]](https://godoc.org/github.com/plar/go-adaptive-radix-tree)
- [levenshtein](https://github.com/agnivade/levenshtein) **star:237** Implementation to calculate levenshtein distance in Go.   [![godoc][D]](https://godoc.org/github.com/agnivade/levenshtein)
- [levenshtein](https://github.com/agext/levenshtein) **star:70** Levenshtein distance and similarity metrics with customizable edit costs and Winkler-like bonus for common prefix.   [![godoc][D]](https://godoc.org/github.com/agext/levenshtein)
- [ptrie](https://github.com/viant/ptrie) **star:29** An implementation of prefix tree.   [![godoc][D]](https://godoc.org/github.com/viant/ptrie)
- [mspm](https://github.com/BlackRabbitt/mspm) **star:18** Multi-String Pattern Matching Algorithm for information retrieval.   [![It hasn't been updated in recent three years][Y]](https://github.com/BlackRabbitt/mspm)   [![godoc][D]](https://godoc.org/github.com/BlackRabbitt/mspm)
- [parsefields](https://github.com/MonaxGT/parsefields) **star:7** Tools for parse JSON-like logs for collecting unique fields and events.   [![It hasn't been updated in recent three years][Y]](https://github.com/MonaxGT/parsefields)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/parsefields)

### Trees

- [hashsplit](http://github.com/bobg/hashsplit)  Split byte streams into chunks, and arrange chunks into trees, with boundaries determined by content, not position.
- [skiplist](https://github.com/MauriceGit/skiplist) **star:229** Very fast Go Skiplist implementation.   [![godoc][D]](https://godoc.org/github.com/MauriceGit/skiplist)
- [skiplist](https://github.com/gansidui/skiplist) **star:79** Skiplist implementation in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/gansidui/skiplist)   [![godoc][D]](https://godoc.org/github.com/gansidui/skiplist)
- [treemap](https://github.com/igrmk/treemap) **star:26** Generic key-sorted map using a red-black tree under the hood.   [![godoc][D]](https://godoc.org/github.com/igrmk/treemap)
- [treap](https://github.com/perdata/treap) **star:20** Persistent, fast ordered map using tree heaps.   [![godoc][D]](https://godoc.org/github.com/perdata/treap)
- [merkle](https://github.com/bobg/merkle) **star:7** Space-efficient computation of Merkle root hashes and inclusion proofs.   [![godoc][D]](https://godoc.org/github.com/bobg/merkle)

### Pipes

- [pipeline](https://github.com/hyfather/pipeline) **star:44** An implementation of pipelines with fan-in and fan-out.   [![godoc][D]](https://godoc.org/github.com/hyfather/pipeline)
- [parapipe](https://github.com/nazar256/parapipe) **star:21** FIFO Pipeline which parallels execution on each stage while maintaining the order of messages and results.   [![godoc][D]](https://godoc.org/github.com/nazar256/parapipe)
- [ordered-concurrently](https://github.com/tejzpr/ordered-concurrently) **star:16** Go module that processes work concurrently and returns output in a channel in the order of input.   [![godoc][D]](https://godoc.org/github.com/tejzpr/ordered-concurrently)

**[⬆ back to top](#contents)**

## Database

### Caches

_Data stores with expiring records, in-memory distributed data stores, or in-memory subsets of file-based databases._

- [groupcache](https://github.com/golang/groupcache) **star:11714** Groupcache is a caching and cache-filling library, intended as a replacement for memcached in many cases.   [![godoc][D]](https://godoc.org/github.com/golang/groupcache)
- [BigCache](https://github.com/allegro/bigcache) **star:6034** Efficient key/value cache for gigabytes of data.   [![There was an update last month][G]](https://github.com/allegro/bigcache)   [![godoc][D]](https://godoc.org/github.com/allegro/bigcache)
- [GCache](https://github.com/bluele/gcache) **star:2123** Cache library with support for expirable Cache, LFU, LRU and ARC.   [![godoc][D]](https://godoc.org/github.com/bluele/gcache)
- [cache2go](https://github.com/muesli/cache2go) **star:1823** In-memory key:value cache which supports automatic invalidation based on timeouts.   [![godoc][D]](https://godoc.org/github.com/muesli/cache2go)
- [fastcache](https://github.com/VictoriaMetrics/fastcache) **star:1557** fast thread-safe inmemory cache for big number of entries. Minimizes GC overhead.   [![godoc][D]](https://godoc.org/github.com/VictoriaMetrics/fastcache)
- [gocache](https://github.com/eko/gocache) **star:1493** A complete Go cache library with multiple stores (memory, memcache, redis, ...), chainable, loadable, metrics cache and more.   [![godoc][D]](https://godoc.org/github.com/eko/gocache)
- [ttlcache](https://github.com/jellydator/ttlcache) **star:496** An in-memory cache with item expiration and generics.   [![godoc][D]](https://godoc.org/github.com/jellydator/ttlcache)
- [cachego](https://github.com/faabiosr/cachego) **star:186** Golang Cache component for multiple drivers.   [![godoc][D]](https://godoc.org/github.com/faabiosr/cachego)
- [remember-go](https://github.com/rocketlaunchr/remember-go) **star:117** A universal interface for caching slow database queries (backed by redis, memcached, ristretto, or in-memory).   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/remember-go)
- [cache](https://github.com/akyoto/cache) **star:115** In-memory key:value store with expiration time, 0 dependencies, <100 LoC, 100% coverage.   [![godoc][D]](https://godoc.org/github.com/akyoto/cache)
- [bcache](https://github.com/iwanbk/bcache) **star:97** Eventually consistent distributed in-memory  cache Go library.   [![It hasn't been updated in recent three years][Y]](https://github.com/iwanbk/bcache)   [![godoc][D]](https://godoc.org/github.com/iwanbk/bcache)
- [go-mcache](https://github.com/OrlovEvgeny/go-mcache) **star:84** Fast in-memory key:value store/cache library. Pointer caches.   [![godoc][D]](https://godoc.org/github.com/OrlovEvgeny/go-mcache)
- [go-cache](https://github.com/viney-shih/go-cache) **star:73** A flexible multi-layer Go caching library to deal with in-memory and shared cache by adopting Cache-Aside pattern.   [![godoc][D]](https://godoc.org/github.com/viney-shih/go-cache)
- [couchcache](https://github.com/codingsince1985/couchcache) **star:58** RESTful caching micro-service backed by Couchbase server.   [![godoc][D]](https://godoc.org/github.com/codingsince1985/couchcache)
- [timedmap](https://github.com/zekroTJA/timedmap) **star:48** Map with expiring key-value pairs.   [![godoc][D]](https://godoc.org/github.com/zekroTJA/timedmap)
- [clusteredBigCache](https://github.com/oaStuff/clusteredBigCache) **star:42** BigCache with clustering support and individual item expiration.   [![It hasn't been updated in recent three years][Y]](https://github.com/oaStuff/clusteredBigCache)   [![godoc][D]](https://godoc.org/github.com/oaStuff/clusteredBigCache)
- [2q](https://github.com/floatdrop/2q) **star:12** 2Q in-memory cache implementation.   [![godoc][D]](https://godoc.org/github.com/floatdrop/2q)
- [gdcache](https://github.com/ulovecode/gdcache) **star:10** A pure non-intrusive cache library implemented by golang, you can use it to implement your own distributed cache.   [![godoc][D]](https://godoc.org/github.com/ulovecode/gdcache)   [![Contains Chinese documents][CN]](https://github.com/ulovecode/gdcache)
- [ttlcache](https://github.com/cheshir/ttlcache) **star:7** In-memory key value storage with TTL for each record.   [![There was an update last month][G]](https://github.com/cheshir/ttlcache)   [![godoc][D]](https://godoc.org/github.com/cheshir/ttlcache)


### Databases Implemented in Go

- [prometheus](https://github.com/prometheus/prometheus) **star:44607** Monitoring system and time series database.   [![There was an update last month][G]](https://github.com/prometheus/prometheus)   [![godoc][D]](https://godoc.org/github.com/prometheus/prometheus)
- [tidb](https://github.com/pingcap/tidb) **star:32491** TiDB is a distributed SQL database. Inspired by the design of Google F1.   [![There was an update last month][G]](https://github.com/pingcap/tidb)   [![godoc][D]](https://godoc.org/github.com/pingcap/tidb)   [![Contains Chinese documents][CN]](https://github.com/pingcap/tidb)
- [cockroach](https://github.com/cockroachdb/cockroach) **star:25778** Scalable, Geo-Replicated, Transactional Datastore.   [![There was an update last month][G]](https://github.com/cockroachdb/cockroach)   [![godoc][D]](https://godoc.org/github.com/cockroachdb/cockroach)
- [influxdb](https://github.com/influxdb/influxdb) **star:24223** Scalable datastore for metrics, events, and real-time analytics.   [![There was an update last month][G]](https://github.com/influxdb/influxdb)   [![godoc][D]](https://godoc.org/github.com/influxdb/influxdb)
- [dgraph](https://github.com/dgraph-io/dgraph) **star:18506** Scalable, Distributed, Low Latency, High Throughput Graph Database.   [![There was an update last month][G]](https://github.com/dgraph-io/dgraph)   [![godoc][D]](https://godoc.org/github.com/dgraph-io/dgraph)
- [Milvus](https://github.com/milvus-io/milvus) **star:13846** Milvus is a vector database for embedding management, analytics and search.   [![There was an update last month][G]](https://github.com/milvus-io/milvus)   [![godoc][D]](https://godoc.org/github.com/milvus-io/milvus)
- [dolt](https://github.com/dolthub/dolt) **star:13063** Dolt – It's Git for Data.   [![There was an update last month][G]](https://github.com/dolthub/dolt)   [![godoc][D]](https://godoc.org/github.com/dolthub/dolt)
- [badger](https://github.com/dgraph-io/badger) **star:11337** Fast key-value store in Go.   [![godoc][D]](https://godoc.org/github.com/dgraph-io/badger)
- [rqlite](https://github.com/rqlite/rqlite) **star:11165** The lightweight, distributed, relational database built on SQLite.   [![There was an update last month][G]](https://github.com/rqlite/rqlite)   [![godoc][D]](https://godoc.org/github.com/rqlite/rqlite)
- [immudb](https://github.com/codenotary/immudb) **star:7875** immudb is a lightweight, high-speed immutable database for systems and applications written in Go.   [![There was an update last month][G]](https://github.com/codenotary/immudb)   [![godoc][D]](https://godoc.org/github.com/codenotary/immudb)
- [VictoriaMetrics](https://github.com/VictoriaMetrics/VictoriaMetrics) **star:7229** fast, resource-effective and scalable open source time series database. May be used as long-term remote storage for Prometheus. Supports PromQL.   [![There was an update last month][G]](https://github.com/VictoriaMetrics/VictoriaMetrics)   [![godoc][D]](https://godoc.org/github.com/VictoriaMetrics/VictoriaMetrics)
- [bbolt](https://github.com/etcd-io/bbolt) **star:5891** An embedded key/value database for Go.   [![godoc][D]](https://godoc.org/github.com/etcd-io/bbolt)
- [Bitcask](https://git.mills.io/prologic/bitcask)  Bitcask is an embeddable, persistent and fast key-value (KV) database written in pure Go with predictable read/write performance, low latency and high throughput thanks to the bitcask on-disk layout (LSM+WAL).
- [goleveldb](https://github.com/syndtr/goleveldb) **star:5389** Implementation of the [LevelDB](https://github.com/google/leveldb) key/value database in Go.   [![godoc][D]](https://godoc.org/github.com/syndtr/goleveldb)
- [ledisdb](https://github.com/siddontang/ledisdb) **star:3903** Ledisdb is a high performance NoSQL like Redis based on LevelDB.   [![godoc][D]](https://godoc.org/github.com/siddontang/ledisdb)
- [buntdb](https://github.com/tidwall/buntdb) **star:3879** Fast, embeddable, in-memory key/value database for Go with custom indexing and spatial support.   [![godoc][D]](https://godoc.org/github.com/tidwall/buntdb)
- [rosedb](https://github.com/roseduan/rosedb) **star:3228** An embedded k-v database based on LSM+WAL, supports string, list, hash, set, zset.   [![godoc][D]](https://godoc.org/github.com/roseduan/rosedb)   [![Contains Chinese documents][CN]](https://github.com/roseduan/rosedb)
- [tiedot](https://github.com/HouzuoGuo/tiedot) **star:2700** Your NoSQL database powered by Golang.   [![godoc][D]](https://godoc.org/github.com/HouzuoGuo/tiedot)
- [nutsdb](https://github.com/xujiajun/nutsdb) **star:2489** Nutsdb is a simple, fast, embeddable, persistent key/value store written in pure Go. It supports fully serializable transactions and many data structures such as  list, set, sorted set.   [![godoc][D]](https://godoc.org/github.com/xujiajun/nutsdb)   [![Contains Chinese documents][CN]](https://github.com/xujiajun/nutsdb)
- [godis](https://github.com/hdt3213/godis) **star:2202** A Golang implemented high-performance Redis server and cluster.   [![There was an update last month][G]](https://github.com/hdt3213/godis)   [![godoc][D]](https://godoc.org/github.com/hdt3213/godis)   [![Contains Chinese documents][CN]](https://github.com/hdt3213/godis)
- [CovenantSQL](https://github.com/CovenantSQL/CovenantSQL) **star:1364** CovenantSQL is a SQL database on blockchain.   [![godoc][D]](https://godoc.org/github.com/CovenantSQL/CovenantSQL)
- [diskv](https://github.com/peterbourgon/diskv) **star:1223** Home-grown disk-backed key-value store.   [![godoc][D]](https://godoc.org/github.com/peterbourgon/diskv)
- [Databunker](https://github.com/paranoidguy/databunker) **star:1018** Personally identifiable information (PII) storage service built to comply with GDPR and CCPA.   [![There was an update last month][G]](https://github.com/paranoidguy/databunker)   [![godoc][D]](https://godoc.org/github.com/paranoidguy/databunker)
- [column](https://github.com/kelindar/column) **star:989** High-performance, columnar, embeddable in-memory store with bitmap indexing and transactions.   [![godoc][D]](https://godoc.org/github.com/kelindar/column)
- [lotusdb](https://github.com/flower-corp/lotusdb) **star:974** Fast k/v database compatible with lsm and b+tree.   [![godoc][D]](https://godoc.org/github.com/flower-corp/lotusdb)
- [eliasdb](https://github.com/krotik/eliasdb) **star:947** Dependency-free, transactional graph database with REST API, phrase search and SQL-like query language.   [![godoc][D]](https://godoc.org/github.com/krotik/eliasdb)
- [pogreb](https://github.com/akrylysov/pogreb) **star:941** Embedded key-value store for read-heavy workloads.   [![godoc][D]](https://godoc.org/github.com/akrylysov/pogreb)
- [moss](https://github.com/couchbase/moss) **star:891** Moss is a simple LSM key-value storage engine written in 100% Go.   [![godoc][D]](https://godoc.org/github.com/couchbase/moss)
- [levigo](https://github.com/jmhodges/levigo) **star:407** Levigo is a Go wrapper for LevelDB.   [![godoc][D]](https://godoc.org/github.com/jmhodges/levigo)
- [pudge](https://github.com/recoilme/pudge) **star:332** Fast and simple key/value store written using Go's standard library.   [![godoc][D]](https://godoc.org/github.com/recoilme/pudge)
- [clover](https://github.com/ostafen/clover) **star:273** A lightweight document-oriented NoSQL database written in pure Golang.   [![godoc][D]](https://godoc.org/github.com/ostafen/clover)
- [Vasto](https://github.com/chrislusf/vasto) **star:240** A distributed high-performance key-value store. On Disk. Eventual consistent. HA. Able to grow or shrink without service interruption.   [![It hasn't been updated in recent three years][Y]](https://github.com/chrislusf/vasto)   [![godoc][D]](https://godoc.org/github.com/chrislusf/vasto)
- [dtf](https://github.com/dtm-labs/dtf) **star:233** A distributed transaction manager. Support XA, TCC, SAGA, Reliable Messages.   [![godoc][D]](https://godoc.org/github.com/dtm-labs/dtf)   [![Contains Chinese documents][CN]](https://github.com/dtm-labs/dtf)   [![Archived][Archived]](https://github.com/dtm-labs/dtf)
- [piladb](https://github.com/fern4lvarez/piladb) **star:199** Lightweight RESTful database engine based on stack data structures.   [![godoc][D]](https://godoc.org/github.com/fern4lvarez/piladb)
- [unitdb](https://github.com/unit-io/unitdb) **star:97** Fast timeseries database for IoT, realtime messaging  applications. Access unitdb with pubsub over tcp or websocket using github.com/unit-io/unitd application.   [![godoc][D]](https://godoc.org/github.com/unit-io/unitdb)
- [hare](https://github.com/jameycribbs/hare) **star:62** A simple database management system that stores each table as a text file of line-delimited JSON.   [![godoc][D]](https://godoc.org/github.com/jameycribbs/hare)
- [Coffer](https://github.com/claygod/coffer) **star:31** Simple ACID key-value database that supports transactions.   [![godoc][D]](https://godoc.org/github.com/claygod/coffer)
- [tempdb](https://github.com/rafaeljesus/tempdb) **star:17** Key-value store for temporary items.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/tempdb)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/tempdb)

### Database Schema Migration

- [migrate](https://github.com/golang-migrate/migrate) **star:9832** Database migrations. CLI and Golang library.   [![There was an update last month][G]](https://github.com/golang-migrate/migrate)   [![godoc][D]](https://godoc.org/github.com/golang-migrate/migrate)
- [bytebase](https://github.com/bytebase/bytebase) **star:3983** Safe database schema change and version control for DevOps teams.   [![There was an update last month][G]](https://github.com/bytebase/bytebase)   [![godoc][D]](https://godoc.org/github.com/bytebase/bytebase)
- [goose](https://github.com/pressly/goose) **star:3038** Database migration tool. You can manage your database's evolution by creating incremental SQL or Go scripts.   [![godoc][D]](https://godoc.org/github.com/pressly/goose)
- [sql-migrate](https://github.com/rubenv/sql-migrate) **star:2587** Database migration tool. Allows embedding migrations into the application using go-bindata.   [![godoc][D]](https://godoc.org/github.com/rubenv/sql-migrate)
- [atlas](https://github.com/ariga/atlas) **star:1952** A Database Toolkit. A CLI designed to help companies better work with their data.   [![There was an update last month][G]](https://github.com/ariga/atlas)   [![godoc][D]](https://godoc.org/github.com/ariga/atlas)
- [skeema](https://github.com/skeema/skeema) **star:1056** Pure-SQL schema management system for MySQL, with support for sharding and external online schema change tools.   [![There was an update last month][G]](https://github.com/skeema/skeema)   [![godoc][D]](https://godoc.org/github.com/skeema/skeema)
- [soda](https://github.com/gobuffalo/pop/tree/master/soda)  Database migration, creation, ORM, etc... for MySQL, PostgreSQL, and SQLite.
- [goavro](https://github.com/linkedin/goavro) **star:840** A Go package that encodes and decodes Avro data.   [![godoc][D]](https://godoc.org/github.com/linkedin/goavro)
- [gormigrate](https://github.com/go-gormigrate/gormigrate) **star:825** Database schema migration helper for Gorm ORM.   [![godoc][D]](https://godoc.org/github.com/go-gormigrate/gormigrate)
- [darwin](https://github.com/GuiaBolso/darwin) **star:135** Database schema evolution library for Go.   [![godoc][D]](https://godoc.org/github.com/GuiaBolso/darwin)
- [migrator](https://github.com/lopezator/migrator) **star:132** Dead simple Go database migration library.   [![godoc][D]](https://godoc.org/github.com/lopezator/migrator)
- [go-pg-migrations](https://github.com/robinjoseph08/go-pg-migrations) **star:81** A Go package to help write migrations with go-pg/pg.   [![godoc][D]](https://godoc.org/github.com/robinjoseph08/go-pg-migrations)
- [sqlize](https://github.com/sunary/sqlize) **star:42** Database migration generator. Allows generate sql migration from model and existing sql by differ them.   [![godoc][D]](https://godoc.org/github.com/sunary/sqlize)
- [avro](https://github.com/khezen/avro) **star:40** Discover SQL schemas and convert them to AVRO schemas. Query SQL records into AVRO bytes.   [![godoc][D]](https://godoc.org/github.com/khezen/avro)
- [go-fixtures](https://github.com/RichardKnop/go-fixtures) **star:29** Django style fixtures for Golang's excellent built-in database/sql library.   [![godoc][D]](https://godoc.org/github.com/RichardKnop/go-fixtures)
- [pravasan](https://github.com/pravasan/pravasan) **star:29** Simple Migration tool - currently for MySQL but planning to soon support Postgres, SQLite, MongoDB, etc.   [![It hasn't been updated in recent three years][Y]](https://github.com/pravasan/pravasan)
- [schema](https://github.com/adlio/schema) **star:25** Library to embed schema migrations for database/sql-compatible databases inside your Go binaries.   [![godoc][D]](https://godoc.org/github.com/adlio/schema)
- [migrator](https://github.com/larapulse/migrator) **star:20** MySQL database migrator designed to run migrations to your features and manage database schema update with intuitive go code.   [![godoc][D]](https://godoc.org/github.com/larapulse/migrator)
- [go-pg-migrate](https://github.com/lawzava/go-pg-migrate) **star:8** CLI-friendly package for go-pg migrations management.   [![godoc][D]](https://godoc.org/github.com/lawzava/go-pg-migrate)
- [gorm-seeder](https://github.com/Kachit/gorm-seeder) **star:5** Simple database seeder for Gorm ORM.   [![godoc][D]](https://godoc.org/github.com/Kachit/gorm-seeder)
- [libschema](https://github.com/muir/libschema) **star:4** Define your migrations separately in each library.  Migrations for open source libraries.  MySQL & PostgreSQL.   [![godoc][D]](https://godoc.org/github.com/muir/libschema)
- [godfish](https://github.com/rafaelespinoza/godfish) **star:3** Database migration manager, works with native query language. Support for cassandra, mysql, postgres, sqlite3.   [![godoc][D]](https://godoc.org/github.com/rafaelespinoza/godfish)

### Database Tools

- [vitess](https://github.com/youtube/vitess) **star:14811** vitess provides servers and tools which facilitate scaling of MySQL databases for large scale web services.   [![There was an update last month][G]](https://github.com/youtube/vitess)   [![godoc][D]](https://godoc.org/github.com/youtube/vitess)
- [pgweb](https://github.com/sosedoff/pgweb) **star:7511** Web-based PostgreSQL database browser.   [![godoc][D]](https://godoc.org/github.com/sosedoff/pgweb)
- [kingshard](https://github.com/flike/kingshard) **star:6098** kingshard is a high performance proxy for MySQL powered by Golang.   [![godoc][D]](https://godoc.org/github.com/flike/kingshard)   [![Contains Chinese documents][CN]](https://github.com/flike/kingshard)
- [orchestrator](https://github.com/github/orchestrator) **star:4675** MySQL replication topology manager & visualizer.   [![godoc][D]](https://godoc.org/github.com/github/orchestrator)
- [go-mysql-elasticsearch](https://github.com/siddontang/go-mysql-elasticsearch) **star:3842** Sync your MySQL data into Elasticsearch automatically.   [![godoc][D]](https://godoc.org/github.com/siddontang/go-mysql-elasticsearch)
- [hasql](https://golang.yandex/hasql)  Library for accessing multi-host SQL database installations.
- [go-mysql](https://github.com/siddontang/go-mysql) **star:3815** Go toolset to handle MySQL protocol and replication.   [![There was an update last month][G]](https://github.com/siddontang/go-mysql)   [![godoc][D]](https://godoc.org/github.com/siddontang/go-mysql)
- [pREST](https://github.com/prest/prest) **star:3385** Simplify and accelerate development, ⚡ instant, realtime, high-performance on any Postgres application, existing or new.   [![godoc][D]](https://godoc.org/github.com/prest/prest)
- [chproxy](https://github.com/Vertamedia/chproxy) **star:988** HTTP proxy for ClickHouse database.   [![There was an update last month][G]](https://github.com/Vertamedia/chproxy)   [![godoc][D]](https://godoc.org/github.com/Vertamedia/chproxy)
- [pg_timetable](https://github.com/cybertec-postgresql/pg_timetable) **star:792** Advanced scheduling for PostgreSQL.   [![godoc][D]](https://godoc.org/github.com/cybertec-postgresql/pg_timetable)
- [clickhouse-bulk](https://github.com/nikepan/clickhouse-bulk) **star:389** Collects small inserts and sends big requests to ClickHouse servers.   [![godoc][D]](https://godoc.org/github.com/nikepan/clickhouse-bulk)
- [myreplication](https://github.com/2tvenom/myreplication) **star:188** MySql binary log replication listener. Supports statement and row based replication.   [![It hasn't been updated in recent three years][Y]](https://github.com/2tvenom/myreplication)   [![godoc][D]](https://godoc.org/github.com/2tvenom/myreplication)
- [rdb](https://github.com/HDT3213/rdb) **star:187** Redis RDB file parser for secondary development and memory analysis.   [![godoc][D]](https://godoc.org/github.com/HDT3213/rdb)
- [octillery](https://github.com/knocknote/octillery) **star:172** Go package for sharding databases ( Supports every ORM or raw SQL ).   [![godoc][D]](https://godoc.org/github.com/knocknote/octillery)
- [dbbench](https://github.com/sj14/dbbench) **star:74** Database benchmarking tool with support for several databases and scripts.   [![There was an update last month][G]](https://github.com/sj14/dbbench)   [![godoc][D]](https://godoc.org/github.com/sj14/dbbench)
- [datagen](https://github.com/codingconcepts/datagen) **star:50** A fast data generator that's multi-table aware and supports multi-row DML.   [![godoc][D]](https://godoc.org/github.com/codingconcepts/datagen)
- [prep](https://github.com/hexdigest/prep) **star:32** Use prepared SQL statements without changing your code.   [![It hasn't been updated in recent three years][Y]](https://github.com/hexdigest/prep)   [![godoc][D]](https://godoc.org/github.com/hexdigest/prep)
- [rwdb](https://github.com/andizzle/rwdb) **star:16** rwdb provides read replica capability for multiple database servers setup.   [![It hasn't been updated in recent three years][Y]](https://github.com/andizzle/rwdb)   [![godoc][D]](https://godoc.org/github.com/andizzle/rwdb)
- [dynago](https://github.com/twharmon/dynago) **star:4** Simplify working with AWS DynamoDB.   [![godoc][D]](https://godoc.org/github.com/twharmon/dynago)

### SQL Query Builders
_Libraries for building and using SQL._

- [sqlc](https://github.com/kyleconroy/sqlc) **star:6435** Generate type-safe code from SQL.   [![There was an update last month][G]](https://github.com/kyleconroy/sqlc)   [![godoc][D]](https://godoc.org/github.com/kyleconroy/sqlc)
- [Squirrel](https://github.com/Masterminds/squirrel) **star:5208** Go library that helps you build SQL queries.   [![There was an update last month][G]](https://github.com/Masterminds/squirrel)   [![godoc][D]](https://godoc.org/github.com/Masterminds/squirrel)
- [xo](https://github.com/knq/xo) **star:3235** Generate idiomatic Go code for databases based on existing schema definitions or custom queries supporting PostgreSQL, MySQL, SQLite, Oracle, and Microsoft SQL Server.   [![godoc][D]](https://godoc.org/github.com/knq/xo)
- [goqu](https://github.com/doug-martin/goqu) **star:1679** Idiomatic SQL builder and query library.   [![godoc][D]](https://godoc.org/github.com/doug-martin/goqu)
- [gendry](https://github.com/didi/gendry) **star:1434** Non-invasive SQL builder and powerful data binder.   [![godoc][D]](https://godoc.org/github.com/didi/gendry)   [![Contains Chinese documents][CN]](https://github.com/didi/gendry)
- [jet](https://github.com/go-jet/jet) **star:801** Framework for writing type-safe SQL queries in Go, with ability to easily convert database query result into desired arbitrary object structure.   [![There was an update last month][G]](https://github.com/go-jet/jet)   [![godoc][D]](https://godoc.org/github.com/go-jet/jet)
- [Dotsql](https://github.com/gchaincl/dotsql) **star:649** Go library that helps you keep sql files in one place and use them with ease.   [![godoc][D]](https://godoc.org/github.com/gchaincl/dotsql)
- [ozzo-dbx](https://github.com/go-ozzo/ozzo-dbx) **star:578** Powerful data retrieval methods as well as DB-agnostic query building capabilities.   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-dbx)
- [dbq](https://github.com/rocketlaunchr/dbq) **star:350** Zero boilerplate database operations for Go.   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/dbq)
- [sqlingo](https://github.com/lqs/sqlingo) **star:265** A lightweight DSL to build SQL in Go.   [![godoc][D]](https://godoc.org/github.com/lqs/sqlingo)
- [sqrl](https://github.com/elgris/sqrl) **star:245** SQL query builder, fork of Squirrel with improved performance.   [![godoc][D]](https://godoc.org/github.com/elgris/sqrl)
- [Squalus](https://gitlab.com/qosenergy/squalus)  Thin layer over the Go SQL package that makes it easier to perform queries.
- [sq](https://github.com/bokwoon95/go-structured-query) **star:172** Type-safe SQL builder and struct mapper for Go.   [![godoc][D]](https://godoc.org/github.com/bokwoon95/go-structured-query)
- [igor](https://github.com/galeone/igor) **star:88** Abstraction layer for PostgreSQL that supports advanced functionality and uses gorm-like syntax.   [![godoc][D]](https://godoc.org/github.com/galeone/igor)
- [sqlf](https://github.com/leporo/sqlf) **star:85** Fast SQL query builder.   [![godoc][D]](https://godoc.org/github.com/leporo/sqlf)
- [buildsqlx](https://github.com/arthurkushman/buildsqlx) **star:78** Go database query builder library for PostgreSQL.   [![godoc][D]](https://godoc.org/github.com/arthurkushman/buildsqlx)
- [godbal](https://github.com/xujiajun/godbal) **star:54** Database Abstraction Layer (dbal) for go. Support SQL builder and get result easily.   [![It hasn't been updated in recent three years][Y]](https://github.com/xujiajun/godbal)   [![godoc][D]](https://godoc.org/github.com/xujiajun/godbal)
- [bqb](https://github.com/nullism/bqb) **star:48** Lightweight and easy to learn query builder.   [![godoc][D]](https://godoc.org/github.com/nullism/bqb)
- [gosql](https://github.com/twharmon/gosql) **star:26** SQL Query builder with better null values support.   [![godoc][D]](https://godoc.org/github.com/twharmon/gosql)
- [qry](https://github.com/HnH/qry) **star:23** Tool that generates constants from files with raw SQL queries.   [![godoc][D]](https://godoc.org/github.com/HnH/qry)
- [ormlite](https://github.com/pupizoid/ormlite) **star:4** Lightweight package containing some ORM-like features and helpers for sqlite databases.   [![godoc][D]](https://godoc.org/github.com/pupizoid/ormlite)
- [sg](https://github.com/go-the-way/sg) **star:2** A SQL Gen for generating standard SQLs(supports: CRUD) written in Go.   [![godoc][D]](https://godoc.org/github.com/go-the-way/sg)

**[⬆ back to top](#contents)**

## Database Drivers

### Interfaces to Multiple Backends

- [cayley](https://github.com/google/cayley) **star:14346** Graph database with support for multiple backends.   [![There was an update last month][G]](https://github.com/google/cayley)   [![godoc][D]](https://godoc.org/github.com/google/cayley)
- [gokv](https://github.com/philippgille/gokv) **star:480** Simple key-value store abstraction and implementations for Go (Redis, Consul, etcd, bbolt, BadgerDB, LevelDB, Memcached, DynamoDB, S3, PostgreSQL, MongoDB, CockroachDB and many more).   [![godoc][D]](https://godoc.org/github.com/philippgille/gokv)
- [dsc](https://github.com/viant/dsc) **star:26** Datastore connectivity for SQL, NoSQL, structured files.   [![godoc][D]](https://godoc.org/github.com/viant/dsc)

### Relational Database Drivers

- [go-sql-driver/mysql](https://github.com/go-sql-driver/mysql) **star:12660** MySQL driver for Go.   [![There was an update last month][G]](https://github.com/go-sql-driver/mysql)   [![godoc][D]](https://godoc.org/github.com/go-sql-driver/mysql)
- [pq](https://github.com/lib/pq) **star:7625** Pure Go Postgres driver for database/sql.   [![godoc][D]](https://godoc.org/github.com/lib/pq)
- [pgx](https://github.com/jackc/pgx) **star:6066** PostgreSQL driver supporting features beyond those exposed by database/sql.   [![There was an update last month][G]](https://github.com/jackc/pgx)   [![godoc][D]](https://godoc.org/github.com/jackc/pgx)
- [go-sqlite3](https://github.com/mattn/go-sqlite3) **star:6057** SQLite3 driver for go that uses database/sql.   [![There was an update last month][G]](https://github.com/mattn/go-sqlite3)
- [go-mssqldb](https://github.com/denisenkom/go-mssqldb) **star:1644** Microsoft MSSQL driver for Go.   [![There was an update last month][G]](https://github.com/denisenkom/go-mssqldb)   [![godoc][D]](https://godoc.org/github.com/denisenkom/go-mssqldb)
- [go-oci8](https://github.com/mattn/go-oci8) **star:595** Oracle driver for go that uses database/sql.   [![godoc][D]](https://godoc.org/github.com/mattn/go-oci8)
- [sqlhooks](https://github.com/qustavo/sqlhooks) **star:584** Attach hooks to any database/sql driver.   [![godoc][D]](https://godoc.org/github.com/qustavo/sqlhooks)
- [godror](https://github.com/godror/godror) **star:393** Oracle driver for Go, using the ODPI-C driver.
- [Kivik](https://github.com/go-kivik/kivik) **star:243** Kivik provides a common Go and GopherJS client library for CouchDB, PouchDB, and similar databases.   [![godoc][D]](https://godoc.org/github.com/go-kivik/kivik)
- [KSQL](https://github.com/VinGarcia/ksql) **star:183** A Simple and Powerful Golang SQL Library   [![There was an update last month][G]](https://github.com/VinGarcia/ksql)   [![godoc][D]](https://godoc.org/github.com/VinGarcia/ksql)
- [firebirdsql](https://github.com/nakagami/firebirdsql) **star:179** Firebird RDBMS SQL driver for Go.   [![godoc][D]](https://godoc.org/github.com/nakagami/firebirdsql)
- [go-adodb](https://github.com/mattn/go-adodb) **star:130** Microsoft ActiveX Object DataBase driver for go that uses database/sql.   [![godoc][D]](https://godoc.org/github.com/mattn/go-adodb)
- [Sqinn-Go](https://github.com/cvilsmeier/sqinn-go) **star:126** SQLite with pure Go.   [![godoc][D]](https://godoc.org/github.com/cvilsmeier/sqinn-go)
- [gofreetds](https://github.com/minus5/gofreetds) **star:107** Microsoft MSSQL driver. Go wrapper over [FreeTDS](https://www.freetds.org).   [![godoc][D]](https://godoc.org/github.com/minus5/gofreetds)
- [avatica](https://github.com/apache/calcite-avatica-go) **star:103** Apache Avatica/Phoenix SQL driver for database/sql.   [![godoc][D]](https://godoc.org/github.com/apache/calcite-avatica-go)
- [ydb-go-sdk](https://github.com/ydb-platform/ydb-go-sdk) **star:62** native and database/sql driver YDB (Yandex Database)   [![There was an update last month][G]](https://github.com/ydb-platform/ydb-go-sdk)   [![godoc][D]](https://godoc.org/github.com/ydb-platform/ydb-go-sdk)
- [bgc](https://github.com/viant/bgc) **star:17** Datastore Connectivity for BigQuery for go.   [![godoc][D]](https://godoc.org/github.com/viant/bgc)
- [pig](https://github.com/alexeyco/pig) **star:10** Simple [pgx](https://github.com/jackc/pgx) wrapper to execute and [scan](https://github.com/georgysavva/scany) query results easily.   [![godoc][D]](https://godoc.org/github.com/alexeyco/pig)

### NoSQL Database Drivers

- [redis](https://github.com/go-redis/redis) **star:15519** Redis client for Golang.   [![There was an update last month][G]](https://github.com/go-redis/redis)   [![godoc][D]](https://godoc.org/github.com/go-redis/redis)
- [rueidis](http://github.com/rueian/rueidis)  Fast Redis RESP3 client with auto pipelining and server-assisted client side caching.
- [redigo](https://github.com/gomodule/redigo) **star:9298** Redigo is a Go client for the Redis database.   [![godoc][D]](https://godoc.org/github.com/gomodule/redigo)
- [mongo-go-driver](https://github.com/mongodb/mongo-go-driver) **star:6952** Official MongoDB driver for the Go language.   [![There was an update last month][G]](https://github.com/mongodb/mongo-go-driver)   [![godoc][D]](https://godoc.org/github.com/mongodb/mongo-go-driver)
- [mgo](https://github.com/globalsign/mgo) **star:1953** (unmaintained) MongoDB driver for the Go language that implements a rich and well tested selection of features under a very simple API following standard Go idioms.   [![godoc][D]](https://godoc.org/github.com/globalsign/mgo)
- [gorethink](https://github.com/dancannon/gorethink) **star:1606** Go language driver for RethinkDB.   [![godoc][D]](https://godoc.org/github.com/dancannon/gorethink)
- [qmgo](https://github.com/qiniu/qmgo) **star:973** The MongoDB driver for Go. It‘s based on official MongoDB driver but easier to use like Mgo.   [![There was an update last month][G]](https://github.com/qiniu/qmgo)   [![godoc][D]](https://godoc.org/github.com/qiniu/qmgo)   [![Contains Chinese documents][CN]](https://github.com/qiniu/qmgo)
- [mgm](https://github.com/kamva/mgm) **star:568** MongoDB model-based ODM for Go (based on official MongoDB driver).   [![godoc][D]](https://godoc.org/github.com/kamva/mgm)
- [redeo](https://github.com/bsm/redeo) **star:419** Redis-protocol compatible TCP servers/services.   [![godoc][D]](https://godoc.org/github.com/bsm/redeo)
- [aerospike-client-go](https://github.com/aerospike/aerospike-client-go) **star:397** Aerospike client in Go language.   [![godoc][D]](https://godoc.org/github.com/aerospike/aerospike-client-go)
- [neoism](https://github.com/jmcvetta/neoism) **star:388** Neo4j client for Golang.   [![godoc][D]](https://godoc.org/github.com/jmcvetta/neoism)
- [gocb](https://github.com/couchbase/gocb) **star:339** Official Couchbase Go SDK.   [![There was an update last month][G]](https://github.com/couchbase/gocb)   [![godoc][D]](https://godoc.org/github.com/couchbase/gocb)
- [go-couchbase](https://github.com/couchbase/go-couchbase) **star:317** Couchbase client in Go.   [![godoc][D]](https://godoc.org/github.com/couchbase/go-couchbase)
- [go-rejson](https://github.com/nitishm/go-rejson) **star:285** Golang client for redislabs' ReJSON module using Redigo golang client. Store and manipulate structs as JSON objects in redis with ease.   [![godoc][D]](https://godoc.org/github.com/nitishm/go-rejson)
- [godis](https://github.com/piaohao/godis) **star:106** redis client implement by golang, inspired by jedis.   [![godoc][D]](https://godoc.org/github.com/piaohao/godis)
- [Neo4j-GO](https://github.com/davemeehan/Neo4j-GO) **star:77** Neo4j REST Client in golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/davemeehan/Neo4j-GO)   [![godoc][D]](https://godoc.org/github.com/davemeehan/Neo4j-GO)
- [arangolite](https://github.com/solher/arangolite) **star:73** Lightweight golang driver for ArangoDB.   [![godoc][D]](https://godoc.org/github.com/solher/arangolite)
- [go-pilosa](https://github.com/pilosa/go-pilosa) **star:56** Go client library for Pilosa.   [![godoc][D]](https://godoc.org/github.com/pilosa/go-pilosa)   [![Archived][Archived]](https://github.com/pilosa/go-pilosa)
- [forestdb](https://github.com/couchbase/goforestdb) **star:33** Go bindings for ForestDB.   [![It hasn't been updated in recent three years][Y]](https://github.com/couchbase/goforestdb)   [![godoc][D]](https://godoc.org/github.com/couchbase/goforestdb)
- [goriak](https://github.com/zegl/goriak) **star:28** Go language driver for Riak KV.   [![godoc][D]](https://godoc.org/github.com/zegl/goriak)
- [neo4j](https://github.com/cihangir/neo4j) **star:28** Neo4j Rest API Bindings for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/cihangir/neo4j)   [![godoc][D]](https://godoc.org/github.com/cihangir/neo4j)
- [xredis](https://github.com/shomali11/xredis) **star:19** Typesafe, customizable, clean & easy to use Redis client.   [![It hasn't been updated in recent three years][Y]](https://github.com/shomali11/xredis)   [![godoc][D]](https://godoc.org/github.com/shomali11/xredis)
- [gocosmos](https://github.com/btnguyen2k/gocosmos) **star:11** REST client and standard `database/sql` driver for Azure Cosmos DB.   [![godoc][D]](https://godoc.org/github.com/btnguyen2k/gocosmos)
- [gocql](https://gocql.github.io)  Go language driver for Apache Cassandra.
- [godscache](https://github.com/defcronyke/godscache) **star:11** A wrapper for the Google Cloud Platform Go Datastore package that adds caching using memcached.   [![It hasn't been updated in recent three years][Y]](https://github.com/defcronyke/godscache)   [![godoc][D]](https://godoc.org/github.com/defcronyke/godscache)
- [gomemcache](https://github.com/bradfitz/gomemcache/)  memcache client library for the Go programming language.
- [asc](https://github.com/viant/asc) **star:9** Datastore Connectivity for Aerospike for go.   [![It hasn't been updated in recent three years][Y]](https://github.com/viant/asc)   [![godoc][D]](https://godoc.org/github.com/viant/asc)

### Search and Analytic Databases

- [elastic](https://github.com/olivere/elastic) **star:7009** Elasticsearch client for Go.   [![There was an update last month][G]](https://github.com/olivere/elastic)   [![godoc][D]](https://godoc.org/github.com/olivere/elastic)
- [go-elasticsearch](https://github.com/elastic/go-elasticsearch) **star:4423** Official Elasticsearch client for Go.   [![godoc][D]](https://godoc.org/github.com/elastic/go-elasticsearch)
- [elasticsql](https://github.com/cch123/elasticsql) **star:964** Convert sql to elasticsearch dsl in Go.   [![godoc][D]](https://godoc.org/github.com/cch123/elasticsql)
- [elastigo](https://github.com/mattbaird/elastigo) **star:948** Elasticsearch client library.   [![It hasn't been updated in recent three years][Y]](https://github.com/mattbaird/elastigo)   [![godoc][D]](https://godoc.org/github.com/mattbaird/elastigo)
- [skizze](https://github.com/seiflotfy/skizze) **star:88** probabilistic data-structures service and storage.   [![It hasn't been updated in recent three years][Y]](https://github.com/seiflotfy/skizze)   [![godoc][D]](https://godoc.org/github.com/seiflotfy/skizze)
- [goes](https://github.com/OwnLocal/goes) **star:29** Library to interact with Elasticsearch.   [![godoc][D]](https://godoc.org/github.com/OwnLocal/goes)

**[⬆ back to top](#contents)**

## Date and Time

_Libraries for working with dates and times._

- [now](https://github.com/jinzhu/now) **star:3832** Now is a time toolkit for golang.   [![godoc][D]](https://godoc.org/github.com/jinzhu/now)
- [carbon](https://github.com/golang-module/carbon) **star:2319** A simple, semantic and developer-friendly golang package for datetime.   [![godoc][D]](https://godoc.org/github.com/golang-module/carbon)
- [dateparse](https://github.com/araddon/dateparse) **star:1788** Parse date's without knowing format in advance.   [![godoc][D]](https://godoc.org/github.com/araddon/dateparse)
- [carbon](https://github.com/uniplaces/carbon) **star:728** Simple Time extension with a lot of util methods, ported from PHP Carbon library.   [![godoc][D]](https://godoc.org/github.com/uniplaces/carbon)
- [durafmt](https://github.com/hako/durafmt) **star:448** Time duration formatting library for Go.   [![godoc][D]](https://godoc.org/github.com/hako/durafmt)
- [timeutil](https://github.com/leekchan/timeutil) **star:189** Useful extensions (Timedelta, Strftime, ...) to the golang's time package.   [![It hasn't been updated in recent three years][Y]](https://github.com/leekchan/timeutil)   [![godoc][D]](https://godoc.org/github.com/leekchan/timeutil)
- [gostradamus](https://github.com/bykof/gostradamus) **star:171** A Go package for working with dates.   [![godoc][D]](https://godoc.org/github.com/bykof/gostradamus)
- [go-persian-calendar](https://github.com/yaa110/go-persian-calendar) **star:129** The implementation of the Persian (Solar Hijri) Calendar in Go (golang).   [![godoc][D]](https://godoc.org/github.com/yaa110/go-persian-calendar)
- [iso8601](https://github.com/relvacode/iso8601) **star:108** Efficiently parse ISO8601 date-times without regex.   [![godoc][D]](https://godoc.org/github.com/relvacode/iso8601)
- [date](https://github.com/rickb777/date) **star:96** Augments Time for working with dates, date ranges, time spans, periods, and time-of-day.   [![godoc][D]](https://godoc.org/github.com/rickb777/date)
- [timespan](https://github.com/SaidinWoT/timespan) **star:82** For interacting with intervals of time, defined as a start time and a duration.   [![It hasn't been updated in recent three years][Y]](https://github.com/SaidinWoT/timespan)   [![godoc][D]](https://godoc.org/github.com/SaidinWoT/timespan)
- [go-sunrise](https://github.com/nathan-osman/go-sunrise) **star:59** Calculate the sunrise and sunset times for a given location.   [![godoc][D]](https://godoc.org/github.com/nathan-osman/go-sunrise)
- [go-str2duration](https://github.com/xhit/go-str2duration) **star:50** Convert string to duration. Support time.Duration returned string and more.   [![godoc][D]](https://godoc.org/github.com/xhit/go-str2duration)
- [feiertage](https://github.com/wlbr/feiertage) **star:43** Set of functions to calculate public holidays in Germany, incl. specialization on the states of Germany (Bundesländer). Things like Easter, Pentecost, Thanksgiving...   [![godoc][D]](https://godoc.org/github.com/wlbr/feiertage)
- [kair](https://github.com/GuilhermeCaruso/kair) **star:24** Date and Time - Golang Formatting Library.   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/kair)
- [cronrange](https://github.com/1set/cronrange) **star:18** Parses Cron-style time range expressions, checks if the given time is within any ranges.   [![godoc][D]](https://godoc.org/github.com/1set/cronrange)
- [NullTime](https://github.com/kirillDanshin/nulltime) **star:13** Nullable `time.Time`.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/nulltime)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/nulltime)
- [tuesday](https://github.com/osteele/tuesday) **star:12** Ruby-compatible Strftime function.   [![godoc][D]](https://godoc.org/github.com/osteele/tuesday)
- [strftime](https://github.com/awoodbeck/strftime) **star:11** C99-compatible strftime formatter.   [![It hasn't been updated in recent three years][Y]](https://github.com/awoodbeck/strftime)   [![godoc][D]](https://godoc.org/github.com/awoodbeck/strftime)
- [go-week](https://github.com/stoewer/go-week) **star:8** An efficient package to work with ISO8601 week dates.   [![godoc][D]](https://godoc.org/github.com/stoewer/go-week)

**[⬆ back to top](#contents)**

## Distributed Systems

_Packages that help with building Distributed Systems._

- [go-kit](https://github.com/go-kit/kit) **star:23942** Microservice toolkit with support for service discovery, load balancing, pluggable transports, request tracking, etc.   [![godoc][D]](https://godoc.org/github.com/go-kit/kit)
- [go-zero](https://github.com/tal-tech/go-zero) **star:20789** A web and rpc framework. It's born to ensure the stability of the busy sites with resilient design. Builtin goctl greatly improves the development productivity.   [![There was an update last month][G]](https://github.com/tal-tech/go-zero)   [![godoc][D]](https://godoc.org/github.com/tal-tech/go-zero)
- [go-micro](https://github.com/micro/go-micro) **star:19403** A distributed systems development framework.   [![There was an update last month][G]](https://github.com/micro/go-micro)   [![godoc][D]](https://godoc.org/github.com/micro/go-micro)
- [Kratos](https://github.com/go-kratos/kratos) **star:18957** A modular-designed and easy-to-use microservices framework in Go.   [![There was an update last month][G]](https://github.com/go-kratos/kratos)   [![godoc][D]](https://godoc.org/github.com/go-kratos/kratos)   [![Contains Chinese documents][CN]](https://github.com/go-kratos/kratos)
- [grpc-go](https://github.com/grpc/grpc-go) **star:16862** The Go language implementation of gRPC. HTTP/2 based RPC.   [![There was an update last month][G]](https://github.com/grpc/grpc-go)   [![godoc][D]](https://godoc.org/github.com/grpc/grpc-go)
- [NATS](https://github.com/nats-io/gnatsd) **star:11624** Lightweight, high performance messaging system for microservices, IoT, and cloud native systems.   [![There was an update last month][G]](https://github.com/nats-io/gnatsd)   [![godoc][D]](https://godoc.org/github.com/nats-io/gnatsd)
- [micro](https://github.com/micro/micro) **star:11408** A distributed systems runtime for the cloud and beyond.   [![There was an update last month][G]](https://github.com/micro/micro)   [![godoc][D]](https://godoc.org/github.com/micro/micro)
- [rpcx](https://github.com/smallnest/rpcx) **star:7242** Distributed pluggable RPC service framework like alibaba Dubbo.   [![godoc][D]](https://godoc.org/github.com/smallnest/rpcx)
- [raft](https://github.com/hashicorp/raft) **star:6416** Golang implementation of the Raft consensus protocol, by HashiCorp.   [![There was an update last month][G]](https://github.com/hashicorp/raft)   [![godoc][D]](https://godoc.org/github.com/hashicorp/raft)
- [raft](https://github.com/coreos/etcd/tree/master/raft)  Go implementation of the Raft consensus protocol, by CoreOS.
- [lura](https://github.com/luraproject/lura) **star:5249** Ultra performant API Gateway framework with middlewares.   [![There was an update last month][G]](https://github.com/luraproject/lura)   [![godoc][D]](https://godoc.org/github.com/luraproject/lura)
- [torrent](https://github.com/anacrolix/torrent) **star:4515** BitTorrent client package.   [![There was an update last month][G]](https://github.com/anacrolix/torrent)   [![godoc][D]](https://godoc.org/github.com/anacrolix/torrent)
- [dragonboat](https://github.com/lni/dragonboat) **star:4393** A feature complete and high performance multi-group Raft library in Go.   [![godoc][D]](https://godoc.org/github.com/lni/dragonboat)   [![Contains Chinese documents][CN]](https://github.com/lni/dragonboat)
- [emitter-io](https://github.com/emitter-io/emitter) **star:3365** High performance, distributed, secure and low latency publish-subscribe platform built with MQTT, Websockets and love.   [![godoc][D]](https://godoc.org/github.com/emitter-io/emitter)
- [gleam](https://github.com/chrislusf/gleam) **star:3124** Fast and scalable distributed map/reduce system written in pure Go and Luajit, combining Go's high concurrency with Luajit's high performance, runs standalone or distributed.   [![godoc][D]](https://godoc.org/github.com/chrislusf/gleam)
- [glow](https://github.com/chrislusf/glow) **star:3089** Easy-to-Use scalable distributed big data processing, Map-Reduce, DAG execution, all in pure Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/chrislusf/glow)   [![godoc][D]](https://godoc.org/github.com/chrislusf/glow)
- [liftbridge](https://github.com/liftbridge-io/liftbridge) **star:2359** Lightweight, fault-tolerant message streams for NATS.   [![godoc][D]](https://godoc.org/github.com/liftbridge-io/liftbridge)
- [hprose](https://github.com/hprose/hprose-golang) **star:1218** Very newbility RPC Library, support 25+ languages now.   [![godoc][D]](https://godoc.org/github.com/hprose/hprose-golang)   [![Contains Chinese documents][CN]](https://github.com/hprose/hprose-golang)
- [go-doudou](https://github.com/unionj-cloud/go-doudou) **star:860** A gossip protocol and OpenAPI 3.0 spec based decentralized microservice framework. Built-in go-doudou cli focusing on low-code and rapid dev can power up your productivity.   [![There was an update last month][G]](https://github.com/unionj-cloud/go-doudou)   [![godoc][D]](https://godoc.org/github.com/unionj-cloud/go-doudou)   [![Contains Chinese documents][CN]](https://github.com/unionj-cloud/go-doudou)
- [redis-lock](https://github.com/bsm/redislock) **star:819** Simplified distributed locking implementation using Redis.   [![godoc][D]](https://godoc.org/github.com/bsm/redislock)
- [resgate](https://resgate.io/)  Realtime API Gateway for building REST, real time, and RPC APIs, where all clients are synchronized seamlessly.
- [rain](https://github.com/cenkalti/rain) **star:773** BitTorrent client and library.   [![There was an update last month][G]](https://github.com/cenkalti/rain)   [![godoc][D]](https://godoc.org/github.com/cenkalti/rain)
- [ringpop-go](https://github.com/uber/ringpop-go) **star:752** Scalable, fault-tolerant application-layer sharding for Go applications.   [![godoc][D]](https://godoc.org/github.com/uber/ringpop-go)
- [gorpc](https://github.com/valyala/gorpc) **star:660** Simple, fast and scalable RPC library for high load.   [![It hasn't been updated in recent three years][Y]](https://github.com/valyala/gorpc)   [![godoc][D]](https://godoc.org/github.com/valyala/gorpc)
- [go-health](https://github.com/InVisionApp/go-health) **star:637** Library for enabling asynchronous dependency health checks in your service.   [![godoc][D]](https://godoc.org/github.com/InVisionApp/go-health)
- [arpc](https://github.com/lesismal/arpc) **star:610** More effective network communication, support two-way-calling, notify, broadcast.   [![godoc][D]](https://godoc.org/github.com/lesismal/arpc)
- [consistent](https://github.com/buraksezer/consistent) **star:517** Consistent hashing with bounded loads.   [![godoc][D]](https://godoc.org/github.com/buraksezer/consistent)
- [go-sundheit](https://github.com/AppsFlyer/go-sundheit) **star:498** A library built to provide support for defining async service health checks for golang services.   [![godoc][D]](https://godoc.org/github.com/AppsFlyer/go-sundheit)
- [digota](https://github.com/digota/digota) **star:464** grpc ecommerce microservice.   [![godoc][D]](https://godoc.org/github.com/digota/digota)
- [dot](https://github.com/dotchain/dot/)  distributed sync using operational transformation/OT.
- [sleuth](https://github.com/ursiform/sleuth) **star:358** Library for master-less p2p auto-discovery and RPC between HTTP services (using [ZeroMQ](https://github.com/zeromq/libzmq)).   [![It hasn't been updated in recent three years][Y]](https://github.com/ursiform/sleuth)   [![godoc][D]](https://godoc.org/github.com/ursiform/sleuth)
- [go-jump](https://github.com/dgryski/go-jump) **star:351** Port of Google's "Jump" Consistent Hash function.   [![godoc][D]](https://godoc.org/github.com/dgryski/go-jump)
- [dht](https://github.com/anacrolix/dht) **star:247** BitTorrent Kademlia DHT implementation.   [![godoc][D]](https://godoc.org/github.com/anacrolix/dht)
- [jsonrpc](https://github.com/ybbus/jsonrpc) **star:247** JSON-RPC 2.0 HTTP client implementation.   [![godoc][D]](https://godoc.org/github.com/ybbus/jsonrpc)
- [jsonrpc](https://github.com/osamingo/jsonrpc) **star:169** The jsonrpc package helps implement of JSON-RPC 2.0.   [![godoc][D]](https://godoc.org/github.com/osamingo/jsonrpc)
- [outboxer](https://github.com/italolelis/outboxer) **star:89** Outboxer is a go library that implements the outbox pattern.   [![There was an update last month][G]](https://github.com/italolelis/outboxer)   [![godoc][D]](https://godoc.org/github.com/italolelis/outboxer)
- [pglock](https://cirello.io/pglock)  PostgreSQL-backed distributed locking implementation.
- [pjrpc](https://gitlab.com/pjrpc/pjrpc)  Golang JSON-RPC Server-Client with Protobuf spec.
- [doublejump](https://github.com/edwingeng/doublejump) **star:79** A revamped Google's jump consistent hash.   [![godoc][D]](https://godoc.org/github.com/edwingeng/doublejump)
- [Semaphore](https://github.com/jexia/semaphore) **star:77** A straightforward (micro) service orchestrator.   [![godoc][D]](https://godoc.org/github.com/jexia/semaphore)
- [celeriac](https://github.com/svcavallar/celeriac.v1) **star:74** Library for adding support for interacting and monitoring Celery workers, tasks and events in Go.   [![godoc][D]](https://godoc.org/github.com/svcavallar/celeriac.v1)
- [flowgraph](https://github.com/vectaport/flowgraph) **star:53** flow-based programming package.   [![godoc][D]](https://godoc.org/github.com/vectaport/flowgraph)
- [go-mysql-lock](https://github.com/sanketplus/go-mysql-lock) **star:49** MySQL based distributed lock.   [![godoc][D]](https://godoc.org/github.com/sanketplus/go-mysql-lock)
- [drmaa](https://github.com/dgruber/drmaa) **star:42** Job submission library for cluster schedulers based on the DRMAA standard.   [![godoc][D]](https://godoc.org/github.com/dgruber/drmaa)
- [dynamolock](https://cirello.io/dynamolock)  DynamoDB-backed distributed locking implementation.
- [go-pdu](https://github.com/pdupub/go-pdu) **star:41** A decentralized identity-based social network.   [![There was an update last month][G]](https://github.com/pdupub/go-pdu)   [![godoc][D]](https://godoc.org/github.com/pdupub/go-pdu)
- [gmsec](https://github.com/gmsec/micro) **star:23** A Go distributed systems development framework.   [![godoc][D]](https://godoc.org/github.com/gmsec/micro)
- [dynatomic](https://github.com/tylfin/dynatomic) **star:15** A library for using DynamoDB as an atomic counter.   [![godoc][D]](https://godoc.org/github.com/tylfin/dynatomic)
- [consistenthash](https://github.com/mbrostami/consistenthash) **star:14** Consistent hashing with configurable replicas.   [![godoc][D]](https://godoc.org/github.com/mbrostami/consistenthash)
- [failured](https://github.com/andy2046/failured) **star:7** adaptive accrual failure detector for distributed systems.   [![godoc][D]](https://godoc.org/github.com/andy2046/failured)

**[⬆ back to top](#contents)**

## Dynamic DNS

_Tools for updating dynamic DNS records._

- [GoDNS](https://github.com/timothyye/godns) **star:1164** A dynamic DNS client tool, supports DNSPod & HE.net, written in Go.   [![There was an update last month][G]](https://github.com/timothyye/godns)   [![godoc][D]](https://godoc.org/github.com/timothyye/godns)
- [DDNS](https://github.com/skibish/ddns) **star:218** Personal DDNS client with Digital Ocean Networking DNS as backend.   [![godoc][D]](https://godoc.org/github.com/skibish/ddns)
- [dyndns](https://gitlab.com/alcastle/dyndns)  Background Go process to regularly and automatically check your IP Address and make updates to (one or many) Dynamic DNS records for Google domains whenever your address changes.

**[⬆ back to top](#contents)**

## Email

_Libraries and tools that implement email creation and sending._

- [MailHog](https://github.com/mailhog/MailHog) **star:10877** Email and SMTP testing with web and API interface.   [![godoc][D]](https://godoc.org/github.com/mailhog/MailHog)
- [hermes](https://github.com/matcornic/hermes) **star:2534** Golang package that generates clean, responsive HTML e-mails.   [![godoc][D]](https://godoc.org/github.com/matcornic/hermes)
- [email](https://github.com/jordan-wright/email) **star:2156** A robust and flexible email library for Go.   [![There was an update last month][G]](https://github.com/jordan-wright/email)   [![godoc][D]](https://godoc.org/github.com/jordan-wright/email)
- [go-imap](https://github.com/emersion/go-imap) **star:1621** IMAP library for clients and servers.   [![There was an update last month][G]](https://github.com/emersion/go-imap)   [![godoc][D]](https://godoc.org/github.com/emersion/go-imap)
- [chasquid](https://blitiri.com.ar/p/chasquid)  SMTP server written in Go.
- [SendGrid](https://github.com/sendgrid/sendgrid-go) **star:850** SendGrid's Go library for sending email.   [![godoc][D]](https://godoc.org/github.com/sendgrid/sendgrid-go)
- [mailgun-go](https://github.com/mailgun/mailgun-go) **star:623** Go library for sending mail with the Mailgun API.   [![There was an update last month][G]](https://github.com/mailgun/mailgun-go)   [![godoc][D]](https://godoc.org/github.com/mailgun/mailgun-go)
- [email-verifier](https://github.com/AfterShip/email-verifier) **star:521** A Go library for email verification without sending any emails.   [![godoc][D]](https://godoc.org/github.com/AfterShip/email-verifier)
- [go-simple-mail](https://github.com/xhit/go-simple-mail) **star:387** Very simple package to send emails with SMTP Keep Alive and two timeouts: Connect and Send.   [![godoc][D]](https://godoc.org/github.com/xhit/go-simple-mail)
- [go-message](https://github.com/emersion/go-message) **star:272** Streaming library for the Internet Message Format and mail messages.   [![godoc][D]](https://godoc.org/github.com/emersion/go-message)
- [douceur](https://github.com/aymerick/douceur) **star:221** CSS inliner for your HTML emails.   [![godoc][D]](https://godoc.org/github.com/aymerick/douceur)
- [Hectane](https://github.com/hectane/hectane) **star:221** Lightweight SMTP client providing an HTTP API.   [![godoc][D]](https://godoc.org/github.com/hectane/hectane)
- [mailchain](https://github.com/mailchain/mailchain) **star:128** Send encrypted emails to blockchain addresses written in Go.
- [go-premailer](https://github.com/vanng822/go-premailer) **star:93** Inline styling for HTML mail in Go.   [![There was an update last month][G]](https://github.com/vanng822/go-premailer)   [![godoc][D]](https://godoc.org/github.com/vanng822/go-premailer)
- [go-dkim](https://github.com/toorop/go-dkim) **star:82** DKIM library, to sign & verify email.   [![godoc][D]](https://godoc.org/github.com/toorop/go-dkim)
- [go-mail](https://github.com/wneessen/go-mail) **star:82** A simple Go library for sending mails in Go.   [![There was an update last month][G]](https://github.com/wneessen/go-mail)   [![godoc][D]](https://godoc.org/github.com/wneessen/go-mail)
- [smtp](https://github.com/mailhog/smtp) **star:73** SMTP server protocol state machine.   [![godoc][D]](https://godoc.org/github.com/mailhog/smtp)
- [smtpmock](https://github.com/mocktools/go-smtp-mock) **star:54** Lightweight configurable multithreaded fake SMTP server. Mimic any SMTP behaviour for your test environment.   [![godoc][D]](https://godoc.org/github.com/mocktools/go-smtp-mock)
- [go-email-normalizer](https://github.com/dimuska139/go-email-normalizer) **star:52** Golang library for providing a canonical representation of email address.   [![godoc][D]](https://godoc.org/github.com/dimuska139/go-email-normalizer)
- [go-email-validator](https://github.com/go-email-validator/go-email-validator) **star:40** Modular email validator for syntax, disposable, smtp, etc... checking.   [![godoc][D]](https://godoc.org/github.com/go-email-validator/go-email-validator)
- [truemail-go](https://github.com/truemail-rb/truemail-go) **star:21** Configurable Golang email validator/verifier. Verify email via Regex, DNS, SMTP and even more.   [![godoc][D]](https://godoc.org/github.com/truemail-rb/truemail-go)
- [mailx](https://github.com/valord577/mailx) **star:5** Mailx is a library that makes it easier to send email via SMTP. It is an enhancement of the golang standard library `net/smtp`.   [![godoc][D]](https://godoc.org/github.com/valord577/mailx)

**[⬆ back to top](#contents)**

## Embeddable Scripting Languages

_Embedding other languages inside your go code._

- [gopher-lua](https://github.com/yuin/gopher-lua) **star:5031** Lua 5.1 VM and compiler written in Go.   [![godoc][D]](https://godoc.org/github.com/yuin/gopher-lua)
- [goja](https://github.com/dop251/goja) **star:3276** ECMAScript 5.1(+) implementation in Go.   [![There was an update last month][G]](https://github.com/dop251/goja)   [![godoc][D]](https://godoc.org/github.com/dop251/goja)
- [tengo](https://github.com/d5/tengo) **star:2896** Bytecode compiled script language for Go.   [![There was an update last month][G]](https://github.com/d5/tengo)   [![godoc][D]](https://godoc.org/github.com/d5/tengo)
- [expr](https://github.com/antonmedv/expr) **star:2853** Expression evaluation engine for Go: fast, non-Turing complete, dynamic typing, static typing.   [![There was an update last month][G]](https://github.com/antonmedv/expr)   [![godoc][D]](https://godoc.org/github.com/antonmedv/expr)
- [go-lua](https://github.com/Shopify/go-lua) **star:2510** Port of the Lua 5.2 VM to pure Go.   [![There was an update last month][G]](https://github.com/Shopify/go-lua)   [![godoc][D]](https://godoc.org/github.com/Shopify/go-lua)
- [go-python](https://github.com/sbinet/go-python) **star:1424** naive go bindings to the CPython C-API.   [![godoc][D]](https://godoc.org/github.com/sbinet/go-python)
- [cel-go](https://github.com/google/cel-go) **star:1336** Fast, portable, non-Turing complete expression evaluation with gradual typing.   [![There was an update last month][G]](https://github.com/google/cel-go)   [![godoc][D]](https://godoc.org/github.com/google/cel-go)
- [anko](https://github.com/mattn/anko) **star:1288** Scriptable interpreter written in Go.   [![godoc][D]](https://godoc.org/github.com/mattn/anko)
- [metacall](https://github.com/metacall/core) **star:1085** Cross-platform Polyglot Runtime which supports NodeJS, JavaScript, TypeScript, Python, Ruby, C#, WebAssembly, Java, Cobol and more.   [![There was an update last month][G]](https://github.com/metacall/core)
- [go-php](https://github.com/deuill/go-php) **star:872** PHP bindings for Go.   [![godoc][D]](https://godoc.org/github.com/deuill/go-php)
- [go-duktape](https://github.com/olebedev/go-duktape) **star:781** Duktape JavaScript engine bindings for Go.   [![godoc][D]](https://godoc.org/github.com/olebedev/go-duktape)   [![Archived][Archived]](https://github.com/olebedev/go-duktape)
- [golua](https://github.com/aarzilli/golua) **star:593** Go bindings for Lua C API.
- [gval](https://github.com/PaesslerAG/gval) **star:533** A highly customizable expression language written in Go.   [![godoc][D]](https://godoc.org/github.com/PaesslerAG/gval)
- [gisp](https://github.com/jcla1/gisp) **star:492** Simple LISP in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/jcla1/gisp)   [![godoc][D]](https://godoc.org/github.com/jcla1/gisp)
- [prolog](https://github.com/ichiban/prolog) **star:432** Embeddable Prolog.   [![godoc][D]](https://godoc.org/github.com/ichiban/prolog)
- [gentee](https://github.com/gentee/gentee) **star:99** Embeddable scripting programming language.   [![godoc][D]](https://godoc.org/github.com/gentee/gentee)
- [binder](https://github.com/alexeyco/binder) **star:63** Go to Lua binding library, based on [gopher-lua](https://github.com/yuin/gopher-lua).   [![godoc][D]](https://godoc.org/github.com/alexeyco/binder)
- [purl](https://github.com/ian-kent/purl) **star:35** Perl 5.18.2 embedded in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/purl)   [![godoc][D]](https://godoc.org/github.com/ian-kent/purl)
- [ecal](https://github.com/krotik/ecal) **star:27** A simple embeddable scripting language which supports concurrent event processing.   [![godoc][D]](https://godoc.org/github.com/krotik/ecal)
- [ngaro](https://github.com/db47h/ngaro) **star:23** Embeddable Ngaro VM implementation enabling scripting in Retro.   [![It hasn't been updated in recent three years][Y]](https://github.com/db47h/ngaro)   [![godoc][D]](https://godoc.org/github.com/db47h/ngaro)

**[⬆ back to top](#contents)**

## Error Handling

_Libraries for handling errors._

- [errors](https://github.com/pkg/errors) **star:7906** Package that provides simple error handling primitives.   [![godoc][D]](https://godoc.org/github.com/pkg/errors)   [![Archived][Archived]](https://github.com/pkg/errors)
- [go-multierror](https://github.com/hashicorp/go-multierror) **star:1703** Go (golang) package for representing a list of errors as a single error.   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-multierror)
- [errors](https://github.com/cockroachdb/errors) **star:1441** Go error library with error portability over the network.   [![godoc][D]](https://godoc.org/github.com/cockroachdb/errors)
- [eris](https://github.com/rotisserie/eris) **star:1116** A better way to handle, trace, and log errors in Go. Compatible with the standard error library and github.com/pkg/errors.   [![godoc][D]](https://godoc.org/github.com/rotisserie/eris)
- [errorx](https://github.com/joomcode/errorx) **star:895** A feature rich error package with stack traces, composition of errors and more.   [![godoc][D]](https://godoc.org/github.com/joomcode/errorx)
- [tracerr](https://github.com/ztrue/tracerr) **star:741** Golang errors with stack trace and source fragments.   [![It hasn't been updated in recent three years][Y]](https://github.com/ztrue/tracerr)   [![godoc][D]](https://godoc.org/github.com/ztrue/tracerr)
- [errlog](https://github.com/snwfdhmp/errlog) **star:410** Hackable package that determines responsible source code for an error (and some other fast-debugging features). Pluggable to any logger in-place.   [![godoc][D]](https://godoc.org/github.com/snwfdhmp/errlog)
- [emperror](https://github.com/emperror/emperror) **star:264** Error handling tools and best practices for Go libraries and applications.   [![godoc][D]](https://godoc.org/github.com/emperror/emperror)
- [errors](https://github.com/emperror/errors) **star:161** Drop-in replacement for the standard library errors package and github.com/pkg/errors. Provides various error handling primitives.   [![godoc][D]](https://godoc.org/github.com/emperror/errors)
- [errors](https://github.com/bnkamalesh/errors) **star:45** Drop-in replacement for builtin Go errors. This is a minimal error handling package with custom error types, user friendly messages, Unwrap & Is. With very easy to use and straightforward helper functions.   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/errors)
- [exception](https://github.com/rbrahul/exception) **star:18** A simple utility package for exception handling with try-catch in Golang.   [![godoc][D]](https://godoc.org/github.com/rbrahul/exception)
- [Falcon](https://github.com/SonicRoshan/falcon) **star:8** A Simple Yet Highly Powerful Package For Error Handling.   [![It hasn't been updated in recent three years][Y]](https://github.com/SonicRoshan/falcon)   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/falcon)
- [errors](https://github.com/PumpkinSeed/errors) **star:7** The most simple error wrapper with awesome performance and minimal memory overhead.   [![godoc][D]](https://godoc.org/github.com/PumpkinSeed/errors)
- [errors](https://github.com/neuronlabs/errors) **star:4** Simple golang error handling with classification primitives.   [![It hasn't been updated in recent three years][Y]](https://github.com/neuronlabs/errors)   [![godoc][D]](https://godoc.org/github.com/neuronlabs/errors)

**[⬆ back to top](#contents)**

## File Handling

_Libraries for handling files and file systems._

- [afero](https://github.com/spf13/afero) **star:4798** FileSystem Abstraction System for Go.   [![godoc][D]](https://godoc.org/github.com/spf13/afero)
- [pdfcpu](https://github.com/pdfcpu/pdfcpu) **star:3377** PDF processor.   [![There was an update last month][G]](https://github.com/pdfcpu/pdfcpu)   [![godoc][D]](https://godoc.org/github.com/pdfcpu/pdfcpu)
- [gdu](https://github.com/dundee/gdu) **star:2000** Disk usage analyzer with console interface.   [![godoc][D]](https://godoc.org/github.com/dundee/gdu)
- [notify](https://github.com/rjeczalik/notify) **star:760** File system event notification library with simple API, similar to os/signal.   [![godoc][D]](https://godoc.org/github.com/rjeczalik/notify)
- [copy](https://github.com/otiai10/copy) **star:461** Copy directory recursively.   [![godoc][D]](https://godoc.org/github.com/otiai10/copy)
- [bigfile](https://github.com/bigfile/bigfile) **star:230** A file transfer system, support to manage files with http api, rpc call and ftp client.   [![godoc][D]](https://godoc.org/github.com/bigfile/bigfile)   [![Contains Chinese documents][CN]](https://github.com/bigfile/bigfile)
- [afs](https://github.com/viant/afs) **star:205** Abstract File Storage (mem, scp, zip, tar, cloud: s3, gs) for Go.   [![godoc][D]](https://godoc.org/github.com/viant/afs)
- [vfs](https://github.com/C2FO/vfs) **star:199** A pluggable, extensible, and opinionated set of filesystem functionality for Go across a number of filesystem types such as os, S3, and GCS.   [![godoc][D]](https://godoc.org/github.com/C2FO/vfs)
- [go-exiftool](https://github.com/barasher/go-exiftool) **star:135** Go bindings for ExifTool, the well-known library used to extract as much metadata as possible (EXIF, IPTC, ...) from files (pictures, PDF, office, ...).   [![godoc][D]](https://godoc.org/github.com/barasher/go-exiftool)
- [go-csv-tag](https://github.com/artonge/go-csv-tag) **star:98** Load csv file using tag.   [![godoc][D]](https://godoc.org/github.com/artonge/go-csv-tag)
- [gofs](https://github.com/no-src/gofs) **star:97** A file synchronization tool out of the box.   [![There was an update last month][G]](https://github.com/no-src/gofs)   [![godoc][D]](https://godoc.org/github.com/no-src/gofs)   [![Contains Chinese documents][CN]](https://github.com/no-src/gofs)
- [skywalker](https://github.com/dixonwille/skywalker) **star:85** Package to allow one to concurrently go through a filesystem with ease.   [![godoc][D]](https://godoc.org/github.com/dixonwille/skywalker)
- [stl](https://gitlab.com/russoj88/stl)  Modules to read and write STL (stereolithography) files.  Concurrent algorithm for reading.
- [opc](https://github.com/qmuntal/opc) **star:73** Load Open Packaging Conventions (OPC) files for Go.   [![godoc][D]](https://godoc.org/github.com/qmuntal/opc)
- [checksum](https://github.com/codingsince1985/checksum) **star:70** Compute message digest, like MD5, SHA256, SHA1, CRC or BLAKE2s, for large files.   [![godoc][D]](https://godoc.org/github.com/codingsince1985/checksum)
- [parquet](https://github.com/parsyl/parquet) **star:58** Read and write [parquet](https://parquet.apache.org) files.   [![godoc][D]](https://godoc.org/github.com/parsyl/parquet)
- [tarfs](https://github.com/posener/tarfs) **star:51** Implementation of the [`FileSystem` interface](https://godoc.org/github.com/kr/fs#FileSystem) for tar files.   [![godoc][D]](https://godoc.org/github.com/posener/tarfs)
- [baraka](https://github.com/xis/baraka) **star:46** A library to process http file uploads easily.   [![There was an update last month][G]](https://github.com/xis/baraka)   [![godoc][D]](https://godoc.org/github.com/xis/baraka)
- [go-gtfs](https://github.com/artonge/go-gtfs) **star:33** Load gtfs files in go.   [![godoc][D]](https://godoc.org/github.com/artonge/go-gtfs)
- [flop](https://github.com/homedepot/flop) **star:32** File operations library which aims to mirror feature parity with [GNU cp](https://www.gnu.org/software/coreutils/manual/html_node/cp-invocation.html).   [![godoc][D]](https://godoc.org/github.com/homedepot/flop)
- [gut/yos](https://github.com/1set/gut) **star:25** Simple and reliable package for file operations like copy/move/diff/list on files, directories and symbolic links.   [![godoc][D]](https://godoc.org/github.com/1set/gut)
- [go-decent-copy](https://github.com/hugocarreira/go-decent-copy) **star:17** Copy files for humans.   [![godoc][D]](https://godoc.org/github.com/hugocarreira/go-decent-copy)
- [todotxt](https://github.com/1set/todotxt) **star:15** Go library for Gina Trapani's [_todo.txt_](http://todotxt.org/) files, supports parsing and manipulating of task lists in the [_todo.txt_ format](https://github.com/todotxt/todo.txt).   [![godoc][D]](https://godoc.org/github.com/1set/todotxt)
- [higgs](https://github.com/dastoori/higgs) **star:13** A tiny cross-platform Go library to hide/unhide files and directories.   [![godoc][D]](https://godoc.org/github.com/dastoori/higgs)
- [pathtype](https://github.com/jonchun/pathtype) **star:12** Treat paths as their own type instead of using strings.   [![godoc][D]](https://godoc.org/github.com/jonchun/pathtype)

**[⬆ back to top](#contents)**

## Financial

_Packages for accounting and finance._

- [decimal](https://github.com/shopspring/decimal) **star:4384** Arbitrary-precision fixed-point decimal numbers.   [![There was an update last month][G]](https://github.com/shopspring/decimal)   [![godoc][D]](https://godoc.org/github.com/shopspring/decimal)
- [ticker](https://github.com/achannarasappa/ticker) **star:4378** Terminal stock watcher and stock position tracker.   [![godoc][D]](https://godoc.org/github.com/achannarasappa/ticker)
- [go-money](https://github.com/rhymond/go-money) **star:1168** Implementation of Fowler's Money pattern.   [![godoc][D]](https://godoc.org/github.com/rhymond/go-money)
- [accounting](https://github.com/leekchan/accounting) **star:770** money and currency formatting for golang.   [![godoc][D]](https://godoc.org/github.com/leekchan/accounting)
- [bbgo](https://github.com/c9s/bbgo) **star:705** A crypto trading bot framework written in Go. Including common crypto exchange API, standard indicators, back-testing and many built-in strategies.   [![There was an update last month][G]](https://github.com/c9s/bbgo)   [![godoc][D]](https://godoc.org/github.com/c9s/bbgo)
- [techan](https://github.com/sdcoffey/techan) **star:676** Technical analysis library with advanced market analysis and trading strategies.   [![godoc][D]](https://godoc.org/github.com/sdcoffey/techan)
- [go-finance](https://github.com/FlashBoys/go-finance) **star:537** Comprehensive financial markets data in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/FlashBoys/go-finance)   [![godoc][D]](https://godoc.org/github.com/FlashBoys/go-finance)
- [currency](https://github.com/bojanz/currency) **star:335** Handles currency amounts, provides currency information and formatting.   [![There was an update last month][G]](https://github.com/bojanz/currency)   [![godoc][D]](https://godoc.org/github.com/bojanz/currency)
- [ach](https://github.com/moov-io/ach) **star:333** A reader, writer, and validator for Automated Clearing House (ACH) files.   [![There was an update last month][G]](https://github.com/moov-io/ach)   [![godoc][D]](https://godoc.org/github.com/moov-io/ach)
- [orderbook](https://github.com/i25959341/orderbook) **star:296** Matching Engine for Limit Order Book in Golang.   [![godoc][D]](https://godoc.org/github.com/i25959341/orderbook)
- [go-finance](https://github.com/alpeb/go-finance) **star:143** Library of financial functions for time value of money (annuities), cash flow, interest rate conversions, bonds and depreciation calculations.   [![godoc][D]](https://godoc.org/github.com/alpeb/go-finance)
- [transaction](https://github.com/claygod/transaction) **star:116** Embedded transactional database of accounts, running in multithreaded mode.   [![godoc][D]](https://godoc.org/github.com/claygod/transaction)
- [ofxgo](https://github.com/aclindsa/ofxgo) **star:110** Query OFX servers and/or parse the responses (with example command-line client).   [![godoc][D]](https://godoc.org/github.com/aclindsa/ofxgo)
- [sleet](https://github.com/BoltApp/sleet) **star:100** One unified interface for multiple Payment Service Providers (PsP) to process online payment.   [![There was an update last month][G]](https://github.com/BoltApp/sleet)   [![godoc][D]](https://godoc.org/github.com/BoltApp/sleet)
- [vat](https://github.com/dannyvankooten/vat) **star:98** VAT number validation & EU VAT rates.   [![godoc][D]](https://godoc.org/github.com/dannyvankooten/vat)
- [go-finnhub](https://github.com/m1/go-finnhub) **star:76** Client for stock market, forex and crypto data from finnhub.io. Access real-time financial market data from 60+ stock exchanges, 10 forex brokers, and 15+ crypto exchanges.   [![godoc][D]](https://godoc.org/github.com/m1/go-finnhub)   [![Archived][Archived]](https://github.com/m1/go-finnhub)
- [currency](https://github.com/bnkamalesh/currency) **star:50** High performant & accurate currency computation package.   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/currency)
- [fastme](https://github.com/newity/fastme) **star:37** Fast extensible matching engine Go implementation.   [![godoc][D]](https://godoc.org/github.com/newity/fastme)
- [fpdecimal](https://github.com/nikolaydubina/fpdecimal) **star:14** Fast and precise serialization and arithmetic for small fixed-point decimals   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/fpdecimal)
- [payme](https://github.com/jovandeginste/payme) **star:12** QR code generator (ASCII & PNG) for SEPA payments.   [![godoc][D]](https://godoc.org/github.com/jovandeginste/payme)
- [fpmoney](https://github.com/nikolaydubina/fpmoney) **star:10** Fast and simple ISO4217 fixed-point decimal money.   [![There was an update last month][G]](https://github.com/nikolaydubina/fpmoney)   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/fpmoney)
- [go-finance](https://github.com/pieterclaerhout/go-finance) **star:10** Module to fetch exchange rates, check VAT numbers via VIES and check IBAN bank account numbers.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-finance)

**[⬆ back to top](#contents)**

## Forms

_Libraries for working with forms._

- [nosurf](https://github.com/justinas/nosurf) **star:1326** CSRF protection middleware for Go.   [![godoc][D]](https://godoc.org/github.com/justinas/nosurf)
- [gorilla/csrf](https://github.com/gorilla/csrf) **star:832** CSRF protection for Go web applications & services.   [![godoc][D]](https://godoc.org/github.com/gorilla/csrf)
- [binding](https://github.com/mholt/binding) **star:791** Binds form and JSON data from net/http Request to struct.   [![It hasn't been updated in recent three years][Y]](https://github.com/mholt/binding)   [![godoc][D]](https://godoc.org/github.com/mholt/binding)   [![Archived][Archived]](https://github.com/mholt/binding)
- [form](https://github.com/go-playground/form) **star:558** Decodes url.Values into Go value(s) and Encodes Go value(s) into url.Values. Dual Array and Full map support.   [![godoc][D]](https://godoc.org/github.com/go-playground/form)
- [conform](https://github.com/leebenson/conform) **star:273** Keeps user input in check. Trims, sanitizes & scrubs data based on struct tags.   [![godoc][D]](https://godoc.org/github.com/leebenson/conform)
- [formam](https://github.com/monoculum/formam) **star:175** decode form's values into a struct.   [![godoc][D]](https://godoc.org/github.com/monoculum/formam)
- [forms](https://github.com/albrow/forms) **star:132** Framework-agnostic library for parsing and validating form/JSON data which supports multipart forms and files.   [![It hasn't been updated in recent three years][Y]](https://github.com/albrow/forms)   [![godoc][D]](https://godoc.org/github.com/albrow/forms)
- [httpin](https://github.com/ggicci/httpin) **star:116** Decode an HTTP request into a custom struct, including querystring, forms, HTTP headers, etc.   [![There was an update last month][G]](https://github.com/ggicci/httpin)   [![godoc][D]](https://godoc.org/github.com/ggicci/httpin)
- [qs](https://github.com/sonh/qs) **star:64** Go module for encoding structs into URL query parameters.   [![godoc][D]](https://godoc.org/github.com/sonh/qs)
- [bind](https://github.com/robfig/bind) **star:28** Bind form data to any Go values.   [![It hasn't been updated in recent three years][Y]](https://github.com/robfig/bind)   [![godoc][D]](https://godoc.org/github.com/robfig/bind)
- [queryparam](https://github.com/tomwright/queryparam) **star:14** Decode `url.Values` into usable struct values of standard or custom types.   [![godoc][D]](https://godoc.org/github.com/tomwright/queryparam)
- [gbind](https://github.com/bdjimmy/gbind) **star:8** Bind data to any Go value. Can use built-in and custom expression binding capabilities; supports data validation   [![godoc][D]](https://godoc.org/github.com/bdjimmy/gbind)   [![Contains Chinese documents][CN]](https://github.com/bdjimmy/gbind)

**[⬆ back to top](#contents)**

## Functional

_Packages to support functional programming in Go._

- [go-underscore](https://github.com/tobyhede/go-underscore) **star:1255** Useful collection of helpfully functional Go collection utilities.   [![godoc][D]](https://godoc.org/github.com/tobyhede/go-underscore)
- [mo](https://github.com/samber/mo) **star:1005** Monads and popular FP abstractions, based on Go 1.18+ Generics (Option, Result, Either...).   [![There was an update last month][G]](https://github.com/samber/mo)   [![godoc][D]](https://godoc.org/github.com/samber/mo)
- [fpGo](https://github.com/TeaEntityLab/fpGo) **star:296** Monad, Functional Programming features for Golang.   [![godoc][D]](https://godoc.org/github.com/TeaEntityLab/fpGo)
- [gofp](https://github.com/rbrahul/gofp) **star:132** A lodash like powerful utility library for Golang.   [![godoc][D]](https://godoc.org/github.com/rbrahul/gofp)
- [fuego](https://github.com/seborama/fuego) **star:125** Functional Experiment in Go.   [![godoc][D]](https://godoc.org/github.com/seborama/fuego)
- [fp-go](https://github.com/repeale/fp-go) **star:121** Collection of Functional Programming helpers powered by Golang 1.18+ generics.   [![godoc][D]](https://godoc.org/github.com/repeale/fp-go)
- [underscore](https://github.com/rjNemo/underscore) **star:72** Functional programming helpers for Go 1.18 and beyond.   [![godoc][D]](https://godoc.org/github.com/rjNemo/underscore)
- [valor](https://github.com/phelmkamp/valor) **star:8** Generic option and result types that optionally contain a value.   [![godoc][D]](https://godoc.org/github.com/phelmkamp/valor)

**[⬆ back to top](#contents)**

## Game Development

_Awesome game development libraries._

- [Ebitengine](https://github.com/hajimehoshi/ebiten) **star:7175** dead simple 2D game engine in Go.   [![There was an update last month][G]](https://github.com/hajimehoshi/ebiten)   [![godoc][D]](https://godoc.org/github.com/hajimehoshi/ebiten)
- [Leaf](https://github.com/name5566/leaf) **star:4553** Lightweight game server framework.   [![godoc][D]](https://godoc.org/github.com/name5566/leaf)   [![Contains Chinese documents][CN]](https://github.com/name5566/leaf)
- [Pixel](https://github.com/faiface/pixel) **star:4063** Hand-crafted 2D game library in Go.   [![godoc][D]](https://godoc.org/github.com/faiface/pixel)
- [goworld](https://github.com/xiaonanln/goworld) **star:2203** Scalable game server engine, featuring space-entity framework and hot-swapping.   [![godoc][D]](https://godoc.org/github.com/xiaonanln/goworld)   [![Contains Chinese documents][CN]](https://github.com/xiaonanln/goworld)
- [g3n](https://github.com/g3n/engine) **star:2150** Go 3D Game Engine.   [![godoc][D]](https://godoc.org/github.com/g3n/engine)
- [nano](https://github.com/lonng/nano) **star:2122** Lightweight, facility, high performance golang based game server framework.   [![godoc][D]](https://godoc.org/github.com/lonng/nano)   [![Contains Chinese documents][CN]](https://github.com/lonng/nano)
- [go-sdl2](https://github.com/veandco/go-sdl2) **star:1840** Go bindings for the [Simple DirectMedia Layer](https://www.libsdl.org/).   [![There was an update last month][G]](https://github.com/veandco/go-sdl2)
- [Pitaya](https://github.com/topfreegames/pitaya) **star:1551** Scalable game server framework with clustering support and client libraries for iOS, Android, Unity and others through the C SDK.   [![There was an update last month][G]](https://github.com/topfreegames/pitaya)   [![godoc][D]](https://godoc.org/github.com/topfreegames/pitaya)
- [engo](https://github.com/EngoEngine/engo) **star:1541** Engo is an open-source 2D game engine written in Go. It follows the Entity-Component-System paradigm.   [![godoc][D]](https://godoc.org/github.com/EngoEngine/engo)
- [termloop](https://github.com/JoelOtter/termloop) **star:1299** Terminal-based game engine for Go, built on top of Termbox.   [![godoc][D]](https://godoc.org/github.com/JoelOtter/termloop)
- [Oak](https://github.com/oakmound/oak) **star:1294** Pure Go game engine.   [![godoc][D]](https://godoc.org/github.com/oakmound/oak)
- [gonet](https://github.com/xtaci/gonet) **star:1190** Game server skeleton implemented with golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/xtaci/gonet)   [![godoc][D]](https://godoc.org/github.com/xtaci/gonet)
- [raylib-go](https://github.com/gen2brain/raylib-go) **star:874** Go bindings for [raylib](https://www.raylib.com/), a simple and easy-to-use library to learn videogames programming.
- [Azul3D](https://github.com/azul3d/engine) **star:556** 3D game engine written in Go.
- [go-astar](https://github.com/beefsack/go-astar) **star:523** Go implementation of the A\* path finding algorithm.   [![godoc][D]](https://godoc.org/github.com/beefsack/go-astar)
- [go3d](https://github.com/ungerik/go3d) **star:272** Performance oriented 2D/3D math package for Go.   [![godoc][D]](https://godoc.org/github.com/ungerik/go3d)
- [prototype](https://github.com/gonutz/prototype) **star:76** Cross-platform (Windows/Linux/Mac) library for creating desktop games using a minimal API.   [![There was an update last month][G]](https://github.com/gonutz/prototype)   [![godoc][D]](https://godoc.org/github.com/gonutz/prototype)
- [tile](https://github.com/kelindar/tile) **star:72** Data-oriented and cache-friendly 2D Grid library (TileMap), includes pathfinding, observers and import/export.   [![godoc][D]](https://godoc.org/github.com/kelindar/tile)
- [fantasyname](https://github.com/s0rg/fantasyname) **star:11** Fantasy names generator.   [![There was an update last month][G]](https://github.com/s0rg/fantasyname)   [![godoc][D]](https://godoc.org/github.com/s0rg/fantasyname)

**[⬆ back to top](#contents)**

## Generators

_Tools that generate Go code._

- [go-linq](https://github.com/ahmetalpbalkan/go-linq) **star:3110** .NET LINQ-like query methods for Go.   [![godoc][D]](https://godoc.org/github.com/ahmetalpbalkan/go-linq)
- [jennifer](https://github.com/dave/jennifer) **star:2572** Generate arbitrary Go code without templates.   [![godoc][D]](https://godoc.org/github.com/dave/jennifer)
- [goderive](https://github.com/awalterschulze/goderive) **star:1016** Derives functions from input types.   [![godoc][D]](https://godoc.org/github.com/awalterschulze/goderive)
- [GoWrap](https://github.com/hexdigest/gowrap) **star:670** Generate decorators for Go interfaces using simple templates.   [![godoc][D]](https://godoc.org/github.com/hexdigest/gowrap)
- [go-enum](https://github.com/abice/go-enum) **star:377** Code generation for enums from code comments.   [![There was an update last month][G]](https://github.com/abice/go-enum)   [![godoc][D]](https://godoc.org/github.com/abice/go-enum)
- [interfaces](https://github.com/rjeczalik/interfaces) **star:357** Command line tool for generating interface definitions.   [![godoc][D]](https://godoc.org/github.com/rjeczalik/interfaces)
- [copygen](https://github.com/switchupcb/copygen) **star:186** Generate type-to-type and type-based code without reflection.   [![godoc][D]](https://godoc.org/github.com/switchupcb/copygen)
- [goverter](https://github.com/jmattheis/goverter) **star:157** Generate converters by defining an interface.   [![godoc][D]](https://godoc.org/github.com/jmattheis/goverter)
- [gotype](https://github.com/wzshiming/gotype) **star:49** Golang source code parsing, usage like reflect package.   [![godoc][D]](https://godoc.org/github.com/wzshiming/gotype)   [![Contains Chinese documents][CN]](https://github.com/wzshiming/gotype)
- [generis](https://github.com/senselogic/GENERIS) **star:37** Code generation tool providing generics, free-form macros, conditional compilation and HTML templating.
- [go-xray](https://github.com/pieterclaerhout/go-xray) **star:24** Helpers for making the use of reflection easier.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-xray)
- [typeregistry](https://github.com/xiaoxin01/typeregistry) **star:15** A library to create type dynamically.   [![godoc][D]](https://godoc.org/github.com/xiaoxin01/typeregistry)

**[⬆ back to top](#contents)**

## Geographic

_Geographic tools and servers_

- [godal](https://github.com/airbusgeo/godal) **star:82** Go wrapper for GDAL.   [![There was an update last month][G]](https://github.com/airbusgeo/godal)   [![godoc][D]](https://godoc.org/github.com/airbusgeo/godal)
- [geoserver](https://github.com/hishamkaram/geoserver) **star:76** geoserver Is a Go Package For Manipulating a GeoServer Instance via the GeoServer REST API.   [![godoc][D]](https://godoc.org/github.com/hishamkaram/geoserver)
- [gismanager](https://github.com/hishamkaram/gismanager) **star:48** Publish Your GIS Data(Vector Data) to PostGIS and Geoserver.   [![It hasn't been updated in recent three years][Y]](https://github.com/hishamkaram/gismanager)   [![godoc][D]](https://godoc.org/github.com/hishamkaram/gismanager)
- [h3-go] - Go bindings for H3, a hierarchical hexagonal geospatial indexing system.
- [Tile38](https://github.com/tidwall/tile38) **star:8284** Geolocation DB with spatial index and realtime geofencing.   [![godoc][D]](https://godoc.org/github.com/tidwall/tile38)
- [S2 geometry](https://github.com/golang/geo) **star:1434** S2 geometry library in Go.   [![godoc][D]](https://godoc.org/github.com/golang/geo)
- [mbtileserver](https://github.com/consbio/mbtileserver) **star:395** A simple Go-based server for map tiles stored in mbtiles format.   [![There was an update last month][G]](https://github.com/consbio/mbtileserver)   [![godoc][D]](https://godoc.org/github.com/consbio/mbtileserver)
- [osm](https://github.com/paulmach/osm) **star:235** Library for reading, writing and working with OpenStreetMap data and APIs.   [![godoc][D]](https://godoc.org/github.com/paulmach/osm)
- [simplefeatures](https://github.com/peterstace/simplefeatures) **star:64** simplesfeatures is a 2D geometry library that provides Go types that model geometries, as well as algorithms that operate on them.   [![godoc][D]](https://godoc.org/github.com/peterstace/simplefeatures)
- [pbf](https://github.com/maguro/pbf) **star:39** OpenStreetMap PBF golang encoder/decoder.   [![godoc][D]](https://godoc.org/github.com/maguro/pbf)
- [S2 geojson](https://github.com/pantrif/s2-geojson) **star:19** Convert geojson to s2 cells & demonstrating some S2 geometry features on map.   [![godoc][D]](https://godoc.org/github.com/pantrif/s2-geojson)
- [H3 GeoJSON](https://github.com/mmadfox/go-geojson2h3) **star:3** Conversion utilities between H3 indexes and GeoJSON.   [![godoc][D]](https://godoc.org/github.com/mmadfox/go-geojson2h3)
- [H3GeoDist](https://github.com/mmadfox/go-h3geo-dist) **star:1** Distribution of Uber H3geo cells by virtual nodes.   [![godoc][D]](https://godoc.org/github.com/mmadfox/go-h3geo-dist)
- [Web-Mercator-Projection](https://github.com/jorelosorio/web-mercator-projection) A project to easily use and convert LonLat, Point and Tile to display info, markers, etc, in a map using the Web Mercator Projection.
- [WGS84](https://github.com/wroge/wgs84) **star:90** Library for Coordinate Conversion and Transformation (ETRS89, OSGB36, NAD83, RGF93, Web Mercator, UTM).   [![godoc][D]](https://godoc.org/github.com/wroge/wgs84)

**[⬆ back to top](#contents)**

## Go Compilers

_Tools for compiling Go to other languages._

- [gopherjs](https://github.com/gopherjs/gopherjs) **star:11506** Compiler from Go to JavaScript.   [![There was an update last month][G]](https://github.com/gopherjs/gopherjs)   [![godoc][D]](https://godoc.org/github.com/gopherjs/gopherjs)
- [tardisgo](https://github.com/tardisgo/tardisgo) **star:420** Golang to Haxe to CPP/CSharp/Java/JavaScript transpiler.   [![It hasn't been updated in recent three years][Y]](https://github.com/tardisgo/tardisgo)   [![godoc][D]](https://godoc.org/github.com/tardisgo/tardisgo)
- [c4go](https://github.com/Konstantin8105/c4go) **star:326** Transpile C code to Go code.   [![godoc][D]](https://godoc.org/github.com/Konstantin8105/c4go)
- [c2go](https://github.com/goplus/c2go) **star:205** Convert C code to Go code.   [![godoc][D]](https://godoc.org/github.com/goplus/c2go)
- [esp32](https://github.com/andygeiss/esp32-transpiler) **star:54** Transpile Go into Arduino code.   [![godoc][D]](https://godoc.org/github.com/andygeiss/esp32-transpiler)
- [f4go](https://github.com/Konstantin8105/f4go) **star:34** Transpile FORTRAN 77 code to Go code.   [![godoc][D]](https://godoc.org/github.com/Konstantin8105/f4go)

**[⬆ back to top](#contents)**

## Goroutines

_Tools for managing and working with Goroutines._

- [ants](https://github.com/panjf2000/ants) **star:9201** A high-performance and low-cost goroutine pool in Go.   [![godoc][D]](https://godoc.org/github.com/panjf2000/ants)   [![Contains Chinese documents][CN]](https://github.com/panjf2000/ants)
- [tunny](https://github.com/Jeffail/tunny) **star:3218** Goroutine pool for golang.   [![godoc][D]](https://godoc.org/github.com/Jeffail/tunny)
- [goworker](https://github.com/benmanns/goworker) **star:2685** goworker is a Go-based background worker.   [![godoc][D]](https://godoc.org/github.com/benmanns/goworker)
- [workerpool](https://github.com/gammazero/workerpool) **star:929** Goroutine pool that limits the concurrency of task execution, not the number of tasks queued.   [![godoc][D]](https://godoc.org/github.com/gammazero/workerpool)
- [grpool](https://github.com/ivpusic/grpool) **star:713** Lightweight Goroutine pool.   [![It hasn't been updated in recent three years][Y]](https://github.com/ivpusic/grpool)   [![godoc][D]](https://godoc.org/github.com/ivpusic/grpool)
- [pool](https://github.com/go-playground/pool) **star:697** Limited consumer goroutine or unlimited goroutine pool for easier goroutine handling and cancellation.   [![godoc][D]](https://godoc.org/github.com/go-playground/pool)
- [pond](https://github.com/alitto/pond) **star:648** Minimalistic and High-performance goroutine worker pool written in Go.   [![godoc][D]](https://godoc.org/github.com/alitto/pond)
- [gowp](https://github.com/xxjwxc/gowp) **star:418** gowp is concurrency limiting goroutine pool.   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gowp)   [![Contains Chinese documents][CN]](https://github.com/xxjwxc/gowp)
- [go-floc](https://github.com/workanator/go-floc) **star:261** Orchestrate goroutines with ease.   [![godoc][D]](https://godoc.org/github.com/workanator/go-floc)
- [go-flow](https://github.com/kamildrazkiewicz/go-flow) **star:199** Control goroutines execution order.   [![It hasn't been updated in recent three years][Y]](https://github.com/kamildrazkiewicz/go-flow)   [![godoc][D]](https://godoc.org/github.com/kamildrazkiewicz/go-flow)
- [semaphore](https://github.com/marusama/semaphore) **star:153** Fast resizable semaphore implementation based on CAS (faster than channel-based semaphore implementations).   [![godoc][D]](https://godoc.org/github.com/marusama/semaphore)
- [go-workers](https://github.com/catmullet/go-workers) **star:145** Easily and safely run workers for large data processing pipelines.   [![godoc][D]](https://godoc.org/github.com/catmullet/go-workers)
- [neilotoole/errgroup](https://github.com/neilotoole/errgroup) **star:139** Drop-in alternative to `sync/errgroup`, limited to a pool of N worker goroutines.   [![godoc][D]](https://godoc.org/github.com/neilotoole/errgroup)
- [artifex](https://github.com/borderstech/artifex) **star:136** Simple in-memory job queue for Golang using worker-based dispatching.   [![godoc][D]](https://godoc.org/github.com/borderstech/artifex)
- [async](https://github.com/studiosol/async) **star:113** A safe way to execute functions asynchronously, recovering them in case of panic.   [![godoc][D]](https://godoc.org/github.com/studiosol/async)
- [cyclicbarrier](https://github.com/marusama/cyclicbarrier) **star:110** CyclicBarrier for golang.   [![godoc][D]](https://godoc.org/github.com/marusama/cyclicbarrier)
- [gollback](https://github.com/vardius/gollback) **star:98** asynchronous simple function utilities, for managing execution of closures and callbacks.   [![godoc][D]](https://godoc.org/github.com/vardius/gollback)
- [async](https://github.com/reugn/async) **star:92** An alternative sync library for Go (Future, Promise, Locks).   [![godoc][D]](https://godoc.org/github.com/reugn/async)
- [semaphore](https://github.com/kamilsk/semaphore) **star:91** Semaphore pattern implementation with timeout of lock/unlock operations based on channel and context.   [![godoc][D]](https://godoc.org/github.com/kamilsk/semaphore)
- [Hunch](https://github.com/AaronJan/Hunch) **star:90** Hunch provides functions like: `All`, `First`, `Retry`, `Waterfall` etc., that makes asynchronous flow control more intuitive.   [![godoc][D]](https://godoc.org/github.com/AaronJan/Hunch)
- [gpool](https://github.com/Sherifabdlnaby/gpool) **star:85** manages a resizeable pool of context-aware goroutines to bound concurrency.   [![godoc][D]](https://godoc.org/github.com/Sherifabdlnaby/gpool)
- [worker-pool](https://github.com/vardius/worker-pool) **star:85** goworker is a Go simple async worker pool.   [![godoc][D]](https://godoc.org/github.com/vardius/worker-pool)
- [threadpool](https://github.com/shettyh/threadpool) **star:79** Golang threadpool implementation.   [![godoc][D]](https://godoc.org/github.com/shettyh/threadpool)
- [routine](https://github.com/timandy/routine) **star:62** `routine` is a `ThreadLocal` for go library. It encapsulates and provides some easy-to-use, non-competitive, high-performance `goroutine` context access interfaces, which can help you access coroutine context information more gracefully.   [![godoc][D]](https://godoc.org/github.com/timandy/routine)   [![Contains Chinese documents][CN]](https://github.com/timandy/routine)
- [goccm](https://github.com/zenthangplus/goccm) **star:59** Go Concurrency Manager package limits the number of goroutines that allowed to run concurrently.   [![There was an update last month][G]](https://github.com/zenthangplus/goccm)   [![godoc][D]](https://godoc.org/github.com/zenthangplus/goccm)
- [routine](https://github.com/x-mod/routine) **star:53** go routine control with context, support: Main, Go, Pool and some useful Executors.   [![godoc][D]](https://godoc.org/github.com/x-mod/routine)
- [nursery](https://github.com/arunsworld/nursery) **star:52** Structured concurrency in Go.   [![godoc][D]](https://godoc.org/github.com/arunsworld/nursery)
- [oversight](https://cirello.io/oversight)  Oversight is a complete implementation of the Erlang supervision trees.
- [gohive](https://github.com/loveleshsharma/gohive) **star:43** A highly performant and easy to use Goroutine pool for Go.   [![godoc][D]](https://godoc.org/github.com/loveleshsharma/gohive)
- [kyoo](https://github.com/dirkaholic/kyoo) **star:39** Provides an unlimited job queue and concurrent worker pools.   [![godoc][D]](https://godoc.org/github.com/dirkaholic/kyoo)
- [gowl](https://github.com/hamed-yousefi/gowl) **star:38** Gowl is a process management and process monitoring tool at once. An infinite worker pool gives you the ability to control the pool and processes and monitor their status.   [![godoc][D]](https://godoc.org/github.com/hamed-yousefi/gowl)
- [parallel-fn](https://github.com/rafaeljesus/parallel-fn) **star:34** Run functions in parallel.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/parallel-fn)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/parallel-fn)
- [go-waitgroup](https://github.com/pieterclaerhout/go-waitgroup) **star:33** Like `sync.WaitGroup` with error handling and concurrency control.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-waitgroup)
- [go-trylock](https://github.com/subchen/go-trylock) **star:32** TryLock support on read-write lock for Golang.   [![godoc][D]](https://godoc.org/github.com/subchen/go-trylock)
- [channelify](https://github.com/ddelizia/channelify) **star:25** Transform your function to return channels for easy and powerful parallel processing.   [![godoc][D]](https://godoc.org/github.com/ddelizia/channelify)
- [stl](https://github.com/ssgreg/stl) **star:24** Software transactional locks based on Software Transactional Memory (STM) concurrency control mechanism.   [![godoc][D]](https://godoc.org/github.com/ssgreg/stl)
- [conexec](https://github.com/ITcathyh/conexec) **star:13** A concurrent toolkit to help execute funcs concurrently in an efficient and safe way. It supports specifying the overall timeout to avoid blocking and uses goroutine pool to improve efficiency.   [![godoc][D]](https://godoc.org/github.com/ITcathyh/conexec)
- [execpool](https://github.com/hexdigest/execpool) **star:13** A pool built around exec.Cmd that spins up a given number of processes in advance and attaches stdin and stdout to them when needed. Very similar to FastCGI or Apache Prefork MPM but works for any command.   [![godoc][D]](https://godoc.org/github.com/hexdigest/execpool)
- [queue](https://github.com/AnikHasibul/queue) **star:13** Gives you a `sync.WaitGroup` like queue group accessibility. Helps you to throttle and limit goroutines, wait for the end of the all goroutines and much more.   [![It hasn't been updated in recent three years][Y]](https://github.com/AnikHasibul/queue)   [![godoc][D]](https://godoc.org/github.com/AnikHasibul/queue)
- [concurrency-limiter](https://github.com/vivek-ng/concurrency-limiter) **star:10** Concurrency limiter with support for timeouts , dynamic priority and context cancellation of goroutines.   [![godoc][D]](https://godoc.org/github.com/vivek-ng/concurrency-limiter)
- [hands](https://github.com/duanckham/hands) **star:10** A process controller used to control the execution and return strategies of multiple goroutines.   [![godoc][D]](https://godoc.org/github.com/duanckham/hands)
- [breaker](https://github.com/kamilsk/breaker) **star:8** Flexible mechanism to make execution flow interruptible.
- [go-tools/multithreading](https://github.com/nikhilsaraf/go-tools) **star:8** Manage a pool of goroutines using this lightweight library with a simple API.   [![It hasn't been updated in recent three years][Y]](https://github.com/nikhilsaraf/go-tools)   [![godoc][D]](https://godoc.org/github.com/nikhilsaraf/go-tools)
- [go-workerpool](https://github.com/zenthangplus/go-workerpool) **star:6** Inspired from Java Thread Pool, Go WorkerPool aims to control heavy Go Routines.   [![godoc][D]](https://godoc.org/github.com/zenthangplus/go-workerpool)
- [async-job](https://github.com/lab210-dev/async-job) **star:3** AsyncJob is an asynchronous queue job manager with light code, clear and speed.   [![godoc][D]](https://godoc.org/github.com/lab210-dev/async-job)

**[⬆ back to top](#contents)**

## GUI

_Libraries for building GUI Applications._

_Toolkits_

- [fyne](https://github.com/fyne-io/fyne) **star:18362** Cross platform native GUIs designed for Go based on Material Design. Supports: Linux, macOS, Windows, BSD, iOS and Android.   [![There was an update last month][G]](https://github.com/fyne-io/fyne)   [![godoc][D]](https://godoc.org/github.com/fyne-io/fyne)
- [gio](https://gioui.org)  Gio is a library for writing cross-platform immediate mode GUI-s in Go. Gio supports all the major platforms: Linux, macOS, Windows, Android, iOS, FreeBSD, OpenBSD and WebAssembly.
- [webview](https://github.com/zserge/webview) **star:10504** Cross-platform webview window with simple two-way JavaScript bindings (Windows / macOS / Linux).
- [qt](https://github.com/therecipe/qt) **star:9459** Qt binding for Go (support for Windows / macOS / Linux / Android / iOS / Sailfish OS / Raspberry Pi).   [![godoc][D]](https://godoc.org/github.com/therecipe/qt)
- [ui](https://github.com/andlabs/ui) **star:8178** Platform-native GUI library for Go. Cross platform.   [![godoc][D]](https://godoc.org/github.com/andlabs/ui)
- [Wails](https://wails.app)  Mac, Windows, Linux desktop apps with HTML UI using built-in OS HTML renderer.
- [app](https://github.com/murlokswarm/app) **star:6502** Package to create apps with GO, HTML and CSS. Supports: MacOS, Windows in progress.   [![There was an update last month][G]](https://github.com/murlokswarm/app)   [![godoc][D]](https://godoc.org/github.com/murlokswarm/app)
- [walk](https://github.com/lxn/walk) **star:6202** Windows application library kit for Go.   [![godoc][D]](https://godoc.org/github.com/lxn/walk)
- [go-astilectron](https://github.com/asticode/go-astilectron) **star:4511** Build cross platform GUI apps with GO and HTML/JS/CSS (powered by Electron).   [![godoc][D]](https://godoc.org/github.com/asticode/go-astilectron)
- [go-gtk](https://mattn.github.io/go-gtk/)  Go bindings for GTK.
- [go-sciter](https://github.com/sciter-sdk/go-sciter) **star:2451** Go bindings for Sciter: the Embeddable HTML/CSS/script engine for modern desktop UI development. Cross platform.
- [gotk3](https://github.com/gotk3/gotk3) **star:1826** Go bindings for GTK3.   [![godoc][D]](https://godoc.org/github.com/gotk3/gotk3)
- [gowd](https://github.com/dtylman/gowd) **star:380** Rapid and simple desktop UI development with GO, HTML, CSS and NW.js. Cross platform.   [![godoc][D]](https://godoc.org/github.com/dtylman/gowd)
- [goradd/html5tag](https://github.com/goradd/html5tag) **star:4** Library for outputting HTML5 tags.   [![godoc][D]](https://godoc.org/github.com/goradd/html5tag)

_Interaction_

- [robotgo](https://github.com/go-vgo/robotgo) **star:7881** Go Native cross-platform GUI system automation. Control the mouse, keyboard and other.   [![godoc][D]](https://godoc.org/github.com/go-vgo/robotgo)
- [systray](https://github.com/getlantern/systray) **star:2528** Cross platform Go library to place an icon and menu in the notification area.   [![godoc][D]](https://godoc.org/github.com/getlantern/systray)
- [gosx-notifier](https://github.com/deckarep/gosx-notifier) **star:574** OSX Desktop Notifications library for Go.   [![godoc][D]](https://godoc.org/github.com/deckarep/gosx-notifier)
- [zenity](https://github.com/ncruces/zenity) **star:346** Cross-platform Go library and CLI to create simple dialogs that interact graphically with the user.   [![godoc][D]](https://godoc.org/github.com/ncruces/zenity)
- [trayhost](https://github.com/shurcooL/trayhost) **star:233** Cross-platform Go library to place an icon in the host operating system's taskbar.   [![godoc][D]](https://godoc.org/github.com/shurcooL/trayhost)
- [mac-activity-tracker](https://github.com/prashantgupta24/activity-tracker) **star:21** OSX library to notify about any (pluggable) activity on your machine.   [![It hasn't been updated in recent three years][Y]](https://github.com/prashantgupta24/activity-tracker)   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/activity-tracker)
- [mac-sleep-notifier](https://github.com/prashantgupta24/mac-sleep-notifier) **star:20** OSX Sleep/Wake notifications in golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/prashantgupta24/mac-sleep-notifier)   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/mac-sleep-notifier)
- [AppIndicator Go](https://github.com/gopherlibs/appindicator) **star:3** Go bindings for libappindicator3 C library.   [![godoc][D]](https://godoc.org/github.com/gopherlibs/appindicator)

**[⬆ back to top](#contents)**

## Hardware

_Libraries, tools, and tutorials for interacting with hardware._

- [arduino-cli](https://github.com/arduino/arduino-cli) **star:3568** Official Arduino CLI and library. Can run standalone, or be incorporated into larger Go projects.   [![There was an update last month][G]](https://github.com/arduino/arduino-cli)   [![godoc][D]](https://godoc.org/github.com/arduino/arduino-cli)
- [go-rpio](https://github.com/stianeikeland/go-rpio) **star:1941** GPIO for Go, doesn't require cgo.   [![godoc][D]](https://godoc.org/github.com/stianeikeland/go-rpio)
- [ghw](https://github.com/jaypipes/ghw) **star:1229** Golang hardware discovery/inspection library.   [![godoc][D]](https://godoc.org/github.com/jaypipes/ghw)
- [emgo](https://github.com/ziutek/emgo) **star:990** Go-like language for programming embedded systems (e.g. STM32 MCU).
- [sysinfo](https://github.com/zcalusic/sysinfo) **star:383** A pure Go library providing Linux OS / kernel / hardware system information.   [![godoc][D]](https://godoc.org/github.com/zcalusic/sysinfo)
- [goroslib](https://github.com/aler9/goroslib) **star:226** Robot Operating System (ROS) library for Go.   [![godoc][D]](https://godoc.org/github.com/aler9/goroslib)
- [go-osc](https://github.com/hypebeast/go-osc) **star:160** Open Sound Control (OSC) bindings for Go.   [![godoc][D]](https://godoc.org/github.com/hypebeast/go-osc)
- [joystick](https://github.com/0xcafed00d/joystick) **star:40** a polled API to read the state of an attached joystick.   [![godoc][D]](https://godoc.org/github.com/0xcafed00d/joystick)

**[⬆ back to top](#contents)**

## Images

_Libraries for manipulating images._

- [gocv](https://github.com/hybridgroup/gocv) **star:5041** Go package for computer vision using OpenCV 3.3+.   [![There was an update last month][G]](https://github.com/hybridgroup/gocv)   [![godoc][D]](https://godoc.org/github.com/hybridgroup/gocv)
- [imaginary](https://github.com/h2non/imaginary) **star:4580** Fast and simple HTTP microservice for image resizing.   [![godoc][D]](https://godoc.org/github.com/h2non/imaginary)
- [imaging](https://github.com/disintegration/imaging) **star:4396** Simple Go image processing package.   [![godoc][D]](https://godoc.org/github.com/disintegration/imaging)
- [bild](https://github.com/anthonynsimon/bild) **star:3622** Collection of image processing algorithms in pure Go.   [![godoc][D]](https://godoc.org/github.com/anthonynsimon/bild)
- [gg](https://github.com/fogleman/gg) **star:3597** 2D rendering in pure Go.   [![godoc][D]](https://godoc.org/github.com/fogleman/gg)
- [ln](https://github.com/fogleman/ln) **star:3100** 3D line art rendering in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/fogleman/ln)   [![godoc][D]](https://godoc.org/github.com/fogleman/ln)
- [resize](https://github.com/nfnt/resize) **star:2885** Image resizing for Go with common interpolation methods.   [![godoc][D]](https://godoc.org/github.com/nfnt/resize)   [![Archived][Archived]](https://github.com/nfnt/resize)
- [bimg](https://github.com/h2non/bimg) **star:2056** Small package for fast and efficient image processing using libvips.   [![There was an update last month][G]](https://github.com/h2non/bimg)   [![godoc][D]](https://godoc.org/github.com/h2non/bimg)
- [pt](https://github.com/fogleman/pt) **star:2035** Path tracing engine written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/fogleman/pt)   [![godoc][D]](https://godoc.org/github.com/fogleman/pt)
- [svgo](https://github.com/ajstarks/svgo) **star:1895** Go Language Library for SVG generation.   [![godoc][D]](https://godoc.org/github.com/ajstarks/svgo)
- [gowitness](https://github.com/sensepost/gowitness) **star:1780** Screenshoting webpages using go and headless chrome on command line.   [![godoc][D]](https://godoc.org/github.com/sensepost/gowitness)
- [picfit](https://github.com/thoas/picfit) **star:1702** An image resizing server written in Go.   [![godoc][D]](https://godoc.org/github.com/thoas/picfit)
- [smartcrop](https://github.com/muesli/smartcrop) **star:1669** Finds good crops for arbitrary images and crop sizes.   [![godoc][D]](https://godoc.org/github.com/muesli/smartcrop)
- [gift](https://github.com/disintegration/gift) **star:1587** Package of image processing filters.   [![godoc][D]](https://godoc.org/github.com/disintegration/gift)
- [imagick](https://github.com/gographics/imagick) **star:1501** Go binding to ImageMagick's MagickWand C API.   [![godoc][D]](https://godoc.org/github.com/gographics/imagick)
- [go-opencv](https://github.com/lazywei/go-opencv) **star:1282** Go bindings for OpenCV.   [![It hasn't been updated in recent three years][Y]](https://github.com/lazywei/go-opencv)   [![godoc][D]](https://godoc.org/github.com/lazywei/go-opencv)
- [geopattern](https://github.com/pravj/geopattern) **star:1208** Create beautiful generative image patterns from a string.   [![It hasn't been updated in recent three years][Y]](https://github.com/pravj/geopattern)   [![godoc][D]](https://godoc.org/github.com/pravj/geopattern)
- [canvas](https://github.com/tdewolff/canvas) **star:1034** Vector graphics to PDF, SVG or rasterized image.   [![godoc][D]](https://godoc.org/github.com/tdewolff/canvas)
- [stegify](https://github.com/DimitarPetrov/stegify) **star:1034** Go tool for LSB steganography, capable of hiding any file within an image.   [![godoc][D]](https://godoc.org/github.com/DimitarPetrov/stegify)
- [govips](https://github.com/davidbyttow/govips) **star:760** A lightning fast image processing and resizing library for Go.   [![godoc][D]](https://godoc.org/github.com/davidbyttow/govips)
- [image2ascii](https://github.com/qeesung/image2ascii) **star:699** Convert image to ASCII.   [![godoc][D]](https://godoc.org/github.com/qeesung/image2ascii)
- [draft](https://github.com/lucasepe/draft) **star:550** Generate High Level Microservice Architecture diagrams for GraphViz using simple YAML syntax.   [![godoc][D]](https://godoc.org/github.com/lucasepe/draft)
- [goimagehash](https://github.com/corona10/goimagehash) **star:535** Go Perceptual image hashing package.   [![godoc][D]](https://godoc.org/github.com/corona10/goimagehash)
- [govatar](https://github.com/o1egl/govatar) **star:522** Library and CMD tool for generating funny avatars.   [![There was an update last month][G]](https://github.com/o1egl/govatar)   [![godoc][D]](https://godoc.org/github.com/o1egl/govatar)
- [mort](https://github.com/aldor007/mort) **star:462** Storage and image processing server written in Go.   [![godoc][D]](https://godoc.org/github.com/aldor007/mort)
- [go-nude](https://github.com/koyachi/go-nude) **star:357** Nudity detection with Go.   [![godoc][D]](https://godoc.org/github.com/koyachi/go-nude)
- [rez](https://github.com/bamiaux/rez) **star:208** Image resizing in pure Go and SIMD.   [![It hasn't been updated in recent three years][Y]](https://github.com/bamiaux/rez)   [![godoc][D]](https://godoc.org/github.com/bamiaux/rez)
- [darkroom](https://github.com/gojek/darkroom) **star:199** An image proxy with changeable storage backends and image processing engines with focus on speed and resiliency.   [![godoc][D]](https://godoc.org/github.com/gojek/darkroom)
- [mergi](https://github.com/noelyahan/mergi) **star:185** Tool & Go library for image manipulation (Merge, Crop, Resize, Watermark, Animate).   [![godoc][D]](https://godoc.org/github.com/noelyahan/mergi)
- [gltf](https://github.com/qmuntal/gltf) **star:180** Efficient and robust glTF 2.0 reader, writer and validator.   [![There was an update last month][G]](https://github.com/qmuntal/gltf)   [![godoc][D]](https://godoc.org/github.com/qmuntal/gltf)
- [steganography](https://github.com/auyer/steganography) **star:156** Pure Go Library for LSB steganography.   [![godoc][D]](https://godoc.org/github.com/auyer/steganography)
- [img](https://github.com/hawx/img) **star:142** Selection of image manipulation tools.   [![It hasn't been updated in recent three years][Y]](https://github.com/hawx/img)   [![godoc][D]](https://godoc.org/github.com/hawx/img)
- [go-cairo](https://github.com/ungerik/go-cairo) **star:125** Go binding for the cairo graphics library.   [![godoc][D]](https://godoc.org/github.com/ungerik/go-cairo)
- [cameron](https://github.com/aofei/cameron) **star:92** An avatar generator for Go.   [![godoc][D]](https://godoc.org/github.com/aofei/cameron)
- [go-webp](https://github.com/kolesa-team/go-webp) **star:80** Library for encode and decode webp pictures, using libwebp.   [![godoc][D]](https://godoc.org/github.com/kolesa-team/go-webp)
- [go-gd](https://github.com/bolknote/go-gd) **star:55** Go binding for GD library.   [![It hasn't been updated in recent three years][Y]](https://github.com/bolknote/go-gd)   [![godoc][D]](https://godoc.org/github.com/bolknote/go-gd)
- [gridder](https://github.com/shomali11/gridder) **star:55** A Grid based 2D Graphics library.   [![godoc][D]](https://godoc.org/github.com/shomali11/gridder)
- [webp-server](https://github.com/mehdipourfar/webp-server) **star:48** Simple and minimal image server capable of storing, resizing, converting and caching images.   [![godoc][D]](https://godoc.org/github.com/mehdipourfar/webp-server)
- [goimghdr](https://github.com/corona10/goimghdr) **star:39** The imghdr module determines the type of image contained in a file for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/corona10/goimghdr)   [![godoc][D]](https://godoc.org/github.com/corona10/goimghdr)
- [tga](https://github.com/ftrvxmtrx/tga) **star:32** Package tga is a TARGA image format decoder/encoder.   [![It hasn't been updated in recent three years][Y]](https://github.com/ftrvxmtrx/tga)   [![godoc][D]](https://godoc.org/github.com/ftrvxmtrx/tga)   [![Archived][Archived]](https://github.com/ftrvxmtrx/tga)
- [go-webcolors](https://github.com/jyotiska/go-webcolors) **star:27** Port of webcolors library from Python to Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/jyotiska/go-webcolors)   [![godoc][D]](https://godoc.org/github.com/jyotiska/go-webcolors)
- [mpo](https://github.com/donatj/mpo) **star:10** Decoder and conversion tool for MPO 3D Photos.   [![godoc][D]](https://godoc.org/github.com/donatj/mpo)
- [scout](https://github.com/jonoton/scout) **star:6** Scout is a standalone open source software solution for DIY video security.   [![godoc][D]](https://godoc.org/github.com/jonoton/scout)

**[⬆ back to top](#contents)**

## IoT (Internet of Things)

_Libraries for programming devices of the IoT._

- [flogo](https://github.com/tibcosoftware/flogo) **star:2115** Project Flogo is an Open Source Framework for IoT Edge Apps & Integration.
- [mainflux](https://github.com/Mainflux/mainflux) **star:1892** Industrial IoT Messaging and Device Management Server.   [![There was an update last month][G]](https://github.com/Mainflux/mainflux)   [![godoc][D]](https://godoc.org/github.com/Mainflux/mainflux)
- [periph](https://periph.io/)  Peripherals I/O to interface with low-level board facilities.
- [gatt](https://github.com/paypal/gatt) **star:1042** Gatt is a Go package for building Bluetooth Low Energy peripherals.   [![godoc][D]](https://godoc.org/github.com/paypal/gatt)
- [gobot](https://github.com/hybridgroup/gobot/)  Gobot is a framework for robotics, physical computing, and the Internet of Things.
- [connectordb](https://github.com/connectordb/connectordb) **star:350** Open-Source Platform for Quantified Self & IoT.   [![godoc][D]](https://godoc.org/github.com/connectordb/connectordb)
- [devices](https://github.com/goiot/devices) **star:256** Suite of libraries for IoT devices, experimental for x/exp/io.   [![It hasn't been updated in recent three years][Y]](https://github.com/goiot/devices)   [![godoc][D]](https://godoc.org/github.com/goiot/devices)
- [huego](https://github.com/amimof/huego) **star:219** An extensive Philips Hue client library for Go.   [![godoc][D]](https://godoc.org/github.com/amimof/huego)
- [iot](https://github.com/vaelen/iot/)  IoT is a simple framework for implementing a Google IoT Core device.
- [sensorbee](https://github.com/sensorbee/sensorbee) **star:214** Lightweight stream processing engine for IoT.   [![godoc][D]](https://godoc.org/github.com/sensorbee/sensorbee)
- [eywa](https://github.com/xcodersun/eywa) **star:58** Project Eywa is essentially a connection manager that keeps track of connected devices.   [![It hasn't been updated in recent three years][Y]](https://github.com/xcodersun/eywa)   [![godoc][D]](https://godoc.org/github.com/xcodersun/eywa)

**[⬆ back to top](#contents)**

## Job Scheduler

_Libraries for scheduling jobs._

- [gocron](https://github.com/go-co-op/gocron) **star:2365** Easy and fluent Go job scheduling. This is an actively maintained fork of [jasonlvhit/gocron](https://github.com/jasonlvhit/gocron).   [![godoc][D]](https://godoc.org/github.com/go-co-op/gocron)
- [go-quartz](https://github.com/reugn/go-quartz) **star:951** Simple, zero-dependency scheduling library for Go.   [![godoc][D]](https://godoc.org/github.com/reugn/go-quartz)
- [JobRunner](https://github.com/bamzi/jobrunner) **star:942** Smart and featureful cron job scheduler with job queuing and live monitoring built in.   [![godoc][D]](https://godoc.org/github.com/bamzi/jobrunner)
- [gron](https://github.com/roylee0704/gron) **star:920** Define time-based tasks using a simple Go API and Gron’s scheduler will run them accordingly.   [![godoc][D]](https://godoc.org/github.com/roylee0704/gron)
- [jobs](https://github.com/albrow/jobs) **star:492** Persistent and flexible background jobs library.   [![It hasn't been updated in recent three years][Y]](https://github.com/albrow/jobs)   [![godoc][D]](https://godoc.org/github.com/albrow/jobs)   [![Archived][Archived]](https://github.com/albrow/jobs)
- [Dagu](https://github.com/dagu-go/dagu) **star:418** No-code workflow executor. it executes DAGs defined in a simple YAML format.   [![There was an update last month][G]](https://github.com/dagu-go/dagu)   [![godoc][D]](https://godoc.org/github.com/dagu-go/dagu)
- [scheduler](https://github.com/carlescere/scheduler) **star:398** Cronjobs scheduling made easy.   [![godoc][D]](https://godoc.org/github.com/carlescere/scheduler)
- [gronx](https://github.com/adhocore/gronx) **star:215** Cron expression parser, task runner and daemon consuming crontab like task list.   [![godoc][D]](https://godoc.org/github.com/adhocore/gronx)
- [go-cron](https://github.com/rk/go-cron) **star:213** Simple Cron library for go that can execute closures or functions at varying intervals, from once a second to once a year on a specific date and time. Primarily for web applications and long running daemons.   [![godoc][D]](https://godoc.org/github.com/rk/go-cron)
- [clockwerk](https://github.com/onatm/clockwerk) **star:126** Go package to schedule periodic jobs using a simple, fluent syntax.   [![godoc][D]](https://godoc.org/github.com/onatm/clockwerk)
- [tasks](https://github.com/madflojo/tasks) **star:113** An easy to use in-process scheduler for recurring tasks in Go.   [![godoc][D]](https://godoc.org/github.com/madflojo/tasks)
- [leprechaun](https://github.com/kilgaloon/leprechaun) **star:90** Job scheduler that supports webhooks, crons and classic scheduling.   [![godoc][D]](https://godoc.org/github.com/kilgaloon/leprechaun)
- [goflow](https://github.com/fieldryand/goflow) **star:64** A workflow orchestrator and scheduler for rapid prototyping of ETL/ML/AI pipelines.   [![godoc][D]](https://godoc.org/github.com/fieldryand/goflow)
- [cheek](https://github.com/datarootsio/cheek) **star:53** A simple crontab like scheduler that aims to offer a KISS approach to job scheduling.   [![There was an update last month][G]](https://github.com/datarootsio/cheek)   [![godoc][D]](https://godoc.org/github.com/datarootsio/cheek)
- [sched](https://github.com/romshark/sched) **star:26** A job scheduler with the ability to fast-forward time.   [![godoc][D]](https://godoc.org/github.com/romshark/sched)
- [cdule](https://github.com/deepaksinghvi/cdule) **star:12** Job scheduler library with database support   [![godoc][D]](https://godoc.org/github.com/deepaksinghvi/cdule)
- [cronticker](https://github.com/krayzpipes/cronticker) **star:7** A ticker implementation to support cron schedules.   [![godoc][D]](https://godoc.org/github.com/krayzpipes/cronticker)

**[⬆ back to top](#contents)**

## JSON

_Libraries for working with JSON._

- [GJSON](https://github.com/tidwall/gjson) **star:11145** Get a JSON value with one line of code.   [![godoc][D]](https://godoc.org/github.com/tidwall/gjson)
- [gojson](https://github.com/ChimeraCoder/gojson) **star:2541** Automatically generate Go (golang) struct definitions from example JSON.   [![godoc][D]](https://godoc.org/github.com/ChimeraCoder/gojson)
- [fastjson](https://github.com/valyala/fastjson) **star:1677** Fast JSON parser and validator for Go. No custom structs, no code generation, no reflection.   [![godoc][D]](https://godoc.org/github.com/valyala/fastjson)
- [OjG](https://github.com/ohler55/ojg) **star:513** Optimized JSON for Go is a high performance parser with a variety of additional JSON tools including JSONPath.   [![godoc][D]](https://godoc.org/github.com/ohler55/ojg)
- [kazaam](https://github.com/Qntfy/kazaam) **star:241** API for arbitrary transformation of JSON documents.   [![godoc][D]](https://godoc.org/github.com/Qntfy/kazaam)
- [marshmallow](https://github.com/PerimeterX/marshmallow) **star:210** Performant JSON unmarshaling for flexible use cases.   [![There was an update last month][G]](https://github.com/PerimeterX/marshmallow)   [![godoc][D]](https://godoc.org/github.com/PerimeterX/marshmallow)
- [jsondiff](https://github.com/wI2L/jsondiff) **star:206** JSON diff library for Go based on RFC6902 (JSON Patch).   [![godoc][D]](https://godoc.org/github.com/wI2L/jsondiff)
- [gojq](https://github.com/elgs/gojq) **star:184** JSON query in Golang.   [![godoc][D]](https://godoc.org/github.com/elgs/gojq)
- [jettison](https://github.com/wI2L/jettison) **star:136** Fast and flexible JSON encoder for Go.   [![godoc][D]](https://godoc.org/github.com/wI2L/jettison)
- [ajson](https://github.com/spyzhov/ajson) **star:131** Abstract JSON for golang with JSONPath support.   [![godoc][D]](https://godoc.org/github.com/spyzhov/ajson)
- [gjo](https://github.com/skanehira/gjo) **star:112** Small utility to create JSON objects.   [![godoc][D]](https://godoc.org/github.com/skanehira/gjo)
- [json2go](https://github.com/m-zajac/json2go) **star:107** Advanced JSON to Go struct conversion. Provides package that can parse multiple JSON documents and create struct to fit them all.   [![godoc][D]](https://godoc.org/github.com/m-zajac/json2go)
- [jsongo](https://github.com/ricardolonga/jsongo) **star:105** Fluent API to make it easier to create Json objects.   [![godoc][D]](https://godoc.org/github.com/ricardolonga/jsongo)
- [JayDiff](https://github.com/yazgazan/jaydiff) **star:92** JSON diff utility written in Go.   [![godoc][D]](https://godoc.org/github.com/yazgazan/jaydiff)
- [jsonf](https://github.com/miolini/jsonf) **star:64** Console tool for highlighted formatting and struct query fetching JSON.   [![godoc][D]](https://godoc.org/github.com/miolini/jsonf)
- [ujson](https://github.com/olvrng/ujson) **star:60** Fast and minimal JSON parser and transformer that works on unstructured JSON.   [![godoc][D]](https://godoc.org/github.com/olvrng/ujson)
- [go-respond](https://github.com/nicklaw5/go-respond) **star:50** Go package for handling common HTTP JSON responses.   [![godoc][D]](https://godoc.org/github.com/nicklaw5/go-respond)
- [mp](https://github.com/sanbornm/mp) **star:46** Simple cli email parser. It currently takes stdin and outputs JSON.   [![It hasn't been updated in recent three years][Y]](https://github.com/sanbornm/mp)   [![godoc][D]](https://godoc.org/github.com/sanbornm/mp)
- [vjson](https://github.com/miladibra10/vjson) **star:31** Go package for validating JSON objects with declaring a JSON schema with fluent API.   [![godoc][D]](https://godoc.org/github.com/miladibra10/vjson)
- [jsoncolor](https://github.com/neilotoole/jsoncolor) **star:28** Drop-in replacement for `encoding/json` that outputs colorized JSON.   [![godoc][D]](https://godoc.org/github.com/neilotoole/jsoncolor)
- [ask](https://github.com/simonnilsson/ask) **star:19** Easy access to nested values in maps and slices. Works in combination with encoding/json and other packages that "Unmarshal" arbitrary data into Go data-types.   [![godoc][D]](https://godoc.org/github.com/simonnilsson/ask)
- [jscan](https://github.com/romshark/jscan) **star:15** High performance zero-allocation JSON iterator.   [![godoc][D]](https://godoc.org/github.com/romshark/jscan)
- [JSON-to-Go](https://mholt.github.io/json-to-go/)  Convert JSON to Go struct.
- [JSON-to-Proto](https://json-to-proto.github.io/)  Convert JSON to Protobuf online.
- [mapslice-json](https://github.com/mickep76/mapslice-json) **star:14** Go MapSlice for ordered marshal/ unmarshal of maps in JSON.   [![godoc][D]](https://godoc.org/github.com/mickep76/mapslice-json)
- [dynjson](https://github.com/cocoonspace/dynjson) **star:13** Client-customizable JSON formats for dynamic APIs.   [![godoc][D]](https://godoc.org/github.com/cocoonspace/dynjson)
- [go-jsonerror](https://github.com/ddymko/go-jsonerror) **star:13** Go-JsonError is ment to allow us to easily create json response errors that follow the JsonApi spec.   [![It hasn't been updated in recent three years][Y]](https://github.com/ddymko/go-jsonerror)   [![godoc][D]](https://godoc.org/github.com/ddymko/go-jsonerror)
- [jsonapi-errors](https://github.com/AmuzaTkts/jsonapi-errors) **star:13** Go bindings based on the JSON API errors reference.   [![It hasn't been updated in recent three years][Y]](https://github.com/AmuzaTkts/jsonapi-errors)   [![godoc][D]](https://godoc.org/github.com/AmuzaTkts/jsonapi-errors)
- [jsonhal](https://github.com/RichardKnop/jsonhal) **star:12** Simple Go package to make custom structs marshal into HAL compatible JSON responses.   [![godoc][D]](https://godoc.org/github.com/RichardKnop/jsonhal)
- [jzon](https://github.com/zerosnake0/jzon) **star:11** JSON library with standard compatible API/behavior.   [![godoc][D]](https://godoc.org/github.com/zerosnake0/jzon)
- [epoch](https://github.com/vtopc/epoch) **star:10** Contains primitives for marshaling/unmarshaling Unix timestamp/epoch to/from build-in time.Time type in JSON.   [![godoc][D]](https://godoc.org/github.com/vtopc/epoch)
- [ej](https://github.com/lucassscaravelli/ej) **star:9** Write and read JSON from different sources succinctly.   [![godoc][D]](https://godoc.org/github.com/lucassscaravelli/ej)
- [jsonic](https://github.com/sinhashubham95/jsonic) **star:8** Utilities to handle and query JSON without defining structs in a type safe manner.   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/jsonic)
- [omg.jsonparser](https://github.com/dedalqq/omg.jsonparser) **star:4** Simple JSON parser with validation by condition via golang struct fields tags.   [![godoc][D]](https://godoc.org/github.com/dedalqq/omg.jsonparser)

**[⬆ back to top](#contents)**

## Logging

_Libraries for generating and working with log files._

- [logrus](https://github.com/Sirupsen/logrus) **star:21394** Structured logger for Go.   [![godoc][D]](https://godoc.org/github.com/Sirupsen/logrus)
- [lumberjack](https://github.com/natefinch/lumberjack) **star:3582** Simple rolling logger, implements io.WriteCloser.   [![There was an update last month][G]](https://github.com/natefinch/lumberjack)   [![godoc][D]](https://godoc.org/github.com/natefinch/lumberjack)
- [glog](https://github.com/golang/glog) **star:3238** Leveled execution logs for Go.   [![godoc][D]](https://godoc.org/github.com/golang/glog)
- [seelog](https://github.com/cihub/seelog) **star:1619** Logging functionality with flexible dispatching, filtering, and formatting.   [![It hasn't been updated in recent three years][Y]](https://github.com/cihub/seelog)   [![godoc][D]](https://godoc.org/github.com/cihub/seelog)
- [log](https://github.com/apex/log) **star:1260** Structured logging package for Go.   [![godoc][D]](https://godoc.org/github.com/apex/log)
- [log15](https://github.com/inconshreveable/log15) **star:1069** Simple, powerful logging for Go.   [![godoc][D]](https://godoc.org/github.com/inconshreveable/log15)
- [phuslu/log](https://github.com/phuslu/log) **star:454** High performance structured logging.   [![godoc][D]](https://godoc.org/github.com/phuslu/log)
- [onelog](https://github.com/francoispqt/onelog) **star:402** Onelog is a dead simple but very efficient JSON logger. It is the fastest JSON logger out there in all scenarios. Also, it is one of the logger with the lowest allocation.   [![It hasn't been updated in recent three years][Y]](https://github.com/francoispqt/onelog)   [![godoc][D]](https://godoc.org/github.com/francoispqt/onelog)
- [logxi](https://github.com/mgutz/logxi) **star:350** 12-factor app logger that is fast and makes you happy.   [![godoc][D]](https://godoc.org/github.com/mgutz/logxi)
- [logutils](https://github.com/hashicorp/logutils) **star:331** Utilities for slightly better logging in Go (Golang) extending the standard logger.   [![godoc][D]](https://godoc.org/github.com/hashicorp/logutils)
- [log](https://github.com/go-playground/log) **star:283** Simple, configurable and scalable Structured Logging for Go.   [![godoc][D]](https://godoc.org/github.com/go-playground/log)
- [go-logger](https://github.com/apsdehal/go-logger) **star:280** Simple logger of Go Programs, with level handlers.   [![It hasn't been updated in recent three years][Y]](https://github.com/apsdehal/go-logger)   [![godoc][D]](https://godoc.org/github.com/apsdehal/go-logger)
- [httpretty](https://github.com/henvic/httpretty) **star:278** Pretty-prints your regular HTTP requests on your terminal for debugging (similar to http.DumpRequest).   [![godoc][D]](https://godoc.org/github.com/henvic/httpretty)
- [rollingwriter](https://github.com/arthurkiller/rollingWriter) **star:247** RollingWriter is an auto-rotate `io.Writer` implementation with multi policies to provide log file rotation.   [![godoc][D]](https://godoc.org/github.com/arthurkiller/rollingWriter)
- [logur](https://github.com/logur/logur) **star:176** An opinionated logger interface and collection of logging best practices with adapters and integrations for well-known libraries ([logrus](https://github.com/sirupsen/logrus), [go-kit log](https://github.com/go-kit/kit/tree/master/log), [zap](https://github.com/uber-go/zap), [zerolog](https://github.com/rs/zerolog), etc).   [![godoc][D]](https://godoc.org/github.com/logur/logur)
- [glg](https://github.com/kpango/glg) **star:171** glg is simple and fast leveled logging library for Go.   [![godoc][D]](https://godoc.org/github.com/kpango/glg)
- [logger](https://github.com/azer/logger) **star:157** Minimalistic logging library for Go.   [![godoc][D]](https://godoc.org/github.com/azer/logger)
- [ozzo-log](https://github.com/go-ozzo/ozzo-log) **star:121** High performance logging supporting log severity, categorization, and filtering. Can send filtered log messages to various targets (e.g. console, network, mail).   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-log)   [![Contains Chinese documents][CN]](https://github.com/go-ozzo/ozzo-log)
- [log-voyage](https://github.com/firstrow/logvoyage) **star:93** Full-featured logging saas written in golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/firstrow/logvoyage)   [![godoc][D]](https://godoc.org/github.com/firstrow/logvoyage)
- [go-cronowriter](https://github.com/utahta/go-cronowriter) **star:50** Simple writer that rotate log files automatically based on current date and time, like cronolog.   [![godoc][D]](https://godoc.org/github.com/utahta/go-cronowriter)
- [gologger](https://github.com/sadlil/gologger) **star:41** Simple easy to use log lib for go, logs in Colored Console, Simple Console, File or Elasticsearch.   [![It hasn't been updated in recent three years][Y]](https://github.com/sadlil/gologger)   [![godoc][D]](https://godoc.org/github.com/sadlil/gologger)   [![Archived][Archived]](https://github.com/sadlil/gologger)
- [logex](https://github.com/chzyer/logex) **star:40** Golang log lib, supports tracking and level, wrap by standard log lib.   [![godoc][D]](https://godoc.org/github.com/chzyer/logex)
- [noodlog](https://github.com/gyozatech/noodlog) **star:40** Parametrized JSON logging library which lets you obfuscate sensitive data and marshal any kind of content. No more printed pointers instead of values, nor escape chars for the JSON strings.   [![godoc][D]](https://godoc.org/github.com/gyozatech/noodlog)
- [go-log](https://github.com/ian-kent/go-log) **star:39** Log4j implementation in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/go-log)   [![godoc][D]](https://godoc.org/github.com/ian-kent/go-log)
- [go-log](https://github.com/siddontang/go-log) **star:32** Log lib supports level and multi handlers.   [![It hasn't been updated in recent three years][Y]](https://github.com/siddontang/go-log)   [![godoc][D]](https://godoc.org/github.com/siddontang/go-log)
- [journald](https://github.com/ssgreg/journald) **star:32** Go implementation of systemd Journal's native API for logging.   [![godoc][D]](https://godoc.org/github.com/ssgreg/journald)
- [distillog](https://github.com/amoghe/distillog) **star:30** distilled levelled logging (think of it as stdlib + log levels).   [![It hasn't been updated in recent three years][Y]](https://github.com/amoghe/distillog)   [![godoc][D]](https://godoc.org/github.com/amoghe/distillog)
- [logrusly](https://github.com/sebest/logrusly) **star:28** [logrus](https://github.com/sirupsen/logrus) plug-in to send errors to a [Loggly](https://www.loggly.com/).   [![godoc][D]](https://godoc.org/github.com/sebest/logrusly)
- [mlog](https://github.com/jbrodriguez/mlog) **star:28** Simple logging module for go, with 5 levels, an optional rotating logfile feature and stdout/stderr output.   [![It hasn't been updated in recent three years][Y]](https://github.com/jbrodriguez/mlog)   [![godoc][D]](https://godoc.org/github.com/jbrodriguez/mlog)
- [log](https://github.com/teris-io/log) **star:26** Structured log interface for Go cleanly separates logging facade from its implementation.   [![It hasn't been updated in recent three years][Y]](https://github.com/teris-io/log)   [![godoc][D]](https://godoc.org/github.com/teris-io/log)
- [gomol](https://github.com/aphistic/gomol) **star:19** Multiple-output, structured logging for Go with extensible logging outputs.   [![It hasn't been updated in recent three years][Y]](https://github.com/aphistic/gomol)   [![godoc][D]](https://godoc.org/github.com/aphistic/gomol)
- [gone/log](https://github.com/One-com/gone/tree/master/log)  Fast, extendable, full-featured, std-lib source compatible log library.
- [glo](https://github.com/lajosbencz/glo) **star:15** PHP Monolog inspired logging facility with identical severity levels.   [![It hasn't been updated in recent three years][Y]](https://github.com/lajosbencz/glo)   [![godoc][D]](https://godoc.org/github.com/lajosbencz/glo)
- [logmatic](https://github.com/borderstech/logmatic) **star:15** Colorized logger for Golang with dynamic log level configuration.   [![godoc][D]](https://godoc.org/github.com/borderstech/logmatic)
- [logrusiowriter](https://github.com/cabify/logrusiowriter) **star:14** `io.Writer` implementation using [logrus](https://github.com/sirupsen/logrus) logger.   [![godoc][D]](https://godoc.org/github.com/cabify/logrusiowriter)
- [go-log](https://github.com/subchen/go-log) **star:13** Simple and configurable Logging in Go, with level, formatters and writers.   [![It hasn't been updated in recent three years][Y]](https://github.com/subchen/go-log)   [![godoc][D]](https://godoc.org/github.com/subchen/go-log)
- [log](https://github.com/heartwilltell/log) **star:13** Simple leveled logging wrapper around standard log package.   [![godoc][D]](https://godoc.org/github.com/heartwilltell/log)
- [logo](https://github.com/mbndr/logo) **star:11** Golang logger to different configurable writers.   [![godoc][D]](https://godoc.org/github.com/mbndr/logo)
- [go-log](https://github.com/pieterclaerhout/go-log) **star:10** A logging library with stack traces, object dumping and optional timestamps.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-log)
- [log](https://github.com/aerogo/log) **star:10** An O(1) logging system that allows you to connect one log to multiple writers (e.g. stdout, a file and a TCP connection).   [![godoc][D]](https://godoc.org/github.com/aerogo/log)
- [logdump](https://github.com/ewwwwwqm/logdump) **star:10** Package for multi-level logging.   [![It hasn't been updated in recent three years][Y]](https://github.com/ewwwwwqm/logdump)   [![godoc][D]](https://godoc.org/github.com/ewwwwwqm/logdump)
- [kemba](https://github.com/clok/kemba) **star:9** A tiny debug logging tool inspired by [debug](https://github.com/visionmedia/debug), great for CLI tools and applications.   [![godoc][D]](https://godoc.org/github.com/clok/kemba)
- [slf4g](https://github.com/echocat/slf4g) **star:2** Simple Logging Facade for Golang: Simple structured logging; but powerful, extendable and customizable, with huge amount of learnings from decades of past logging frameworks.   [![godoc][D]](https://godoc.org/github.com/echocat/slf4g)
- [slog](https://github.com/gookit/slog) Lightweight, configurable, extensible logger for Go.
- [zap](https://github.com/uber-go/zap) **star:17107** Fast, structured, leveled logging in Go.   [![godoc][D]](https://godoc.org/github.com/uber-go/zap)
- [zerolog](https://github.com/rs/zerolog) **star:7021** Zero-allocation JSON logger.   [![There was an update last month][G]](https://github.com/rs/zerolog)   [![godoc][D]](https://godoc.org/github.com/rs/zerolog)
- [spew](https://github.com/davecgh/go-spew) **star:5321** Implements a deep pretty printer for Go data structures to aid in debugging.   [![godoc][D]](https://godoc.org/github.com/davecgh/go-spew)
- [tail](https://github.com/hpcloud/tail) **star:2434** Go package striving to emulate the features of the BSD tail program.   [![godoc][D]](https://godoc.org/github.com/hpcloud/tail)
- [sqldb-logger](https://github.com/simukti/sqldb-logger) **star:268** A logger for Go SQL database driver without modify existing *sql.DB stdlib usage.   [![godoc][D]](https://godoc.org/github.com/simukti/sqldb-logger)
- [xlog](https://github.com/rs/xlog) **star:137** Structured logger for `net/context` aware HTTP handlers with flexible dispatching.   [![godoc][D]](https://godoc.org/github.com/rs/xlog)
- [stdlog](https://github.com/alexcesaro/log) **star:45** Stdlog is an object-oriented library providing leveled logging. It is very useful for cron jobs.   [![It hasn't been updated in recent three years][Y]](https://github.com/alexcesaro/log)   [![godoc][D]](https://godoc.org/github.com/alexcesaro/log)
- [zkits-logger](https://github.com/edoger/zkits-logger) **star:22** A powerful zero-dependency JSON logger.   [![godoc][D]](https://godoc.org/github.com/edoger/zkits-logger)
- [xlog](https://github.com/xfxdev/xlog) **star:8** Plugin architecture and flexible log system for Go, with level ctrl, multiple log target and custom log format.   [![It hasn't been updated in recent three years][Y]](https://github.com/xfxdev/xlog)   [![godoc][D]](https://godoc.org/github.com/xfxdev/xlog)
- [structy/log](https://github.com/structy/log) **star:5** A simple to use log system, minimalist but with features for debugging and differentiation of messages.   [![godoc][D]](https://godoc.org/github.com/structy/log)
- [xylog](https://github.com/xybor-x/xylog) **star:5** Leveled and structured logging, dynamic fields, high performance, zone management, simple configuration, and readable syntax.   [![godoc][D]](https://godoc.org/github.com/xybor-x/xylog)
- [yell](https://github.com/jfcg/yell) **star:1** Yet another minimalistic logging library.   [![godoc][D]](https://godoc.org/github.com/jfcg/yell)

**[⬆ back to top](#contents)**

## Machine Learning

_Libraries for Machine Learning._

- [GoLearn](https://github.com/sjwhitworth/golearn) **star:8540** General Machine Learning library for Go.   [![godoc][D]](https://godoc.org/github.com/sjwhitworth/golearn)   [![Contains Chinese documents][CN]](https://github.com/sjwhitworth/golearn)
- [gorse](https://github.com/zhenghaoz/gorse) **star:6233** An offline recommender system backend based on collaborative filtering written in Go.   [![There was an update last month][G]](https://github.com/zhenghaoz/gorse)   [![godoc][D]](https://godoc.org/github.com/zhenghaoz/gorse)   [![Contains Chinese documents][CN]](https://github.com/zhenghaoz/gorse)
- [gorgonia](https://github.com/gorgonia/gorgonia) **star:4659** graph-based computational library like Theano for Go that provides primitives for building various machine learning and neural network algorithms.   [![godoc][D]](https://godoc.org/github.com/gorgonia/gorgonia)
- [m2cgen](https://github.com/BayesWitnesses/m2cgen) **star:2218** A CLI tool to transpile trained classic ML models into a native Go code with zero dependencies, written in Python with Go language support.   [![There was an update last month][G]](https://github.com/BayesWitnesses/m2cgen)
- [tfgo](https://github.com/galeone/tfgo) **star:2042** Easy to use Tensorflow bindings: simplifies the usage of the official Tensorflow Go bindings. Define computational graphs in Go, load and execute models trained in Python.   [![godoc][D]](https://godoc.org/github.com/galeone/tfgo)
- [gosseract](https://github.com/otiai10/gosseract) **star:1873** Go package for OCR (Optical Character Recognition), by using Tesseract C++ library.   [![godoc][D]](https://godoc.org/github.com/otiai10/gosseract)
- [goml](https://github.com/cdipaolo/goml) **star:1384** On-line Machine Learning in Go.   [![godoc][D]](https://godoc.org/github.com/cdipaolo/goml)
- [eaopt](https://github.com/MaxHalford/eaopt) **star:812** An evolutionary optimization library.   [![godoc][D]](https://godoc.org/github.com/MaxHalford/eaopt)
- [bayesian](https://github.com/jbrukh/bayesian) **star:742** Naive Bayesian Classification for Golang.   [![godoc][D]](https://godoc.org/github.com/jbrukh/bayesian)
- [CloudForest](https://github.com/ryanbressler/CloudForest) **star:717** Fast, flexible, multi-threaded ensembles of decision trees for machine learning in pure Go.   [![godoc][D]](https://godoc.org/github.com/ryanbressler/CloudForest)
- [ocrserver](https://github.com/otiai10/ocrserver) **star:530** A simple OCR API server, seriously easy to be deployed by Docker and Heroku.   [![godoc][D]](https://godoc.org/github.com/otiai10/ocrserver)
- [gobrain](https://github.com/goml/gobrain) **star:526** Neural Networks written in go.   [![godoc][D]](https://godoc.org/github.com/goml/gobrain)
- [onnx-go](https://github.com/owulveryck/onnx-go) **star:428** Go Interface to Open Neural Network Exchange (ONNX).   [![There was an update last month][G]](https://github.com/owulveryck/onnx-go)   [![godoc][D]](https://godoc.org/github.com/owulveryck/onnx-go)
- [go-deep](https://github.com/patrikeh/go-deep) **star:390** A feature-rich neural network library in Go.   [![godoc][D]](https://godoc.org/github.com/patrikeh/go-deep)
- [regommend](https://github.com/muesli/regommend) **star:300** Recommendation & collaborative filtering engine.   [![It hasn't been updated in recent three years][Y]](https://github.com/muesli/regommend)   [![godoc][D]](https://godoc.org/github.com/muesli/regommend)
- [Goptuna](https://github.com/c-bata/goptuna) **star:223** Bayesian optimization framework for black-box functions written in Go. Everything will be optimized.   [![godoc][D]](https://godoc.org/github.com/c-bata/goptuna)
- [go-galib](https://github.com/thoj/go-galib) **star:193** Genetic Algorithms library written in Go / golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/thoj/go-galib)   [![godoc][D]](https://godoc.org/github.com/thoj/go-galib)
- [goRecommend](https://github.com/timkaye11/goRecommend) **star:192** Recommendation Algorithms library written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/timkaye11/goRecommend)   [![godoc][D]](https://godoc.org/github.com/timkaye11/goRecommend)
- [goga](https://github.com/tomcraven/goga) **star:168** Genetic algorithm library for Go.   [![godoc][D]](https://godoc.org/github.com/tomcraven/goga)
- [shield](https://github.com/eaigner/shield) **star:152** Bayesian text classifier with flexible tokenizers and storage backends for Go.   [![godoc][D]](https://godoc.org/github.com/eaigner/shield)
- [go-fann](https://github.com/white-pony/go-fann) **star:111** Go bindings for Fast Artificial Neural Networks(FANN) library.   [![It hasn't been updated in recent three years][Y]](https://github.com/white-pony/go-fann)   [![godoc][D]](https://godoc.org/github.com/white-pony/go-fann)
- [goscore](https://github.com/asafschers/goscore) **star:84** Go Scoring API for PMML.   [![It hasn't been updated in recent three years][Y]](https://github.com/asafschers/goscore)   [![godoc][D]](https://godoc.org/github.com/asafschers/goscore)
- [go-featureprocessing](https://github.com/nikolaydubina/go-featureprocessing) **star:82** Fast and convenient feature processing for low latency machine learning in Go.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-featureprocessing)
- [gonet](https://github.com/dathoangnd/gonet) **star:76** Neural Network for Go.   [![godoc][D]](https://godoc.org/github.com/dathoangnd/gonet)
- [libsvm](https://github.com/datastream/libsvm) **star:72** libsvm golang version derived work based on LIBSVM 3.14.   [![It hasn't been updated in recent three years][Y]](https://github.com/datastream/libsvm)   [![godoc][D]](https://godoc.org/github.com/datastream/libsvm)
- [fonet](https://github.com/Fontinalis/fonet) **star:70** A Deep Neural Network library written in Go.   [![godoc][D]](https://godoc.org/github.com/Fontinalis/fonet)
- [neat](https://github.com/jinyeom/neat) **star:66** Plug-and-play, parallel Go framework for NeuroEvolution of Augmenting Topologies (NEAT).   [![It hasn't been updated in recent three years][Y]](https://github.com/jinyeom/neat)   [![godoc][D]](https://godoc.org/github.com/jinyeom/neat)   [![Archived][Archived]](https://github.com/jinyeom/neat)
- [neural-go](https://github.com/schuyler/neural-go) **star:64** Multilayer perceptron network implemented in Go, with training via backpropagation.   [![godoc][D]](https://godoc.org/github.com/schuyler/neural-go)
- [go-pr](https://github.com/daviddengcn/go-pr) **star:62** Pattern recognition package in Go lang.   [![It hasn't been updated in recent three years][Y]](https://github.com/daviddengcn/go-pr)   [![godoc][D]](https://godoc.org/github.com/daviddengcn/go-pr)
- [Varis](https://github.com/Xamber/Varis) **star:48** Golang Neural Network.   [![It hasn't been updated in recent three years][Y]](https://github.com/Xamber/Varis)   [![godoc][D]](https://godoc.org/github.com/Xamber/Varis)
- [golinear](https://github.com/danieldk/golinear) **star:45** liblinear bindings for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/danieldk/golinear)   [![godoc][D]](https://godoc.org/github.com/danieldk/golinear)
- [go-cluster](https://github.com/e-XpertSolutions/go-cluster) **star:35** Go implementation of the k-modes and k-prototypes clustering algorithms.   [![It hasn't been updated in recent three years][Y]](https://github.com/e-XpertSolutions/go-cluster)   [![godoc][D]](https://godoc.org/github.com/e-XpertSolutions/go-cluster)
- [godist](https://github.com/e-dard/godist) **star:35** Various probability distributions, and associated methods.   [![It hasn't been updated in recent three years][Y]](https://github.com/e-dard/godist)   [![godoc][D]](https://godoc.org/github.com/e-dard/godist)
- [GoMind](https://github.com/surenderthakran/gomind) **star:35** A simplistic Neural Network Library in Go.   [![godoc][D]](https://godoc.org/github.com/surenderthakran/gomind)
- [evoli](https://github.com/khezen/evoli) **star:25** Genetic Algorithm and Particle Swarm Optimization library.   [![godoc][D]](https://godoc.org/github.com/khezen/evoli)
- [randomforest](https://github.com/malaschitz/randomForest) **star:25** Easy to use Random Forest library for Go.   [![godoc][D]](https://godoc.org/github.com/malaschitz/randomForest)
- [ddt](https://github.com/sgrodriguez/ddt) **star:21** Dynamic decision tree, create trees defining customizable rules.   [![godoc][D]](https://godoc.org/github.com/sgrodriguez/ddt)
- [probab](https://github.com/ThePaw/probab) **star:18** Probability distribution functions. Bayesian inference. Written in pure Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ThePaw/probab)   [![godoc][D]](https://godoc.org/github.com/ThePaw/probab)

**[⬆ back to top](#contents)**

## Messaging

_Libraries that implement messaging systems._

- [sarama](https://github.com/Shopify/sarama) **star:9239** Go library for Apache Kafka.   [![There was an update last month][G]](https://github.com/Shopify/sarama)   [![godoc][D]](https://godoc.org/github.com/Shopify/sarama)
- [gorush](https://github.com/appleboy/gorush) **star:6597** Push notification server using [APNs2](https://github.com/sideshow/apns2) and google [GCM](https://github.com/google/go-gcm).   [![godoc][D]](https://godoc.org/github.com/appleboy/gorush)
- [machinery](https://github.com/RichardKnop/machinery) **star:6519** Asynchronous task queue/job queue based on distributed message passing.   [![godoc][D]](https://godoc.org/github.com/RichardKnop/machinery)
- [Centrifugo](https://github.com/centrifugal/centrifugo) **star:6438** Real-time messaging (Websockets or SockJS) server in Go.   [![There was an update last month][G]](https://github.com/centrifugal/centrifugo)   [![godoc][D]](https://godoc.org/github.com/centrifugal/centrifugo)
- [go-socket.io](https://github.com/googollee/go-socket.io) **star:4824** socket.io library for golang, a realtime application framework.   [![godoc][D]](https://godoc.org/github.com/googollee/go-socket.io)
- [Benthos](https://github.com/Jeffail/benthos) **star:4823** A message streaming bridge between a range of protocols.   [![There was an update last month][G]](https://github.com/Jeffail/benthos)   [![godoc][D]](https://godoc.org/github.com/Jeffail/benthos)
- [Asynq](https://github.com/hibiken/asynq) **star:4387** A simple, reliable, and efficient distributed task queue for Go built on top of Redis.   [![godoc][D]](https://godoc.org/github.com/hibiken/asynq)
- [NATS Go Client](https://github.com/nats-io/nats) **star:4164** Lightweight and high performance publish-subscribe and distributed queueing messaging system - this is the Go library.   [![There was an update last month][G]](https://github.com/nats-io/nats)   [![godoc][D]](https://godoc.org/github.com/nats-io/nats)
- [Confluent Kafka Golang Client](https://github.com/confluentinc/confluent-kafka-go) **star:3604** confluent-kafka-go is Confluent's Golang client for Apache Kafka and the Confluent Platform.   [![There was an update last month][G]](https://github.com/confluentinc/confluent-kafka-go)   [![godoc][D]](https://godoc.org/github.com/confluentinc/confluent-kafka-go)
- [Mercure](https://github.com/dunglas/mercure) **star:3058** Server and library to dispatch server-sent updates using the Mercure protocol (built on top of Server-Sent Events).   [![godoc][D]](https://godoc.org/github.com/dunglas/mercure)
- [APNs2](https://github.com/sideshow/apns2) **star:2715** HTTP/2 Apple Push Notification provider for Go — Send push notifications to iOS, tvOS, Safari and OSX apps.   [![godoc][D]](https://godoc.org/github.com/sideshow/apns2)
- [melody](https://github.com/olahol/melody) **star:2562** Minimalist framework for dealing with websocket sessions, includes broadcasting and automatic ping/pong handling.   [![There was an update last month][G]](https://github.com/olahol/melody)   [![godoc][D]](https://godoc.org/github.com/olahol/melody)
- [go-nsq](https://github.com/nsqio/go-nsq) **star:2317** the official Go package for NSQ.   [![godoc][D]](https://godoc.org/github.com/nsqio/go-nsq)
- [gopush-cluster](https://github.com/Terry-Mao/gopush-cluster) **star:2053** gopush-cluster is a go push server cluster.   [![It hasn't been updated in recent three years][Y]](https://github.com/Terry-Mao/gopush-cluster)   [![godoc][D]](https://godoc.org/github.com/Terry-Mao/gopush-cluster)   [![Contains Chinese documents][CN]](https://github.com/Terry-Mao/gopush-cluster)
- [Uniqush-Push](https://github.com/uniqush/uniqush-push) **star:1436** Redis backed unified push service for server-side notifications to mobile devices.   [![godoc][D]](https://godoc.org/github.com/uniqush/uniqush-push)
- [Beaver](https://github.com/Clivern/Beaver) **star:1381** A real time messaging server to build a scalable in-app notifications, multiplayer games, chat apps in web and mobile apps.   [![godoc][D]](https://godoc.org/github.com/Clivern/Beaver)
- [EventBus](https://github.com/asaskevich/EventBus) **star:1281** The lightweight event bus with async compatibility.   [![godoc][D]](https://godoc.org/github.com/asaskevich/EventBus)
- [zmq4](https://github.com/pebbe/zmq4) **star:1023** Go interface to ZeroMQ version 4. Also available for [version 3](https://github.com/pebbe/zmq3) and [version 2](https://github.com/pebbe/zmq2).   [![godoc][D]](https://godoc.org/github.com/pebbe/zmq4)
- [Chanify](https://github.com/chanify/chanify) **star:927** A push notification server send message to your iOS devices.   [![godoc][D]](https://godoc.org/github.com/chanify/chanify)   [![Contains Chinese documents][CN]](https://github.com/chanify/chanify)
- [Gollum](https://github.com/trivago/gollum) **star:923** A n:m multiplexer that gathers messages from different sources and broadcasts them to a set of destinations.   [![godoc][D]](https://godoc.org/github.com/trivago/gollum)
- [dbus](https://github.com/godbus/dbus) **star:764** Native Go bindings for D-Bus.   [![godoc][D]](https://godoc.org/github.com/godbus/dbus)
- [golongpoll](https://github.com/jcuga/golongpoll) **star:612** HTTP longpoll server library that makes web pub-sub simple.   [![godoc][D]](https://godoc.org/github.com/jcuga/golongpoll)
- [mangos](https://github.com/nanomsg/mangos) **star:557** Pure go implementation of the Nanomsg ("Scalability Protocols") with transport interoperability.   [![godoc][D]](https://godoc.org/github.com/nanomsg/mangos)
- [amqp](https://github.com/rabbitmq/amqp091-go) **star:539** Go RabbitMQ Client Library.   [![There was an update last month][G]](https://github.com/rabbitmq/amqp091-go)   [![godoc][D]](https://godoc.org/github.com/rabbitmq/amqp091-go)
- [emitter](https://github.com/olebedev/emitter) **star:435** Emits events using Go way, with wildcard, predicates, cancellation possibilities and many other good wins.   [![godoc][D]](https://godoc.org/github.com/olebedev/emitter)
- [Glue](https://github.com/desertbit/glue) **star:404** Robust Go and Javascript Socket Library (Alternative to Socket.io).   [![godoc][D]](https://godoc.org/github.com/desertbit/glue)
- [pubsub](https://github.com/tuxychandru/pubsub) **star:386** Simple pubsub package for go.   [![godoc][D]](https://godoc.org/github.com/tuxychandru/pubsub)
- [Bus](https://github.com/mustafaturan/bus) **star:276** Minimalist message bus implementation for internal communication.   [![godoc][D]](https://godoc.org/github.com/mustafaturan/bus)
- [Quamina](https://github.com/timbray/quamina) **star:275** Fast pattern-matching for filtering messages and events.   [![There was an update last month][G]](https://github.com/timbray/quamina)   [![godoc][D]](https://godoc.org/github.com/timbray/quamina)
- [messagebus](https://github.com/vardius/message-bus) **star:233** messagebus is a Go simple async message bus, perfect for using as event bus when doing event sourcing, CQRS, DDD.
- [rabtap](https://github.com/jandelgado/rabtap) **star:224** RabbitMQ swiss army knife cli app.   [![godoc][D]](https://godoc.org/github.com/jandelgado/rabtap)
- [guble](https://github.com/smancke/guble) **star:153** Messaging server using push notifications (Google Firebase Cloud Messaging, Apple Push Notification services, SMS) as well as websockets, a REST API, featuring distributed operation and message-persistence.   [![It hasn't been updated in recent three years][Y]](https://github.com/smancke/guble)   [![godoc][D]](https://godoc.org/github.com/smancke/guble)
- [hub](https://github.com/leandro-lugaresi/hub) **star:122** A Message/Event Hub for Go applications, using publish/subscribe pattern with support for alias like rabbitMQ exchanges.   [![godoc][D]](https://godoc.org/github.com/leandro-lugaresi/hub)
- [oplog](https://github.com/dailymotion/oplog) **star:113** Generic oplog/replication system for REST APIs.   [![It hasn't been updated in recent three years][Y]](https://github.com/dailymotion/oplog)   [![godoc][D]](https://godoc.org/github.com/dailymotion/oplog)
- [rabbus](https://github.com/rafaeljesus/rabbus) **star:94** A tiny wrapper over amqp exchanges and queues.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/rabbus)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/rabbus)
- [redisqueue](https://github.com/robinjoseph08/redisqueue) **star:87** redisqueue provides a producer and consumer of a queue that uses Redis streams.   [![godoc][D]](https://godoc.org/github.com/robinjoseph08/redisqueue)
- [drone-line](https://github.com/appleboy/drone-line) **star:78** Sending [Line](https://at.line.me/en) notifications using a binary, docker or Drone CI.   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-line)
- [go-mq](https://github.com/cheshir/go-mq) **star:78** RabbitMQ client with declarative configuration.   [![There was an update last month][G]](https://github.com/cheshir/go-mq)   [![godoc][D]](https://godoc.org/github.com/cheshir/go-mq)
- [nsq-event-bus](https://github.com/rafaeljesus/nsq-event-bus) **star:75** A tiny wrapper around NSQ topic and channel.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/nsq-event-bus)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/nsq-event-bus)
- [RapidMQ](https://github.com/sybrexsys/RapidMQ) **star:65** RapidMQ is a lightweight and reliable library for managing of the local messages queue.   [![It hasn't been updated in recent three years][Y]](https://github.com/sybrexsys/RapidMQ)   [![godoc][D]](https://godoc.org/github.com/sybrexsys/RapidMQ)
- [go-notify](https://github.com/TheCreeper/go-notify) **star:62** Native implementation of the freedesktop notification spec.   [![godoc][D]](https://godoc.org/github.com/TheCreeper/go-notify)
- [Commander](https://github.com/jeroenrinzema/commander) **star:61** A high-level event driven consumer/producer supporting various "dialects" such as Apache Kafka.   [![godoc][D]](https://godoc.org/github.com/jeroenrinzema/commander)
- [go-res](https://github.com/jirenius/go-res) **star:61** Package for building REST/real-time services where clients are synchronized seamlessly, using NATS and Resgate.   [![godoc][D]](https://godoc.org/github.com/jirenius/go-res)
- [Ratus](https://github.com/hyperonym/ratus) **star:54** Ratus is a RESTful asynchronous task queue server.   [![godoc][D]](https://godoc.org/github.com/hyperonym/ratus)
- [hare](https://github.com/leozz37/hare) **star:51** A user friendly library for sending messages and listening to TCP sockets.   [![godoc][D]](https://godoc.org/github.com/leozz37/hare)
- [event](https://github.com/agoalofalife/event) **star:48** Implementation of the pattern observer.   [![It hasn't been updated in recent three years][Y]](https://github.com/agoalofalife/event)   [![godoc][D]](https://godoc.org/github.com/agoalofalife/event)
- [ami](https://github.com/kak-tus/ami) **star:24** Go client to reliable queues based on Redis Cluster Streams.   [![godoc][D]](https://godoc.org/github.com/kak-tus/ami)
- [gosd](https://github.com/alexsniffin/gosd) **star:21** A library for scheduling when to dispatch a message to a channel.   [![godoc][D]](https://godoc.org/github.com/alexsniffin/gosd)
- [go-vitotrol](https://github.com/maxatome/go-vitotrol) **star:20** Client library to Viessmann Vitotrol web service.   [![godoc][D]](https://godoc.org/github.com/maxatome/go-vitotrol)
- [rmqconn](https://github.com/sbabiv/rmqconn) **star:20** RabbitMQ Reconnection. Wrapper over amqp.Connection and amqp.Dial. Allowing to do a reconnection when the connection is broken before forcing the call to the Close () method to be closed.   [![godoc][D]](https://godoc.org/github.com/sbabiv/rmqconn)
- [jazz](https://github.com/socifi/jazz) **star:17** A simple RabbitMQ abstraction layer for queue administration and publishing and consuming of messages.   [![It hasn't been updated in recent three years][Y]](https://github.com/socifi/jazz)   [![godoc][D]](https://godoc.org/github.com/socifi/jazz)
- [gaurun-client](https://github.com/osamingo/gaurun-client) **star:11** Gaurun Client written in Go.   [![godoc][D]](https://godoc.org/github.com/osamingo/gaurun-client)
- [mob](https://github.com/erni27/mob) **star:6** mob is a generic-based, simple mediator / event aggregator library. It supports in-process requests / events processing.   [![There was an update last month][G]](https://github.com/erni27/mob)   [![godoc][D]](https://godoc.org/github.com/erni27/mob)

**[⬆ back to top](#contents)**

## Microsoft Office

- [unioffice](https://github.com/unidoc/unioffice) **star:3525** Pure go library for creating and processing Office Word (.docx), Excel (.xlsx) and Powerpoint (.pptx) documents.   [![godoc][D]](https://godoc.org/github.com/unidoc/unioffice)

### Microsoft Excel

_Libraries for working with Microsoft Excel._

- [excelize](https://github.com/xuri/excelize) **star:13004** Golang library for reading and writing Microsoft Excel&trade; (XLSX) files.   [![There was an update last month][G]](https://github.com/xuri/excelize)   [![godoc][D]](https://godoc.org/github.com/xuri/excelize)
- [xlsx](https://github.com/tealeg/xlsx) **star:5399** Library to simplify reading the XML format used by recent version of Microsoft Excel in Go programs.   [![godoc][D]](https://godoc.org/github.com/tealeg/xlsx)
- [go-excel](https://github.com/szyhf/go-excel) **star:161** A simple and light reader to read a relate-db-like excel as a table.   [![godoc][D]](https://godoc.org/github.com/szyhf/go-excel)
- [xlsx](https://github.com/plandem/xlsx) **star:154** Fast and safe way to read/update your existing Microsoft Excel files in Go programs.   [![godoc][D]](https://godoc.org/github.com/plandem/xlsx)
- [goxlsxwriter](https://github.com/fterrag/goxlsxwriter) **star:19** Golang bindings for libxlsxwriter for writing XLSX (Microsoft Excel) files.   [![godoc][D]](https://godoc.org/github.com/fterrag/goxlsxwriter)   [![Archived][Archived]](https://github.com/fterrag/goxlsxwriter)
- [exl](https://github.com/go-the-way/exl) **star:12** Excel binding to struct written in Go.(Only supports Go1.18+)   [![There was an update last month][G]](https://github.com/go-the-way/exl)   [![godoc][D]](https://godoc.org/github.com/go-the-way/exl)

**[⬆ back to top](#contents)**

## Miscellaneous

### Dependency Injection

_Libraries for working with dependency injection._

- [google/wire](https://github.com/google/wire) **star:9228** Automated Initialization in Go.   [![godoc][D]](https://godoc.org/github.com/google/wire)
- [fx](https://github.com/uber-go/fx) **star:3141** A dependency injection based application framework for Go (built on top of dig).   [![There was an update last month][G]](https://github.com/uber-go/fx)   [![godoc][D]](https://godoc.org/github.com/uber-go/fx)
- [dig](https://github.com/uber-go/dig) **star:2773** A reflection based dependency injection toolkit for Go.   [![godoc][D]](https://godoc.org/github.com/uber-go/dig)
- [do](https://github.com/samber/do) **star:595** A dependency injection framework based on Generics.   [![godoc][D]](https://godoc.org/github.com/samber/do)
- [GoLobby/Container](https://github.com/golobby/container) **star:383** GoLobby Container is a lightweight yet powerful IoC dependency injection container for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/container)
- [goioc/di](https://github.com/goioc/di) **star:211** Spring-inspired Dependency Injection Container.   [![godoc][D]](https://godoc.org/github.com/goioc/di)
- [di](https://github.com/goava/di) **star:165** A dependency injection container for go programming language.   [![godoc][D]](https://godoc.org/github.com/goava/di)
- [dingo](https://github.com/i-love-flamingo/dingo) **star:140** A dependency injection toolkit for Go, based on Guice.   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/dingo)
- [alice](https://github.com/magic003/alice) **star:49** Additive dependency injection container for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/magic003/alice)   [![godoc][D]](https://godoc.org/github.com/magic003/alice)
- [wire](https://github.com/Fs02/wire) **star:37** Strict Runtime Dependency Injection for Golang.   [![godoc][D]](https://godoc.org/github.com/Fs02/wire)
- [linker](https://github.com/logrange/linker) **star:36** A reflection based dependency injection and inversion of control library with components lifecycle support.   [![godoc][D]](https://godoc.org/github.com/logrange/linker)
- [nject](https://github.com/muir/nject) **star:20** A type safe, reflective framework for libraries, tests, http endpoints, and service startup.   [![godoc][D]](https://godoc.org/github.com/muir/nject)
- [gocontainer](https://github.com/vardius/gocontainer) **star:18** Simple Dependency Injection Container.   [![godoc][D]](https://godoc.org/github.com/vardius/gocontainer)
- [kinit](https://github.com/go-kata/kinit) **star:9** Customizable dependency injection container with the global mode, cascade initialization and panic-safe finalization.   [![godoc][D]](https://godoc.org/github.com/go-kata/kinit)
- [HnH/di](https://github.com/HnH/di) **star:5** DI container library that is focused on clean API and flexibility.   [![godoc][D]](https://godoc.org/github.com/HnH/di)

**[⬆ back to top](#contents)**

### Project Layout

_**Unofficial** set of patterns for structuring projects._

- [golang-standards/project-layout](https://github.com/golang-standards/project-layout) **star:34974** Set of common historical and emerging project layout patterns in the Go ecosystem. Note: despite the org-name they do not represent official golang standards, see [this issue](https://github.com/golang-standards/project-layout/issues/117) for more information. Nonetheless, some may find the layout useful.
- [ardanlabs/service](https://github.com/ardanlabs/service) **star:2470** A [starter kit](https://github.com/ardanlabs/service/wiki) for building production grade scalable web service applications.   [![There was an update last month][G]](https://github.com/ardanlabs/service)   [![godoc][D]](https://godoc.org/github.com/ardanlabs/service)
- [modern-go-application](https://github.com/sagikazarmark/modern-go-application) **star:1331** Go application boilerplate and example applying modern practices.   [![godoc][D]](https://godoc.org/github.com/sagikazarmark/modern-go-application)
- [cookiecutter-golang](https://github.com/lacion/cookiecutter-golang) **star:548** A Go application boilerplate template for quick starting projects following production best practices.   [![godoc][D]](https://godoc.org/github.com/lacion/cookiecutter-golang)
- [pagoda](https://github.com/mikestefanello/pagoda) **star:445** Rapid, easy full-stack web development starter kit built in Go.   [![There was an update last month][G]](https://github.com/mikestefanello/pagoda)   [![godoc][D]](https://godoc.org/github.com/mikestefanello/pagoda)
- [golang-templates/seed](https://github.com/golang-templates/seed) **star:330** Go application GitHub repository template.
- [go-starter](https://github.com/allaboutapps/go-starter) **star:257** An opinionated production-ready RESTful JSON backend template, highly integrated with VSCode DevContainers.   [![There was an update last month][G]](https://github.com/allaboutapps/go-starter)   [![godoc][D]](https://godoc.org/github.com/allaboutapps/go-starter)
- [go-todo-backend](https://github.com/Fs02/go-todo-backend) **star:174** Go Todo Backend example using modular project layout for product microservice.   [![godoc][D]](https://godoc.org/github.com/Fs02/go-todo-backend)
- [scaffold](https://github.com/catchplay/scaffold) **star:124** Scaffold generates a starter Go project layout. Lets you focus on business logic implemented.   [![It hasn't been updated in recent three years][Y]](https://github.com/catchplay/scaffold)   [![godoc][D]](https://godoc.org/github.com/catchplay/scaffold)
- [go-sample](https://github.com/zitryss/go-sample) **star:111** A sample layout for Go application projects with the real code.   [![It hasn't been updated in recent three years][Y]](https://github.com/zitryss/go-sample)   [![godoc][D]](https://godoc.org/github.com/zitryss/go-sample)
- [gobase](https://github.com/wajox/gobase) **star:34** A simple skeleton for golang application with basic setup for real golang application.   [![godoc][D]](https://godoc.org/github.com/wajox/gobase)
- [wangyoucao577/go-project-layout](https://github.com/wangyoucao577/go-project-layout) **star:19** Set of practices and discussions on how to structure Go project layout.   [![godoc][D]](https://godoc.org/github.com/wangyoucao577/go-project-layout)
- [insidieux/inizio](https://github.com/insidieux/inizio) **star:13** Golang project layout generator with plugins.   [![godoc][D]](https://godoc.org/github.com/insidieux/inizio)

**[⬆ back to top](#contents)**

### Strings

_Libraries for working with strings._

- [xstrings](https://github.com/huandu/xstrings) **star:1080** Collection of useful string functions ported from other languages.   [![godoc][D]](https://godoc.org/github.com/huandu/xstrings)
- [sttr](https://github.com/abhimanyu003/sttr) **star:421** cross-platform, cli app to perform various operations on string.   [![godoc][D]](https://godoc.org/github.com/abhimanyu003/sttr)
- [strutil](https://github.com/ozgio/strutil) **star:186** String utilities.   [![godoc][D]](https://godoc.org/github.com/ozgio/strutil)
- [gobeam/Stringy](https://github.com/gobeam/Stringy) **star:148** String manipulation library to convert string to camel case, snake case, kebab case / slugify etc.   [![godoc][D]](https://godoc.org/github.com/gobeam/Stringy)
- [bexp](https://github.com/mkungla/bexp) **star:12** Go implementation of Brace Expansion mechanism to generate arbitrary strings.   [![godoc][D]](https://godoc.org/github.com/mkungla/bexp)
- [go-formatter](https://gitlab.com/tymonx/go-formatter)  Implements **replacement fields** surrounded by curly braces `{}` format strings.

**[⬆ back to top](#contents)**

### Uncategorized

_These libraries were placed here because none of the other categories seemed to fit._

- [gopsutil](https://github.com/shirou/gopsutil) **star:8241** Cross-platform library for retrieving process and system utilization(CPU, Memory, Disks, etc).   [![There was an update last month][G]](https://github.com/shirou/gopsutil)   [![godoc][D]](https://godoc.org/github.com/shirou/gopsutil)
- [archiver](https://github.com/mholt/archiver) **star:3705** Library and command for making and extracting .zip and .tar.gz archives.   [![godoc][D]](https://godoc.org/github.com/mholt/archiver)
- [gatus](https://github.com/TwinProduction/gatus) **star:2961** Automated service health dashboard.   [![There was an update last month][G]](https://github.com/TwinProduction/gatus)   [![godoc][D]](https://godoc.org/github.com/TwinProduction/gatus)
- [gofakeit](https://github.com/brianvoe/gofakeit) **star:2670** Random data generator written in go.   [![There was an update last month][G]](https://github.com/brianvoe/gofakeit)   [![godoc][D]](https://godoc.org/github.com/brianvoe/gofakeit)
- [go-resiliency](https://github.com/eapache/go-resiliency) **star:1594** Resiliency patterns for golang.   [![godoc][D]](https://godoc.org/github.com/eapache/go-resiliency)
- [base64Captcha](https://github.com/mojocn/base64Captcha) **star:1578** Base64captch supports digit, number, alphabet, arithmetic, audio and digit-alphabet captcha.   [![godoc][D]](https://godoc.org/github.com/mojocn/base64Captcha)   [![Contains Chinese documents][CN]](https://github.com/mojocn/base64Captcha)
- [gosms](https://github.com/haxpax/gosms) **star:1393** Your own local SMS gateway in Go that can be used to send SMS.   [![godoc][D]](https://godoc.org/github.com/haxpax/gosms)
- [go-commons-pool](https://github.com/jolestar/go-commons-pool) **star:1077** Generic object pool for Golang.   [![godoc][D]](https://godoc.org/github.com/jolestar/go-commons-pool)   [![Contains Chinese documents][CN]](https://github.com/jolestar/go-commons-pool)
- [go-openapi](https://github.com/go-openapi)  Collection of packages to parse and utilize open-api schemas.
- [llvm](https://github.com/llir/llvm) **star:962** Library for interacting with LLVM IR in pure Go.   [![godoc][D]](https://godoc.org/github.com/llir/llvm)
- [shortid](https://github.com/teris-io/shortid) **star:805** Distributed generation of super short, unique, non-sequential, URL friendly IDs.   [![godoc][D]](https://godoc.org/github.com/teris-io/shortid)
- [health](https://github.com/alexliesenfeld/health) **star:615** A simple and flexible health check library for Go.   [![There was an update last month][G]](https://github.com/alexliesenfeld/health)   [![godoc][D]](https://godoc.org/github.com/alexliesenfeld/health)
- [stateless](https://github.com/qmuntal/stateless) **star:487** A fluent library for creating state machines.   [![godoc][D]](https://godoc.org/github.com/qmuntal/stateless)
- [shoutrrr](https://github.com/containrrr/shoutrrr) **star:466** Notification library providing easy access to various messaging services like slack, mattermost, gotify and smtp among others.   [![There was an update last month][G]](https://github.com/containrrr/shoutrrr)   [![godoc][D]](https://godoc.org/github.com/containrrr/shoutrrr)
- [health](https://github.com/dimiro1/health) **star:435** Easy to use, extensible health check library.   [![godoc][D]](https://godoc.org/github.com/dimiro1/health)
- [banner](https://github.com/dimiro1/banner) **star:409** Add beautiful banners into your Go applications.   [![godoc][D]](https://godoc.org/github.com/dimiro1/banner)
- [xz](https://github.com/ulikunitz/xz) **star:386** Pure golang package for reading and writing xz-compressed files.   [![godoc][D]](https://godoc.org/github.com/ulikunitz/xz)
- [conv](https://github.com/cstockton/go-conv) **star:385** Package conv provides fast and intuitive conversions across Go types.   [![godoc][D]](https://godoc.org/github.com/cstockton/go-conv)
- [gountries](https://github.com/pariz/gountries) **star:359** Package that exposes country and subdivision data.   [![godoc][D]](https://godoc.org/github.com/pariz/gountries)
- [ffmt](https://github.com/go-ffmt/ffmt) **star:280** Beautify data display for Humans.   [![godoc][D]](https://godoc.org/github.com/go-ffmt/ffmt)   [![Contains Chinese documents][CN]](https://github.com/go-ffmt/ffmt)
- [lk](https://github.com/hyperboloide/lk) **star:253** A simple licensing library for golang.   [![There was an update last month][G]](https://github.com/hyperboloide/lk)   [![godoc][D]](https://godoc.org/github.com/hyperboloide/lk)
- [antch](https://github.com/antchfx/antch) **star:238** A fast, powerful and extensible web crawling & scraping framework.   [![godoc][D]](https://godoc.org/github.com/antchfx/antch)   [![Contains Chinese documents][CN]](https://github.com/antchfx/antch)
- [healthcheck](https://github.com/etherlabsio/healthcheck) **star:234** An opinionated and concurrent health-check HTTP handler for RESTful services.   [![godoc][D]](https://godoc.org/github.com/etherlabsio/healthcheck)
- [battery](https://github.com/distatus/battery) **star:211** Cross-platform, normalized battery information library.   [![godoc][D]](https://godoc.org/github.com/distatus/battery)
- [go-unarr](https://github.com/gen2brain/go-unarr) **star:205** Decompression library for RAR, TAR, ZIP and 7z archives.   [![godoc][D]](https://godoc.org/github.com/gen2brain/go-unarr)
- [bitio](https://github.com/icza/bitio) **star:198** Highly optimized bit-level Reader and Writer for Go.   [![godoc][D]](https://godoc.org/github.com/icza/bitio)
- [stats](https://github.com/go-playground/stats) **star:164** Monitors Go MemStats + System stats such as Memory, Swap and CPU and sends via UDP anywhere you want for logging etc...   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/stats)   [![godoc][D]](https://godoc.org/github.com/go-playground/stats)
- [turtle](https://github.com/hackebrot/turtle) **star:138** Emojis for Go.   [![godoc][D]](https://godoc.org/github.com/hackebrot/turtle)
- [captcha](https://github.com/steambap/captcha) **star:120** Package captcha provides an easy to use, unopinionated API for captcha generation.   [![godoc][D]](https://godoc.org/github.com/steambap/captcha)
- [gommit](https://github.com/antham/gommit) **star:98** Analyze git commit messages to ensure they follow defined patterns.   [![godoc][D]](https://godoc.org/github.com/antham/gommit)
- [indigo](https://github.com/osamingo/indigo) **star:96** Distributed unique ID generator of using Sonyflake and encoded by Base58.   [![godoc][D]](https://godoc.org/github.com/osamingo/indigo)
- [gotoprom](https://github.com/cabify/gotoprom) **star:94** Type-safe metrics builder wrapper library for the official Prometheus client.   [![godoc][D]](https://godoc.org/github.com/cabify/gotoprom)
- [morse](https://github.com/alwindoss/morse) **star:75** Library to convert to and from morse code.   [![godoc][D]](https://godoc.org/github.com/alwindoss/morse)
- [gtree](https://github.com/ddddddO/gtree) **star:73** Provide CLI and Package for tree output and directories creation from Markdown or programmatically.   [![There was an update last month][G]](https://github.com/ddddddO/gtree)   [![godoc][D]](https://godoc.org/github.com/ddddddO/gtree)
- [faker](https://github.com/pioz/faker) **star:67** Random fake data and struct generator for Go.   [![godoc][D]](https://godoc.org/github.com/pioz/faker)
- [persian](https://github.com/mavihq/persian) **star:66** Some utilities for Persian language in go.   [![godoc][D]](https://godoc.org/github.com/mavihq/persian)
- [pdfgen](https://github.com/hyperboloide/pdfgen) **star:60** HTTP service to generate PDF from Json requests.   [![It hasn't been updated in recent three years][Y]](https://github.com/hyperboloide/pdfgen)   [![godoc][D]](https://godoc.org/github.com/hyperboloide/pdfgen)
- [xkg](https://github.com/go-xkg/xkg) **star:54** X Keyboard Grabber.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-xkg/xkg)   [![godoc][D]](https://godoc.org/github.com/go-xkg/xkg)
- [browscap_go](https://github.com/digitalcrab/browscap_go) **star:43** GoLang Library for [Browser Capabilities Project](https://browscap.org/).   [![godoc][D]](https://godoc.org/github.com/digitalcrab/browscap_go)
- [datacounter](https://github.com/miolini/datacounter) **star:42** Go counters for readers/writer/http.ResponseWriter.   [![godoc][D]](https://godoc.org/github.com/miolini/datacounter)
- [autoflags](https://github.com/artyom/autoflags) **star:38** Go package to automatically define command line flags from struct fields.   [![godoc][D]](https://godoc.org/github.com/artyom/autoflags)
- [sandid](https://github.com/aofei/sandid) **star:38** Every grain of sand on earth has its own ID.   [![godoc][D]](https://godoc.org/github.com/aofei/sandid)
- [url-shortener](https://github.com/pantrif/url-shortener) **star:38** A modern, powerful, and robust URL shortener microservice with mysql support.   [![It hasn't been updated in recent three years][Y]](https://github.com/pantrif/url-shortener)   [![godoc][D]](https://godoc.org/github.com/pantrif/url-shortener)
- [VarHandler](https://github.com/azr/generators/tree/master/varhandler)  Generate boilerplate http input and output handling.
- [gosh](https://github.com/osamingo/gosh) **star:31** Provide Go Statistics Handler, Struct, Measure Method.   [![godoc][D]](https://godoc.org/github.com/osamingo/gosh)
- [xdg](https://github.com/rkoesters/xdg) **star:29** FreeDesktop.org (xdg) Specs implemented in Go.   [![godoc][D]](https://godoc.org/github.com/rkoesters/xdg)
- [metrics](https://github.com/pascaldekloe/metrics) **star:24** Library for metrics instrumentation and Prometheus exposition.   [![godoc][D]](https://godoc.org/github.com/pascaldekloe/metrics)
- [shellwords](https://github.com/Wing924/shellwords) **star:18** A Golang library to manipulate strings according to the word parsing rules of the UNIX Bourne shell.   [![godoc][D]](https://godoc.org/github.com/Wing924/shellwords)
- [anagent](https://github.com/mudler/anagent) **star:15** Minimalistic, pluggable Golang evloop/timer handler with dependency-injection.   [![It hasn't been updated in recent three years][Y]](https://github.com/mudler/anagent)   [![godoc][D]](https://godoc.org/github.com/mudler/anagent)
- [avgRating](https://github.com/kirillDanshin/avgRating) **star:12** Calculate average score and rating based on Wilson Score Equation.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/avgRating)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/avgRating)
- [hostutils](https://github.com/Wing924/hostutils) **star:12** A golang library for packing and unpacking FQDNs list.   [![godoc][D]](https://godoc.org/github.com/Wing924/hostutils)
- [numa](https://github.com/lrita/numa) **star:11** NUMA is a utility library, which is written in go. It help us to write some NUMA-AWARED code.   [![godoc][D]](https://godoc.org/github.com/lrita/numa)
- [openapi](https://github.com/neotoolkit/openapi) **star:9** OpenAPI 3.x parser.   [![godoc][D]](https://godoc.org/github.com/neotoolkit/openapi)
- [faker](https://github.com/neotoolkit/faker) **star:8** Fake data generator.   [![godoc][D]](https://godoc.org/github.com/neotoolkit/faker)
- [go-commandbus](https://github.com/lana/go-commandbus) **star:6** A slight and pluggable command-bus for Go.   [![godoc][D]](https://godoc.org/github.com/lana/go-commandbus)
- [basexx](https://github.com/bobg/basexx) **star:3** Convert to, from, and between digit strings in various number bases.   [![godoc][D]](https://godoc.org/github.com/bobg/basexx)
- [varint](https://github.com/chmike/varint) **star:3** A faster varying length integer encoder/decoder than the one provided in the standard library.   [![godoc][D]](https://godoc.org/github.com/chmike/varint)

**[⬆ back to top](#contents)**

## Natural Language Processing

_Libraries for working with human languages._

See also [Text Processing](#text-processing) and [Text Analysis](#text-analysis).

### Language Detection

- [whatlanggo](https://github.com/abadojack/whatlanggo) **star:564** Natural language detection package for Go. Supports 84 languages and 24 scripts (writing systems e.g. Latin, Cyrillic, etc).   [![godoc][D]](https://godoc.org/github.com/abadojack/whatlanggo)
- [getlang](https://github.com/rylans/getlang) **star:142** Fast natural language detection package.   [![godoc][D]](https://godoc.org/github.com/rylans/getlang)
- [guesslanguage](https://github.com/endeveit/guesslanguage) **star:56** Functions to determine the natural language of a unicode text.   [![It hasn't been updated in recent three years][Y]](https://github.com/endeveit/guesslanguage)   [![godoc][D]](https://godoc.org/github.com/endeveit/guesslanguage)
- [detectlanguage](https://github.com/detectlanguage/detectlanguage-go) **star:16** Language Detection API Go Client. Supports batch requests, short phrase or single word language detection.   [![godoc][D]](https://godoc.org/github.com/detectlanguage/detectlanguage-go)

### Morphological Analyzers

- [spaGO](https://github.com/nlpodyssey/spago) **star:1253** Self-contained Machine Learning and Natural Language Processing library in Go.   [![godoc][D]](https://godoc.org/github.com/nlpodyssey/spago)
- [kagome](https://github.com/ikawaha/kagome) **star:674** JP morphological analyzer written in pure Go.   [![There was an update last month][G]](https://github.com/ikawaha/kagome)   [![godoc][D]](https://godoc.org/github.com/ikawaha/kagome)
- [nlp](https://github.com/Shixzie/nlp) **star:380** Extract values from strings and fill your structs with nlp.   [![It hasn't been updated in recent three years][Y]](https://github.com/Shixzie/nlp)   [![godoc][D]](https://godoc.org/github.com/Shixzie/nlp)
- [nlp](https://github.com/james-bowman/nlp) **star:377** Go Natural Language Processing library supporting LSA (Latent Semantic Analysis).   [![godoc][D]](https://godoc.org/github.com/james-bowman/nlp)
- [RAKE.go](https://github.com/afjoseph/RAKE.Go) **star:97** Go port of the Rapid Automatic Keyword Extraction Algorithm (RAKE).   [![godoc][D]](https://godoc.org/github.com/afjoseph/RAKE.Go)
- [go-stem](https://github.com/agonopol/go-stem) **star:69** Implementation of the porter stemming algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/agonopol/go-stem)   [![godoc][D]](https://godoc.org/github.com/agonopol/go-stem)
- [go2vec](https://github.com/danieldk/go2vec) **star:49** Reader and utility functions for word2vec embeddings.   [![It hasn't been updated in recent three years][Y]](https://github.com/danieldk/go2vec)   [![godoc][D]](https://godoc.org/github.com/danieldk/go2vec)
- [porter2](https://github.com/zhenjl/porter2) **star:46** Really fast Porter 2 stemmer.   [![godoc][D]](https://godoc.org/github.com/zhenjl/porter2)
- [snowball](https://github.com/goodsign/snowball) **star:33** Snowball stemmer port (cgo wrapper) for Go. Provides word stem extraction functionality [Snowball native](http://snowball.tartarus.org/).   [![It hasn't been updated in recent three years][Y]](https://github.com/goodsign/snowball)
- [paicehusk](https://github.com/rookii/paicehusk) **star:29** Golang implementation of the Paice/Husk Stemming Algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/rookii/paicehusk)   [![godoc][D]](https://godoc.org/github.com/rookii/paicehusk)
- [govader](https://github.com/jonreiter/govader) **star:28** Go implementation of [VADER Sentiment Analysis](https://github.com/cjhutto/vaderSentiment).   [![godoc][D]](https://godoc.org/github.com/jonreiter/govader)
- [golibstemmer](https://github.com/rjohnsondev/golibstemmer) **star:20** Go bindings for the snowball libstemmer library including porter 2.   [![It hasn't been updated in recent three years][Y]](https://github.com/rjohnsondev/golibstemmer)   [![godoc][D]](https://godoc.org/github.com/rjohnsondev/golibstemmer)
- [libtextcat](https://github.com/goodsign/libtextcat) **star:12** Cgo binding for libtextcat C library. Guaranteed compatibility with version 2.2.   [![It hasn't been updated in recent three years][Y]](https://github.com/goodsign/libtextcat)   [![godoc][D]](https://godoc.org/github.com/goodsign/libtextcat)
- [porter](https://github.com/a2800276/porter) **star:10** This is a fairly straightforward port of Martin Porter's C implementation of the Porter stemming algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/a2800276/porter)   [![godoc][D]](https://godoc.org/github.com/a2800276/porter)
- [gosentiwordnet](https://github.com/dinopuguh/gosentiwordnet) **star:9** Sentiment analyzer using sentiwordnet lexicon in Go.   [![godoc][D]](https://godoc.org/github.com/dinopuguh/gosentiwordnet)
- [govader-backend](https://github.com/PIMPfiction/govader_backend) **star:3** Microservice implementation of [GoVader](https://github.com/jonreiter/govader).   [![godoc][D]](https://godoc.org/github.com/PIMPfiction/govader_backend)
- [spelling-corrector](https://github.com/jorelosorio/spellingcorrector) **star:1** A spelling corrector for the Spanish language or create your own.   [![godoc][D]](https://godoc.org/github.com/jorelosorio/spellingcorrector)

### Slugifiers

- [slug](https://github.com/gosimple/slug) **star:866** URL-friendly slugify with multiple languages support.   [![There was an update last month][G]](https://github.com/gosimple/slug)   [![godoc][D]](https://godoc.org/github.com/gosimple/slug)
- [go-slugify](https://github.com/mozillazg/go-slugify) **star:82** Make pretty slug with multiple languages support.   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-slugify)
- [Slugify](https://github.com/avelino/slugify) **star:32** Go slugify application that handles string.   [![It hasn't been updated in recent three years][Y]](https://github.com/avelino/slugify)   [![godoc][D]](https://godoc.org/github.com/avelino/slugify)

### Tokenizers

- [prose](https://github.com/jdkato/prose) **star:2948** Library for text processing that supports tokenization, part-of-speech tagging, named-entity extraction, and more. English only.   [![godoc][D]](https://godoc.org/github.com/jdkato/prose)   [![Archived][Archived]](https://github.com/jdkato/prose)
- [gse](https://github.com/go-ego/gse) **star:2023** Go efficient text segmentation; support english, chinese, japanese and other.   [![godoc][D]](https://godoc.org/github.com/go-ego/gse)   [![Contains Chinese documents][CN]](https://github.com/go-ego/gse)
- [gojieba](https://github.com/yanyiwu/gojieba) **star:1969** This is a Go implementation of [jieba](https://github.com/fxsjy/jieba) which a Chinese word splitting algorithm.   [![There was an update last month][G]](https://github.com/yanyiwu/gojieba)   [![godoc][D]](https://godoc.org/github.com/yanyiwu/gojieba)   [![Contains Chinese documents][CN]](https://github.com/yanyiwu/gojieba)
- [sentences](https://github.com/neurosnap/sentences) **star:332** Sentence tokenizer:  converts text into a list of sentences.   [![godoc][D]](https://godoc.org/github.com/neurosnap/sentences)
- [segment](https://github.com/blevesearch/segment) **star:71** Go library for performing Unicode Text Segmentation as described in [Unicode Standard Annex #29](https://www.unicode.org/reports/tr29/)   [![godoc][D]](https://godoc.org/github.com/blevesearch/segment)
- [textcat](https://github.com/pebbe/textcat) **star:68** Go package for n-gram based text categorization, with support for utf-8 and raw text.   [![godoc][D]](https://godoc.org/github.com/pebbe/textcat)
- [MMSEGO](https://github.com/awsong/MMSEGO) **star:62** This is a GO implementation of [MMSEG](http://technology.chtsai.org/mmseg/) which a Chinese word splitting algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/awsong/MMSEGO)   [![godoc][D]](https://godoc.org/github.com/awsong/MMSEGO)
- [stemmer](https://github.com/dchest/stemmer) **star:52** Stemmer packages for Go programming language. Includes English and German stemmers.   [![It hasn't been updated in recent three years][Y]](https://github.com/dchest/stemmer)   [![godoc][D]](https://godoc.org/github.com/dchest/stemmer)
- [gotokenizer](https://github.com/xujiajun/gotokenizer) **star:15** A tokenizer based on the dictionary and Bigram language models for Golang. (Now only support chinese segmentation)   [![It hasn't been updated in recent three years][Y]](https://github.com/xujiajun/gotokenizer)   [![godoc][D]](https://godoc.org/github.com/xujiajun/gotokenizer)
- [shamoji](https://github.com/osamingo/shamoji) **star:13** The shamoji is word filtering package written in Go.   [![godoc][D]](https://godoc.org/github.com/osamingo/shamoji)

### Translation

- [go-pinyin](https://github.com/mozillazg/go-pinyin) **star:1270** CN Hanzi to Hanyu Pinyin converter.   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-pinyin)
- [gotext](https://github.com/leonelquinteros/gotext) **star:353** GNU gettext utilities for Go.   [![godoc][D]](https://godoc.org/github.com/leonelquinteros/gotext)
- [go-i18n](https://github.com/nicksnyder/go-i18n/)  Package and an accompanying tool to work with localized text.
- [go-localize](https://github.com/m1/go-localize) **star:45** Simple and easy to use i18n (Internationalization and localization) engine - used for translating locale strings.   [![godoc][D]](https://godoc.org/github.com/m1/go-localize)
- [iuliia-go](https://github.com/mehanizm/iuliia-go) **star:31** Transliterate Cyrillic → Latin in every possible way.   [![godoc][D]](https://godoc.org/github.com/mehanizm/iuliia-go)
- [go-mystem](https://github.com/dveselov/mystem) **star:29** CGo bindings to Yandex.Mystem - russian morphology analyzer.   [![It hasn't been updated in recent three years][Y]](https://github.com/dveselov/mystem)   [![godoc][D]](https://godoc.org/github.com/dveselov/mystem)
- [icu](https://github.com/goodsign/icu) **star:21** Cgo binding for icu4c C library detection and conversion functions. Guaranteed compatibility with version 50.1.   [![It hasn't been updated in recent three years][Y]](https://github.com/goodsign/icu)   [![godoc][D]](https://godoc.org/github.com/goodsign/icu)
- [t](https://github.com/youthlin/t) **star:12** Another i18n pkg for golang, which follows GNU gettext style and supports .po/.mo files: `t.T (gettext)`, `t.N (ngettext)`, etc. And it contains a cmd tool [xtemplate](https://github.com/youthlin/t/blob/main/cmd/xtemplate), which can extract messages as a pot file from text/html template.   [![godoc][D]](https://godoc.org/github.com/youthlin/t)   [![Contains Chinese documents][CN]](https://github.com/youthlin/t)
- [spreak](https://github.com/vorlif/spreak) **star:11** Flexible translation and humanization library for Go, based on the concepts behind gettext.   [![godoc][D]](https://godoc.org/github.com/vorlif/spreak)

### Transliteration

- [go-unidecode](https://github.com/mozillazg/go-unidecode) **star:96** ASCII transliterations of Unicode text.   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-unidecode)
- [gounidecode](https://github.com/fiam/gounidecode) **star:76** Unicode transliterator (also known as unidecode) for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/fiam/gounidecode)   [![godoc][D]](https://godoc.org/github.com/fiam/gounidecode)
- [transliterator](https://github.com/alexsergivan/transliterator) **star:25** Provides one-way string transliteration with supporting of language-specific transliteration rules.   [![godoc][D]](https://godoc.org/github.com/alexsergivan/transliterator)
- [enca](https://github.com/endeveit/enca) **star:12** Minimal cgo bindings for [libenca](https://cihar.com/software/enca/), which detects character encodings.   [![It hasn't been updated in recent three years][Y]](https://github.com/endeveit/enca)   [![godoc][D]](https://godoc.org/github.com/endeveit/enca)

**[⬆ back to top](#contents)**

## Networking

_Libraries for working with various layers of the network._

- [fasthttp](https://github.com/valyala/fasthttp) **star:18493** Package fasthttp is a fast HTTP implementation for Go, up to 10 times faster than net/http.   [![There was an update last month][G]](https://github.com/valyala/fasthttp)   [![godoc][D]](https://godoc.org/github.com/valyala/fasthttp)
- [kcptun](https://github.com/xtaci/kcptun) **star:13019** Extremely simple & fast udp tunnel based on KCP protocol.   [![godoc][D]](https://godoc.org/github.com/xtaci/kcptun)
- [webrtc](https://github.com/pions/webrtc) **star:10054** A pure Go implementation of the WebRTC API.   [![There was an update last month][G]](https://github.com/pions/webrtc)   [![godoc][D]](https://godoc.org/github.com/pions/webrtc)
- [quic-go](https://github.com/lucas-clemente/quic-go) **star:7333** An implementation of the QUIC protocol in pure Go.   [![There was an update last month][G]](https://github.com/lucas-clemente/quic-go)   [![godoc][D]](https://godoc.org/github.com/lucas-clemente/quic-go)
- [gnet](https://github.com/panjf2000/gnet) **star:6962** `gnet` is a high-performance, lightweight, non-blocking, event-driven networking framework written in pure Go.   [![There was an update last month][G]](https://github.com/panjf2000/gnet)   [![godoc][D]](https://godoc.org/github.com/panjf2000/gnet)   [![Contains Chinese documents][CN]](https://github.com/panjf2000/gnet)
- [dns](https://github.com/miekg/dns) **star:6541** Go library for working with DNS.   [![godoc][D]](https://godoc.org/github.com/miekg/dns)
- [gopacket](https://github.com/google/gopacket) **star:5126** Go library for packet processing with libpcap bindings.   [![godoc][D]](https://godoc.org/github.com/google/gopacket)
- [HTTPLab](https://github.com/gchaincl/httplab) **star:3839** HTTPLabs let you inspect HTTP requests and forge responses.   [![It hasn't been updated in recent three years][Y]](https://github.com/gchaincl/httplab)   [![godoc][D]](https://godoc.org/github.com/gchaincl/httplab)
- [kcp-go](https://github.com/xtaci/kcp-go) **star:3451** KCP - Fast and Reliable ARQ Protocol.   [![godoc][D]](https://godoc.org/github.com/xtaci/kcp-go)
- [netpoll](https://github.com/cloudwego/netpoll) **star:3096** A high-performance non-blocking I/O networking framework, which focused on RPC scenarios, developed by ByteDance.   [![godoc][D]](https://godoc.org/github.com/cloudwego/netpoll)   [![Contains Chinese documents][CN]](https://github.com/cloudwego/netpoll)
- [gobgp](https://github.com/osrg/gobgp) **star:3002** BGP implemented in the Go Programming Language.   [![There was an update last month][G]](https://github.com/osrg/gobgp)   [![godoc][D]](https://godoc.org/github.com/osrg/gobgp)
- [ssh](https://github.com/gliderlabs/ssh) **star:2725** Higher-level API for building SSH servers (wraps crypto/ssh).   [![There was an update last month][G]](https://github.com/gliderlabs/ssh)   [![godoc][D]](https://godoc.org/github.com/gliderlabs/ssh)
- [fortio](https://github.com/fortio/fortio) **star:2689** Load testing library and command line tool, advanced echo server and web UI. Allows to specify a set query-per-second load and record latency histograms and other useful stats and graph them. Tcp, Http, gRPC.   [![godoc][D]](https://godoc.org/github.com/fortio/fortio)
- [water](https://github.com/songgao/water) **star:1532** Simple TUN/TAP library.   [![godoc][D]](https://godoc.org/github.com/songgao/water)
- [gev](https://github.com/Allenxuxu/gev) **star:1492** gev is a lightweight, fast non-blocking TCP network library based on Reactor mode.   [![godoc][D]](https://godoc.org/github.com/Allenxuxu/gev)
- [go-getter](https://github.com/hashicorp/go-getter) **star:1401** Go library for downloading files or directories from various sources using a URL.   [![There was an update last month][G]](https://github.com/hashicorp/go-getter)   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-getter)
- [NFF-Go](https://github.com/intel-go/nff-go) **star:1249** Framework for rapid development of performant network functions for cloud and bare-metal (former YANFF).   [![godoc][D]](https://godoc.org/github.com/intel-go/nff-go)
- [sftp](https://github.com/pkg/sftp) **star:1224** Package sftp implements the SSH File Transfer Protocol as described in <https://filezilla-project.org/specs/draft-ietf-secsh-filexfer-02.txt>.   [![There was an update last month][G]](https://github.com/pkg/sftp)   [![godoc][D]](https://godoc.org/github.com/pkg/sftp)
- [grab](https://github.com/cavaliercoder/grab) **star:1120** Go package for managing file downloads.   [![godoc][D]](https://godoc.org/github.com/cavaliercoder/grab)
- [ftp](https://github.com/jlaffaye/ftp) **star:996** Package ftp implements a FTP client as described in [RFC 959](https://tools.ietf.org/html/rfc959).   [![There was an update last month][G]](https://github.com/jlaffaye/ftp)   [![godoc][D]](https://godoc.org/github.com/jlaffaye/ftp)
- [mdns](https://github.com/hashicorp/mdns) **star:908** Simple mDNS (Multicast DNS) client/server library in Golang.   [![godoc][D]](https://godoc.org/github.com/hashicorp/mdns)
- [mqttPaho](https://eclipse.org/paho/clients/golang/)  The Paho Go Client provides an MQTT client library for connection to MQTT brokers via TCP, TLS or WebSockets.
- [gosnmp](https://github.com/soniah/gosnmp) **star:901** Native Go library for performing SNMP actions.   [![There was an update last month][G]](https://github.com/soniah/gosnmp)   [![godoc][D]](https://godoc.org/github.com/soniah/gosnmp)
- [vssh](https://github.com/yahoo/vssh) **star:866** Go library for building network and server automation over SSH protocol.   [![godoc][D]](https://godoc.org/github.com/yahoo/vssh)
- [nbio](https://github.com/lesismal/nbio) **star:795** Pure Go 1000k+ connections solution, support tls/http1.x/websocket and basically compatible with net/http, with high-performance and low memory cost, non-blocking, event-driven, easy-to-use.   [![godoc][D]](https://godoc.org/github.com/lesismal/nbio)
- [cidranger](https://github.com/yl2chen/cidranger) **star:747** Fast IP to CIDR lookup for Go.   [![godoc][D]](https://godoc.org/github.com/yl2chen/cidranger)
- [gmqtt](https://github.com/DrmagicE/gmqtt) **star:742** Gmqtt is a flexible, high-performance MQTT broker library that fully implements the MQTT protocol V3.1.1.   [![godoc][D]](https://godoc.org/github.com/DrmagicE/gmqtt)   [![Contains Chinese documents][CN]](https://github.com/DrmagicE/gmqtt)
- [lhttp](https://github.com/fanux/lhttp) **star:676** Powerful websocket framework, build your IM server more easily.   [![It hasn't been updated in recent three years][Y]](https://github.com/fanux/lhttp)   [![godoc][D]](https://godoc.org/github.com/fanux/lhttp)   [![Contains Chinese documents][CN]](https://github.com/fanux/lhttp)
- [peerdiscovery](https://github.com/schollz/peerdiscovery) **star:561** Pure Go library for cross-platform local peer discovery using UDP multicast.   [![godoc][D]](https://godoc.org/github.com/schollz/peerdiscovery)
- [go-stun](https://github.com/ccding/go-stun) **star:522** Go implementation of the STUN client (RFC 3489 and RFC 5389).   [![godoc][D]](https://godoc.org/github.com/ccding/go-stun)
- [gotcp](https://github.com/gansidui/gotcp) **star:499** Go package for quickly writing tcp applications.   [![It hasn't been updated in recent three years][Y]](https://github.com/gansidui/gotcp)   [![godoc][D]](https://godoc.org/github.com/gansidui/gotcp)
- [stun](https://github.com/go-rtc/stun) **star:487** Go implementation of RFC 5389 STUN protocol.   [![godoc][D]](https://godoc.org/github.com/go-rtc/stun)   [![Archived][Archived]](https://github.com/go-rtc/stun)
- [easytcp](https://github.com/DarthPestilane/easytcp) **star:484** A light-weight TCP framework written in Go (Golang), built with message router. EasyTCP helps you build a TCP server easily fast and less painful.   [![godoc][D]](https://godoc.org/github.com/DarthPestilane/easytcp)
- [gaio](https://github.com/xtaci/gaio) **star:463** High performance async-io networking for Golang in proactor mode.   [![godoc][D]](https://godoc.org/github.com/xtaci/gaio)
- [gopcap](https://github.com/akrennmair/gopcap) **star:457** Go wrapper for libpcap.   [![godoc][D]](https://godoc.org/github.com/akrennmair/gopcap)
- [raw](https://github.com/mdlayher/raw) **star:423** Package raw enables reading and writing data at the device driver level for a network interface.   [![godoc][D]](https://godoc.org/github.com/mdlayher/raw)   [![Archived][Archived]](https://github.com/mdlayher/raw)
- [tcp_server](https://github.com/firstrow/tcp_server) **star:419** Go library for building tcp servers faster.   [![godoc][D]](https://godoc.org/github.com/firstrow/tcp_server)
- [winrm](https://github.com/masterzen/winrm) **star:381** Go WinRM client to remotely execute commands on Windows machines.   [![godoc][D]](https://godoc.org/github.com/masterzen/winrm)
- [ftpserverlib](https://github.com/fclairamb/ftpserverlib) **star:330** Fully featured FTP server library.   [![There was an update last month][G]](https://github.com/fclairamb/ftpserverlib)   [![godoc][D]](https://godoc.org/github.com/fclairamb/ftpserverlib)
- [arp](https://github.com/mdlayher/arp) **star:296** Package arp implements the ARP protocol, as described in RFC 826.   [![godoc][D]](https://godoc.org/github.com/mdlayher/arp)
- [buffstreams](https://github.com/stabbycutyou/buffstreams) **star:251** Streaming protocolbuffer data over TCP made easy.   [![godoc][D]](https://godoc.org/github.com/stabbycutyou/buffstreams)
- [ethernet](https://github.com/mdlayher/ethernet) **star:245** Package ethernet implements marshaling and unmarshaling of IEEE 802.3 Ethernet II frames and IEEE 802.1Q VLAN tags.   [![godoc][D]](https://godoc.org/github.com/mdlayher/ethernet)
- [gNxI](https://github.com/google/gnxi) **star:222** A collection of tools for Network Management that use the gNMI and gNOI protocols.
- [dnsmonster](https://github.com/mosajjal/dnsmonster) **star:209** Passive DNS Capture/Monitoring Framework.   [![There was an update last month][G]](https://github.com/mosajjal/dnsmonster)   [![godoc][D]](https://godoc.org/github.com/mosajjal/dnsmonster)
- [jazigo](https://github.com/udhos/jazigo) **star:185** Jazigo is a tool written in Go for retrieving configuration for multiple network devices.   [![It hasn't been updated in recent three years][Y]](https://github.com/udhos/jazigo)   [![godoc][D]](https://godoc.org/github.com/udhos/jazigo)
- [utp](https://github.com/anacrolix/utp) **star:164** Go uTP micro transport protocol implementation.   [![godoc][D]](https://godoc.org/github.com/anacrolix/utp)
- [canopus](https://github.com/zubairhamed/canopus) **star:148** CoAP Client/Server implementation (RFC 7252).   [![It hasn't been updated in recent three years][Y]](https://github.com/zubairhamed/canopus)   [![godoc][D]](https://godoc.org/github.com/zubairhamed/canopus)
- [sslb](https://github.com/eduardonunesp/sslb) **star:143** It's a Super Simples Load Balancer, just a little project to achieve some kind of performance.   [![It hasn't been updated in recent three years][Y]](https://github.com/eduardonunesp/sslb)   [![godoc][D]](https://godoc.org/github.com/eduardonunesp/sslb)
- [xtcp](https://github.com/xfxdev/xtcp) **star:137** TCP Server Framework with simultaneous full duplex communication, graceful shutdown, and custom protocol.   [![godoc][D]](https://godoc.org/github.com/xfxdev/xtcp)
- [iplib](https://github.com/c-robinson/iplib) **star:93** Library for working with IP addresses (net.IP, net.IPNet), inspired by python [ipaddress](https://docs.python.org/3/library/ipaddress.html) and ruby [ipaddr](https://ruby-doc.org/stdlib-2.5.1/libdoc/ipaddr/rdoc/IPAddr.html)   [![godoc][D]](https://godoc.org/github.com/c-robinson/iplib)
- [ether](https://github.com/songgao/ether) **star:78** Cross-platform Go package for sending and receiving ethernet frames.   [![It hasn't been updated in recent three years][Y]](https://github.com/songgao/ether)   [![godoc][D]](https://godoc.org/github.com/songgao/ether)
- [dhcp6](https://github.com/mdlayher/dhcp6) **star:76** Package dhcp6 implements a DHCPv6 server, as described in RFC 3315.   [![It hasn't been updated in recent three years][Y]](https://github.com/mdlayher/dhcp6)   [![godoc][D]](https://godoc.org/github.com/mdlayher/dhcp6)
- [gldap](https://github.com/jimlambrt/gldap) **star:76** gldap provides an ldap server implementation and you provide handlers for its ldap operations.   [![godoc][D]](https://godoc.org/github.com/jimlambrt/gldap)
- [packet](https://github.com/aerogo/packet) **star:74** Send packets over TCP and UDP. It can buffer messages and hot-swap connections if needed.   [![godoc][D]](https://godoc.org/github.com/aerogo/packet)
- [go-powerdns](https://github.com/joeig/go-powerdns) **star:65** PowerDNS API bindings for Golang.   [![There was an update last month][G]](https://github.com/joeig/go-powerdns)   [![godoc][D]](https://godoc.org/github.com/joeig/go-powerdns)
- [linkio](https://github.com/ian-kent/linkio) **star:53** Network link speed simulation for Reader/Writer interfaces.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/linkio)   [![godoc][D]](https://godoc.org/github.com/ian-kent/linkio)
- [portproxy](https://github.com/aybabtme/portproxy) **star:51** Simple TCP proxy which adds CORS support to API's which don't support it.   [![It hasn't been updated in recent three years][Y]](https://github.com/aybabtme/portproxy)   [![godoc][D]](https://godoc.org/github.com/aybabtme/portproxy)
- [fullproxy](https://github.com/shoriwe/fullproxy) **star:37** A fully featured scriptable and daemon configurable proxy and pivoting toolkit with SOCKS5, HTTP, raw ports and reverse proxy protocols.   [![godoc][D]](https://godoc.org/github.com/shoriwe/fullproxy)
- [panoptes-stream](https://github.com/yahoo/panoptes-stream) **star:37** A cloud native distributed streaming network telemetry (gNMI, Juniper JTI and Cisco MDT).   [![godoc][D]](https://godoc.org/github.com/yahoo/panoptes-stream)
- [graval](https://github.com/koofr/graval) **star:28** Experimental FTP server framework.   [![godoc][D]](https://godoc.org/github.com/koofr/graval)
- [golibwireshark](https://github.com/sunwxg/golibwireshark) **star:26** Package golibwireshark use libwireshark library to decode pcap file and analyse dissection data.   [![It hasn't been updated in recent three years][Y]](https://github.com/sunwxg/golibwireshark)   [![godoc][D]](https://godoc.org/github.com/sunwxg/golibwireshark)
- [publicip](https://github.com/polera/publicip) **star:26** Package publicip returns your public facing IPv4 address (internet egress).   [![It hasn't been updated in recent three years][Y]](https://github.com/polera/publicip)   [![godoc][D]](https://godoc.org/github.com/polera/publicip)
- [gohooks](https://github.com/averageflow/gohooks) **star:21** GoHooks make it easy to send and consume secured web-hooks from a Go application. Inspired by Spatie's Laravel Webhook Client and Server.   [![godoc][D]](https://godoc.org/github.com/averageflow/gohooks)
- [httpproxy](https://github.com/wzshiming/httpproxy) **star:18** HTTP proxy handler and dialer.   [![godoc][D]](https://godoc.org/github.com/wzshiming/httpproxy)
- [goshark](https://github.com/sunwxg/goshark) **star:15** Package goshark use tshark to decode IP packet and create data struct to analyse packet.   [![It hasn't been updated in recent three years][Y]](https://github.com/sunwxg/goshark)   [![godoc][D]](https://godoc.org/github.com/sunwxg/goshark)
- [tspool](https://github.com/two/tspool) **star:14** A TCP Library use worker pool to improve performance and protect your server.   [![It hasn't been updated in recent three years][Y]](https://github.com/two/tspool)   [![godoc][D]](https://godoc.org/github.com/two/tspool)
- [llb](https://github.com/kirillDanshin/llb) **star:13** It's a very simple but quick backend for proxy servers. Can be useful for fast redirection to predefined domain with zero memory allocation and fast response.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/llb)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/llb)

**[⬆ back to top](#contents)**

### HTTP Clients

_Libraries for making HTTP requests._

- [resty](https://github.com/go-resty/resty) **star:6750** Simple HTTP and REST client for Go inspired by Ruby rest-client.   [![There was an update last month][G]](https://github.com/go-resty/resty)   [![godoc][D]](https://godoc.org/github.com/go-resty/resty)
- [req](https://github.com/imroc/req) **star:2706** Simple Go HTTP client with Black Magic (Less code and More efficiency).   [![godoc][D]](https://godoc.org/github.com/imroc/req)
- [heimdall](https://github.com/gojektech/heimdall) **star:2330** An enhanced http client with retry and hystrix capabilities.   [![godoc][D]](https://godoc.org/github.com/gojektech/heimdall)
- [grequests](https://github.com/levigross/grequests) **star:1909** A Go "clone" of the great and famous Requests library.   [![godoc][D]](https://godoc.org/github.com/levigross/grequests)
- [sling](https://github.com/dghubble/sling) **star:1484** Sling is a Go HTTP client library for creating and sending API requests.   [![godoc][D]](https://godoc.org/github.com/dghubble/sling)
- [go-retryablehttp](https://github.com/hashicorp/go-retryablehttp) **star:1318** Retryable HTTP client in Go.   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-retryablehttp)
- [gentleman](https://github.com/h2non/gentleman) **star:970** Full-featured plugin-driven HTTP client library.   [![godoc][D]](https://godoc.org/github.com/h2non/gentleman)
- [pester](https://github.com/sethgrid/pester) **star:599** Go HTTP client calls with retries, backoff, and concurrency.   [![godoc][D]](https://godoc.org/github.com/sethgrid/pester)
- [requests](https://github.com/carlmjohnson/requests) **star:421** HTTP requests for Gophers. Uses context.Context and doesn't hide the underlying net/http.Client, making it compatible with standard Go APIs. Also includes testing tools.   [![There was an update last month][G]](https://github.com/carlmjohnson/requests)   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/requests)
- [go-cleanhttp](https://github.com/hashicorp/go-cleanhttp) **star:264** Get easily stdlib HTTP client, which does not share any state with other clients.   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-cleanhttp)
- [request](https://github.com/monaco-io/request) **star:214** HTTP client for golang. If you have experience about axios or requests, you will love it. No 3rd dependency.   [![godoc][D]](https://godoc.org/github.com/monaco-io/request)
- [go-otelroundtripper](https://github.com/NdoleStudio/go-otelroundtripper) **star:66** Go http.RoundTripper that emits open telemetry metrics for HTTP requests.   [![godoc][D]](https://godoc.org/github.com/NdoleStudio/go-otelroundtripper)
- [go-http-client](https://github.com/bozd4g/go-http-client) **star:42** Make http calls simply and easily.   [![godoc][D]](https://godoc.org/github.com/bozd4g/go-http-client)
- [rq](https://github.com/ddo/rq) **star:42** A nicer interface for golang stdlib HTTP client.   [![It hasn't been updated in recent three years][Y]](https://github.com/ddo/rq)   [![godoc][D]](https://godoc.org/github.com/ddo/rq)
- [httpretry](https://github.com/ybbus/httpretry) **star:24** Enriches the default go HTTP client with retry functionality.   [![godoc][D]](https://godoc.org/github.com/ybbus/httpretry)
- [go-zoox/fetch](https://github.com/go-zoox/fetch) **star:18** A Powerful, Lightweight, Easy Http Client, inspired by Web Fetch API.   [![godoc][D]](https://godoc.org/github.com/go-zoox/fetch)
- [go-req](https://github.com/wenerme/go-req) **star:16** Declarative golang HTTP client.   [![godoc][D]](https://godoc.org/github.com/wenerme/go-req)
- [httpc](https://github.com/valord577/httpc) **star:6** A customizable and simple HTTP client library. Only depend on the stdlib HTTP client.   [![godoc][D]](https://godoc.org/github.com/valord577/httpc)   [![Archived][Archived]](https://github.com/valord577/httpc)

**[⬆ back to top](#contents)**

## OpenGL

_Libraries for using OpenGL in Go._

- [glfw](https://github.com/go-gl/glfw) **star:1324** Go bindings for GLFW 3.
- [gl](https://github.com/go-gl/gl) **star:932** Go bindings for OpenGL (generated via glow).
- [mathgl](https://github.com/go-gl/mathgl) **star:460** Pure Go math package specialized for 3D math, with inspiration from GLM.   [![godoc][D]](https://godoc.org/github.com/go-gl/mathgl)
- [goxjs/gl](https://github.com/goxjs/gl) **star:160** Go cross-platform OpenGL bindings (OS X, Linux, Windows, browsers, iOS, Android).   [![godoc][D]](https://godoc.org/github.com/goxjs/gl)
- [goxjs/glfw](https://github.com/goxjs/glfw) **star:77** Go cross-platform glfw library for creating an OpenGL context and receiving events.   [![godoc][D]](https://godoc.org/github.com/goxjs/glfw)
- [go-glmatrix](https://github.com/technohippy/go-glmatrix) **star:5** Go port of [glMatrix](https://glmatrix.net/) library.   [![godoc][D]](https://godoc.org/github.com/technohippy/go-glmatrix)

**[⬆ back to top](#contents)**

## ORM

_Libraries that implement Object-Relational Mapping or datamapping techniques._

- [GORM](https://github.com/go-gorm/gorm) **star:29865** The fantastic ORM library for Golang, aims to be developer friendly.   [![There was an update last month][G]](https://github.com/go-gorm/gorm)   [![godoc][D]](https://godoc.org/github.com/go-gorm/gorm)
- [ent](https://github.com/facebook/ent) **star:11728** An entity framework for Go. Simple, yet powerful ORM for modeling and querying data.   [![There was an update last month][G]](https://github.com/facebook/ent)   [![godoc][D]](https://godoc.org/github.com/facebook/ent)
- [SQLBoiler](https://github.com/volatiletech/sqlboiler) **star:5210** ORM generator. Generate a featureful and blazing-fast ORM tailored to your database schema.   [![godoc][D]](https://godoc.org/github.com/volatiletech/sqlboiler)
- [gorp](https://github.com/go-gorp/gorp) **star:3588** Go Relational Persistence, ORM-ish library for Go.   [![godoc][D]](https://godoc.org/github.com/go-gorp/gorp)
- [upper.io/db](https://github.com/upper/db) **star:3190** Single interface for interacting with different data sources through the use of adapters that wrap mature database drivers.   [![godoc][D]](https://godoc.org/github.com/upper/db)
- [XORM](https://gitea.com/xorm/xorm)  Simple and powerful ORM for Go. (Support: MySQL, MyMysql, PostgreSQL, Tidb, SQLite3, MsSql and Oracle).
- [gormt](https://github.com/xxjwxc/gormt) **star:2006** Mysql database to golang gorm struct.   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gormt)
- [bun](https://github.com/uptrace/bun) **star:1500** SQL-first Golang ORM. Successor of go-pg.   [![godoc][D]](https://godoc.org/github.com/uptrace/bun)
- [reform](https://github.com/go-reform/reform) **star:1332** Better ORM for Go, based on non-empty interfaces and code generation.   [![There was an update last month][G]](https://github.com/go-reform/reform)   [![godoc][D]](https://godoc.org/github.com/go-reform/reform)
- [Prisma](https://github.com/prisma/prisma-client-go) **star:1310** Prisma Client Go, Typesafe database access for Go.   [![godoc][D]](https://godoc.org/github.com/prisma/prisma-client-go)
- [pop/soda](https://github.com/gobuffalo/pop) **star:1241** Database migration, creation, ORM, etc... for MySQL, PostgreSQL, and SQLite.   [![godoc][D]](https://godoc.org/github.com/gobuffalo/pop)
- [go-sqlbuilder](https://github.com/huandu/go-sqlbuilder) **star:848** A flexible and powerful SQL string builder library plus a zero-config ORM.   [![godoc][D]](https://godoc.org/github.com/huandu/go-sqlbuilder)
- [go-queryset](https://github.com/jirfag/go-queryset) **star:682** 100% type-safe ORM with code generation and MySQL, PostgreSQL, Sqlite3, SQL Server support based on GORM.   [![godoc][D]](https://godoc.org/github.com/jirfag/go-queryset)
- [rel](https://github.com/go-rel/rel) **star:583** Modern Database Access Layer for Golang - Testable, Extendable and Crafted Into a Clean and Elegant API.   [![godoc][D]](https://godoc.org/github.com/go-rel/rel)
- [Zoom](https://github.com/albrow/zoom) **star:293** Blazing-fast datastore and querying engine built on Redis.   [![godoc][D]](https://godoc.org/github.com/albrow/zoom)
- [go-sql](https://github.com/rushteam/gosql) **star:168** A easy ORM for mysql.   [![godoc][D]](https://godoc.org/github.com/rushteam/gosql)
- [grimoire](https://github.com/Fs02/grimoire) **star:158** Grimoire is a database access layer and validation for golang. (Support: MySQL, PostgreSQL and SQLite3).   [![godoc][D]](https://godoc.org/github.com/Fs02/grimoire)
- [golobby/orm](https://github.com/golobby/orm) **star:111** Simple, fast, type-safe, generic orm for developer happiness.   [![godoc][D]](https://godoc.org/github.com/golobby/orm)
- [go-store](https://github.com/gosuri/go-store) **star:109** Simple and fast Redis backed key-value store library for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/gosuri/go-store)   [![godoc][D]](https://godoc.org/github.com/gosuri/go-store)
- [go-firestorm](https://github.com/jschoedt/go-firestorm) **star:38** A simple ORM for Google/Firebase Cloud Firestore.   [![godoc][D]](https://godoc.org/github.com/jschoedt/go-firestorm)
- [cacheme](https://github.com/Yiling-J/cacheme-go) **star:22** Schema based, typed Redis caching/memoize framework for Go.   [![godoc][D]](https://godoc.org/github.com/Yiling-J/cacheme-go)   [![Contains Chinese documents][CN]](https://github.com/Yiling-J/cacheme-go)
- [marlow](https://github.com/marlow/marlow) **star:12** Generated ORM from project structs for compile time safety assurances.   [![godoc][D]](https://godoc.org/github.com/marlow/marlow)
- [lore](https://github.com/abrahambotros/lore) **star:11** Simple and lightweight pseudo-ORM/pseudo-struct-mapping environment for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/abrahambotros/lore)   [![godoc][D]](https://godoc.org/github.com/abrahambotros/lore)

**[⬆ back to top](#contents)**

## Package Management

_Official tooling for dependency and package management_

- [go modules](https://golang.org/cmd/go/#hdr-Modules__module_versions__and_more)  Modules are the unit of source code interchange and versioning. The go command has direct support for working with modules, including recording and resolving dependencies on other modules.

_Official experimental tooling for package management_

- [dep](https://github.com/golang/dep) **star:13008** Go dependency tool.   [![godoc][D]](https://godoc.org/github.com/golang/dep)   [![Archived][Archived]](https://github.com/golang/dep)
- [vgo](https://go.googlesource.com/vgo/)  Versioned Go.

_Unofficial libraries for package and dependency management._

- [glide](https://github.com/Masterminds/glide) **star:8167** Manage your golang vendor and vendored packages with ease. Inspired by tools like Maven, Bundler, and Pip.   [![godoc][D]](https://godoc.org/github.com/Masterminds/glide)
- [godep](https://github.com/tools/godep) **star:5591** dependency tool for go, godep helps build packages reproducibly by fixing their dependencies.   [![It hasn't been updated in recent three years][Y]](https://github.com/tools/godep)   [![godoc][D]](https://godoc.org/github.com/tools/godep)   [![Archived][Archived]](https://github.com/tools/godep)
- [govendor](https://github.com/kardianos/govendor) **star:4981** Go Package Manager. Go vendor tool that works with the standard vendor file.   [![godoc][D]](https://godoc.org/github.com/kardianos/govendor)   [![Archived][Archived]](https://github.com/kardianos/govendor)
- [gopm](https://github.com/gpmgo/gopm) **star:2483** Go Package Manager.   [![It hasn't been updated in recent three years][Y]](https://github.com/gpmgo/gopm)   [![godoc][D]](https://godoc.org/github.com/gpmgo/gopm)   [![Archived][Archived]](https://github.com/gpmgo/gopm)
- [gom](https://github.com/mattn/gom) **star:1394** Go Manager - bundle for go.   [![It hasn't been updated in recent three years][Y]](https://github.com/mattn/gom)   [![godoc][D]](https://godoc.org/github.com/mattn/gom)   [![Archived][Archived]](https://github.com/mattn/gom)
- [gpm](https://github.com/pote/gpm) **star:1201** Barebones dependency manager for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/pote/gpm)
- [goop](https://github.com/nitrous-io/goop) **star:779** Simple dependency manager for Go (golang), inspired by Bundler.   [![It hasn't been updated in recent three years][Y]](https://github.com/nitrous-io/goop)   [![godoc][D]](https://godoc.org/github.com/nitrous-io/goop)
- [modgv](https://github.com/lucasepe/modgv) **star:441** Converts 'go mod graph' output into Graphviz's DOT language.   [![godoc][D]](https://godoc.org/github.com/lucasepe/modgv)
- [nut](https://github.com/jingweno/nut) **star:238** Vendor Go dependencies.   [![It hasn't been updated in recent three years][Y]](https://github.com/jingweno/nut)   [![godoc][D]](https://godoc.org/github.com/jingweno/nut)
- [johnny-deps](https://github.com/VividCortex/johnny-deps) **star:214** Minimal dependency version using Git.
- [mvn-golang](https://github.com/raydac/mvn-golang) **star:145** plugin that provides way for auto-loading of Golang SDK, dependency management and start build environment in Maven project infrastructure.
- [gup](https://github.com/nao1215/gup) **star:133** Update binaries installed by "go install".   [![There was an update last month][G]](https://github.com/nao1215/gup)   [![godoc][D]](https://godoc.org/github.com/nao1215/gup)
- [VenGO](https://github.com/DamnWidget/VenGO) **star:124** create and manage exportable isolated go virtual environments.   [![It hasn't been updated in recent three years][Y]](https://github.com/DamnWidget/VenGO)   [![godoc][D]](https://godoc.org/github.com/DamnWidget/VenGO)
- [gop](https://github.com/lunny/gop) **star:49** Build and manage your Go applications out of GOPATH.   [![It hasn't been updated in recent three years][Y]](https://github.com/lunny/gop)   [![godoc][D]](https://godoc.org/github.com/lunny/gop)   [![Contains Chinese documents][CN]](https://github.com/lunny/gop)   [![Archived][Archived]](https://github.com/lunny/gop)

**[⬆ back to top](#contents)**

## Performance

- [jaeger](https://github.com/jaegertracing/jaeger) **star:16490** A distributed tracing system.   [![There was an update last month][G]](https://github.com/jaegertracing/jaeger)   [![godoc][D]](https://godoc.org/github.com/jaegertracing/jaeger)
- [pixie](https://github.com/pixie-labs/pixie) **star:3893** No instrumentation tracing for Golang applications via eBPF.   [![There was an update last month][G]](https://github.com/pixie-labs/pixie)
- [statsviz](https://github.com/arl/statsviz) **star:2267** Live visualization of your Go application runtime statistics.   [![There was an update last month][G]](https://github.com/arl/statsviz)   [![godoc][D]](https://godoc.org/github.com/arl/statsviz)
- [profile](https://github.com/pkg/profile) **star:1781** Simple profiling support package for Go.   [![godoc][D]](https://godoc.org/github.com/pkg/profile)
- [tracer](https://github.com/kamilsk/tracer) **star:67** Simple, lightweight tracing.   [![godoc][D]](https://godoc.org/github.com/kamilsk/tracer)

**[⬆ back to top](#contents)**

## Query Language

- [graphql-go](https://github.com/graphql-go/graphql) **star:8796** Implementation of GraphQL for Go.   [![godoc][D]](https://godoc.org/github.com/graphql-go/graphql)
- [gqlgen](https://github.com/99designs/gqlgen) **star:8159** go generate based graphql server library.   [![There was an update last month][G]](https://github.com/99designs/gqlgen)   [![godoc][D]](https://godoc.org/github.com/99designs/gqlgen)
- [graphql](https://github.com/neelance/graphql-go) **star:4256** GraphQL server with a focus on ease of use.   [![There was an update last month][G]](https://github.com/neelance/graphql-go)   [![godoc][D]](https://godoc.org/github.com/neelance/graphql-go)
- [dasel](https://github.com/tomwright/dasel) **star:3672** Query and update data structures using selectors from the command line. Comparable to jq/yq but supports JSON, YAML, TOML and XML with zero runtime dependencies.   [![There was an update last month][G]](https://github.com/tomwright/dasel)   [![godoc][D]](https://godoc.org/github.com/tomwright/dasel)
- [gojsonq](https://github.com/thedevsaddam/gojsonq) **star:1934** A simple Go package to Query over JSON Data.   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/gojsonq)
- [rql](https://github.com/a8m/rql) **star:264** Resource Query Language for REST API.   [![There was an update last month][G]](https://github.com/a8m/rql)   [![godoc][D]](https://godoc.org/github.com/a8m/rql)
- [jsonql](https://github.com/elgs/jsonql) **star:256** JSON query expression library in Golang.   [![godoc][D]](https://godoc.org/github.com/elgs/jsonql)
- [jsonslice](https://github.com/bhmj/jsonslice) **star:72** Jsonpath queries with advanced filters.   [![godoc][D]](https://godoc.org/github.com/bhmj/jsonslice)
- [graphql](https://github.com/tmc/graphql) **star:57** graphql parser + utilities.   [![It hasn't been updated in recent three years][Y]](https://github.com/tmc/graphql)   [![godoc][D]](https://godoc.org/github.com/tmc/graphql)   [![Archived][Archived]](https://github.com/tmc/graphql)
- [api-fu](https://github.com/ccbrown/api-fu) **star:45** Comprehensive GraphQL implementation.   [![godoc][D]](https://godoc.org/github.com/ccbrown/api-fu)
- [rqp](https://github.com/timsolov/rest-query-parser) **star:45** Query Parser for REST API. Filtering, validations, both `AND`, `OR` operations are supported directly in the query.   [![godoc][D]](https://godoc.org/github.com/timsolov/rest-query-parser)
- [goven](https://github.com/SeldonIO/goven) **star:38** A drop-in query language for any database schema.   [![godoc][D]](https://godoc.org/github.com/SeldonIO/goven)
- [straf](https://github.com/SonicRoshan/straf) **star:34** Easily Convert Golang structs to GraphQL objects.   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/straf)
- [jsonpath](https://github.com/AsaiYusuke/jsonpath) **star:11** A query library for retrieving part of JSON based on JSONPath syntax.   [![godoc][D]](https://godoc.org/github.com/AsaiYusuke/jsonpath)
- [gws](https://github.com/Zaba505/gws) **star:5** Apollos' "GraphQL over Websocket" client and server implementation.   [![godoc][D]](https://godoc.org/github.com/Zaba505/gws)

**[⬆ back to top](#contents)**

## Resource Embedding

- [statik](https://github.com/rakyll/statik) **star:3481** Embeds static files into a Go executable.   [![godoc][D]](https://godoc.org/github.com/rakyll/statik)
- [packr](https://github.com/gobuffalo/packr) **star:3414** The simple and easy way to embed static files into Go binaries.   [![godoc][D]](https://godoc.org/github.com/gobuffalo/packr)   [![Archived][Archived]](https://github.com/gobuffalo/packr)
- [go.rice](https://github.com/GeertJohan/go.rice) **star:2307** go.rice is a Go package that makes working with resources such as HTML, JS, CSS, images, and templates very easy.   [![godoc][D]](https://godoc.org/github.com/GeertJohan/go.rice)
- [vfsgen](https://github.com/shurcooL/vfsgen) **star:947** Generates a vfsdata.go file that statically implements the given virtual filesystem.   [![godoc][D]](https://godoc.org/github.com/shurcooL/vfsgen)
- [esc](https://github.com/mjibson/esc) **star:626** Embeds files into Go programs and provides http.FileSystem interfaces to them.   [![godoc][D]](https://godoc.org/github.com/mjibson/esc)
- [fileb0x](https://github.com/UnnoTed/fileb0x) **star:614** Simple tool to embed files in go with focus on "customization" and ease to use.   [![godoc][D]](https://godoc.org/github.com/UnnoTed/fileb0x)
- [go-resources](https://github.com/omeid/go-resources) **star:176** Unfancy resources embedding with Go.   [![godoc][D]](https://godoc.org/github.com/omeid/go-resources)
- [statics](https://github.com/go-playground/statics) **star:65** Embeds static resources into go files for single binary compilation + works with http.FileSystem + symlinks.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/statics)   [![godoc][D]](https://godoc.org/github.com/go-playground/statics)
- [templify](https://github.com/wlbr/templify) **star:28** Embed external template files into Go code to create single file binaries.   [![godoc][D]](https://godoc.org/github.com/wlbr/templify)
- [rebed](https://github.com/soypat/rebed) **star:23** Recreate folder structures and files from Go 1.16's `embed.FS` type   [![godoc][D]](https://godoc.org/github.com/soypat/rebed)
- [debme](https://github.com/leaanthony/debme) **star:22** Create an `embed.FS` from an existing `embed.FS` subdirectory.   [![godoc][D]](https://godoc.org/github.com/leaanthony/debme)
- [mule](https://github.com/wlbr/mule) **star:12** Embed external resources like images, movies ... into Go source code to create single file binaries using `go generate`. Focussed on simplicity.   [![godoc][D]](https://godoc.org/github.com/wlbr/mule)

**[⬆ back to top](#contents)**

## Science and Data Analysis

_Libraries for scientific computing and data analyzing._

- [gonum](https://github.com/gonum/gonum) **star:6084** Gonum is a set of numeric libraries for the Go programming language. It contains libraries for matrices, statistics, optimization, and more.   [![godoc][D]](https://godoc.org/github.com/gonum/gonum)
- [stats](https://github.com/montanaflynn/stats) **star:2517** Statistics package with common functions missing from the Golang standard library.   [![godoc][D]](https://godoc.org/github.com/montanaflynn/stats)
- [gonum/plot](https://github.com/gonum/plot) **star:2290** gonum/plot provides an API for building and drawing plots in Go.   [![godoc][D]](https://godoc.org/github.com/gonum/plot)
- [gosl](https://github.com/cpmech/gosl) **star:1694** Go scientific library for linear algebra, FFT, geometry, NURBS, numerical methods, probabilities, optimisation, differential equations, and more.   [![godoc][D]](https://godoc.org/github.com/cpmech/gosl)
- [streamtools](https://github.com/nytlabs/streamtools) **star:1317** general purpose, graphical tool for dealing with streams of data.   [![It hasn't been updated in recent three years][Y]](https://github.com/nytlabs/streamtools)   [![godoc][D]](https://godoc.org/github.com/nytlabs/streamtools)
- [dataframe-go](https://github.com/rocketlaunchr/dataframe-go) **star:888** Dataframes for machine-learning and statistics (similar to pandas).   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/dataframe-go)
- [go-dsp](https://github.com/mjibson/go-dsp) **star:791** Digital Signal Processing for Go.   [![godoc][D]](https://godoc.org/github.com/mjibson/go-dsp)
- [chart](https://github.com/vdobler/chart) **star:738** Simple Chart Plotting library for Go. Supports many graphs types.   [![godoc][D]](https://godoc.org/github.com/vdobler/chart)
- [goraph](https://github.com/gyuho/goraph) **star:695** Pure Go graph theory library(data structure, algorithm visualization).   [![godoc][D]](https://godoc.org/github.com/gyuho/goraph)
- [orb](https://github.com/paulmach/orb) **star:582** 2D geometry types with clipping, GeoJSON and Mapbox Vector Tile support.   [![There was an update last month][G]](https://github.com/paulmach/orb)   [![godoc][D]](https://godoc.org/github.com/paulmach/orb)
- [graph](https://github.com/yourbasic/graph) **star:579** Library of basic graph algorithms.   [![godoc][D]](https://godoc.org/github.com/yourbasic/graph)
- [ewma](https://github.com/VividCortex/ewma) **star:392** Exponentially-weighted moving averages.   [![godoc][D]](https://godoc.org/github.com/VividCortex/ewma)
- [calendarheatmap](https://github.com/nikolaydubina/calendarheatmap) **star:361** Calendar heatmap in plain Go inspired by Github contribution activity.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/calendarheatmap)
- [gohistogram](https://github.com/VividCortex/gohistogram) **star:167** Approximate histograms for data streams.   [![godoc][D]](https://godoc.org/github.com/VividCortex/gohistogram)
- [TextRank](https://github.com/DavidBelicza/TextRank) **star:166** TextRank implementation in Golang with extendable features (summarization, weighting, phrase extraction) and multithreading (goroutine) support.   [![godoc][D]](https://godoc.org/github.com/DavidBelicza/TextRank)
- [sparse](https://github.com/james-bowman/sparse) **star:136** Go Sparse matrix formats for linear algebra supporting scientific and machine learning applications, compatible with gonum matrix libraries.   [![godoc][D]](https://godoc.org/github.com/james-bowman/sparse)
- [go-estimate](https://github.com/milosgajdos/go-estimate) **star:101** State estimation and filtering algorithms in Go.   [![godoc][D]](https://godoc.org/github.com/milosgajdos/go-estimate)
- [pagerank](https://github.com/alixaxel/pagerank) **star:79** Weighted PageRank algorithm implemented in Go.   [![godoc][D]](https://godoc.org/github.com/alixaxel/pagerank)
- [jsonl-graph](https://github.com/nikolaydubina/jsonl-graph) **star:61** Tool to manipulate JSONL graphs with graphviz support.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/jsonl-graph)
- [geom](https://github.com/skelterjohn/geom) **star:52** 2D geometry for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/skelterjohn/geom)   [![godoc][D]](https://godoc.org/github.com/skelterjohn/geom)
- [evaler](https://github.com/soniah/evaler) **star:50** Simple floating point arithmetic expression evaluator.   [![It hasn't been updated in recent three years][Y]](https://github.com/soniah/evaler)   [![godoc][D]](https://godoc.org/github.com/soniah/evaler)
- [triangolatte](https://github.com/tchayen/triangolatte) **star:30** 2D triangulation library. Allows translating lines and polygons (both based on points) to the language of GPUs.   [![godoc][D]](https://godoc.org/github.com/tchayen/triangolatte)
- [decimal](https://github.com/db47h/decimal) **star:29** Package decimal implements arbitrary-precision decimal floating-point arithmetic.   [![godoc][D]](https://godoc.org/github.com/db47h/decimal)
- [goent](https://github.com/kzahedi/goent) **star:28** GO Implementation of Entropy Measures.   [![It hasn't been updated in recent three years][Y]](https://github.com/kzahedi/goent)   [![godoc][D]](https://godoc.org/github.com/kzahedi/goent)
- [piecewiselinear](https://github.com/sgreben/piecewiselinear) **star:23** Tiny linear interpolation library.   [![godoc][D]](https://godoc.org/github.com/sgreben/piecewiselinear)
- [godesim](https://github.com/soypat/godesim) **star:20** Extended/multivariable ODE solver framework for event-based simulations with simple API.   [![godoc][D]](https://godoc.org/github.com/soypat/godesim)
- [GoStats](https://github.com/OGFris/GoStats) **star:20** GoStats is an Open Source GoLang library for math statistics mostly used in Machine Learning domains, it covers most of the Statistical measures functions.   [![It hasn't been updated in recent three years][Y]](https://github.com/OGFris/GoStats)   [![godoc][D]](https://godoc.org/github.com/OGFris/GoStats)
- [ode](https://github.com/ChristopherRabotin/ode) **star:19** Ordinary differential equation (ODE) solver which supports extended states and channel-based iteration stop conditions.   [![It hasn't been updated in recent three years][Y]](https://github.com/ChristopherRabotin/ode)   [![godoc][D]](https://godoc.org/github.com/ChristopherRabotin/ode)
- [PiHex](https://github.com/claygod/PiHex) **star:18** Implementation of the "Bailey-Borwein-Plouffe" algorithm for the hexadecimal number Pi.   [![godoc][D]](https://godoc.org/github.com/claygod/PiHex)
- [assocentity](https://github.com/ndabAP/assocentity) **star:10** Package assocentity returns the average distance from words to a given entity.   [![godoc][D]](https://godoc.org/github.com/ndabAP/assocentity)
- [rootfinding](https://github.com/khezen/rootfinding) **star:10** root-finding algorithms library for finding roots of quadratic functions.   [![godoc][D]](https://godoc.org/github.com/khezen/rootfinding)
- [go-gt](https://github.com/ThePaw/go-gt) **star:8** Graph theory algorithms written in "Go" language.   [![It hasn't been updated in recent three years][Y]](https://github.com/ThePaw/go-gt)   [![godoc][D]](https://godoc.org/github.com/ThePaw/go-gt)
- [bradleyterry](https://github.com/seanhagen/bradleyterry) **star:7** Provides a Bradley-Terry Model for pairwise comparisons.   [![It hasn't been updated in recent three years][Y]](https://github.com/seanhagen/bradleyterry)   [![godoc][D]](https://godoc.org/github.com/seanhagen/bradleyterry)

**[⬆ back to top](#contents)**

## Security

_Libraries that are used to help make your application more secure._

- [age](https://github.com/FiloSottile/age) **star:11714** A simple, modern and secure encryption tool (and Go library) with small explicit keys, no config options, and UNIX-style composability.   [![There was an update last month][G]](https://github.com/FiloSottile/age)   [![godoc][D]](https://godoc.org/github.com/FiloSottile/age)
- [lego](https://github.com/go-acme/lego) **star:5576** Pure Go ACME client library and CLI tool (for use with Let's Encrypt).   [![There was an update last month][G]](https://github.com/go-acme/lego)   [![godoc][D]](https://godoc.org/github.com/go-acme/lego)
- [CertMagic](https://github.com/caddyserver/certmagic) **star:4221** Mature, robust, and powerful ACME client integration for fully-managed TLS certificate issuance and renewal.   [![There was an update last month][G]](https://github.com/caddyserver/certmagic)   [![godoc][D]](https://godoc.org/github.com/caddyserver/certmagic)
- [Cameradar](https://github.com/Ullaakut/cameradar) **star:3047** Tool and library to remotely hack RTSP streams from surveillance cameras.   [![There was an update last month][G]](https://github.com/Ullaakut/cameradar)   [![godoc][D]](https://godoc.org/github.com/Ullaakut/cameradar)
- [memguard](https://github.com/awnumar/memguard) **star:2226** A pure Go library for handling sensitive values in memory.   [![godoc][D]](https://godoc.org/github.com/awnumar/memguard)
- [secure](https://github.com/unrolled/secure) **star:2013** HTTP middleware for Go that facilitates some quick security wins.   [![godoc][D]](https://godoc.org/github.com/unrolled/secure)
- [acmetool](https://github.com/hlandau/acme) **star:1936** ACME (Let's Encrypt) client tool with automatic renewal.   [![godoc][D]](https://godoc.org/github.com/hlandau/acme)
- [themis](https://github.com/cossacklabs/themis) **star:1600** high-level cryptographic library for solving typical data security tasks (secure data storage, secure messaging, zero-knowledge proof authentication), available for 14 languages, best fit for multi-platform apps.   [![There was an update last month][G]](https://github.com/cossacklabs/themis)
- [acra](https://github.com/cossacklabs/acra) **star:1057** Network encryption proxy to protect database-based applications from data leaks: strong selective encryption, SQL injections prevention, intrusion detection system.   [![There was an update last month][G]](https://github.com/cossacklabs/acra)   [![godoc][D]](https://godoc.org/github.com/cossacklabs/acra)
- [Coraza](https://github.com/corazawaf/coraza) **star:677** Enterprise-ready, modsecurity and OWASP CRS compatible WAF library.   [![There was an update last month][G]](https://github.com/corazawaf/coraza)   [![godoc][D]](https://godoc.org/github.com/corazawaf/coraza)
- [nacl](https://github.com/kevinburke/nacl) **star:529** Go implementation of the NaCL set of API's.   [![godoc][D]](https://godoc.org/github.com/kevinburke/nacl)
- [ssh-vault](https://github.com/ssh-vault/ssh-vault) **star:358** encrypt/decrypt using ssh keys.   [![godoc][D]](https://godoc.org/github.com/ssh-vault/ssh-vault)
- [go-password-validator](https://github.com/lane-c-wagner/go-password-validator) **star:355** Password validator based on raw cryptographic entropy values.   [![godoc][D]](https://godoc.org/github.com/lane-c-wagner/go-password-validator)
- [firewalld-rest](https://github.com/prashantgupta24/firewalld-rest) **star:324** A rest application to dynamically update firewalld rules on a linux server.   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/firewalld-rest)
- [optimus-go](https://github.com/pjebs/optimus-go) **star:322** ID hashing and Obfuscation using Knuth's Algorithm.   [![godoc][D]](https://godoc.org/github.com/pjebs/optimus-go)
- [BadActor](https://github.com/jaredfolkins/badactor) **star:312** In-memory, application-driven jailer built in the spirit of fail2ban.   [![godoc][D]](https://godoc.org/github.com/jaredfolkins/badactor)
- [dongle](https://github.com/golang-module/dongle) **star:284** A simple, semantic and developer-friendly golang package for encoding&decoding and encryption&decryption.   [![godoc][D]](https://godoc.org/github.com/golang-module/dongle)   [![Contains Chinese documents][CN]](https://github.com/golang-module/dongle)
- [go-yara](https://github.com/hillu/go-yara) **star:276** Go Bindings for [YARA](https://github.com/plusvic/yara), the "pattern matching swiss knife for malware researchers (and everyone else)".   [![godoc][D]](https://godoc.org/github.com/hillu/go-yara)
- [passlib](https://github.com/hlandau/passlib) **star:271** Futureproof password hashing library.   [![godoc][D]](https://godoc.org/github.com/hlandau/passlib)
- [simple-scrypt](https://github.com/elithrar/simple-scrypt) **star:182** Scrypt package with a simple, obvious API and automatic cost calibration built-in.   [![godoc][D]](https://godoc.org/github.com/elithrar/simple-scrypt)
- [argon2pw](https://github.com/raja/argon2pw) **star:89** Argon2 password hash generation with constant-time password comparison.   [![godoc][D]](https://godoc.org/github.com/raja/argon2pw)
- [autocert](https://godoc.org/golang.org/x/crypto/acme/autocert)  Auto provision Let's Encrypt certificates and start a TLS server.
- [goSecretBoxPassword](https://github.com/dwin/goSecretBoxPassword) **star:52** A probably paranoid package for securely hashing and encrypting passwords.   [![godoc][D]](https://godoc.org/github.com/dwin/goSecretBoxPassword)
- [Interpol](https://bitbucket.org/vahidi/interpol)  Rule-based data generator for fuzzing and penetration testing.
- [go-generate-password](https://github.com/m1/go-generate-password) **star:45** Password generator that can be used on the cli or as a library.   [![godoc][D]](https://godoc.org/github.com/m1/go-generate-password)
- [go-htpasswd](https://github.com/tg123/go-htpasswd) **star:27** Apache htpasswd Parser for Go.   [![godoc][D]](https://godoc.org/github.com/tg123/go-htpasswd)
- [secureio](https://github.com/xaionaro-go/secureio) **star:26** An keyexchanging+authenticating+encrypting wrapper and multiplexer for `io.ReadWriteCloser` based on XChaCha20-poly1305, ECDH and ED25519.   [![godoc][D]](https://godoc.org/github.com/xaionaro-go/secureio)
- [certificates](https://github.com/mvmaasakkers/certificates) **star:24** An opinionated tool for generating tls certificates.   [![godoc][D]](https://godoc.org/github.com/mvmaasakkers/certificates)
- [argon2-hashing](https://github.com/andskur/argon2-hashing) **star:19** light wrapper around Go's argon2 package that closely mirrors with Go's standard library Bcrypt and simple-scrypt package.   [![godoc][D]](https://godoc.org/github.com/andskur/argon2-hashing)
- [secret](https://github.com/rsjethani/secret) **star:18** Prevent your secrets from leaking into logs, std* etc.   [![godoc][D]](https://godoc.org/github.com/rsjethani/secret)
- [goArgonPass](https://github.com/dwin/goArgonPass) **star:16** Argon2 password hash and verification designed to be compatible with existing Python and PHP implementations.   [![godoc][D]](https://godoc.org/github.com/dwin/goArgonPass)
- [sslmgr](https://github.com/adrianosela/sslmgr) **star:16** SSL certificates made easy with a high level wrapper around acme/autocert.   [![It hasn't been updated in recent three years][Y]](https://github.com/adrianosela/sslmgr)   [![godoc][D]](https://godoc.org/github.com/adrianosela/sslmgr)

**[⬆ back to top](#contents)**

## Serialization

_Libraries and tools for binary serialization._

- [jsoniter](https://github.com/json-iterator/go) **star:11366** High-performance 100% compatible drop-in replacement of "encoding/json".   [![There was an update last month][G]](https://github.com/json-iterator/go)   [![godoc][D]](https://godoc.org/github.com/json-iterator/go)
- [goprotobuf](https://github.com/golang/protobuf) **star:8719** Go support, in the form of a library and protocol compiler plugin, for Google's protocol buffers.   [![godoc][D]](https://godoc.org/github.com/golang/protobuf)
- [mapstructure](https://github.com/mitchellh/mapstructure) **star:6176** Go library for decoding generic map values into native Go structures.   [![There was an update last month][G]](https://github.com/mitchellh/mapstructure)   [![godoc][D]](https://godoc.org/github.com/mitchellh/mapstructure)
- [gogoprotobuf](https://github.com/gogo/protobuf) **star:5436** Protocol Buffers for Go with Gadgets.   [![godoc][D]](https://godoc.org/github.com/gogo/protobuf)
- [go-codec](https://github.com/ugorji/go) **star:1681** High Performance, feature-Rich, idiomatic encode, decode and rpc library for msgpack, cbor and json, with runtime-based OR code-generation support.   [![godoc][D]](https://godoc.org/github.com/ugorji/go)
- [csvutil](https://github.com/jszwec/csvutil) **star:755** High Performance, idiomatic CSV record encoding and decoding to native Go structures.   [![godoc][D]](https://godoc.org/github.com/jszwec/csvutil)
- [colfer](https://github.com/pascaldekloe/colfer) **star:678** Code generation for the Colfer binary format.   [![godoc][D]](https://godoc.org/github.com/pascaldekloe/colfer)
- [cbor](https://github.com/fxamacker/cbor) **star:493** Small, safe, and easy CBOR encoding and decoding library.   [![There was an update last month][G]](https://github.com/fxamacker/cbor)   [![godoc][D]](https://godoc.org/github.com/fxamacker/cbor)
- [go-capnproto](https://github.com/glycerine/go-capnproto) **star:284** Cap'n Proto library and parser for go.   [![godoc][D]](https://godoc.org/github.com/glycerine/go-capnproto)
- [php_session_decoder](https://github.com/yvasiyarov/php_session_decoder) **star:155** GoLang library for working with PHP session format and PHP Serialize/Unserialize functions.   [![It hasn't been updated in recent three years][Y]](https://github.com/yvasiyarov/php_session_decoder)   [![godoc][D]](https://godoc.org/github.com/yvasiyarov/php_session_decoder)
- [structomap](https://github.com/tuvistavie/structomap) **star:138** Library to easily and dynamically generate maps from static structures.   [![It hasn't been updated in recent three years][Y]](https://github.com/tuvistavie/structomap)   [![godoc][D]](https://godoc.org/github.com/tuvistavie/structomap)
- [bambam](https://github.com/glycerine/bambam) **star:65** generator for Cap'n Proto schemas from go.   [![It hasn't been updated in recent three years][Y]](https://github.com/glycerine/bambam)   [![godoc][D]](https://godoc.org/github.com/glycerine/bambam)
- [binstruct](https://github.com/ghostiam/binstruct) **star:60** Golang binary decoder for mapping data into the structure.   [![godoc][D]](https://godoc.org/github.com/ghostiam/binstruct)
- [asn1](https://github.com/PromonLogicalis/asn1) **star:52** Asn.1 BER and DER encoding library for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/PromonLogicalis/asn1)   [![godoc][D]](https://godoc.org/github.com/PromonLogicalis/asn1)   [![Archived][Archived]](https://github.com/PromonLogicalis/asn1)
- [bel](https://github.com/32leaves/bel) **star:28** Generate TypeScript interfaces from Go structs/interfaces. Useful for JSON RPC.   [![godoc][D]](https://godoc.org/github.com/32leaves/bel)
- [fwencoder](https://github.com/o1egl/fwencoder) **star:22** Fixed width file parser (encoding and decoding library) for Go.   [![godoc][D]](https://godoc.org/github.com/o1egl/fwencoder)
- [pletter](https://github.com/vimeda/pletter) **star:19** A standard way to wrap a proto message for message brokers.   [![godoc][D]](https://godoc.org/github.com/vimeda/pletter)
- [elastic](https://github.com/epiclabs-io/elastic) **star:18** Convert slices, maps or any other unknown value across different types at run-time, no matter what.   [![godoc][D]](https://godoc.org/github.com/epiclabs-io/elastic)
- [fixedwidth](https://github.com/huydang284/fixedwidth) **star:8** Fixed-width text formatting (UTF-8 supported).   [![godoc][D]](https://godoc.org/github.com/huydang284/fixedwidth)
- [unitpacking](https://github.com/recolude/unitpacking) **star:5** Library to pack unit vectors into as fewest bytes as possible.   [![godoc][D]](https://godoc.org/github.com/recolude/unitpacking)
- [go-lctree](https://github.com/sbourlon/go-lctree) **star:4** Provides a CLI and primitives to serialize and deserialize [LeetCode binary trees](https://support.leetcode.com/hc/en-us/articles/360011883654-What-does-1-null-2-3-mean-in-binary-tree-representation).   [![godoc][D]](https://godoc.org/github.com/sbourlon/go-lctree)

**[⬆ back to top](#contents)**

## Server Applications

- [Caddy](https://github.com/caddyserver/caddy) **star:43488** Caddy is an alternative, HTTP/2 web server that's easy to configure and use.   [![There was an update last month][G]](https://github.com/caddyserver/caddy)   [![godoc][D]](https://godoc.org/github.com/caddyserver/caddy)
- [consul](https://www.consul.io/)  Consul is a tool for service discovery, monitoring and configuration.
- [etcd](https://github.com/coreos/etcd) **star:41369** Highly-available key value store for shared configuration and service discovery.   [![There was an update last month][G]](https://github.com/coreos/etcd)   [![godoc][D]](https://godoc.org/github.com/coreos/etcd)
- [minio](https://github.com/minio/minio) **star:35590** Minio is a distributed object storage server.   [![There was an update last month][G]](https://github.com/minio/minio)   [![godoc][D]](https://godoc.org/github.com/minio/minio)
- [RoadRunner](https://github.com/spiral/roadrunner) **star:6745** High-performance PHP application server, load-balancer and process manager.   [![There was an update last month][G]](https://github.com/spiral/roadrunner)   [![godoc][D]](https://godoc.org/github.com/spiral/roadrunner)
- [SFTPGo](https://github.com/drakkan/sftpgo) **star:4832** Fully featured and highly configurable SFTP server with optional FTP/S and WebDAV support. It can serve local filesystem and Cloud Storage backends such as S3 and Google Cloud Storage.   [![There was an update last month][G]](https://github.com/drakkan/sftpgo)   [![godoc][D]](https://godoc.org/github.com/drakkan/sftpgo)
- [Easegress](https://github.com/megaease/easegress) **star:4804** A cloud native high availability/performance traffic orchestration system with observability and extensibility.   [![There was an update last month][G]](https://github.com/megaease/easegress)   [![godoc][D]](https://godoc.org/github.com/megaease/easegress)
- [devd](https://github.com/cortesi/devd) **star:3279** Local webserver for developers.   [![godoc][D]](https://godoc.org/github.com/cortesi/devd)
- [algernon](https://github.com/xyproto/algernon) **star:2123** HTTP/2 web server with built-in support for Lua, Markdown, GCSS and Amber.   [![godoc][D]](https://godoc.org/github.com/xyproto/algernon)
- [Fider](https://github.com/getfider/fider) **star:2058** Fider is an open platform to collect and organize customer feedback.   [![godoc][D]](https://godoc.org/github.com/getfider/fider)
- [Flagr](https://github.com/checkr/flagr) **star:2011** Flagr is an open-source feature flagging and A/B testing service.   [![godoc][D]](https://godoc.org/github.com/checkr/flagr)
- [flipt](https://github.com/markphelps/flipt) **star:1902** A self contained feature flag solution written in Go and Vue.js   [![There was an update last month][G]](https://github.com/markphelps/flipt)   [![godoc][D]](https://godoc.org/github.com/markphelps/flipt)
- [Trickster](https://github.com/tricksterproxy/trickster) **star:1768** HTTP reverse proxy cache and time series accelerator.   [![There was an update last month][G]](https://github.com/tricksterproxy/trickster)   [![godoc][D]](https://godoc.org/github.com/tricksterproxy/trickster)
- [discovery](https://github.com/Bilibili/discovery) **star:1687** A registry for resilient mid-tier load balancing and failover.   [![godoc][D]](https://godoc.org/github.com/Bilibili/discovery)
- [Wish](https://github.com/charmbracelet/wish) **star:1613** Make SSH apps, just like that!   [![There was an update last month][G]](https://github.com/charmbracelet/wish)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/wish)
- [jackal](https://github.com/ortuman/jackal) **star:1339** An XMPP server written in Go.   [![There was an update last month][G]](https://github.com/ortuman/jackal)   [![godoc][D]](https://godoc.org/github.com/ortuman/jackal)
- [go-feature-flag](https://github.com/thomaspoignant/go-feature-flag) **star:522** A feature flag solution, with only a YAML file in the backend (S3, GitHub, HTTP, local file ...), no server to install, just add a file in a central system and refer to it.   [![There was an update last month][G]](https://github.com/thomaspoignant/go-feature-flag)   [![godoc][D]](https://godoc.org/github.com/thomaspoignant/go-feature-flag)
- [Euterpe](https://github.com/ironsmile/euterpe) **star:435** Self-hosted music streaming server with built-in web UI and REST API.   [![godoc][D]](https://godoc.org/github.com/ironsmile/euterpe)
- [dummy](https://github.com/neotoolkit/dummy) **star:161** Run mock server based off an API contract with one command.   [![godoc][D]](https://godoc.org/github.com/neotoolkit/dummy)
- [dudeldu](https://github.com/krotik/dudeldu) **star:138** A simple SHOUTcast server.   [![It hasn't been updated in recent three years][Y]](https://github.com/krotik/dudeldu)   [![godoc][D]](https://godoc.org/github.com/krotik/dudeldu)
- [lets-proxy2](https://github.com/rekby/lets-proxy2) **star:69** Reverse proxy for handle https with issue certificates in fly from lets-encrypt.   [![godoc][D]](https://godoc.org/github.com/rekby/lets-proxy2)
- [go-proxy-cache](https://github.com/fabiocicerchia/go-proxy-cache) **star:68** Simple Reverse Proxy with Caching, written in Go, using Redis.   [![godoc][D]](https://godoc.org/github.com/fabiocicerchia/go-proxy-cache)
- [cortex-tenant](https://github.com/blind-oracle/cortex-tenant) **star:55** Prometheus remote write proxy that adds add Cortex tenant ID header based on metric labels.   [![godoc][D]](https://godoc.org/github.com/blind-oracle/cortex-tenant)
- [psql-streamer](https://github.com/blind-oracle/psql-streamer) **star:43** Stream database events from PostgreSQL to Kafka.   [![godoc][D]](https://godoc.org/github.com/blind-oracle/psql-streamer)
- [nginx-prometheus](https://github.com/blind-oracle/nginx-prometheus) **star:34** Nginx log parser and exporter to Prometheus.   [![godoc][D]](https://godoc.org/github.com/blind-oracle/nginx-prometheus)
- [nsq](https://nsq.io/)  A realtime distributed messaging platform.
- [simple-jwt-provider](https://github.com/leberKleber/simple-jwt-provider) **star:30** Simple and lightweight provider which exhibits JWTs, supports login, password-reset (via mail) and user management.   [![godoc][D]](https://godoc.org/github.com/leberKleber/simple-jwt-provider)
- [protoxy](https://github.com/camgraff/protoxy) **star:26** A proxy server that converts JSON request bodies to Protocol Buffers.   [![godoc][D]](https://godoc.org/github.com/camgraff/protoxy)
- [Moxy](https://github.com/sinhashubham95/moxy) **star:8** Moxy is a simple mocker and proxy application server, you can create mock endpoints as well as proxy requests in case no mock exists for the endpoint.   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/moxy)
- [riemann-relay](https://github.com/blind-oracle/riemann-relay) **star:2** Relay to load-balance Riemann events and/or convert them to Carbon.   [![godoc][D]](https://godoc.org/github.com/blind-oracle/riemann-relay)

**[⬆ back to top](#contents)**

## Stream Processing

_Libraries and tools for stream processing and reactive programming._

- [go-streams](https://github.com/reugn/go-streams) **star:1053** Go stream processing library.   [![There was an update last month][G]](https://github.com/reugn/go-streams)   [![godoc][D]](https://godoc.org/github.com/reugn/go-streams)
- [machine](https://github.com/whitaker-io/machine) **star:116** Go library for writing and generating stream workers with built in metrics and traceability.   [![godoc][D]](https://godoc.org/github.com/whitaker-io/machine)
- [stream](https://github.com/youthlin/stream) **star:67** Go Stream, like Java 8 Stream: Filter/Map/FlatMap/Peek/Sorted/ForEach/Reduce...   [![godoc][D]](https://godoc.org/github.com/youthlin/stream)
- [goio](https://github.com/primetalk/goio) **star:48** An implementation of IO, Stream, Fiber for Golang, inspired by awesome Scala libraries cats and fs2.   [![There was an update last month][G]](https://github.com/primetalk/goio)   [![godoc][D]](https://godoc.org/github.com/primetalk/goio)

**[⬆ back to top](#contents)**

## Template Engines

_Libraries and tools for templating and lexing._

- [sprig](https://github.com/Masterminds/sprig) **star:3199** Useful template functions for Go templates.   [![godoc][D]](https://godoc.org/github.com/Masterminds/sprig)
- [quicktemplate](https://github.com/valyala/quicktemplate) **star:2574** Fast, powerful, yet easy to use template engine. Converts templates into Go code and then compiles it.   [![godoc][D]](https://godoc.org/github.com/valyala/quicktemplate)
- [pongo2](https://github.com/flosch/pongo2) **star:2364** Django-like template-engine for Go.   [![godoc][D]](https://godoc.org/github.com/flosch/pongo2)
- [jet](https://github.com/CloudyKit/jet) **star:959** Jet template engine.   [![godoc][D]](https://godoc.org/github.com/CloudyKit/jet)
- [Razor](https://github.com/sipin/gorazor) **star:799** Razor view engine for Golang.   [![godoc][D]](https://godoc.org/github.com/sipin/gorazor)
- [maroto](https://github.com/johnfercher/maroto) **star:766** A maroto way to create PDFs. Maroto is inspired in Bootstrap and uses gofpdf. Fast and simple.   [![godoc][D]](https://godoc.org/github.com/johnfercher/maroto)
- [fasttemplate](https://github.com/valyala/fasttemplate) **star:633** Simple and fast template engine. Substitutes template placeholders up to 10x faster than [text/template](https://golang.org/pkg/text/template/).   [![godoc][D]](https://godoc.org/github.com/valyala/fasttemplate)
- [ego](https://github.com/benbjohnson/ego) **star:535** Lightweight templating language that lets you write templates in Go. Templates are translated into Go and compiled.   [![godoc][D]](https://godoc.org/github.com/benbjohnson/ego)
- [raymond](https://github.com/aymerick/raymond) **star:493** Complete handlebars implementation in Go.   [![godoc][D]](https://godoc.org/github.com/aymerick/raymond)
- [goview](https://github.com/foolin/goview) **star:303** Goview is a lightweight, minimalist and idiomatic template library based on golang html/template for building Go web application.   [![godoc][D]](https://godoc.org/github.com/foolin/goview)
- [liquid](https://github.com/osteele/liquid) **star:174** Go implementation of Shopify Liquid templates.   [![There was an update last month][G]](https://github.com/osteele/liquid)   [![godoc][D]](https://godoc.org/github.com/osteele/liquid)
- [Soy](https://github.com/robfig/soy) **star:167** Closure templates (aka Soy templates) for Go, following the [official spec](https://developers.google.com/closure/templates/).   [![godoc][D]](https://godoc.org/github.com/robfig/soy)
- [extemplate](https://github.com/dannyvankooten/extemplate) **star:50** Tiny wrapper around html/template to allow for easy file-based template inheritance.   [![godoc][D]](https://godoc.org/github.com/dannyvankooten/extemplate)
- [gospin](https://github.com/m1/gospin) **star:40** Article spinning and spintax/spinning syntax engine, useful for A/B, testing pieces of text/articles and creating more natural conversations.   [![godoc][D]](https://godoc.org/github.com/m1/gospin)
- [tbd](https://github.com/lucasepe/tbd) **star:22** A really simple way to create text templates with placeholders - exposes extra builtin Git repo metadata.   [![godoc][D]](https://godoc.org/github.com/lucasepe/tbd)
- [got](https://github.com/goradd/got) **star:3** A Go code generator inspired by Hero and Fasttemplate. Has include files, custom tag definitions, injected Go code, language translation, and more.   [![godoc][D]](https://godoc.org/github.com/goradd/got)

**[⬆ back to top](#contents)**

## Testing

_Libraries for testing codebases and generating test data._

- Testing Frameworks
  - [Testify](https://github.com/stretchr/testify) **star:17752** Sacred extension to the standard go testing package.   [![There was an update last month][G]](https://github.com/stretchr/testify)   [![godoc][D]](https://godoc.org/github.com/stretchr/testify)
  - [testmd](https://godoc.org/github.com/tvastar/test/cmd/testmd)  Convert markdown snippets into testable go code.
  - [go-cmp](https://github.com/google/go-cmp) **star:3128** Package for comparing Go values in tests.   [![godoc][D]](https://godoc.org/github.com/google/go-cmp)
  - [httpexpect](https://github.com/gavv/httpexpect) **star:1996** Concise, declarative, and easy to use end-to-end HTTP and REST API testing.   [![godoc][D]](https://godoc.org/github.com/gavv/httpexpect)
  - [godog](https://github.com/DATA-DOG/godog) **star:1792** Cucumber or Behat like BDD framework for Go.   [![godoc][D]](https://godoc.org/github.com/DATA-DOG/godog)
  - [is](https://github.com/matryer/is) **star:1478** Professional lightweight testing mini-framework for Go.   [![godoc][D]](https://godoc.org/github.com/matryer/is)
  - [go-vcr](https://github.com/dnaeon/go-vcr) **star:953** Record and replay your HTTP interactions for fast, deterministic and accurate tests.   [![godoc][D]](https://godoc.org/github.com/dnaeon/go-vcr)
  - [gnomock](https://github.com/orlangure/gnomock) **star:946** integration testing with real dependencies (database, cache, even Kubernetes or AWS) running in Docker, without mocks.   [![There was an update last month][G]](https://github.com/orlangure/gnomock)   [![godoc][D]](https://godoc.org/github.com/orlangure/gnomock)
  - [goblin](https://github.com/franela/goblin) **star:863** Mocha like testing framework fo Go.   [![godoc][D]](https://godoc.org/github.com/franela/goblin)
  - [testfixtures](https://github.com/go-testfixtures/testfixtures) **star:855** A helper for Rails' like test fixtures to test database applications.   [![godoc][D]](https://godoc.org/github.com/go-testfixtures/testfixtures)
  - [baloo](https://github.com/h2non/baloo) **star:741** Expressive and versatile end-to-end HTTP API testing made easy.   [![godoc][D]](https://godoc.org/github.com/h2non/baloo)
  - [goc](https://github.com/qiniu/goc) **star:574** Goc is a comprehensive coverage testing system for The Go Programming Language.   [![godoc][D]](https://godoc.org/github.com/qiniu/goc)
  - [gocheck](https://labix.org/gocheck)  More advanced testing framework alternative to gotest.
  - [GoConvey](https://github.com/smartystreets/goconvey/)  BDD-style framework with web UI and live reload.
  - [go-mutesting](https://github.com/zimmski/go-mutesting) **star:554** Mutation testing for Go source code.   [![godoc][D]](https://godoc.org/github.com/zimmski/go-mutesting)
  - [embedded-postgres](https://github.com/fergusstrange/embedded-postgres) **star:437** Run a real Postgres database locally on Linux, OSX or Windows as part of another Go application or test.   [![godoc][D]](https://godoc.org/github.com/fergusstrange/embedded-postgres)
  - [gofight](https://github.com/appleboy/gofight) **star:427** API Handler Testing for Golang Router framework.   [![godoc][D]](https://godoc.org/github.com/appleboy/gofight)
  - [testza](https://github.com/MarvinJWendt/testza) **star:398** Full-featured test framework with nice colorized output.   [![There was an update last month][G]](https://github.com/MarvinJWendt/testza)   [![godoc][D]](https://godoc.org/github.com/MarvinJWendt/testza)
  - [gotest.tools](https://github.com/gotestyourself/gotest.tools) **star:358** A collection of packages to augment the go testing package and support common patterns.   [![There was an update last month][G]](https://github.com/gotestyourself/gotest.tools)   [![godoc][D]](https://godoc.org/github.com/gotestyourself/gotest.tools)
  - [go-testdeep](https://github.com/maxatome/go-testdeep) **star:318** Extremely flexible golang deep comparison, extends the go testing package.   [![godoc][D]](https://godoc.org/github.com/maxatome/go-testdeep)
  - [frisby](https://github.com/verdverm/frisby) **star:274** REST API testing framework.   [![godoc][D]](https://godoc.org/github.com/verdverm/frisby)
  - [got](https://github.com/ysmood/got) **star:254** An enjoyable golang test framework.   [![godoc][D]](https://godoc.org/github.com/ysmood/got)
  - [cupaloy](https://github.com/bradleyjkemp/cupaloy) **star:231** Simple snapshot testing addon for your test framework.   [![godoc][D]](https://godoc.org/github.com/bradleyjkemp/cupaloy)
  - [go-carpet](https://github.com/msoap/go-carpet) **star:229** Tool for viewing test coverage in terminal.   [![godoc][D]](https://godoc.org/github.com/msoap/go-carpet)
  - [endly](https://github.com/viant/endly) **star:222** Declarative end to end functional testing.   [![godoc][D]](https://godoc.org/github.com/viant/endly)
  - [commander](https://github.com/SimonBaeumer/commander) **star:204** Tool for testing cli applications on windows, linux and osx.   [![godoc][D]](https://godoc.org/github.com/SimonBaeumer/commander)
  - [charlatan](https://github.com/percolate/charlatan) **star:198** Tool to generate fake interface implementations for tests.   [![It hasn't been updated in recent three years][Y]](https://github.com/percolate/charlatan)   [![godoc][D]](https://godoc.org/github.com/percolate/charlatan)
  - [dbcleaner](https://github.com/khaiql/dbcleaner) **star:141** Clean database for testing purpose, inspired by `database_cleaner` in Ruby.   [![godoc][D]](https://godoc.org/github.com/khaiql/dbcleaner)
  - [go-hit](https://github.com/Eun/go-hit) **star:138** Hit is an http integration test framework written in golang.   [![There was an update last month][G]](https://github.com/Eun/go-hit)   [![godoc][D]](https://godoc.org/github.com/Eun/go-hit)
  - [GoSpec](https://github.com/orfjackal/gospec) **star:114** BDD-style testing framework for the Go programming language.   [![It hasn't been updated in recent three years][Y]](https://github.com/orfjackal/gospec)   [![godoc][D]](https://godoc.org/github.com/orfjackal/gospec)
  - [testcase](https://github.com/adamluzsi/testcase) **star:100** Idiomatic testing framework for Behavior Driven Development.   [![There was an update last month][G]](https://github.com/adamluzsi/testcase)   [![godoc][D]](https://godoc.org/github.com/adamluzsi/testcase)
  - [wstest](https://github.com/posener/wstest) **star:95** Websocket client for unit-testing a websocket http.Handler.   [![godoc][D]](https://godoc.org/github.com/posener/wstest)
  - [jsonassert](https://github.com/kinbiko/jsonassert) **star:94** Package for verifying that your JSON payloads are serialized correctly.   [![godoc][D]](https://godoc.org/github.com/kinbiko/jsonassert)
  - [gocrest](https://github.com/corbym/gocrest) **star:84** Composable hamcrest-like matchers for Go assertions.   [![godoc][D]](https://godoc.org/github.com/corbym/gocrest)
  - [restit](https://github.com/yookoala/restit) **star:56** Go micro framework to help writing RESTful API integration test.   [![It hasn't been updated in recent three years][Y]](https://github.com/yookoala/restit)   [![godoc][D]](https://godoc.org/github.com/yookoala/restit)
  - [gospecify](https://github.com/stesla/gospecify) **star:53** This provides a BDD syntax for testing your Go code. It should be familiar to anybody who has used libraries such as rspec.   [![It hasn't been updated in recent three years][Y]](https://github.com/stesla/gospecify)   [![godoc][D]](https://godoc.org/github.com/stesla/gospecify)
  - [covergates](https://github.com/covergates/covergates) **star:52** Self-hosted code coverage report review and management service.   [![There was an update last month][G]](https://github.com/covergates/covergates)   [![godoc][D]](https://godoc.org/github.com/covergates/covergates)
  - [gherkingen](https://github.com/hedhyw/gherkingen) **star:50** BDD boilerplate generator and framework.   [![godoc][D]](https://godoc.org/github.com/hedhyw/gherkingen)
  - [ginkgo](https://onsi.github.io/ginkgo/)  BDD Testing Framework for Go.
  - [assert](https://github.com/go-playground/assert) **star:48** Basic Assertion Library used along side native go testing, with building blocks for custom assertions.   [![godoc][D]](https://godoc.org/github.com/go-playground/assert)
  - [dsunit](https://github.com/viant/dsunit) **star:43** Datastore testing for SQL, NoSQL, structured files.   [![godoc][D]](https://godoc.org/github.com/viant/dsunit)
  - [gomatch](https://github.com/jfilipczyk/gomatch) **star:43** library created for testing JSON against patterns.   [![godoc][D]](https://godoc.org/github.com/jfilipczyk/gomatch)
  - [gomega](https://onsi.github.io/gomega/)  Rspec like matcher/assertion library.
  - [Hamcrest](https://github.com/rdrdr/hamcrest) **star:28** fluent framework for declarative Matcher objects that, when applied to input values, produce self-describing results.   [![godoc][D]](https://godoc.org/github.com/rdrdr/hamcrest)
  - [apitest](https://apitest.dev)  Simple and extensible behavioural testing library for REST based services or HTTP handlers that supports mocking external http calls and rendering of sequence diagrams.
  - [be](https://github.com/carlmjohnson/be) **star:21** The minimalist generic test assertion library.   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/be)
  - [schema](https://github.com/jgroeneveld/schema) **star:18** Quick and easy expression matching for JSON schemas used in requests and responses.   [![It hasn't been updated in recent three years][Y]](https://github.com/jgroeneveld/schema)   [![godoc][D]](https://godoc.org/github.com/jgroeneveld/schema)
  - [flute](https://github.com/suzuki-shunsuke/flute) **star:17** HTTP client testing framework.   [![godoc][D]](https://godoc.org/github.com/suzuki-shunsuke/flute)
  - [gogiven](https://github.com/corbym/gogiven) **star:14** YATSPEC-like BDD testing framework for Go.   [![godoc][D]](https://godoc.org/github.com/corbym/gogiven)
  - [testsql](https://github.com/zhulongcheng/testsql) **star:14** Generate test data from SQL files before testing and clear it after finished.   [![It hasn't been updated in recent three years][Y]](https://github.com/zhulongcheng/testsql)   [![godoc][D]](https://godoc.org/github.com/zhulongcheng/testsql)
  - [Gont](https://github.com/stv0g/gont) **star:13** Go network testing toolkit for testing building complex network topologies using Linux namespaces.   [![godoc][D]](https://godoc.org/github.com/stv0g/gont)
  - [gosuite](https://github.com/pavlo/gosuite) **star:12** Brings lightweight test suites with setup/teardown facilities to `testing` by leveraging Go1.7's Subtests.   [![It hasn't been updated in recent three years][Y]](https://github.com/pavlo/gosuite)   [![godoc][D]](https://godoc.org/github.com/pavlo/gosuite)
  - [biff](https://github.com/fulldump/biff) **star:11** Bifurcation testing framework, BDD compatible.   [![godoc][D]](https://godoc.org/github.com/fulldump/biff)
  - [badio](https://github.com/cavaliercoder/badio) **star:10** Extensions to Go's `testing/iotest` package.   [![It hasn't been updated in recent three years][Y]](https://github.com/cavaliercoder/badio)   [![godoc][D]](https://godoc.org/github.com/cavaliercoder/badio)
  - [fixenv](https://github.com/rekby/fixenv) **star:7** Fixture manage engine, inspired by pytest fixtures.   [![godoc][D]](https://godoc.org/github.com/rekby/fixenv)
  - [stop-and-go](https://github.com/elgohr/stop-and-go) **star:6** Testing helper for concurrency.   [![godoc][D]](https://godoc.org/github.com/elgohr/stop-and-go)
  - [trial](https://github.com/jgroeneveld/trial) **star:6** Quick and easy extendable assertions without introducing much boilerplate.   [![It hasn't been updated in recent three years][Y]](https://github.com/jgroeneveld/trial)   [![godoc][D]](https://godoc.org/github.com/jgroeneveld/trial)
  - [go-testpredicate](https://github.com/maargenton/go-testpredicate) **star:5** Test predicate style assertions library with extensive diagnostics output.   [![godoc][D]](https://godoc.org/github.com/maargenton/go-testpredicate)
  - [Tt](https://github.com/vcaesar/tt) **star:5** Simple and colorful test tools.   [![godoc][D]](https://godoc.org/github.com/vcaesar/tt)
  - [go-mysql-test-container](https://github.com/arikama/go-mysql-test-container) **star:2** Golang MySQL testcontainer to help with MySQL integration testing.   [![There was an update last month][G]](https://github.com/arikama/go-mysql-test-container)   [![godoc][D]](https://godoc.org/github.com/arikama/go-mysql-test-container)
  - [go-snaps](http://github.com/gkampitakis/go-snaps)  Jest-like snapshot testing in Golang.
  - [omg.testingtools](https://github.com/dedalqq/omg.testingtools) **star:1** The simple library for change a values of private fields for testing.   [![godoc][D]](https://godoc.org/github.com/dedalqq/omg.testingtools)

- Mock
  - [gomock](https://github.com/golang/mock) **star:8010** Mocking framework for the Go programming language.   [![There was an update last month][G]](https://github.com/golang/mock)   [![godoc][D]](https://godoc.org/github.com/golang/mock)
  - [go-sqlmock](https://github.com/DATA-DOG/go-sqlmock) **star:4728** Mock SQL driver for testing database interactions.   [![godoc][D]](https://godoc.org/github.com/DATA-DOG/go-sqlmock)
  - [mockery](https://github.com/vektra/mockery) **star:3919** Tool to generate Go interfaces.   [![There was an update last month][G]](https://github.com/vektra/mockery)   [![godoc][D]](https://godoc.org/github.com/vektra/mockery)
  - [hoverfly](https://github.com/SpectoLabs/hoverfly) **star:1915** HTTP(S) proxy for recording and simulating REST/SOAP APIs with extensible middleware and easy-to-use CLI.   [![godoc][D]](https://godoc.org/github.com/SpectoLabs/hoverfly)
  - [gock](https://github.com/h2non/gock) **star:1705** Versatile HTTP mocking made easy.   [![godoc][D]](https://godoc.org/github.com/h2non/gock)
  - [httpmock](https://github.com/jarcoal/httpmock) **star:1496** Easy mocking of HTTP responses from external resources.   [![There was an update last month][G]](https://github.com/jarcoal/httpmock)   [![godoc][D]](https://godoc.org/github.com/jarcoal/httpmock)
  - [counterfeiter](https://github.com/maxbrunsfeld/counterfeiter) **star:723** Tool for generating self-contained mock objects.   [![godoc][D]](https://godoc.org/github.com/maxbrunsfeld/counterfeiter)
  - [genmock](https://gitlab.com/so_literate/genmock)  Go mocking system with code generator for building calls of the interface methods.
  - [go-txdb](https://github.com/DATA-DOG/go-txdb) **star:482** Single transaction based database driver mainly for testing purposes.   [![godoc][D]](https://godoc.org/github.com/DATA-DOG/go-txdb)
  - [minimock](https://github.com/gojuno/minimock) **star:466** Mock generator for Go interfaces.   [![godoc][D]](https://godoc.org/github.com/gojuno/minimock)
  - [govcr](https://github.com/seborama/govcr) **star:131** HTTP mock for Golang: record and replay HTTP interactions for offline testing.   [![godoc][D]](https://godoc.org/github.com/seborama/govcr)
  - [timex](https://github.com/cabify/timex) **star:65** A test-friendly replacement for the native `time` package.   [![godoc][D]](https://godoc.org/github.com/cabify/timex)
  - [go-localstack](https://github.com/elgohr/go-localstack) **star:54** Tool for using localstack in AWS testing.   [![There was an update last month][G]](https://github.com/elgohr/go-localstack)   [![godoc][D]](https://godoc.org/github.com/elgohr/go-localstack)
  - [mockhttp](https://github.com/tv42/mockhttp) **star:22** Mock object for Go http.ResponseWriter.   [![It hasn't been updated in recent three years][Y]](https://github.com/tv42/mockhttp)   [![godoc][D]](https://godoc.org/github.com/tv42/mockhttp)
  - [mooncake](https://github.com/GuilhermeCaruso/mooncake) **star:14** A simple way to generate mocks for multiple purposes   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/mooncake)
  - [mockit](https://github.com/pasdam/mockit) **star:10** Allows functions and method easy mocking, without defining new types; it's similar to Mockito for Java.   [![There was an update last month][G]](https://github.com/pasdam/mockit)   [![godoc][D]](https://godoc.org/github.com/pasdam/mockit)

- Fuzzing and delta-debugging/reducing/shrinking.
  - [go-fuzz](https://github.com/dvyukov/go-fuzz) **star:4478** Randomized testing system.   [![godoc][D]](https://godoc.org/github.com/dvyukov/go-fuzz)
  - [gofuzz](https://github.com/google/gofuzz) **star:1319** Library for populating go objects with random values.   [![godoc][D]](https://godoc.org/github.com/google/gofuzz)
  - [Tavor](https://github.com/zimmski/tavor) **star:236** Generic fuzzing and delta-debugging framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/zimmski/tavor)   [![godoc][D]](https://godoc.org/github.com/zimmski/tavor)

- Selenium and browser control tools.
  - [chromedp](https://github.com/knq/chromedp) **star:8209** a way to drive/test Chrome, Safari, Edge, Android Webviews, and other browsers supporting the Chrome Debugging Protocol.   [![There was an update last month][G]](https://github.com/knq/chromedp)   [![godoc][D]](https://godoc.org/github.com/knq/chromedp)
  - [rod](https://github.com/go-rod/rod) **star:2812** A Devtools driver to make web automation and scraping easy.   [![godoc][D]](https://godoc.org/github.com/go-rod/rod)
  - [selenoid](https://github.com/aerokube/selenoid) **star:2233** alternative Selenium hub server that launches browsers within containers.   [![godoc][D]](https://godoc.org/github.com/aerokube/selenoid)
  - [playwright-go](https://github.com/mxschmitt/playwright-go) **star:953** browser automation library to control Chromium, Firefox and WebKit with a single API.   [![There was an update last month][G]](https://github.com/mxschmitt/playwright-go)
  - [cdp](https://github.com/mafredri/cdp) **star:638** Type-safe bindings for the Chrome Debugging Protocol that can be used with browsers or other debug targets that implement it.   [![godoc][D]](https://godoc.org/github.com/mafredri/cdp)
  - [ggr](https://github.com/aerokube/ggr) **star:287** a lightweight server that routes and proxies Selenium WebDriver requests to multiple Selenium hubs.   [![godoc][D]](https://godoc.org/github.com/aerokube/ggr)

- Fail injection
  - [failpoint](https://github.com/pingcap/failpoint) **star:738** An implementation of [failpoints](https://www.freebsd.org/cgi/man.cgi?query=fail) for Golang.   [![godoc][D]](https://godoc.org/github.com/pingcap/failpoint)

**[⬆ back to top](#contents)**

## Text Processing

_Libraries for parsing and manipulating texts._

See also [Natural Language Processing](#natural-language-processing) and [Text Analysis](#text-analysis).

### Formatters

- [go-humanize](https://github.com/dustin/go-humanize) **star:3331** Formatters for time, numbers, and memory size to human readable format.   [![godoc][D]](https://godoc.org/github.com/dustin/go-humanize)
- [gotabulate](https://github.com/bndr/gotabulate) **star:290** Easily pretty-print your tabular data with Go.   [![godoc][D]](https://godoc.org/github.com/bndr/gotabulate)
- [align](https://github.com/Guitarbum722/align) **star:78** A general purpose application that aligns text.   [![godoc][D]](https://godoc.org/github.com/Guitarbum722/align)
- [bytes](https://github.com/labstack/gommon/tree/master/bytes)  Formats and parses numeric byte values (10K, 2M, 3G, etc.).
- [go-fixedwidth](https://github.com/ianlopshire/go-fixedwidth) **star:65** Fixed-width text formatting (encoder/decoder with reflection).   [![godoc][D]](https://godoc.org/github.com/ianlopshire/go-fixedwidth)
- [address](https://github.com/bojanz/address) **star:55** Handles address representation, validation and formatting.   [![There was an update last month][G]](https://github.com/bojanz/address)   [![godoc][D]](https://godoc.org/github.com/bojanz/address)
- [textwrap](https://github.com/isbm/textwrap) **star:3** Wraps text at end of lines. Implementation of `textwrap` module from Python.   [![It hasn't been updated in recent three years][Y]](https://github.com/isbm/textwrap)   [![godoc][D]](https://godoc.org/github.com/isbm/textwrap)

### Markup Languages

- [blackfriday](https://github.com/russross/blackfriday) **star:5008** Markdown processor in Go.   [![godoc][D]](https://godoc.org/github.com/russross/blackfriday)
- [github_flavored_markdown](https://godoc.org/github.com/shurcooL/github_flavored_markdown)  GitHub Flavored Markdown renderer (using blackfriday) with fenced code block highlighting, clickable header anchor links.
- [toml](https://github.com/BurntSushi/toml) **star:3986** TOML configuration format (encoder/decoder with reflection).   [![godoc][D]](https://godoc.org/github.com/BurntSushi/toml)
- [goldmark](https://github.com/yuin/goldmark) **star:2348** A Markdown parser written in Go. Easy to extend, standard (CommonMark) compliant, well structured.   [![godoc][D]](https://godoc.org/github.com/yuin/goldmark)
- [go-toml](https://github.com/pelletier/go-toml) **star:1303** Go library for the TOML format with query support and handy cli tools.   [![There was an update last month][G]](https://github.com/pelletier/go-toml)   [![godoc][D]](https://godoc.org/github.com/pelletier/go-toml)
- [mxj](https://github.com/clbanning/mxj) **star:526** Encode / decode XML as JSON or map[string]interface{}; extract values with dot-notation paths and wildcards. Replaces x2j and j2x packages.   [![godoc][D]](https://godoc.org/github.com/clbanning/mxj)
- [htmlquery](https://github.com/antchfx/htmlquery) **star:521** An XPath query package for HTML, lets you extract data or evaluate from HTML documents by an XPath expression.   [![godoc][D]](https://godoc.org/github.com/antchfx/htmlquery)
- [html-to-markdown](https://github.com/JohannesKaufmann/html-to-markdown) **star:394** Convert HTML to Markdown. Even works with entire websites and can be extended through rules.   [![godoc][D]](https://godoc.org/github.com/JohannesKaufmann/html-to-markdown)
- [goq](https://github.com/andrewstuart/goq) **star:219** Declarative unmarshaling of HTML using struct tags with jQuery syntax (uses GoQuery).   [![godoc][D]](https://godoc.org/github.com/andrewstuart/goq)
- [bafi](https://github.com/mmalcek/bafi) **star:65** Universal JSON, BSON, YAML, XML translator to ANY format using templates.   [![godoc][D]](https://godoc.org/github.com/mmalcek/bafi)
- [go-output-format](https://github.com/drewstinnett/go-output-format) **star:8** Output go structures into multiple formats (YAML/JSON/etc) in your command line app.   [![godoc][D]](https://godoc.org/github.com/drewstinnett/go-output-format)
- [bbConvert](https://github.com/CalebQ42/bbConvert) **star:7** Converts bbCode to HTML that allows you to add support for custom bbCode tags.   [![It hasn't been updated in recent three years][Y]](https://github.com/CalebQ42/bbConvert)   [![godoc][D]](https://godoc.org/github.com/CalebQ42/bbConvert)

### Parsers/Encoders/Decoders

- [sh](https://github.com/mvdan/sh) **star:5105** Shell parser and formatter.   [![There was an update last month][G]](https://github.com/mvdan/sh)   [![godoc][D]](https://godoc.org/github.com/mvdan/sh)
- [gofeed](https://github.com/mmcdole/gofeed) **star:1962** Parse RSS and Atom feeds in Go.   [![godoc][D]](https://godoc.org/github.com/mmcdole/gofeed)
- [commonregex](https://github.com/mingrammer/commonregex) **star:833** A collection of common regular expressions for Go.   [![godoc][D]](https://godoc.org/github.com/mingrammer/commonregex)
- [omniparser](https://github.com/jf-tech/omniparser) **star:500** A versatile ETL library that parses text input (CSV/txt/JSON/XML/EDI/X12/EDIFACT/etc) in streaming fashion and transforms data into JSON output using data-driven schema.   [![godoc][D]](https://godoc.org/github.com/jf-tech/omniparser)
- [gographviz](https://github.com/awalterschulze/gographviz) **star:496** Parses the Graphviz DOT language.   [![godoc][D]](https://godoc.org/github.com/awalterschulze/gographviz)
- [go-nmea](https://github.com/adrianmo/go-nmea) **star:185** NMEA parser library for the Go language.   [![godoc][D]](https://godoc.org/github.com/adrianmo/go-nmea)
- [sdp](https://github.com/gortc/sdp) **star:114** SDP: Session Description Protocol [[RFC 4566](https://tools.ietf.org/html/rfc4566)].   [![godoc][D]](https://godoc.org/github.com/gortc/sdp)   [![Archived][Archived]](https://github.com/gortc/sdp)
- [editorconfig-core-go](https://github.com/editorconfig/editorconfig-core-go) **star:107** Editorconfig file parser and manipulator for Go.   [![There was an update last month][G]](https://github.com/editorconfig/editorconfig-core-go)   [![godoc][D]](https://godoc.org/github.com/editorconfig/editorconfig-core-go)
- [go-vcard](https://github.com/emersion/go-vcard) **star:80** Parse and format vCard.   [![godoc][D]](https://godoc.org/github.com/emersion/go-vcard)
- [did](https://github.com/ockam-network/did) **star:67** DID (Decentralized Identifiers) Parser and Stringer in Go.   [![godoc][D]](https://godoc.org/github.com/ockam-network/did)
- [allot](https://github.com/sbstjn/allot) **star:56** Placeholder and wildcard text parsing for CLI tools and bots.   [![godoc][D]](https://godoc.org/github.com/sbstjn/allot)
- [parth](https://github.com/codemodus/parth) **star:42** URL path segmentation parsing.   [![It hasn't been updated in recent three years][Y]](https://github.com/codemodus/parth)   [![godoc][D]](https://godoc.org/github.com/codemodus/parth)
- [gonameparts](https://github.com/polera/gonameparts) **star:38** Parses human names into individual name parts.   [![It hasn't been updated in recent three years][Y]](https://github.com/polera/gonameparts)   [![godoc][D]](https://godoc.org/github.com/polera/gonameparts)
- [normalize](https://github.com/avito-tech/normalize) **star:32** Sanitize, normalize and compare fuzzy text.   [![godoc][D]](https://godoc.org/github.com/avito-tech/normalize)
- [codetree](https://github.com/aerogo/codetree) **star:22** Parses indented code (python, pixy, scarlet, etc.) and returns a tree structure.   [![godoc][D]](https://godoc.org/github.com/aerogo/codetree)
- [go-fasttld](https://github.com/elliotwutingfeng/go-fasttld) **star:10** High performance top level domains (TLD) extraction module.   [![There was an update last month][G]](https://github.com/elliotwutingfeng/go-fasttld)   [![godoc][D]](https://godoc.org/github.com/elliotwutingfeng/go-fasttld)
- [parseargs-go](https://github.com/nproc/parseargs-go) **star:10** string argument parser that understands quotes and backslashes.   [![It hasn't been updated in recent three years][Y]](https://github.com/nproc/parseargs-go)   [![godoc][D]](https://godoc.org/github.com/nproc/parseargs-go)
- [encdec](https://github.com/mickep76/encdec) **star:8** Package provides a generic interface to encoders and decoders.   [![godoc][D]](https://godoc.org/github.com/mickep76/encdec)
- [ltsv](https://github.com/Wing924/ltsv) **star:8** High performance [LTSV (Labeled Tab Separated Value)](http://ltsv.org/) reader for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/Wing924/ltsv)   [![godoc][D]](https://godoc.org/github.com/Wing924/ltsv)
- [doi](https://github.com/hscells/doi) **star:7** Document object identifier (doi) parser in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/hscells/doi)   [![godoc][D]](https://godoc.org/github.com/hscells/doi)
- [tokenizer](https://github.com/bzick/tokenizer) — Parse any string, slice or infinite buffer to any tokens.
- [when](https://github.com/olebedev/when) **star:1166** Natural EN and RU language date/time parser with pluggable rules.   [![godoc][D]](https://godoc.org/github.com/olebedev/when)
- [xj2go](https://github.com/stackerzzq/xj2go) **star:28** Convert xml or json to go struct.   [![godoc][D]](https://godoc.org/github.com/stackerzzq/xj2go)

### Regular Expressions

- [regroup](https://github.com/oriser/regroup) **star:121** Match regex expression named groups into go struct using struct tags and automatic parsing.   [![godoc][D]](https://godoc.org/github.com/oriser/regroup)
- [rex](https://github.com/hedhyw/rex) **star:120** Regular expressions builder.   [![There was an update last month][G]](https://github.com/hedhyw/rex)   [![godoc][D]](https://godoc.org/github.com/hedhyw/rex)
- [goregen](https://github.com/zach-klippenstein/goregen) **star:78** Library for generating random strings from regular expressions.   [![godoc][D]](https://godoc.org/github.com/zach-klippenstein/goregen)
- [genex](https://github.com/alixaxel/genex) **star:68** Count and expand Regular Expressions into all matching Strings.   [![godoc][D]](https://godoc.org/github.com/alixaxel/genex)
- [go-wildcard](https://github.com/IGLOU-EU/go-wildcard) **star:17** Simple and lightweight wildcard pattern matching.   [![godoc][D]](https://godoc.org/github.com/IGLOU-EU/go-wildcard)

### Sanitation

- [bluemonday](https://github.com/microcosm-cc/bluemonday) **star:2456** HTML Sanitizer.   [![There was an update last month][G]](https://github.com/microcosm-cc/bluemonday)   [![godoc][D]](https://godoc.org/github.com/microcosm-cc/bluemonday)
- [gofuckyourself](https://github.com/JoshuaDoes/gofuckyourself) **star:52** A sanitization-based swear filter for Go.   [![godoc][D]](https://godoc.org/github.com/JoshuaDoes/gofuckyourself)

### Scrapers

- [colly](https://github.com/asciimoo/colly) **star:17854** Fast and Elegant Scraping Framework for Gophers.   [![godoc][D]](https://godoc.org/github.com/asciimoo/colly)
- [GoQuery](https://github.com/PuerkitoBio/goquery) **star:11901** GoQuery brings a syntax and a set of features similar to jQuery to the Go language.   [![godoc][D]](https://godoc.org/github.com/PuerkitoBio/goquery)
- [xurls](https://github.com/mvdan/xurls) **star:964** Extract urls from text.   [![godoc][D]](https://godoc.org/github.com/mvdan/xurls)
- [dataflowkit](https://github.com/slotix/dataflowkit) **star:545** Web scraping Framework to turn websites into structured data.   [![godoc][D]](https://godoc.org/github.com/slotix/dataflowkit)
- [gospider](https://github.com/zhshch2002/gospider) **star:176** A simple golang spider/scraping framework,build a spider in 3 lines. migrated from [goribot](https://github.com/zhshch2002/goribot)   [![godoc][D]](https://godoc.org/github.com/zhshch2002/gospider)
- [pagser](https://github.com/foolin/pagser) **star:70** Pagser is a simple, extensible, configurable parse and deserialize html page to struct based on goquery and struct tags for golang crawler.   [![godoc][D]](https://godoc.org/github.com/foolin/pagser)
- [Tagify](https://github.com/zoomio/tagify) **star:24** Produces a set of tags from given source.   [![godoc][D]](https://godoc.org/github.com/zoomio/tagify)
- [go-recipe](https://github.com/kkyr/go-recipe) **star:10** A package for scraping recipes from websites.   [![godoc][D]](https://godoc.org/github.com/kkyr/go-recipe)

### RSS

- [podcast](https://github.com/eduncan911/podcast) **star:112** iTunes Compliant and RSS 2.0 Podcast Generator in Golang   [![godoc][D]](https://godoc.org/github.com/eduncan911/podcast)
- [syndfeed](https://github.com/zhengchun/syndfeed) **star:9** A syndication feed for Atom 1.0 and RSS 2.0.   [![It hasn't been updated in recent three years][Y]](https://github.com/zhengchun/syndfeed)   [![godoc][D]](https://godoc.org/github.com/zhengchun/syndfeed)

### Utility/Miscellaneous

- [go-runewidth](https://github.com/mattn/go-runewidth) **star:488** Functions to get fixed width of the character or string.   [![There was an update last month][G]](https://github.com/mattn/go-runewidth)   [![godoc][D]](https://godoc.org/github.com/mattn/go-runewidth)
- [radix](https://github.com/yourbasic/radix) **star:180** Fast string sorting algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/yourbasic/radix)   [![godoc][D]](https://godoc.org/github.com/yourbasic/radix)
- [go-zero-width](https://github.com/trubitsyn/go-zero-width) **star:106** Zero-width character detection and removal for Go.   [![godoc][D]](https://godoc.org/github.com/trubitsyn/go-zero-width)   [![Archived][Archived]](https://github.com/trubitsyn/go-zero-width)
- [petrovich](https://github.com/striker2000/petrovich) **star:41** Petrovich is the library which inflects Russian names to given grammatical case.   [![godoc][D]](https://godoc.org/github.com/striker2000/petrovich)
- [kace](https://github.com/codemodus/kace) **star:19** Common case conversions covering common initialisms.   [![It hasn't been updated in recent three years][Y]](https://github.com/codemodus/kace)   [![godoc][D]](https://godoc.org/github.com/codemodus/kace)
- [TySug](https://github.com/Dynom/TySug) **star:13** Alternative suggestions with respect to keyboard layouts.   [![godoc][D]](https://godoc.org/github.com/Dynom/TySug)

**[⬆ back to top](#contents)**

## Third-party APIs

_Libraries for accessing third party APIs._

- [github](https://github.com/google/go-github) **star:8835** Go library for accessing the GitHub REST API v3.   [![There was an update last month][G]](https://github.com/google/go-github)   [![godoc][D]](https://godoc.org/github.com/google/go-github)
- [aws-sdk-go](https://github.com/aws/aws-sdk-go) **star:7904** The official AWS SDK for the Go programming language.   [![There was an update last month][G]](https://github.com/aws/aws-sdk-go)   [![godoc][D]](https://godoc.org/github.com/aws/aws-sdk-go)
- [slack](https://github.com/slack-go/slack) **star:4061** Slack API in Go.   [![There was an update last month][G]](https://github.com/slack-go/slack)   [![godoc][D]](https://godoc.org/github.com/slack-go/slack)
- [discordgo](https://github.com/bwmarrin/discordgo) **star:3415** Go bindings for the Discord Chat API.   [![There was an update last month][G]](https://github.com/bwmarrin/discordgo)   [![godoc][D]](https://godoc.org/github.com/bwmarrin/discordgo)
- [google](https://github.com/google/google-api-go-client) **star:3178** Auto-generated Google APIs for Go.   [![There was an update last month][G]](https://github.com/google/google-api-go-client)   [![godoc][D]](https://godoc.org/github.com/google/google-api-go-client)
- [google-cloud](https://github.com/GoogleCloudPlatform/gcloud-golang) **star:3055** Google Cloud APIs Go Client Library.   [![There was an update last month][G]](https://github.com/GoogleCloudPlatform/gcloud-golang)   [![godoc][D]](https://godoc.org/github.com/GoogleCloudPlatform/gcloud-golang)
- [minio-go](https://github.com/minio/minio-go) **star:1713** Minio Go Library for Amazon S3 compatible cloud storage.   [![There was an update last month][G]](https://github.com/minio/minio-go)   [![godoc][D]](https://godoc.org/github.com/minio/minio-go)
- [stripe](https://github.com/stripe/stripe-go) **star:1638** Go client for the Stripe API.   [![There was an update last month][G]](https://github.com/stripe/stripe-go)   [![godoc][D]](https://godoc.org/github.com/stripe/stripe-go)
- [go-twitter](https://github.com/dghubble/go-twitter) **star:1542** Go client library for the Twitter v1.1 APIs.   [![godoc][D]](https://godoc.org/github.com/dghubble/go-twitter)
- [go-jira](https://github.com/andygrunwald/go-jira) **star:1189** Go client library for [Atlassian JIRA](https://www.atlassian.com/software/jira)   [![godoc][D]](https://godoc.org/github.com/andygrunwald/go-jira)
- [anaconda](https://github.com/ChimeraCoder/anaconda) **star:1122** Go client library for the Twitter 1.1 API.   [![godoc][D]](https://godoc.org/github.com/ChimeraCoder/anaconda)
- [facebook](https://github.com/huandu/facebook) **star:1087** Go Library that supports the Facebook Graph API.   [![godoc][D]](https://godoc.org/github.com/huandu/facebook)
- [githubql](https://github.com/shurcooL/githubql) **star:925** Go library for accessing the GitHub GraphQL API v4.   [![godoc][D]](https://godoc.org/github.com/shurcooL/githubql)
- [webhooks](https://github.com/go-playground/webhooks) **star:778** Webhook receiver for GitHub and Bitbucket.   [![There was an update last month][G]](https://github.com/go-playground/webhooks)   [![godoc][D]](https://godoc.org/github.com/go-playground/webhooks)
- [paypal](https://github.com/logpacker/PayPal-Go-SDK) **star:527** Wrapper for PayPal payment API.   [![godoc][D]](https://godoc.org/github.com/logpacker/PayPal-Go-SDK)
- [geo-golang](https://github.com/codingsince1985/geo-golang) **star:440** Go Library to access [Google Maps](https://developers.google.com/maps/documentation/geocoding/intro), [MapQuest](https://open.mapquestapi.com/geocoding/), [Nominatim](https://developer.mapquest.com/documentation/open/nominatim-search), [OpenCage](https://opencagedata.com/api), [Bing](https://msdn.microsoft.com/en-us/library/ff701715.aspx), [Mapbox](https://www.mapbox.com/developers/api/geocoding/), and [OpenStreetMap](https://wiki.openstreetmap.org/wiki/Nominatim) geocoding / reverse geocoding APIs.   [![godoc][D]](https://godoc.org/github.com/codingsince1985/geo-golang)
- [twitter-scraper](https://github.com/n0madic/twitter-scraper) **star:257** Scrape the Twitter Frontend API without authentication and limits.   [![godoc][D]](https://godoc.org/github.com/n0madic/twitter-scraper)
- [ethrpc](https://github.com/onrik/ethrpc) **star:245** Go bindings for Ethereum JSON RPC API.   [![godoc][D]](https://godoc.org/github.com/onrik/ethrpc)
- [lark](https://github.com/chyroc/lark) **star:235** [Feishu](https://open.feishu.cn/)/[Lark](https://open.larksuite.com/) Open API Go SDK, Support ALL Open API and Event Callback.   [![godoc][D]](https://godoc.org/github.com/chyroc/lark)   [![Contains Chinese documents][CN]](https://github.com/chyroc/lark)
- [Trello](https://github.com/adlio/trello) **star:204** Go wrapper for the Trello API.   [![godoc][D]](https://godoc.org/github.com/adlio/trello)
- [go-marathon](https://github.com/gambol99/go-marathon) **star:197** Go library for interacting with Mesosphere's Marathon PAAS.   [![godoc][D]](https://godoc.org/github.com/gambol99/go-marathon)
- [Medium](https://github.com/Medium/medium-sdk-go) **star:133** Golang SDK for Medium's OAuth2 API.   [![It hasn't been updated in recent three years][Y]](https://github.com/Medium/medium-sdk-go)   [![godoc][D]](https://godoc.org/github.com/Medium/medium-sdk-go)
- [wit-go](https://github.com/wit-ai/wit-go) **star:130** Go client for wit.ai HTTP API.   [![There was an update last month][G]](https://github.com/wit-ai/wit-go)   [![godoc][D]](https://godoc.org/github.com/wit-ai/wit-go)
- [gostorm](https://github.com/jsgilmore/gostorm) **star:129** GoStorm is a Go library that implements the communications protocol required to write Storm spouts and Bolts in Go that communicate with the Storm shells.   [![It hasn't been updated in recent three years][Y]](https://github.com/jsgilmore/gostorm)   [![godoc][D]](https://godoc.org/github.com/jsgilmore/gostorm)
- [pushover](https://github.com/gregdel/pushover) **star:127** Go wrapper for the Pushover API.   [![godoc][D]](https://godoc.org/github.com/gregdel/pushover)
- [go-trending](https://github.com/andygrunwald/go-trending) **star:123** Go library for accessing [trending repositories](https://github.com/trending) and [developers](https://github.com/trending/developers) at Github.   [![There was an update last month][G]](https://github.com/andygrunwald/go-trending)   [![godoc][D]](https://godoc.org/github.com/andygrunwald/go-trending)
- [go-lark](https://github.com/go-lark/lark) **star:115** An easy-to-use unofficial SDK for [Feishu](https://open.feishu.cn/) and [Lark](https://open.larksuite.com/) Open Platform.   [![There was an update last month][G]](https://github.com/go-lark/lark)   [![godoc][D]](https://godoc.org/github.com/go-lark/lark)   [![Contains Chinese documents][CN]](https://github.com/go-lark/lark)
- [hipchat (xmpp)](https://github.com/daneharrigan/hipchat) **star:111** A golang package to communicate with HipChat over XMPP.   [![It hasn't been updated in recent three years][Y]](https://github.com/daneharrigan/hipchat)   [![godoc][D]](https://godoc.org/github.com/daneharrigan/hipchat)
- [hipchat](https://github.com/andybons/hipchat) **star:105** This project implements a golang client library for the Hipchat API.   [![It hasn't been updated in recent three years][Y]](https://github.com/andybons/hipchat)   [![godoc][D]](https://godoc.org/github.com/andybons/hipchat)
- [simples3](https://github.com/rhnvrm/simples3) **star:95** Simple no frills AWS S3 Library using REST with V4 Signing written in Go.   [![godoc][D]](https://godoc.org/github.com/rhnvrm/simples3)
- [cachet](https://github.com/andygrunwald/cachet) **star:91** Go client library for [Cachet (open source status page system)](https://cachethq.io/).   [![godoc][D]](https://godoc.org/github.com/andygrunwald/cachet)
- [gosip](https://github.com/koltyakov/gosip) **star:83** Go client library SharePoint API.   [![godoc][D]](https://godoc.org/github.com/koltyakov/gosip)
- [igdb](https://github.com/Henry-Sarabia/igdb) **star:76** Go client for the [Internet Game Database API](https://api.igdb.com/).   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/igdb)
- [gogtrends](https://github.com/groovili/gogtrends) **star:70** Google Trends Unofficial API.   [![godoc][D]](https://godoc.org/github.com/groovili/gogtrends)
- [go-unsplash](https://github.com/hbagdi/go-unsplash) **star:68** Go client library for the [Unsplash.com](https://unsplash.com) API.   [![godoc][D]](https://godoc.org/github.com/hbagdi/go-unsplash)
- [circleci](https://github.com/jszwedko/go-circleci) **star:65** Go client library for interacting with CircleCI's API.   [![godoc][D]](https://godoc.org/github.com/jszwedko/go-circleci)
- [golang-tmdb](https://github.com/cyruzin/golang-tmdb) **star:58** Golang wrapper for The Movie Database API v3.   [![godoc][D]](https://godoc.org/github.com/cyruzin/golang-tmdb)
- [clarifai](https://github.com/samuelcouch/clarifai) **star:57** Go client library for interfacing with the Clarifai API.   [![It hasn't been updated in recent three years][Y]](https://github.com/samuelcouch/clarifai)   [![godoc][D]](https://godoc.org/github.com/samuelcouch/clarifai)
- [megos](https://github.com/andygrunwald/megos) **star:55** Client library for accessing an [Apache Mesos](https://mesos.apache.org/) cluster.   [![godoc][D]](https://godoc.org/github.com/andygrunwald/megos)
- [amazon-product-advertising-api](https://github.com/ngs/go-amazon-product-advertising-api) **star:54** Go Client Library for [Amazon Product Advertising API](https://affiliate-program.amazon.com/gp/advertising/api/detail/main.html).   [![It hasn't been updated in recent three years][Y]](https://github.com/ngs/go-amazon-product-advertising-api)   [![godoc][D]](https://godoc.org/github.com/ngs/go-amazon-product-advertising-api)
- [go-atlassian](https://github.com/ctreminiom/go-atlassian) **star:54** Go library for accessing the [Atlassian Cloud](https://www.atlassian.com/enterprise/cloud) services (Jira, Jira Service Management, Jira Agile, Confluence, Admin Cloud)   [![godoc][D]](https://godoc.org/github.com/ctreminiom/go-atlassian)
- [go-postman-collection](https://github.com/rbretecher/go-postman-collection) **star:53** Go module to work with [Postman Collections](https://learning.getpostman.com/docs/postman/collections/creating-collections/) (compatible with Insomnia).   [![godoc][D]](https://godoc.org/github.com/rbretecher/go-postman-collection)
- [ynab](https://github.com/brunomvsouza/ynab.go) **star:53** Go wrapper for the YNAB API.   [![There was an update last month][G]](https://github.com/brunomvsouza/ynab.go)   [![godoc][D]](https://godoc.org/github.com/brunomvsouza/ynab.go)
- [uptimerobot](https://github.com/bitfield/uptimerobot) **star:52** Go wrapper and command-line client for the Uptime Robot v2 API.   [![godoc][D]](https://godoc.org/github.com/bitfield/uptimerobot)
- [gads](https://github.com/emiddleton/gads) **star:50** Google Adwords Unofficial API.   [![godoc][D]](https://godoc.org/github.com/emiddleton/gads)
- [mixpanel](https://github.com/dukex/mixpanel) **star:49** Mixpanel is a library for tracking events and sending Mixpanel profile updates to Mixpanel from your go applications.   [![godoc][D]](https://godoc.org/github.com/dukex/mixpanel)
- [fcm](https://github.com/maddevsio/fcm) **star:48** Go library for Firebase Cloud Messaging.   [![godoc][D]](https://godoc.org/github.com/maddevsio/fcm)
- [GoMusicBrainz](https://github.com/michiwend/gomusicbrainz) **star:47** Go MusicBrainz WS2 client library.   [![godoc][D]](https://godoc.org/github.com/michiwend/gomusicbrainz)
- [go-xkcd](https://github.com/nishanths/go-xkcd) **star:46** Go client for the xkcd API.   [![godoc][D]](https://godoc.org/github.com/nishanths/go-xkcd)
- [go-yapla](https://git.iglou.eu/Production/go-yapla)  Go client library for the Yapla v2.0 API.
- [airtable](https://github.com/mehanizm/airtable) **star:45** Go client library for the [Airtable API](https://airtable.com/api).   [![godoc][D]](https://godoc.org/github.com/mehanizm/airtable)
- [spotify](https://github.com/rapito/go-spotify) **star:44** Go Library to access Spotify WEB API.   [![godoc][D]](https://godoc.org/github.com/rapito/go-spotify)
- [google-play-scraper](https://github.com/n0madic/google-play-scraper) **star:41** Get data from Google Play Store.   [![godoc][D]](https://godoc.org/github.com/n0madic/google-play-scraper)
- [golyrics](https://github.com/mamal72/golyrics) **star:39** Golyrics is a Go library to fetch music lyrics data from the Wikia website.   [![It hasn't been updated in recent three years][Y]](https://github.com/mamal72/golyrics)   [![godoc][D]](https://godoc.org/github.com/mamal72/golyrics)
- [go-myanimelist](https://github.com/nstratos/go-myanimelist) **star:33** Go client library for accessing the [MyAnimeList API](https://myanimelist.net/apiconfig/references/api/v2).   [![godoc][D]](https://godoc.org/github.com/nstratos/go-myanimelist)
- [patreon-go](https://github.com/mxpv/patreon-go) **star:33** Go library for Patreon API.   [![godoc][D]](https://godoc.org/github.com/mxpv/patreon-go)
- [translate](https://github.com/poorny/translate) **star:32** Go online translation package.   [![It hasn't been updated in recent three years][Y]](https://github.com/poorny/translate)   [![godoc][D]](https://godoc.org/github.com/poorny/translate)   [![Archived][Archived]](https://github.com/poorny/translate)
- [gami](https://github.com/bit4bit/gami) **star:31** Go library for Asterisk Manager Interface.   [![It hasn't been updated in recent three years][Y]](https://github.com/bit4bit/gami)   [![godoc][D]](https://godoc.org/github.com/bit4bit/gami)   [![Archived][Archived]](https://github.com/bit4bit/gami)
- [gcm](https://github.com/Aorioli/gcm) **star:31** Go library for Google Cloud Messaging.   [![It hasn't been updated in recent three years][Y]](https://github.com/Aorioli/gcm)   [![godoc][D]](https://godoc.org/github.com/Aorioli/gcm)
- [lastpass-go](https://github.com/ansd/lastpass-go) **star:30** Go client library for the [LastPass](https://www.lastpass.com/) API.   [![godoc][D]](https://godoc.org/github.com/ansd/lastpass-go)
- [steam](https://github.com/sostronk/go-steam) **star:28** Go Library to interact with Steam game servers.   [![godoc][D]](https://godoc.org/github.com/sostronk/go-steam)
- [go-imgur](https://github.com/koffeinsource/go-imgur) **star:24** Go client library for [imgur](https://imgur.com)   [![There was an update last month][G]](https://github.com/koffeinsource/go-imgur)   [![godoc][D]](https://godoc.org/github.com/koffeinsource/go-imgur)
- [shopify](https://github.com/rapito/go-shopify) **star:24** Go Library to make CRUD request to the Shopify API.   [![godoc][D]](https://godoc.org/github.com/rapito/go-shopify)
- [go-twitch](https://github.com/knspriggs/go-twitch) **star:22** Go client for interacting with the Twitch v3 API.   [![It hasn't been updated in recent three years][Y]](https://github.com/knspriggs/go-twitch)   [![godoc][D]](https://godoc.org/github.com/knspriggs/go-twitch)
- [brewerydb](https://github.com/naegelejd/brewerydb) **star:19** Go library for accessing the BreweryDB API.   [![It hasn't been updated in recent three years][Y]](https://github.com/naegelejd/brewerydb)   [![godoc][D]](https://godoc.org/github.com/naegelejd/brewerydb)
- [codeship-go](https://github.com/codeship/codeship-go) **star:19** Go client library for interacting with Codeship's API v2.   [![godoc][D]](https://godoc.org/github.com/codeship/codeship-go)
- [jokeapi-go](https://github.com/icelain/jokeapi) **star:19** Go client for [JokeAPI](https://sv443.net/jokeapi/v2/).   [![godoc][D]](https://godoc.org/github.com/icelain/jokeapi)
- [textbelt](https://github.com/dietsche/textbelt) **star:18** Go client for the textbelt.com txt messaging API.   [![It hasn't been updated in recent three years][Y]](https://github.com/dietsche/textbelt)   [![godoc][D]](https://godoc.org/github.com/dietsche/textbelt)
- [coinpaprika-go](https://github.com/coinpaprika/coinpaprika-api-go-client) **star:16** Go client library for interacting with Coinpaprika's API.   [![godoc][D]](https://godoc.org/github.com/coinpaprika/coinpaprika-api-go-client)
- [device-check-go](https://github.com/rinchsan/device-check-go) **star:16** Go client library for interacting with [iOS DeviceCheck API](https://developer.apple.com/documentation/devicecheck) v1.   [![godoc][D]](https://godoc.org/github.com/rinchsan/device-check-go)
- [go-hacknews](https://github.com/PaulRosset/go-hacknews) **star:16** Tiny Go client for HackerNews API.   [![It hasn't been updated in recent three years][Y]](https://github.com/PaulRosset/go-hacknews)   [![godoc][D]](https://godoc.org/github.com/PaulRosset/go-hacknews)
- [go-aws-news](https://github.com/circa10a/go-aws-news) **star:15** Go application and library to fetch what's new from AWS.   [![godoc][D]](https://godoc.org/github.com/circa10a/go-aws-news)
- [google-analytics](https://github.com/chonthu/go-google-analytics) **star:13** Simple wrapper for easy google analytics reporting.   [![It hasn't been updated in recent three years][Y]](https://github.com/chonthu/go-google-analytics)   [![godoc][D]](https://godoc.org/github.com/chonthu/go-google-analytics)
- [gopaapi5](https://github.com/utekaravinash/gopaapi5) **star:13** Go Client Library for [Amazon Product Advertising API 5.0](https://webservices.amazon.com/paapi5/documentation/).   [![godoc][D]](https://godoc.org/github.com/utekaravinash/gopaapi5)
- [bqwriter](https://github.com/OTA-Insight/bqwriter) **star:12** High Level Go Library to write data into [Google BigQuery](https://cloud.google.com/bigquery) at a high throughout.   [![godoc][D]](https://godoc.org/github.com/OTA-Insight/bqwriter)
- [go-here](https://github.com/abdullahselek/go-here) **star:11** Go client library around the HERE location based APIs.   [![godoc][D]](https://godoc.org/github.com/abdullahselek/go-here)
- [go-openproject](https://github.com/manuelbcd/go-openproject) **star:11** Go client library for interacting with [OpenProject](https://docs.openproject.org/api/) API.   [![godoc][D]](https://godoc.org/github.com/manuelbcd/go-openproject)
- [go-sophos](https://github.com/esurdam/go-sophos) **star:11** Go client library for the [Sophos UTM REST API](https://www.sophos.com/en-us/medialibrary/PDFs/documentation/UTMonAWS/Sophos-UTM-RESTful-API.pdf?la=en) with zero dependencies.   [![godoc][D]](https://godoc.org/github.com/esurdam/go-sophos)
- [smite](https://github.com/sergiotapia/smitego) **star:11** Go package to wraps access to the Smite game API.   [![It hasn't been updated in recent three years][Y]](https://github.com/sergiotapia/smitego)   [![godoc][D]](https://godoc.org/github.com/sergiotapia/smitego)
- [gomalshare](https://github.com/MonaxGT/gomalshare) **star:10** Go library MalShare API [malshare.com](https://www.malshare.com/)   [![It hasn't been updated in recent three years][Y]](https://github.com/MonaxGT/gomalshare)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/gomalshare)
- [rrdaclient](https://github.com/Omie/rrdaclient) **star:9** Go Library to access statdns.com API, which is in turn RRDA API. DNS Queries over HTTP.   [![It hasn't been updated in recent three years][Y]](https://github.com/Omie/rrdaclient)   [![godoc][D]](https://godoc.org/github.com/Omie/rrdaclient)   [![Archived][Archived]](https://github.com/Omie/rrdaclient)
- [goami2](https://github.com/staskobzar/goami2) **star:8** AMI v2 library for Asterisk PBX.   [![godoc][D]](https://godoc.org/github.com/staskobzar/goami2)
- [google-email-audit-api](https://github.com/ngs/go-google-email-audit-api) **star:8** Go client library for [Google G Suite Email Audit API](https://developers.google.com/admin-sdk/email-audit/).   [![It hasn't been updated in recent three years][Y]](https://github.com/ngs/go-google-email-audit-api)   [![godoc][D]](https://godoc.org/github.com/ngs/go-google-email-audit-api)
- [libgoffi](https://github.com/clevabit/libgoffi) **star:8** Library adapter toolbox for native [libffi](https://sourceware.org/libffi/) integration   [![godoc][D]](https://godoc.org/github.com/clevabit/libgoffi)
- [rawg-sdk-go](https://github.com/dimuska139/rawg-sdk-go) **star:8** Go library for the [RAWG Video Games Database](https://rawg.io/) API   [![godoc][D]](https://godoc.org/github.com/dimuska139/rawg-sdk-go)
- [tumblr](https://github.com/mattcunningham/gumblr) **star:8** Go wrapper for the Tumblr v2 API.   [![It hasn't been updated in recent three years][Y]](https://github.com/mattcunningham/gumblr)   [![godoc][D]](https://godoc.org/github.com/mattcunningham/gumblr)
- [go-chronos](https://github.com/axelspringer/go-chronos) **star:7** Go library for interacting with the [Chronos](https://mesos.github.io/chronos/) Job Scheduler   [![It hasn't been updated in recent three years][Y]](https://github.com/axelspringer/go-chronos)   [![godoc][D]](https://godoc.org/github.com/axelspringer/go-chronos)
- [go-sptrans](https://github.com/sergioaugrod/go-sptrans) **star:7** Go client library for the SPTrans Olho Vivo API.   [![godoc][D]](https://godoc.org/github.com/sergioaugrod/go-sptrans)
- [zooz](https://github.com/gojuno/go-zooz) **star:7** Go client for the Zooz API.   [![godoc][D]](https://godoc.org/github.com/gojuno/go-zooz)
- [go-swagger-ui](https://github.com/esurdam/go-swagger-ui) **star:6** Go library containing precompiled [Swagger UI](https://swagger.io/tools/swagger-ui/) for serving swagger json.
- [go-telegraph](https://gitlab.com/toby3d/telegraph)  Telegraph publishing platform API client.
- [go-hibp](https://github.com/wneessen/go-hibp) **star:5** Simple Go binding to the "Have I Been Pwned" APIs.   [![There was an update last month][G]](https://github.com/wneessen/go-hibp)   [![godoc][D]](https://godoc.org/github.com/wneessen/go-hibp)
- [goagi](https://github.com/staskobzar/goagi) **star:5** Go library to build Asterisk PBX agi/fastagi applications.   [![godoc][D]](https://godoc.org/github.com/staskobzar/goagi)
- [newsapi-go](https://github.com/jellydator/newsapi-go) **star:5** Go client for [NewsAPI](https://newsapi.org/).   [![godoc][D]](https://godoc.org/github.com/jellydator/newsapi-go)
- [appstore-sdk-go](https://github.com/Kachit/appstore-sdk-go) **star:3** Unofficial Golang SDK for AppStore Connect API.   [![godoc][D]](https://godoc.org/github.com/Kachit/appstore-sdk-go)
- [go-restcountries](https://github.com/chriscross0/go-restcountries) **star:3** Go library for the [REST Countries API](https://countrylayer.com/).   [![godoc][D]](https://godoc.org/github.com/chriscross0/go-restcountries)
- [dusupay-sdk-go](https://github.com/Kachit/dusupay-sdk-go) **star:2** Unofficial Dusupay payment gateway API Client for Go   [![godoc][D]](https://godoc.org/github.com/Kachit/dusupay-sdk-go)
- [playlyfe](https://github.com/playlyfe/playlyfe-go-sdk) **star:2** The Playlyfe Rest API Go SDK.   [![It hasn't been updated in recent three years][Y]](https://github.com/playlyfe/playlyfe-go-sdk)   [![godoc][D]](https://godoc.org/github.com/playlyfe/playlyfe-go-sdk)
- [TripAdvisor](https://github.com/mrbenosborne/tripadvisor-golang) **star:2** Go wrapper for the TripAdvisor API.   [![godoc][D]](https://godoc.org/github.com/mrbenosborne/tripadvisor-golang)
- [vl-go](https://github.com/verifid/vl-go) **star:2** Go client library around the VerifID identity verification layer API.   [![godoc][D]](https://godoc.org/github.com/verifid/vl-go)
- [fasapay-sdk-go](https://github.com/Kachit/fasapay-sdk-go) **star:1** Unofficial Fasapay payment gateway XML API Client for Golang.   [![godoc][D]](https://godoc.org/github.com/Kachit/fasapay-sdk-go)

**[⬆ back to top](#contents)**

## Utilities

_General utilities and tools to make your life easier._

- [fzf](https://github.com/junegunn/fzf) **star:47337** Command-line fuzzy finder written in Go.   [![There was an update last month][G]](https://github.com/junegunn/fzf)   [![godoc][D]](https://godoc.org/github.com/junegunn/fzf)
- [hub](https://github.com/github/hub) **star:22082** wrap git commands with additional functionality to interact with github from the terminal.   [![godoc][D]](https://godoc.org/github.com/github/hub)
- [ctop](https://github.com/bcicen/ctop) **star:13441** [Top-like](https://ctop.sh) interface (e.g. htop) for container metrics.   [![godoc][D]](https://godoc.org/github.com/bcicen/ctop)
- [sqlx](https://github.com/jmoiron/sqlx) **star:12630** provides a set of extensions on top of the excellent built-in database/sql package.   [![godoc][D]](https://godoc.org/github.com/jmoiron/sqlx)
- [goreleaser](https://github.com/goreleaser/goreleaser) **star:10703** Deliver Go binaries as fast and easily as possible.   [![There was an update last month][G]](https://github.com/goreleaser/goreleaser)   [![godoc][D]](https://godoc.org/github.com/goreleaser/goreleaser)
- [wuzz](https://github.com/asciimoo/wuzz) **star:10126** Interactive cli tool for HTTP inspection.   [![godoc][D]](https://godoc.org/github.com/asciimoo/wuzz)
- [lo](https://github.com/samber/lo) **star:7964** A Lodash like Go library based on Go 1.18+ Generics (map, filter, contains, find...)   [![There was an update last month][G]](https://github.com/samber/lo)   [![godoc][D]](https://godoc.org/github.com/samber/lo)
- [usql](https://github.com/knq/usql) **star:7593** usql is a universal command-line interface for SQL databases.   [![There was an update last month][G]](https://github.com/knq/usql)   [![godoc][D]](https://godoc.org/github.com/knq/usql)
- [peco](https://github.com/peco/peco) **star:7130** Simplistic interactive filtering tool.   [![godoc][D]](https://godoc.org/github.com/peco/peco)
- [godropbox](https://github.com/dropbox/godropbox) **star:4057** Common libraries for writing Go services/applications from Dropbox.   [![godoc][D]](https://godoc.org/github.com/dropbox/godropbox)
- [go-funk](https://github.com/thoas/go-funk) **star:3852** Modern Go utility library which provides helpers (map, find, contains, filter, chunk, reverse, ...).   [![godoc][D]](https://godoc.org/github.com/thoas/go-funk)
- [hystrix-go](https://github.com/afex/hystrix-go) **star:3772** Implements Hystrix patterns of programmer-defined fallbacks aka circuit breaker.   [![godoc][D]](https://godoc.org/github.com/afex/hystrix-go)
- [panicparse](https://github.com/maruel/panicparse) **star:3239** Groups similar goroutines and colorizes stack dump.   [![godoc][D]](https://godoc.org/github.com/maruel/panicparse)
- [minify](https://github.com/tdewolff/minify) **star:3120** Fast minifiers for HTML, CSS, JS, XML, JSON and SVG file formats.   [![There was an update last month][G]](https://github.com/tdewolff/minify)   [![godoc][D]](https://godoc.org/github.com/tdewolff/minify)
- [goreporter](https://github.com/wgliang/goreporter) **star:3012** Golang tool that does static analysis, unit testing, code review and generate code quality report.   [![It hasn't been updated in recent three years][Y]](https://github.com/wgliang/goreporter)   [![godoc][D]](https://godoc.org/github.com/wgliang/goreporter)
- [mc](https://github.com/minio/mc) **star:2244** Minio Client provides minimal tools to work with Amazon S3 compatible cloud storage and filesystems.   [![There was an update last month][G]](https://github.com/minio/mc)   [![godoc][D]](https://godoc.org/github.com/minio/mc)
- [mergo](https://github.com/imdario/mergo) **star:2138** Helper to merge structs and maps in Golang. Useful for configuration default values, avoiding messy if-statements.   [![godoc][D]](https://godoc.org/github.com/imdario/mergo)
- [Storm](https://github.com/asdine/storm) **star:1928** Simple and powerful toolkit for BoltDB.   [![godoc][D]](https://godoc.org/github.com/asdine/storm)
- [lancet](https://github.com/duke-git/lancet) **star:1727** A comprehensive, efficient, and reusable util function library of go.   [![There was an update last month][G]](https://github.com/duke-git/lancet)   [![godoc][D]](https://godoc.org/github.com/duke-git/lancet)   [![Contains Chinese documents][CN]](https://github.com/duke-git/lancet)
- [filetype](https://github.com/h2non/filetype) **star:1624** Small package to infer the file type checking the magic numbers signature.   [![There was an update last month][G]](https://github.com/h2non/filetype)   [![godoc][D]](https://godoc.org/github.com/h2non/filetype)
- [mole](https://github.com/davrodpin/mole) **star:1598** cli app to easily create ssh tunnels.   [![godoc][D]](https://godoc.org/github.com/davrodpin/mole)
- [boilr](https://github.com/tmrts/boilr) **star:1518** Blazingly fast CLI tool for creating projects from boilerplate templates.   [![godoc][D]](https://godoc.org/github.com/tmrts/boilr)
- [create-go-app](https://github.com/create-go-app/cli) **star:1501** A powerful CLI for create a new production-ready project with backend (Golang), frontend (JavaScript, TypeScript) & deploy automation (Ansible, Docker) by running one command.   [![godoc][D]](https://godoc.org/github.com/create-go-app/cli)
- [gitbatch](https://github.com/isacikgoz/gitbatch) **star:1474** manage your git repositories in one place.   [![godoc][D]](https://godoc.org/github.com/isacikgoz/gitbatch)
- [jump](https://github.com/gsamokovarov/jump) **star:1433** Jump helps you navigate faster by learning your habits.   [![godoc][D]](https://godoc.org/github.com/gsamokovarov/jump)
- [EaseProbe](https://github.com/megaease/easeprobe) **star:1244** A simple, standalone, and lightWeight tool that can do health/status checking daemon, support HTTP/TCP/SSH/Shell/Client/... probes, and Slack/Discord/Telegram/SMS... notification.   [![There was an update last month][G]](https://github.com/megaease/easeprobe)   [![godoc][D]](https://godoc.org/github.com/megaease/easeprobe)
- [circuitbreaker](https://github.com/rubyist/circuitbreaker) **star:1028** Circuit Breakers in Go.   [![godoc][D]](https://godoc.org/github.com/rubyist/circuitbreaker)
- [git-time-metric](https://github.com/git-time-metric/gtm) **star:908** Simple, seamless, lightweight time tracking for Git.   [![godoc][D]](https://godoc.org/github.com/git-time-metric/gtm)
- [mimetype](https://github.com/gabriel-vasile/mimetype) **star:841** Package for MIME type detection based on magic numbers.   [![There was an update last month][G]](https://github.com/gabriel-vasile/mimetype)   [![godoc][D]](https://godoc.org/github.com/gabriel-vasile/mimetype)
- [hostctl](https://github.com/guumaster/hostctl) **star:812** A CLI tool to manage /etc/hosts with easy commands.   [![godoc][D]](https://godoc.org/github.com/guumaster/hostctl)
- [immortal](https://github.com/immortal/immortal) **star:752** \*nix cross-platform (OS agnostic) supervisor.   [![godoc][D]](https://godoc.org/github.com/immortal/immortal)
- [scany](https://github.com/georgysavva/scany) **star:710** Library for scanning data from a database into Go structs and more.   [![There was an update last month][G]](https://github.com/georgysavva/scany)   [![godoc][D]](https://godoc.org/github.com/georgysavva/scany)
- [circuit](https://github.com/cep21/circuit) **star:668** An efficient and feature complete Hystrix like Go implementation of the circuit breaker pattern.   [![godoc][D]](https://godoc.org/github.com/cep21/circuit)
- [htcat](https://github.com/htcat/htcat) **star:549** Parallel and Pipelined HTTP GET Utility.   [![It hasn't been updated in recent three years][Y]](https://github.com/htcat/htcat)   [![godoc][D]](https://godoc.org/github.com/htcat/htcat)
- [ergo](https://github.com/cristianoliveira/ergo) **star:538** The management of multiple local services running over different ports made easy.   [![godoc][D]](https://godoc.org/github.com/cristianoliveira/ergo)
- [delve](https://github.com/derekparker/delve) **star:526** Go debugger.   [![There was an update last month][G]](https://github.com/derekparker/delve)   [![godoc][D]](https://godoc.org/github.com/derekparker/delve)
- [koazee](https://github.com/wesovilabs/koazee) **star:507** Library inspired in Lazy evaluation and functional programming that takes the hassle out of working with arrays.   [![godoc][D]](https://godoc.org/github.com/wesovilabs/koazee)
- [godaemon](https://github.com/VividCortex/godaemon) **star:489** Utility to write daemons.   [![godoc][D]](https://godoc.org/github.com/VividCortex/godaemon)
- [go-dry](https://github.com/ungerik/go-dry) **star:479** DRY (don't repeat yourself) package for Go.   [![godoc][D]](https://godoc.org/github.com/ungerik/go-dry)
- [gopencils](https://github.com/bndr/gopencils) **star:437** Small and simple package to easily consume REST APIs.   [![It hasn't been updated in recent three years][Y]](https://github.com/bndr/gopencils)   [![godoc][D]](https://godoc.org/github.com/bndr/gopencils)
- [request](https://github.com/mozillazg/request) **star:419** Go HTTP Requests for Humans™.   [![godoc][D]](https://godoc.org/github.com/mozillazg/request)
- [gubrak](https://github.com/novalagung/gubrak) **star:417** Golang utility library with syntactic sugar. It's like lodash, but for golang.   [![godoc][D]](https://godoc.org/github.com/novalagung/gubrak)
- [clockwork](https://github.com/jonboulle/clockwork) **star:414** A simple fake clock for golang.   [![godoc][D]](https://godoc.org/github.com/jonboulle/clockwork)
- [Deepcopier](https://github.com/ulule/deepcopier) **star:392** Simple struct copying for Go.   [![godoc][D]](https://godoc.org/github.com/ulule/deepcopier)
- [changie](https://github.com/miniscruff/changie) **star:389** Automated changelog tool for preparing releases with lots of customization options.   [![There was an update last month][G]](https://github.com/miniscruff/changie)   [![godoc][D]](https://godoc.org/github.com/miniscruff/changie)
- [go-rate](https://github.com/beefsack/go-rate) **star:370** Timed rate limiter for Go.   [![godoc][D]](https://godoc.org/github.com/beefsack/go-rate)
- [remote-touchpad](https://github.com/Unrud/remote-touchpad) **star:333** Control mouse and keyboard from a smartphone.   [![godoc][D]](https://godoc.org/github.com/Unrud/remote-touchpad)
- [retry](https://github.com/kamilsk/retry) **star:327** The most advanced functional mechanism to perform actions repetitively until successful.   [![godoc][D]](https://godoc.org/github.com/kamilsk/retry)
- [mani](https://github.com/alajmo/mani) **star:314** CLI tool to help you manage multiple repositories.   [![godoc][D]](https://godoc.org/github.com/alajmo/mani)
- [scan](https://github.com/blockloop/scan) **star:306** Scan golang `sql.Rows` directly to structs, slices, or primitive types.   [![godoc][D]](https://godoc.org/github.com/blockloop/scan)
- [serve](https://github.com/syntaqx/serve) **star:279** A static http server anywhere you need.   [![godoc][D]](https://godoc.org/github.com/syntaqx/serve)
- [clipboard](https://github.com/golang-design/clipboard) **star:275** 📋 cross-platform clipboard package in Go.   [![godoc][D]](https://godoc.org/github.com/golang-design/clipboard)
- [gohper](https://github.com/cosiner/gohper) **star:257** Various tools/modules help for development.   [![It hasn't been updated in recent three years][Y]](https://github.com/cosiner/gohper)   [![godoc][D]](https://godoc.org/github.com/cosiner/gohper)   [![Archived][Archived]](https://github.com/cosiner/gohper)
- [util](https://github.com/shomali11/util) **star:256** Collection of useful utility functions. (strings, concurrency, manipulations, ...).   [![godoc][D]](https://godoc.org/github.com/shomali11/util)
- [gotenv](https://github.com/subosito/gotenv) **star:236** Load environment variables from `.env` or any `io.Reader` in Go.   [![godoc][D]](https://godoc.org/github.com/subosito/gotenv)
- [go-trigger](https://github.com/sadlil/go-trigger) **star:228** Go-lang global event triggerer, Register Events with an id and trigger the event from anywhere from your project.   [![It hasn't been updated in recent three years][Y]](https://github.com/sadlil/go-trigger)   [![godoc][D]](https://godoc.org/github.com/sadlil/go-trigger)
- [grofer](https://github.com/pesos/grofer) **star:223** A system and resource monitoring tool written in Golang!   [![godoc][D]](https://godoc.org/github.com/pesos/grofer)
- [wifiqr](https://github.com/reugn/wifiqr) **star:214** Wi-Fi QR Code Generator.   [![godoc][D]](https://godoc.org/github.com/reugn/wifiqr)
- [countries](https://github.com/biter777/countries) **star:188** Full implementation of ISO-3166-1, ISO-4217, ITU-T E.164, Unicode CLDR and IANA ccTLD standards.   [![godoc][D]](https://godoc.org/github.com/biter777/countries)
- [pattern-match](https://github.com/alexpantyukhin/go-pattern-match) **star:188** Pattern matching libray.   [![godoc][D]](https://godoc.org/github.com/alexpantyukhin/go-pattern-match)
- [Death](https://github.com/vrecan/death) **star:184** Managing go application shutdown with signals.   [![godoc][D]](https://godoc.org/github.com/vrecan/death)
- [go-sitemap-generator](https://github.com/ikeikeikeike/go-sitemap-generator) **star:183** XML Sitemap generator written in Go.   [![godoc][D]](https://godoc.org/github.com/ikeikeikeike/go-sitemap-generator)
- [toolbox](https://github.com/viant/toolbox) **star:183** Slice, map, multimap, struct, function, data conversion utilities. Service router, macro evaluator, tokenizer.   [![godoc][D]](https://godoc.org/github.com/viant/toolbox)
- [go-bind-plugin](https://github.com/wendigo/go-bind-plugin) **star:182** go:generate tool for wrapping symbols exported by golang plugins (1.8 only).   [![It hasn't been updated in recent three years][Y]](https://github.com/wendigo/go-bind-plugin)   [![godoc][D]](https://godoc.org/github.com/wendigo/go-bind-plugin)
- [rospo](https://github.com/ferama/rospo) **star:182** Simple and reliable ssh tunnels with embedded ssh server in Golang.   [![godoc][D]](https://godoc.org/github.com/ferama/rospo)
- [rerun](https://github.com/ivpusic/rerun) **star:165** Recompiling and rerunning go apps when source changes.   [![It hasn't been updated in recent three years][Y]](https://github.com/ivpusic/rerun)   [![godoc][D]](https://godoc.org/github.com/ivpusic/rerun)
- [moldova](https://github.com/StabbyCutyou/moldova) **star:162** Utility for generating random data based on an input template.   [![It hasn't been updated in recent three years][Y]](https://github.com/StabbyCutyou/moldova)   [![godoc][D]](https://godoc.org/github.com/StabbyCutyou/moldova)
- [apm](https://github.com/topfreegames/apm) **star:160** Process manager for Golang applications with an HTTP API.   [![It hasn't been updated in recent three years][Y]](https://github.com/topfreegames/apm)   [![godoc][D]](https://godoc.org/github.com/topfreegames/apm)
- [robustly](https://github.com/VividCortex/robustly) **star:154** Runs functions resiliently, catching and restarting panics.   [![godoc][D]](https://godoc.org/github.com/VividCortex/robustly)
- [chyle](https://github.com/antham/chyle) **star:145** Changelog generator using a git repository with multiple configuration possibilities.   [![godoc][D]](https://godoc.org/github.com/antham/chyle)
- [go-bsdiff](https://github.com/gabstv/go-bsdiff) **star:134** Pure Go bsdiff and bspatch libraries and CLI tools.   [![It hasn't been updated in recent three years][Y]](https://github.com/gabstv/go-bsdiff)   [![godoc][D]](https://godoc.org/github.com/gabstv/go-bsdiff)
- [onecache](https://github.com/adelowo/onecache) **star:130** Caching library with support for multiple backend stores (Redis, Memcached, filesystem etc).   [![godoc][D]](https://godoc.org/github.com/adelowo/onecache)
- [lrserver](https://github.com/jaschaephraim/lrserver) **star:122** LiveReload server for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/jaschaephraim/lrserver)   [![godoc][D]](https://godoc.org/github.com/jaschaephraim/lrserver)
- [cryptgo](https://github.com/Gituser143/cryptgo) **star:121** Crytpgo is a TUI based application written purely in Go to monitor and observe cryptocurrency prices in real time!   [![godoc][D]](https://godoc.org/github.com/Gituser143/cryptgo)
- [nostromo](https://github.com/pokanop/nostromo) **star:120** CLI for building powerful aliases.   [![There was an update last month][G]](https://github.com/pokanop/nostromo)   [![godoc][D]](https://godoc.org/github.com/pokanop/nostromo)
- [cmd](https://github.com/SimonBaeumer/cmd) **star:109** Library for executing shell commands on osx, windows and linux.   [![There was an update last month][G]](https://github.com/SimonBaeumer/cmd)   [![godoc][D]](https://godoc.org/github.com/SimonBaeumer/cmd)
- [sorty](https://github.com/jfcg/sorty) **star:109** Fast Concurrent / Parallel Sorting.   [![godoc][D]](https://godoc.org/github.com/jfcg/sorty)
- [mongo-go-pagination](https://github.com/gobeam/mongo-go-pagination) **star:106** Mongodb Pagination for official mongodb/mongo-go-driver package which supports  both normal queries and Aggregation pipelines.   [![godoc][D]](https://godoc.org/github.com/gobeam/mongo-go-pagination)
- [limiters](https://github.com/mennanov/limiters) **star:103** Rate limiters for distributed applications in Golang with configurable back-ends and distributed locks.   [![godoc][D]](https://godoc.org/github.com/mennanov/limiters)
- [mssqlx](https://github.com/linxGnu/mssqlx) **star:102** Database client library, proxy for any master slave, master master structures. Lightweight and auto balancing in mind.   [![godoc][D]](https://godoc.org/github.com/linxGnu/mssqlx)
- [goseaweedfs](https://github.com/linxGnu/goseaweedfs) **star:99** SeaweedFS client library with almost full features.   [![godoc][D]](https://godoc.org/github.com/linxGnu/goseaweedfs)
- [filter](https://github.com/gookit/filter) **star:97** provide filtering, sanitizing, and conversion of Go data.   [![There was an update last month][G]](https://github.com/gookit/filter)   [![godoc][D]](https://godoc.org/github.com/gookit/filter)
- [xferspdy](https://github.com/monmohan/xferspdy) **star:94** Xferspdy provides binary diff and patch library in golang.   [![godoc][D]](https://godoc.org/github.com/monmohan/xferspdy)
- [go-health](https://github.com/Talento90/go-health) **star:91** Health package simplifies the way you add health check to your services.   [![godoc][D]](https://godoc.org/github.com/Talento90/go-health)
- [goval](https://github.com/maja42/goval) **star:90** Evaluate arbitrary expressions in Go.   [![godoc][D]](https://godoc.org/github.com/maja42/goval)
- [repeat](https://github.com/ssgreg/repeat) **star:81** Go implementation of different backoff strategies useful for retrying operations and heartbeating.   [![godoc][D]](https://godoc.org/github.com/ssgreg/repeat)
- [go-lock](https://github.com/viney-shih/go-lock) **star:80** go-lock is a lock library implementing read-write mutex and read-write trylock without starvation.   [![godoc][D]](https://godoc.org/github.com/viney-shih/go-lock)
- [mimemagic](https://github.com/zRedShift/mimemagic) **star:79** Pure Go ultra performant MIME sniffing library/utility.   [![godoc][D]](https://godoc.org/github.com/zRedShift/mimemagic)
- [pm](https://github.com/VividCortex/pm) **star:78** Process (i.e. goroutine) manager with an HTTP API.   [![godoc][D]](https://godoc.org/github.com/VividCortex/pm)
- [netbug](https://github.com/e-dard/netbug) **star:71** Easy remote profiling of your services.   [![It hasn't been updated in recent three years][Y]](https://github.com/e-dard/netbug)   [![godoc][D]](https://godoc.org/github.com/e-dard/netbug)
- [pgo](https://github.com/arthurkushman/pgo) **star:71** Convenient functions for PHP community.   [![godoc][D]](https://godoc.org/github.com/arthurkushman/pgo)
- [UNIS](https://github.com/esemplastic/unis) **star:70** Common Architecture™ for String Utilities in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/esemplastic/unis)   [![godoc][D]](https://godoc.org/github.com/esemplastic/unis)
- [handy](https://github.com/miguelpragier/handy) **star:69** Many utilities and helpers like string handlers/formatters and validators.   [![godoc][D]](https://godoc.org/github.com/miguelpragier/handy)
- [goreadability](https://github.com/philipjkim/goreadability) **star:68** Webpage summary extractor using Facebook Open Graph and arc90's readability.   [![It hasn't been updated in recent three years][Y]](https://github.com/philipjkim/goreadability)   [![godoc][D]](https://godoc.org/github.com/philipjkim/goreadability)
- [countries](https://github.com/pioz/countries) **star:66** All you need when you are working with countries in Go.   [![godoc][D]](https://godoc.org/github.com/pioz/countries)
- [multitick](https://github.com/VividCortex/multitick) **star:64** Multiplexor for aligned tickers.   [![godoc][D]](https://godoc.org/github.com/VividCortex/multitick)
- [minquery](https://github.com/icza/minquery) **star:60** MongoDB / mgo.v2 query that supports efficient pagination (cursors to continue listing documents where we left off).   [![godoc][D]](https://godoc.org/github.com/icza/minquery)
- [go-astitodo](https://github.com/asticode/go-astitodo) **star:59** Parse TODOs in your GO code.   [![godoc][D]](https://godoc.org/github.com/asticode/go-astitodo)
- [golog](https://github.com/mlimaloureiro/golog) **star:58** Easy and lightweight CLI tool to time track your tasks.   [![It hasn't been updated in recent three years][Y]](https://github.com/mlimaloureiro/golog)   [![godoc][D]](https://godoc.org/github.com/mlimaloureiro/golog)
- [retry](https://github.com/thedevsaddam/retry) **star:58** Simple and easy retry mechanism package for Go.   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/retry)
- [copy-pasta](https://github.com/jutkko/copy-pasta) **star:50** Universal multi-workstation clipboard that uses S3 like backend for the storage.   [![godoc][D]](https://godoc.org/github.com/jutkko/copy-pasta)
- [slice](https://github.com/psampaz/slice) **star:50** Type-safe functions for common Go slice operations.   [![godoc][D]](https://godoc.org/github.com/psampaz/slice)
- [beyond](https://github.com/wesovilabs/beyond) **star:49** The Go tool that will drive you to the AOP world!   [![godoc][D]](https://godoc.org/github.com/wesovilabs/beyond)
- [dbt](https://github.com/nikogura/dbt) **star:49** A framework for running self-updating signed binaries from a central, trusted repository.   [![godoc][D]](https://godoc.org/github.com/nikogura/dbt)
- [golarm](https://github.com/msempere/golarm) **star:49** Fire alarms with system events.   [![It hasn't been updated in recent three years][Y]](https://github.com/msempere/golarm)   [![godoc][D]](https://godoc.org/github.com/msempere/golarm)
- [goback](https://github.com/carlescere/goback) **star:46** Go simple exponential backoff package.   [![godoc][D]](https://godoc.org/github.com/carlescere/goback)
- [intrinsic](https://github.com/mengzhuo/intrinsic) **star:45** Use x86 SIMD without writing any assembly code.   [![It hasn't been updated in recent three years][Y]](https://github.com/mengzhuo/intrinsic)   [![godoc][D]](https://godoc.org/github.com/mengzhuo/intrinsic)   [![Archived][Archived]](https://github.com/mengzhuo/intrinsic)
- [retry-go](https://github.com/rafaeljesus/retry-go) **star:44** Retrying made simple and easy for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/retry-go)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/retry-go)
- [go-httpheader](https://github.com/mozillazg/go-httpheader) **star:41** Go library for encoding structs into Header fields.   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-httpheader)
- [slicer](https://github.com/leaanthony/slicer) **star:40** Makes working with slices easier.   [![godoc][D]](https://godoc.org/github.com/leaanthony/slicer)
- [equalizer](https://github.com/reugn/equalizer) **star:39** Quota manager and rate limiter collection for Go.   [![godoc][D]](https://godoc.org/github.com/reugn/equalizer)
- [gpath](https://github.com/tenntenn/gpath) **star:39** Library to simplify access struct fields with Go's expression in reflection.   [![It hasn't been updated in recent three years][Y]](https://github.com/tenntenn/gpath)   [![godoc][D]](https://godoc.org/github.com/tenntenn/gpath)
- [set](https://github.com/nofeaturesonlybugs/set) **star:39** Performant and flexible struct mapping and loose type conversion.   [![godoc][D]](https://godoc.org/github.com/nofeaturesonlybugs/set)
- [backscanner](https://github.com/icza/backscanner) **star:38** A scanner similar to bufio.Scanner, but it reads and returns lines in reverse order, starting at a given position and going backward.   [![godoc][D]](https://godoc.org/github.com/icza/backscanner)
- [gostrutils](https://github.com/ik5/gostrutils) **star:38** Collections of string manipulation and conversion functions.   [![godoc][D]](https://godoc.org/github.com/ik5/gostrutils)
- [scan](https://github.com/wroge/scan) **star:38** Scan sql rows into any type powered by generics.   [![godoc][D]](https://godoc.org/github.com/wroge/scan)
- [shutdown](https://github.com/ztrue/shutdown) **star:38** App shutdown hooks for `os.Signal` handling.   [![godoc][D]](https://godoc.org/github.com/ztrue/shutdown)
- [sshman](https://github.com/shoobyban/sshman) **star:36** SSH Manager for authorized_keys files on multiple remote servers.   [![godoc][D]](https://godoc.org/github.com/shoobyban/sshman)
- [evaluator](https://github.com/nullne/evaluator) **star:35** Evaluate an expression dynamically based on s-expression. It's simple and easy to extend.   [![godoc][D]](https://godoc.org/github.com/nullne/evaluator)
- [myhttp](https://github.com/inancgumus/myhttp) **star:35** Simple API to make HTTP GET requests with timeout support.   [![It hasn't been updated in recent three years][Y]](https://github.com/inancgumus/myhttp)   [![godoc][D]](https://godoc.org/github.com/inancgumus/myhttp)   [![Archived][Archived]](https://github.com/inancgumus/myhttp)
- [rclient](https://github.com/zpatrick/rclient) **star:33** Readable, flexible, simple-to-use client for REST APIs.   [![godoc][D]](https://godoc.org/github.com/zpatrick/rclient)
- [pointer](https://github.com/xorcare/pointer) **star:31** Package pointer contains helper routines for simplifying the creation of optional fields of basic type.   [![godoc][D]](https://godoc.org/github.com/xorcare/pointer)
- [tome](https://github.com/cyruzin/tome) **star:31** Tome was designed to paginate simple RESTful APIs.   [![godoc][D]](https://godoc.org/github.com/cyruzin/tome)
- [throttle](https://github.com/yudppp/throttle) **star:29** Throttle is an object that will perform exactly one action per duration.   [![godoc][D]](https://godoc.org/github.com/yudppp/throttle)
- [generate](https://github.com/go-playground/generate) **star:28** runs go generate recursively on a specified path or environment variable and can filter by regex.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/generate)   [![godoc][D]](https://godoc.org/github.com/go-playground/generate)
- [ghokin](https://github.com/antham/ghokin) **star:28** Parallelized formatter with no external dependencies for gherkin (cucumber, behat...).   [![godoc][D]](https://godoc.org/github.com/antham/ghokin)
- [copy](https://github.com/gotidy/copy) **star:27** Package for fast copying structs of different types.   [![godoc][D]](https://godoc.org/github.com/gotidy/copy)
- [ugo](https://github.com/alxrm/ugo) **star:27** ugo is slice toolbox with concise syntax for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/alxrm/ugo)   [![godoc][D]](https://godoc.org/github.com/alxrm/ugo)
- [cvt](https://github.com/shockerli/cvt) **star:25** Easy and safe convert any value to another type.   [![godoc][D]](https://godoc.org/github.com/shockerli/cvt)   [![Contains Chinese documents][CN]](https://github.com/shockerli/cvt)
- [goplaceholder](https://github.com/michiwend/goplaceholder) **star:25** a small golang lib to generate placeholder images.   [![It hasn't been updated in recent three years][Y]](https://github.com/michiwend/goplaceholder)   [![godoc][D]](https://godoc.org/github.com/michiwend/goplaceholder)
- [mimesniffer](https://github.com/aofei/mimesniffer) **star:25** A MIME type sniffer for Go.   [![godoc][D]](https://godoc.org/github.com/aofei/mimesniffer)
- [structs](https://github.com/PumpkinSeed/structs) **star:21** Implement simple functions to manipulate structs.   [![It hasn't been updated in recent three years][Y]](https://github.com/PumpkinSeed/structs)   [![godoc][D]](https://godoc.org/github.com/PumpkinSeed/structs)
- [ctxutil](https://github.com/posener/ctxutil) **star:20** A collection of utility functions for contexts.   [![godoc][D]](https://godoc.org/github.com/posener/ctxutil)
- [graterm](https://github.com/skovtunenko/graterm) **star:19** Provides primitives to perform ordered (sequential/concurrent) GRAceful TERMination (aka shutdown) in Go application.   [![godoc][D]](https://godoc.org/github.com/skovtunenko/graterm)
- [dlog](https://github.com/kirillDanshin/dlog) **star:17** Compile-time controlled logger to make your release smaller without removing debug calls.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/dlog)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/dlog)
- [filler](https://github.com/yaronsumel/filler) **star:17** small utility to fill structs using "fill" tag.   [![It hasn't been updated in recent three years][Y]](https://github.com/yaronsumel/filler)   [![godoc][D]](https://godoc.org/github.com/yaronsumel/filler)
- [go-convert](https://github.com/Eun/go-convert) **star:17** Package go-convert enables you to convert a value into another type.   [![godoc][D]](https://godoc.org/github.com/Eun/go-convert)
- [jsend](https://github.com/clevergo/jsend) **star:17** JSend's implementation written in Go.   [![godoc][D]](https://godoc.org/github.com/clevergo/jsend)
- [okrun](https://github.com/xta/okrun) **star:16** go run error steamroller.   [![It hasn't been updated in recent three years][Y]](https://github.com/xta/okrun)   [![godoc][D]](https://godoc.org/github.com/xta/okrun)
- [ptr](https://github.com/gotidy/ptr) **star:16** Package that provide functions for simplified creation of pointers from constants of basic types.   [![godoc][D]](https://godoc.org/github.com/gotidy/ptr)
- [rest-go](https://github.com/edermanoel94/rest-go) **star:16** A package that provide many helpful methods for working with rest api.   [![godoc][D]](https://godoc.org/github.com/edermanoel94/rest-go)
- [go-type](https://github.com/mikekonan/go-types) **star:15** Library providing Go types for store/validation and transfer of ISO-4217, ISO-3166, and other types.   [![godoc][D]](https://godoc.org/github.com/mikekonan/go-types)
- [command](https://github.com/txgruppi/command) **star:14** Command pattern for Go with thread safe serial and parallel dispatcher.   [![It hasn't been updated in recent three years][Y]](https://github.com/txgruppi/command)   [![godoc][D]](https://godoc.org/github.com/txgruppi/command)
- [go-problemdetails](https://github.com/mvmaasakkers/go-problemdetails) **star:14** Go package for working with Problem Details.   [![godoc][D]](https://godoc.org/github.com/mvmaasakkers/go-problemdetails)
- [retry](https://github.com/shafreeck/retry) **star:12** A pretty simple library to ensure your work to be done.   [![godoc][D]](https://godoc.org/github.com/shafreeck/retry)
- [silk](https://github.com/chrispassas/silk) **star:12** Read silk netflow files.   [![godoc][D]](https://godoc.org/github.com/chrispassas/silk)
- [go-actuator](https://github.com/sinhashubham95/go-actuator) **star:10** Production ready features for Go based web frameworks.   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/go-actuator)
- [go-countries](https://github.com/mikekonan/go-countries) **star:10** Lightweight lookup over ISO-3166 codes.   [![godoc][D]](https://godoc.org/github.com/mikekonan/go-countries)
- [statiks](https://github.com/janiltonmaciel/statiks) **star:10** Fast, zero-configuration, static HTTP filer server.   [![godoc][D]](https://godoc.org/github.com/janiltonmaciel/statiks)
- [bleep](https://github.com/sinhashubham95/bleep) **star:9** Perform any number of actions on any set of OS signals in Go.   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/bleep)
- [go-clip](https://github.com/prashantgupta24/go-clip) **star:9** A minimalistic clipboard manager for Mac.   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/go-clip)
- [blank](https://github.com/Henry-Sarabia/blank) **star:8** Verify or remove blanks and whitespace from strings.   [![It hasn't been updated in recent three years][Y]](https://github.com/Henry-Sarabia/blank)   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/blank)
- [retry](https://github.com/percolate/retry) **star:8** A simple but highly configurable retry package for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/percolate/retry)
- [sliceconv](https://github.com/Henry-Sarabia/sliceconv) **star:8** Slice conversion between primitive types.   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/sliceconv)
- [go-pkg](https://github.com/chenquan/go-pkg) **star:7** A go toolkit.   [![godoc][D]](https://godoc.org/github.com/chenquan/go-pkg)   [![Contains Chinese documents][CN]](https://github.com/chenquan/go-pkg)
- [nfdump](https://github.com/chrispassas/nfdump) **star:7** Read nfdump netflow files.   [![godoc][D]](https://godoc.org/github.com/chrispassas/nfdump)
- [go-safe](https://github.com/kenkyu392/go-safe) **star:6** Panic-safe sandbox.   [![godoc][D]](https://godoc.org/github.com/kenkyu392/go-safe)
- [loncha](https://github.com/kazu/loncha) **star:6** A high-performance slice Utilities.   [![godoc][D]](https://godoc.org/github.com/kazu/loncha)
- [lets-go](https://github.com/aplescia-chwy/lets-go) **star:5** Go module that provides common utilities for Cloud Native REST API development. Also contains AWS Specific utilities.   [![godoc][D]](https://godoc.org/github.com/aplescia-chwy/lets-go)
- [olaf](https://github.com/btnguyen2k/olaf) **star:4** Twitter Snowflake implemented in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/btnguyen2k/olaf)   [![godoc][D]](https://godoc.org/github.com/btnguyen2k/olaf)
- [reflectutils](https://github.com/muir/reflectutils) **star:4** Helpers for working with reflection: struct tag parsing; recursive walking; fill value from string.   [![godoc][D]](https://godoc.org/github.com/muir/reflectutils)
- [tik](https://github.com/andy2046/tik) **star:4** Simple and easy timing wheel package for Go.   [![godoc][D]](https://godoc.org/github.com/andy2046/tik)
- [goctx](https://github.com/zerosnake0/goctx) **star:3** Get your context value with high performance.   [![godoc][D]](https://godoc.org/github.com/zerosnake0/goctx)
- [objwalker](https://github.com/rekby/objwalker) **star:2** Walk by go objects with reflection.   [![godoc][D]](https://godoc.org/github.com/rekby/objwalker)

**[⬆ back to top](#contents)**

## UUID

_Libraries for working with UUIDs._

- [uuid](https://github.com/google/uuid) **star:3910** Go package for UUIDs based on RFC 4122 and DCE 1.1: Authentication and Security Services.   [![There was an update last month][G]](https://github.com/google/uuid)   [![godoc][D]](https://godoc.org/github.com/google/uuid)
- [xid](https://github.com/rs/xid) **star:3001** Xid is a globally unique id generator library, ready to be safely used directly in your server code.   [![godoc][D]](https://godoc.org/github.com/rs/xid)
- [ulid](https://github.com/oklog/ulid) **star:2822** Go implementation of ULID (Universally Unique Lexicographically Sortable Identifier).   [![godoc][D]](https://godoc.org/github.com/oklog/ulid)
- [uniq](https://gitlab.com/skilstak/code/go/uniq)  No hassle safe, fast unique identifiers with commands.
- [uuid](https://github.com/gofrs/uuid) **star:1183** Implementation of Universally Unique Identifier (UUID). Supports both creation and parsing of UUIDs. Actively maintained fork of satori uuid.   [![godoc][D]](https://godoc.org/github.com/gofrs/uuid)
- [wuid](https://github.com/edwingeng/wuid) **star:474** An extremely fast unique number generator, 10-135 times faster than UUID.   [![godoc][D]](https://godoc.org/github.com/edwingeng/wuid)
- [sno](https://github.com/muyo/sno) **star:72** Compact, sortable and fast unique IDs with embedded metadata.   [![godoc][D]](https://godoc.org/github.com/muyo/sno)
- [nanoid](https://github.com/aidarkhanov/nanoid) **star:54** A tiny and efficient Go unique string ID generator.   [![godoc][D]](https://godoc.org/github.com/aidarkhanov/nanoid)
- [goid](https://github.com/jakehl/goid) **star:34** Generate and Parse RFC4122 compliant V4 UUIDs.   [![It hasn't been updated in recent three years][Y]](https://github.com/jakehl/goid)   [![godoc][D]](https://godoc.org/github.com/jakehl/goid)
- [gouid](https://github.com/twharmon/gouid) **star:18** Generate cryptographically secure random string IDs with just one allocation.   [![godoc][D]](https://godoc.org/github.com/twharmon/gouid)
- [uuid](https://github.com/agext/uuid) **star:15** Generate, encode, and decode UUIDs v1 with fast or cryptographic-quality random node identifier.   [![godoc][D]](https://godoc.org/github.com/agext/uuid)

**[⬆ back to top](#contents)**

## Validation

_Libraries for validation._

- [validator](https://github.com/go-playground/validator) **star:11502** Go Struct and Field validation, including Cross Field, Cross Struct, Map, Slice and Array diving.   [![There was an update last month][G]](https://github.com/go-playground/validator)   [![godoc][D]](https://godoc.org/github.com/go-playground/validator)
- [govalidator](https://github.com/asaskevich/govalidator) **star:5499** Validators and sanitizers for strings, numerics, slices and structs.   [![godoc][D]](https://godoc.org/github.com/asaskevich/govalidator)
- [ozzo-validation](https://github.com/go-ozzo/ozzo-validation) **star:2925** Supports validation of various data types (structs, strings, maps, slices, etc.) with configurable and extensible validation rules specified in usual code constructs instead of struct tags.   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-validation)
- [govalidator](https://github.com/thedevsaddam/govalidator) **star:1149** Validate Golang request data with simple rules. Highly inspired by Laravel's request validation.   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/govalidator)
- [validate](https://github.com/gookit/validate) **star:790** Go package for data validation and filtering. support validate Map, Struct, Request(Form, JSON, url.Values, Uploaded Files) data and more features.   [![There was an update last month][G]](https://github.com/gookit/validate)   [![godoc][D]](https://godoc.org/github.com/gookit/validate)   [![Contains Chinese documents][CN]](https://github.com/gookit/validate)
- [checkdigit](https://github.com/osamingo/checkdigit) **star:94** Provide check digit algorithms (Luhn, Verhoeff, Damm) and calculators (ISBN, EAN, JAN, UPC, etc.).   [![godoc][D]](https://godoc.org/github.com/osamingo/checkdigit)
- [terraform-validator](https://github.com/thazelart/terraform-validator) **star:79** A norms and conventions validator for Terraform.   [![godoc][D]](https://godoc.org/github.com/thazelart/terraform-validator)
- [validate](https://github.com/gobuffalo/validate) **star:76** This package provides a framework for writing validations for Go applications.   [![godoc][D]](https://godoc.org/github.com/gobuffalo/validate)
- [jio](https://github.com/faceair/jio) **star:70** jio is a json schema validator similar to [joi](https://github.com/hapijs/joi).   [![godoc][D]](https://godoc.org/github.com/faceair/jio)   [![Contains Chinese documents][CN]](https://github.com/faceair/jio)
- [gody](https://github.com/guiferpa/gody) **star:63** :balloon: A lightweight struct validator for Go.   [![godoc][D]](https://godoc.org/github.com/guiferpa/gody)
- [govalid](https://github.com/twharmon/govalid) **star:31** Fast, tag-based validation for structs.   [![godoc][D]](https://godoc.org/github.com/twharmon/govalid)
- [Validator](https://github.com/go-the-way/validator) **star:4** A lightweight model validator written in Go.Contains VFs:Min, Max, MinLength, MaxLength, Length, Enum, Regex.   [![godoc][D]](https://godoc.org/github.com/go-the-way/validator)

**[⬆ back to top](#contents)**

## Version Control

_Libraries for version control._

- [go-git](https://github.com/go-git/go-git) **star:3915** highly extensible Git implementation in pure Go.   [![There was an update last month][G]](https://github.com/go-git/go-git)   [![godoc][D]](https://godoc.org/github.com/go-git/go-git)
- [glab](https://github.com/profclems/glab) **star:2075** An open-source GitLab command line tool bringing GitLab's cool features to your command line.   [![There was an update last month][G]](https://github.com/profclems/glab)   [![godoc][D]](https://godoc.org/github.com/profclems/glab)
- [hercules](https://github.com/src-d/hercules) **star:1809** gaining advanced insights from Git repository history.   [![godoc][D]](https://godoc.org/github.com/src-d/hercules)
- [git2go](https://github.com/libgit2/git2go) **star:1790** Go bindings for libgit2.   [![There was an update last month][G]](https://github.com/libgit2/git2go)   [![godoc][D]](https://godoc.org/github.com/libgit2/git2go)
- [gh](https://github.com/rjeczalik/gh) **star:79** Scriptable server and net/http middleware for GitHub Webhooks.   [![It hasn't been updated in recent three years][Y]](https://github.com/rjeczalik/gh)   [![godoc][D]](https://godoc.org/github.com/rjeczalik/gh)
- [go-vcs](https://github.com/sourcegraph/go-vcs) **star:74** manipulate and inspect VCS repositories in Go.   [![godoc][D]](https://godoc.org/github.com/sourcegraph/go-vcs)
- [githooks](https://github.com/gabyx/githooks) **star:50** Per-repo and shared Git hooks with version control and auto update.   [![godoc][D]](https://godoc.org/github.com/gabyx/githooks)
- [froggit-go](https://github.com/jfrog/froggit-go) **star:20** Froggit-Go is a Go library, allowing to perform actions on VCS providers.   [![godoc][D]](https://godoc.org/github.com/jfrog/froggit-go)
- [hgo](https://github.com/beyang/hgo) **star:14** Hgo is a collection of Go packages providing read-access to local Mercurial repositories.   [![It hasn't been updated in recent three years][Y]](https://github.com/beyang/hgo)   [![godoc][D]](https://godoc.org/github.com/beyang/hgo)

**[⬆ back to top](#contents)**

## Video

_Libraries for manipulating video._

- [goav](https://github.com/giorgisio/goav) **star:1924** Comprehensive Go bindings for FFmpeg.   [![godoc][D]](https://godoc.org/github.com/giorgisio/goav)
- [m3u8](https://github.com/grafov/m3u8) **star:963** Parser and generator library of M3U8 playlists for Apple HLS.   [![godoc][D]](https://godoc.org/github.com/grafov/m3u8)
- [gmf](https://github.com/3d0c/gmf) **star:800** Go bindings for FFmpeg av\* libraries.   [![godoc][D]](https://godoc.org/github.com/3d0c/gmf)
- [go-astits](https://github.com/asticode/go-astits) **star:438** Parse and demux MPEG Transport Streams (.ts) natively in GO.   [![godoc][D]](https://godoc.org/github.com/asticode/go-astits)
- [go-astisub](https://github.com/asticode/go-astisub) **star:410** Manipulate subtitles in GO (.srt, .stl, .ttml, .webvtt, .ssa/.ass, teletext, .smi, etc.).   [![godoc][D]](https://godoc.org/github.com/asticode/go-astisub)
- [libvlc-go](https://github.com/adrg/libvlc-go) **star:317** Go bindings for libvlc 2.X/3.X/4.X (used by the VLC media player).   [![godoc][D]](https://godoc.org/github.com/adrg/libvlc-go)
- [gortsplib](https://github.com/aler9/gortsplib) **star:304** Pure Go RTSP server and client library.   [![godoc][D]](https://godoc.org/github.com/aler9/gortsplib)
- [gst](https://github.com/ziutek/gst) **star:166** Go bindings for GStreamer.   [![godoc][D]](https://godoc.org/github.com/ziutek/gst)
- [go-m3u8](https://github.com/quangngotan95/go-m3u8) **star:99** Parser and generator library for Apple m3u8 playlists.   [![godoc][D]](https://godoc.org/github.com/quangngotan95/go-m3u8)
- [v4l](https://github.com/korandiz/v4l) **star:70** Video capture library for Linux, written in Go.   [![godoc][D]](https://godoc.org/github.com/korandiz/v4l)
- [libgosubs](https://github.com/wargarblgarbl/libgosubs) **star:20** Subtitle format support for go. Supports .srt, .ttml, and .ass.   [![godoc][D]](https://godoc.org/github.com/wargarblgarbl/libgosubs)
- [go-mpd](https://github.com/unki2aut/go-mpd) **star:14** Parser and generator library for MPEG-DASH manifest files.   [![godoc][D]](https://godoc.org/github.com/unki2aut/go-mpd)

**[⬆ back to top](#contents)**

## Web Frameworks

_Full stack web frameworks._

- [Gin](https://github.com/gin-gonic/gin) **star:63315** Gin is a web framework written in Go! It features a martini-like API with much better performance, up to 40 times faster. If you need performance and good productivity.   [![There was an update last month][G]](https://github.com/gin-gonic/gin)   [![godoc][D]](https://godoc.org/github.com/gin-gonic/gin)
- [Beego](https://github.com/beego/beego) **star:28914** beego is an open-source, high-performance web framework for the Go programming language.   [![There was an update last month][G]](https://github.com/beego/beego)   [![godoc][D]](https://godoc.org/github.com/beego/beego)
- [Buffalo](https://gobuffalo.io)  Bringing the productivity of Rails to Go!
- [Confetti Framework](https://confetti-framework.github.io/docs/)  Confetti is a Go web application framework with an expressive, elegant syntax. Confetti combines the elegance of Laravel and the simplicity of Go.
- [Echo](https://github.com/labstack/echo) **star:23897** High performance, minimalist Go web framework.   [![There was an update last month][G]](https://github.com/labstack/echo)   [![godoc][D]](https://godoc.org/github.com/labstack/echo)
- [Fiber](https://github.com/gofiber/fiber) **star:22631** An Express.js inspired web framework build on Fasthttp.   [![There was an update last month][G]](https://github.com/gofiber/fiber)   [![godoc][D]](https://godoc.org/github.com/gofiber/fiber)
- [Revel](https://github.com/revel/revel) **star:12725** High-productivity web framework for the Go language.   [![godoc][D]](https://godoc.org/github.com/revel/revel)
- [Goa](https://github.com/goadesign/goa) **star:4858** Goa provides a holistic approach for developing remote APIs and microservices in Go.   [![There was an update last month][G]](https://github.com/goadesign/goa)   [![godoc][D]](https://godoc.org/github.com/goadesign/goa)
- [Gizmo](https://github.com/NYTimes/gizmo) **star:3647** Microservice toolkit used by the New York Times.   [![godoc][D]](https://godoc.org/github.com/NYTimes/gizmo)
- [go-json-rest](https://github.com/ant0ine/go-json-rest) **star:3504** Quick and easy way to setup a RESTful JSON API.   [![godoc][D]](https://godoc.org/github.com/ant0ine/go-json-rest)
- [Macaron](https://github.com/go-macaron/macaron) **star:3321** Macaron is a high productive and modular design web framework in Go.   [![godoc][D]](https://godoc.org/github.com/go-macaron/macaron)
- [utron](https://github.com/gernest/utron) **star:2220** Lightweight MVC framework for Go(Golang).   [![It hasn't been updated in recent three years][Y]](https://github.com/gernest/utron)   [![godoc][D]](https://godoc.org/github.com/gernest/utron)   [![Archived][Archived]](https://github.com/gernest/utron)
- [Goyave](https://github.com/go-goyave/goyave) **star:1175** Feature-complete REST API framework aimed at clean code and fast development, with powerful built-in functionalities.   [![There was an update last month][G]](https://github.com/go-goyave/goyave)   [![godoc][D]](https://godoc.org/github.com/go-goyave/goyave)
- [tigertonic](https://github.com/rcrowley/go-tigertonic) **star:1001** Go framework for building JSON web services inspired by Dropwizard.   [![It hasn't been updated in recent three years][Y]](https://github.com/rcrowley/go-tigertonic)   [![godoc][D]](https://godoc.org/github.com/rcrowley/go-tigertonic)
- [tango](https://github.com/lunny/tango) **star:836** Micro & pluggable web framework for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/lunny/tango)   [![godoc][D]](https://godoc.org/github.com/lunny/tango)   [![Contains Chinese documents][CN]](https://github.com/lunny/tango)   [![Archived][Archived]](https://github.com/lunny/tango)
- [Gearbox](https://github.com/abahmed/gearbox) **star:672** A web framework written in Go with a focus on high performance and memory optimization.   [![godoc][D]](https://godoc.org/github.com/abahmed/gearbox)
- [Aero](https://github.com/aerogo/aero) **star:501** High-performance web framework for Go, reaches top scores in Lighthouse.   [![godoc][D]](https://godoc.org/github.com/aerogo/aero)
- [gongular](https://github.com/mustafaakin/gongular) **star:451** Fast Go web framework with input mapping/validation and (DI) Dependency Injection.   [![godoc][D]](https://godoc.org/github.com/mustafaakin/gongular)
- [Air](https://github.com/aofei/air) **star:418** An ideally refined web framework for Go.   [![godoc][D]](https://godoc.org/github.com/aofei/air)
- [neo](https://github.com/ivpusic/neo) **star:417** Neo is minimal and fast Go Web Framework with extremely simple API.   [![It hasn't been updated in recent three years][Y]](https://github.com/ivpusic/neo)   [![godoc][D]](https://godoc.org/github.com/ivpusic/neo)
- [mango](https://github.com/paulbellamy/mango) **star:370** Mango is a modular web-application framework for Go, inspired by Rack, and PEP333.   [![It hasn't been updated in recent three years][Y]](https://github.com/paulbellamy/mango)   [![godoc][D]](https://godoc.org/github.com/paulbellamy/mango)
- [Flamingo Commerce](https://github.com/i-love-flamingo/flamingo-commerce) **star:362** Providing e-commerce features using clean architecture like DDD and ports and adapters, that you can use to build flexible e-commerce applications.   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/flamingo-commerce)
- [Flamingo](https://github.com/i-love-flamingo/flamingo) **star:317** Framework for pluggable web projects. Including a concept for modules and offering features for DI, Configareas, i18n, template engines, graphql, observability, security, events, routing & reverse routing etc.   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/flamingo)
- [Gondola](https://github.com/rainycape/gondola) **star:310** The web framework for writing faster sites, faster.   [![It hasn't been updated in recent three years][Y]](https://github.com/rainycape/gondola)   [![godoc][D]](https://godoc.org/github.com/rainycape/gondola)
- [rk-boot](https://github.com/rookie-ninja/rk-boot) **star:299** A bootstrapper library for building enterprise go microservice with Gin and gRPC quickly and easily.   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-boot)
- [WebGo](https://github.com/bnkamalesh/webgo) **star:260** A micro-framework to build web apps; with handler chaining, middleware and context injection. With standard library compliant HTTP handlers(i.e. http.HandlerFunc).   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/webgo)
- [Golf](https://github.com/dinever/golf) **star:259** Golf is a fast, simple and lightweight micro-web framework for Go. It comes with powerful features and has no dependencies other than the Go Standard Library.   [![godoc][D]](https://godoc.org/github.com/dinever/golf)
- [Ginrpc](https://github.com/xxjwxc/ginrpc) **star:238** Gin parameter automatic binding tool,gin rpc tools.   [![godoc][D]](https://godoc.org/github.com/xxjwxc/ginrpc)   [![Contains Chinese documents][CN]](https://github.com/xxjwxc/ginrpc)
- [uAdmin](https://github.com/uadmin/uadmin) **star:207** Fully featured web framework for Golang, inspired by Django.   [![godoc][D]](https://godoc.org/github.com/uadmin/uadmin)
- [hiboot](https://github.com/hidevopsio/hiboot) **star:179** hiboot is a high performance web application framework with auto configuration and dependency injection support.   [![godoc][D]](https://godoc.org/github.com/hidevopsio/hiboot)   [![Contains Chinese documents][CN]](https://github.com/hidevopsio/hiboot)
- [Huma](https://github.com/danielgtaylor/huma/)  Framework for modern REST/GraphQL APIs with built-in OpenAPI 3, generated documentation, and a CLI.
- [appy](https://github.com/appist/appy) **star:128** An opinionated productive web framework that helps scaling business easier.   [![godoc][D]](https://godoc.org/github.com/appist/appy)
- [go-rest](https://github.com/ungerik/go-rest) **star:125** Small and evil REST framework for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ungerik/go-rest)   [![godoc][D]](https://godoc.org/github.com/ungerik/go-rest)
- [Microservice](https://github.com/claygod/microservice) **star:105** The framework for the creation of microservices, written in Golang.   [![godoc][D]](https://godoc.org/github.com/claygod/microservice)
- [patron](https://github.com/beatlabs/patron) **star:98** Patron is a microservice framework following best cloud practices with a focus on productivity.   [![There was an update last month][G]](https://github.com/beatlabs/patron)   [![godoc][D]](https://godoc.org/github.com/beatlabs/patron)
- [rux](https://github.com/gookit/rux) **star:83** Simple and fast web framework for build golang HTTP applications.   [![There was an update last month][G]](https://github.com/gookit/rux)   [![godoc][D]](https://godoc.org/github.com/gookit/rux)   [![Contains Chinese documents][CN]](https://github.com/gookit/rux)
- [vox](https://github.com/aisk/vox) **star:79** A golang web framework for humans, inspired by Koa heavily.   [![godoc][D]](https://godoc.org/github.com/aisk/vox)
- [Golax](https://github.com/fulldump/golax) **star:75** A non Sinatra fast HTTP framework with support for Google custom methods, deep interceptors, recursion and more.   [![godoc][D]](https://godoc.org/github.com/fulldump/golax)
- [aah](https://aahframework.org)  Scalable, performant, rapid development Web framework for Go.
- [YARF](https://github.com/yarf-framework/yarf) **star:66** Fast micro-framework designed to build REST APIs and web services in a fast and simple way.   [![It hasn't been updated in recent three years][Y]](https://github.com/yarf-framework/yarf)   [![godoc][D]](https://godoc.org/github.com/yarf-framework/yarf)
- [Fireball](https://github.com/zpatrick/fireball) **star:59** More "natural" feeling web framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/zpatrick/fireball)   [![godoc][D]](https://godoc.org/github.com/zpatrick/fireball)
- [goa](https://github.com/goa-go/goa) **star:47** goa is just like koajs for golang, it is a flexible, light, high-performance and extensible web framework based on middleware.   [![godoc][D]](https://godoc.org/github.com/goa-go/goa)
- [GoTuna](https://github.com/gotuna/gotuna) **star:42** Minimalistic web framework for Go with mux router, middlewares, sessions, templates, embedded views and static files.   [![godoc][D]](https://godoc.org/github.com/gotuna/gotuna)
- [goweb](https://github.com/twharmon/goweb) **star:33** Web framework with routing, websockets, logging, middleware, static file server (optional gzip), and automatic TLS.   [![godoc][D]](https://godoc.org/github.com/twharmon/goweb)
- [Resoursea](https://github.com/resoursea/api) **star:33** REST framework for quickly writing resource based services.   [![It hasn't been updated in recent three years][Y]](https://github.com/resoursea/api)   [![godoc][D]](https://godoc.org/github.com/resoursea/api)
- [REST Layer](https://rest-layer.io)  Framework to build REST/GraphQL API on top of databases with mostly configuration over code.
- [rex](https://github.com/goanywhere/rex) **star:33** Rex is a library for modular development built upon gorilla/mux, fully compatible with `net/http`.   [![It hasn't been updated in recent three years][Y]](https://github.com/goanywhere/rex)   [![godoc][D]](https://godoc.org/github.com/goanywhere/rex)
- [Banjo](https://github.com/nsheremet/banjo) **star:20** Very simple and fast web framework for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/nsheremet/banjo)   [![godoc][D]](https://godoc.org/github.com/nsheremet/banjo)
- [anoweb](https://github.com/go-the-way/anoweb) **star:5** The lightweight and powerful web framework using the new way for Go.Another go the way.   [![godoc][D]](https://godoc.org/github.com/go-the-way/anoweb)
- [golamb](https://github.com/twharmon/golamb) **star:3** Golamb makes it easier to write API endpoints for use with AWS Lambda and API Gateway.   [![godoc][D]](https://godoc.org/github.com/twharmon/golamb)

**[⬆ back to top](#contents)**

### Middlewares

#### Actual middlewares

- [Tollbooth](https://github.com/didip/tollbooth) **star:2296** Rate limit HTTP request handler.   [![godoc][D]](https://godoc.org/github.com/didip/tollbooth)
- [CORS](https://github.com/rs/cors) **star:2197** Easily add CORS capabilities to your API.   [![There was an update last month][G]](https://github.com/rs/cors)   [![godoc][D]](https://godoc.org/github.com/rs/cors)
- [Limiter](https://github.com/ulule/limiter) **star:1640** Dead simple rate limit middleware for Go.   [![godoc][D]](https://godoc.org/github.com/ulule/limiter)
- [go-server-timing](https://github.com/mitchellh/go-server-timing) **star:841** Add/parse Server-Timing header.   [![godoc][D]](https://godoc.org/github.com/mitchellh/go-server-timing)
- [go-fault](https://github.com/github/go-fault) **star:464** Fault injection middleware for Go.   [![godoc][D]](https://godoc.org/github.com/github/go-fault)
- [ln-paywall](https://github.com/philippgille/ln-paywall) **star:128** Go middleware for monetizing APIs on a per-request basis with the Lightning Network (Bitcoin).   [![It hasn't been updated in recent three years][Y]](https://github.com/philippgille/ln-paywall)   [![godoc][D]](https://godoc.org/github.com/philippgille/ln-paywall)
- [XFF](https://github.com/sebest/xff) **star:94** Handle `X-Forwarded-For` header and friends.   [![godoc][D]](https://godoc.org/github.com/sebest/xff)
- [rk-grpc](https://github.com/rookie-ninja/rk-grpc) **star:51** Middleware for gRPC with logging, metrics, auth, tracing etc.   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-grpc)
- [formjson](https://github.com/rs/formjson) **star:38** Transparently handle JSON input as a standard form POST.   [![It hasn't been updated in recent three years][Y]](https://github.com/rs/formjson)   [![godoc][D]](https://godoc.org/github.com/rs/formjson)
- [rk-gin](https://github.com/rookie-ninja/rk-gin) **star:37** Middleware for Gin framework with logging, metrics, auth, tracing etc.   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-gin)
- [client-timing](https://github.com/posener/client-timing) **star:21** An HTTP client for Server-Timing header.   [![godoc][D]](https://godoc.org/github.com/posener/client-timing)
- [echo-middleware](https://github.com/faabiosr/echo-middleware) **star:12** Middleware for Echo framework with logging and metrics.   [![There was an update last month][G]](https://github.com/faabiosr/echo-middleware)   [![godoc][D]](https://godoc.org/github.com/faabiosr/echo-middleware)
- [mid](https://github.com/bobg/mid) **star:5** Miscellaneous HTTP middleware features: idiomatic error return from handlers; receive/respond with JSON data; request tracing; and more.   [![godoc][D]](https://godoc.org/github.com/bobg/mid)


#### Libraries for creating HTTP middlewares

- [negroni](https://github.com/urfave/negroni) **star:7258** Idiomatic HTTP middleware for Golang.   [![godoc][D]](https://godoc.org/github.com/urfave/negroni)   [![Contains Chinese documents][CN]](https://github.com/urfave/negroni)
- [alice](https://github.com/justinas/alice) **star:2660** Painless middleware chaining for Go.   [![godoc][D]](https://godoc.org/github.com/justinas/alice)
- [render](https://github.com/unrolled/render) **star:1680** Go package for easily rendering JSON, XML, and HTML template responses.   [![godoc][D]](https://godoc.org/github.com/unrolled/render)
- [stats](https://github.com/thoas/stats) **star:587** Go middleware that stores various information about your web application.   [![It hasn't been updated in recent three years][Y]](https://github.com/thoas/stats)   [![godoc][D]](https://godoc.org/github.com/thoas/stats)
- [interpose](https://github.com/carbocation/interpose) **star:296** Minimalist net/http middleware for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/carbocation/interpose)   [![godoc][D]](https://godoc.org/github.com/carbocation/interpose)
- [renderer](https://github.com/thedevsaddam/renderer) **star:245** Simple, lightweight and faster response (JSON, JSONP, XML, YAML, HTML, File) rendering package for Go.   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/renderer)
- [muxchain](https://github.com/stephens2424/muxchain) **star:210** Lightweight middleware for net/http.   [![It hasn't been updated in recent three years][Y]](https://github.com/stephens2424/muxchain)   [![godoc][D]](https://godoc.org/github.com/stephens2424/muxchain)
- [gores](https://github.com/alioygur/gores) **star:101** Go package that handles HTML, JSON, XML and etc. responses. Useful for RESTful APIs.   [![godoc][D]](https://godoc.org/github.com/alioygur/gores)
- [rye](https://github.com/InVisionApp/rye) **star:98** Tiny Go middleware library (with canned Middlewares) that supports JWT, CORS, Statsd, and Go 1.7 context.   [![It hasn't been updated in recent three years][Y]](https://github.com/InVisionApp/rye)   [![godoc][D]](https://godoc.org/github.com/InVisionApp/rye)
- [mediary](https://github.com/HereMobilityDevelopers/mediary) **star:81** add interceptors to `http.Client` to allow dumping/shaping/tracing/... of requests/responses.   [![godoc][D]](https://godoc.org/github.com/HereMobilityDevelopers/mediary)
- [chain](https://github.com/codemodus/chain) **star:65** Handler wrapper chaining with scoped data (net/context-based "middleware").   [![It hasn't been updated in recent three years][Y]](https://github.com/codemodus/chain)   [![godoc][D]](https://godoc.org/github.com/codemodus/chain)
- [go-wrap](https://github.com/go-on/wrap)  Small middlewares package for net/http.
- [catena](https://github.com/codemodus/catena) **star:9** http.Handler wrapper catenation (same API as "chain").   [![It hasn't been updated in recent three years][Y]](https://github.com/codemodus/catena)   [![godoc][D]](https://godoc.org/github.com/codemodus/catena)

**[⬆ back to top](#contents)**

### Routers

- [mux](https://github.com/gorilla/mux) **star:17441** Powerful URL router and dispatcher for golang.   [![godoc][D]](https://godoc.org/github.com/gorilla/mux)
- [httprouter](https://github.com/julienschmidt/httprouter) **star:14507** High performance router. Use this and the standard http handlers to form a very high performance web framework.   [![There was an update last month][G]](https://github.com/julienschmidt/httprouter)   [![godoc][D]](https://godoc.org/github.com/julienschmidt/httprouter)
- [chi](https://github.com/go-chi/chi) **star:12315** Small, fast and expressive HTTP router built on net/context.   [![godoc][D]](https://godoc.org/github.com/go-chi/chi)
- [gocraft/web](https://github.com/gocraft/web) **star:1479** Mux and middleware package in Go.   [![godoc][D]](https://godoc.org/github.com/gocraft/web)
- [Bone](https://github.com/go-zoo/bone) **star:1286** Lightning Fast HTTP Multiplexer.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-zoo/bone)   [![godoc][D]](https://godoc.org/github.com/go-zoo/bone)
- [Goji](https://github.com/goji/goji) **star:910** Goji is a minimalistic and flexible HTTP request multiplexer with support for `net/context`.   [![godoc][D]](https://godoc.org/github.com/goji/goji)
- [fasthttprouter](https://github.com/buaazp/fasthttprouter) **star:870** High performance router forked from `httprouter`. The first router fit for `fasthttp`.   [![It hasn't been updated in recent three years][Y]](https://github.com/buaazp/fasthttprouter)   [![godoc][D]](https://godoc.org/github.com/buaazp/fasthttprouter)
- [httptreemux](https://github.com/dimfeld/httptreemux) **star:559** High-speed, flexible tree-based HTTP router for Go. Inspiration from httprouter.   [![godoc][D]](https://godoc.org/github.com/dimfeld/httptreemux)
- [xujiajun/gorouter](https://github.com/xujiajun/gorouter) **star:529** A simple and fast HTTP router for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/xujiajun/gorouter)   [![godoc][D]](https://godoc.org/github.com/xujiajun/gorouter)
- [ozzo-routing](https://github.com/go-ozzo/ozzo-routing) **star:441** An extremely fast Go (golang) HTTP router that supports regular expression route matching. Comes with full support for building RESTful APIs.   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-routing)
- [lars](https://github.com/go-playground/lars) **star:390** Is a lightweight, fast and extensible zero allocation HTTP router for Go used to create customizable frameworks.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/lars)   [![godoc][D]](https://godoc.org/github.com/go-playground/lars)
- [Siesta](https://github.com/VividCortex/siesta) **star:353** Composable framework to write middleware and handlers.   [![godoc][D]](https://godoc.org/github.com/VividCortex/siesta)
- [vestigo](https://github.com/husobee/vestigo) **star:269** Performant, stand-alone, HTTP compliant URL Router for go web applications.   [![godoc][D]](https://godoc.org/github.com/husobee/vestigo)
- [gowww/router](https://github.com/gowww/router) **star:165** Lightning fast HTTP router fully compatible with the net/http.Handler interface.   [![godoc][D]](https://godoc.org/github.com/gowww/router)
- [GoRouter](https://github.com/vardius/gorouter) **star:135** GoRouter is a Server/API micro framework, HTTP request router, multiplexer, mux that provides request router with middleware supporting `net/context`.   [![godoc][D]](https://godoc.org/github.com/vardius/gorouter)
- [pure](https://github.com/go-playground/pure) **star:130** Is a lightweight HTTP router that sticks to the std "net/http" implementation.   [![godoc][D]](https://godoc.org/github.com/go-playground/pure)
- [alien](https://github.com/gernest/alien) **star:123** Lightweight and fast http router from outer space.   [![It hasn't been updated in recent three years][Y]](https://github.com/gernest/alien)   [![godoc][D]](https://godoc.org/github.com/gernest/alien)
- [Bxog](https://github.com/claygod/Bxog) **star:105** Simple and fast HTTP router for Go. It works with routes of varying difficulty, length and nesting. And he knows how to create a URL from the received parameters.   [![godoc][D]](https://godoc.org/github.com/claygod/Bxog)
- [violetear](https://github.com/nbari/violetear) **star:105** Go HTTP router.   [![godoc][D]](https://godoc.org/github.com/nbari/violetear)
- [xmux](https://github.com/rs/xmux) **star:95** High performance muxer based on `httprouter` with `net/context` support.   [![It hasn't been updated in recent three years][Y]](https://github.com/rs/xmux)   [![godoc][D]](https://godoc.org/github.com/rs/xmux)
- [bellt](https://github.com/GuilhermeCaruso/bellt) **star:55** A simple Go HTTP router.   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/bellt)
- [ngamux](https://github.com/ngamux/ngamux) **star:52** Simple HTTP router for Go.   [![godoc][D]](https://godoc.org/github.com/ngamux/ngamux)
- [goblin](https://github.com/bmf-san/goblin) **star:39** A golang http router based on trie tree.   [![godoc][D]](https://godoc.org/github.com/bmf-san/goblin)
- [FastRouter](https://github.com/razonyang/fastrouter) **star:22** a fast, flexible HTTP router written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/razonyang/fastrouter)   [![godoc][D]](https://godoc.org/github.com/razonyang/fastrouter)
- [GoLobby/Router](https://github.com/golobby/router) **star:20** GoLobby Router is a lightweight yet powerful HTTP router for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/router)
- [goroute](https://github.com/goroute/route) **star:8** Simple yet powerful HTTP request multiplexer.   [![godoc][D]](https://godoc.org/github.com/goroute/route)
- [nchi](https://github.com/muir/nchi) **star:7** chi-like router built on httprouter with dependency injection based middleware wrappers   [![godoc][D]](https://godoc.org/github.com/muir/nchi)

**[⬆ back to top](#contents)**

## WebAssembly

- [tinygo](https://github.com/tinygo-org/tinygo) **star:11600** Go compiler for small places. Microcontrollers, WebAssembly, and command-line tools. Based on LLVM.   [![There was an update last month][G]](https://github.com/tinygo-org/tinygo)   [![godoc][D]](https://godoc.org/github.com/tinygo-org/tinygo)
- [dom](https://github.com/dennwc/dom) **star:463** DOM library.   [![It hasn't been updated in recent three years][Y]](https://github.com/dennwc/dom)   [![godoc][D]](https://godoc.org/github.com/dennwc/dom)
- [go-canvas](https://github.com/markfarnan/go-canvas) **star:177** Library to use HTML5 Canvas, with all drawing within go code.   [![godoc][D]](https://godoc.org/github.com/markfarnan/go-canvas)
- [wasmbrowsertest](https://github.com/agnivade/wasmbrowsertest) **star:131** Run Go WASM tests in your browser.   [![godoc][D]](https://godoc.org/github.com/agnivade/wasmbrowsertest)
- [webapi](https://github.com/gowebapi/webapi) **star:120** Bindings for DOM and HTML generated from WebIDL.   [![godoc][D]](https://godoc.org/github.com/gowebapi/webapi)
- [vert](https://github.com/norunners/vert) **star:77** Interop between Go and JS values.   [![godoc][D]](https://godoc.org/github.com/norunners/vert)

**[⬆ back to top](#contents)**

## Windows

- [go-ole](https://github.com/go-ole/go-ole) **star:907** Win32 OLE implementation for golang.   [![godoc][D]](https://godoc.org/github.com/go-ole/go-ole)
- [d3d9](https://github.com/gonutz/d3d9) **star:133** Go bindings for Direct3D9.   [![godoc][D]](https://godoc.org/github.com/gonutz/d3d9)
- [gosddl](https://github.com/MonaxGT/gosddl) **star:9** Converter from SDDL-string to user-friendly JSON. SDDL consist of four part: Owner, Primary Group, DACL, SACL.   [![It hasn't been updated in recent three years][Y]](https://github.com/MonaxGT/gosddl)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/gosddl)

**[⬆ back to top](#contents)**

## XML

_Libraries and tools for manipulating XML._

- [zek](https://github.com/miku/zek) **star:598** Generate a Go struct from XML.   [![godoc][D]](https://godoc.org/github.com/miku/zek)
- [xpath](https://github.com/antchfx/xpath) **star:513** XPath package for Go.   [![godoc][D]](https://godoc.org/github.com/antchfx/xpath)
- [xquery](https://github.com/antchfx/xquery) **star:156** XQuery lets you extract data from HTML/XML documents using XPath expression.   [![It hasn't been updated in recent three years][Y]](https://github.com/antchfx/xquery)   [![godoc][D]](https://godoc.org/github.com/antchfx/xquery)   [![Archived][Archived]](https://github.com/antchfx/xquery)
- [xml2map](https://github.com/sbabiv/xml2map) **star:43** XML to MAP converter written Golang.   [![godoc][D]](https://godoc.org/github.com/sbabiv/xml2map)
- [xmlwriter](https://github.com/shabbyrobe/xmlwriter) **star:22** Procedural XML generation API based on libxml2's xmlwriter module.   [![godoc][D]](https://godoc.org/github.com/shabbyrobe/xmlwriter)
- [XML-Comp](https://github.com/xml-comp/xml-comp) **star:18** Simple command line XML comparer that generates diffs of folders, files and tags.   [![It hasn't been updated in recent three years][Y]](https://github.com/xml-comp/xml-comp)   [![godoc][D]](https://godoc.org/github.com/xml-comp/xml-comp)

## Zero Trust

_Libraries and tools to implement Zero Trust architectures._

- [Cosign](https://github.com/sigstore/cosign) **star:2548** Container Signing, Verification and Storage in an OCI registry.   [![There was an update last month][G]](https://github.com/sigstore/cosign)   [![godoc][D]](https://godoc.org/github.com/sigstore/cosign)
- [Spire](https://github.com/spiffe/spire) **star:1256** SPIRE (the SPIFFE Runtime Environment) is a toolchain of APIs for establishing trust between software systems across a wide variety of hosting platforms.   [![There was an update last month][G]](https://github.com/spiffe/spire)   [![godoc][D]](https://godoc.org/github.com/spiffe/spire)
- [in-toto](https://github.com/in-toto/in-toto-golang) **star:64** Go implementation of the in-toto (provides a framework to protect the integrity of the software supply chain) python reference implementation.   [![There was an update last month][G]](https://github.com/in-toto/in-toto-golang)   [![godoc][D]](https://godoc.org/github.com/in-toto/in-toto-golang)
- [Spiffe-Vault](https://github.com/philips-labs/spiffe-vault) **star:44** Utilizes Spiffe JWT authentication with Hashicorp Vault for secretless authentication.   [![There was an update last month][G]](https://github.com/philips-labs/spiffe-vault)   [![godoc][D]](https://godoc.org/github.com/philips-labs/spiffe-vault)

## Code Analysis

_Source code analysis tools, also known as Static Application Security Testing (SAST) Tools._

- [GoLint](https://github.com/golang/lint) **star:3964** Golint is a linter for Go source code.   [![godoc][D]](https://godoc.org/github.com/golang/lint)   [![Archived][Archived]](https://github.com/golang/lint)
- [errcheck](https://github.com/kisielk/errcheck) **star:1909** Errcheck is a program for checking for unchecked errors in Go programs.   [![There was an update last month][G]](https://github.com/kisielk/errcheck)   [![godoc][D]](https://godoc.org/github.com/kisielk/errcheck)
- [go-critic](https://github.com/go-critic/go-critic) **star:1407** source code linter that brings checks that are currently not implemented in other linters.   [![There was an update last month][G]](https://github.com/go-critic/go-critic)   [![godoc][D]](https://godoc.org/github.com/go-critic/go-critic)
- [GoPlantUML](https://github.com/jfeliu007/goplantuml) **star:1120** Library and CLI that generates text plantump class diagram containing information about structures and interfaces with the relationship among them.   [![godoc][D]](https://godoc.org/github.com/jfeliu007/goplantuml)
- [goreturns](https://sourcegraph.com/github.com/sqs/goreturns)  Adds zero-value return statements to match the func return types.
- [gosimple](https://github.com/dominikh/go-tools/tree/master/cmd/gosimple)  gosimple is a linter for Go source code that specialises on simplifying code.
- [gcvis](https://github.com/davecheney/gcvis) **star:1068** Visualise Go program GC trace data in real time.   [![It hasn't been updated in recent three years][Y]](https://github.com/davecheney/gcvis)   [![godoc][D]](https://godoc.org/github.com/davecheney/gcvis)
- [php-parser](https://github.com/z7zmey/php-parser) **star:894** A Parser for PHP written in Go.   [![godoc][D]](https://godoc.org/github.com/z7zmey/php-parser)
- [staticcheck](https://github.com/dominikh/go-tools/tree/master/cmd/staticcheck)  staticcheck is `go vet` on steroids, applying a ton of static analysis checks you might be used to from tools like ReSharper for C#.
- [goast-viewer](https://github.com/yuroyoro/goast-viewer) **star:659** Web based Golang AST visualizer.
- [GoCover.io](https://gocover.io/)  GoCover.io offers the code coverage of any golang package as a service.
- [goimports](https://godoc.org/golang.org/x/tools/cmd/goimports)  Tool to fix (add, remove) your Go imports automatically.
- [go-cleanarch](https://github.com/roblaszczak/go-cleanarch) **star:624** go-cleanarch was created to validate Clean Architecture rules, like a The Dependency Rule and interaction between packages in your Go projects.   [![godoc][D]](https://godoc.org/github.com/roblaszczak/go-cleanarch)
- [go-mod-outdated](https://github.com/psampaz/go-mod-outdated) **star:602** An easy way to find outdated dependencies of your Go projects.   [![godoc][D]](https://godoc.org/github.com/psampaz/go-mod-outdated)
- [golines](https://github.com/segmentio/golines) **star:472** Formatter that automatically shortens long lines in Go code.   [![godoc][D]](https://godoc.org/github.com/segmentio/golines)
- [todocheck](https://github.com/preslavmihaylov/todocheck) **star:391** Static code analyser which links TODO comments in code with issues in your issue tracker.   [![godoc][D]](https://godoc.org/github.com/preslavmihaylov/todocheck)
- [unconvert](https://github.com/mdempsky/unconvert) **star:334** Remove unnecessary type conversions from Go source.   [![There was an update last month][G]](https://github.com/mdempsky/unconvert)   [![godoc][D]](https://godoc.org/github.com/mdempsky/unconvert)
- [unused](https://github.com/dominikh/go-tools/tree/master/cmd/unused)  unused checks Go code for unused constants, variables, functions and types.
- [dupl](https://github.com/mibk/dupl) **star:297** Tool for code clone detection.   [![godoc][D]](https://godoc.org/github.com/mibk/dupl)
- [tickgit](https://github.com/augmentable-dev/tickgit) **star:281** CLI and go package for surfacing code comment TODOs (in any language) and applying a `git blame`to identify the author.   [![godoc][D]](https://godoc.org/github.com/augmentable-dev/tickgit)
- [gostatus](https://github.com/shurcooL/gostatus) **star:244** Command line tool, shows the status of repositories that contain Go packages.   [![It hasn't been updated in recent three years][Y]](https://github.com/shurcooL/gostatus)   [![godoc][D]](https://godoc.org/github.com/shurcooL/gostatus)
- [apicompat](https://github.com/bradleyfalzon/apicompat) **star:176** Checks recent changes to a Go project for backwards incompatible changes.   [![It hasn't been updated in recent three years][Y]](https://github.com/bradleyfalzon/apicompat)   [![godoc][D]](https://godoc.org/github.com/bradleyfalzon/apicompat)
- [go-checkstyle](https://github.com/qiniu/checkstyle) **star:122** checkstyle is a style check tool like java checkstyle. This tool inspired by java checkstyle, golint. The style referred to some points in Go Code Review Comments.   [![godoc][D]](https://godoc.org/github.com/qiniu/checkstyle)
- [lint](https://github.com/surullabs/lint) **star:67** Run linters as part of go test.   [![It hasn't been updated in recent three years][Y]](https://github.com/surullabs/lint)   [![godoc][D]](https://godoc.org/github.com/surullabs/lint)
- [validate](https://github.com/mccoyst/validate) **star:60** Automatically validates struct fields with tags.   [![It hasn't been updated in recent three years][Y]](https://github.com/mccoyst/validate)   [![godoc][D]](https://godoc.org/github.com/mccoyst/validate)
- [go-outdated](https://github.com/firstrow/go-outdated) **star:44** Console application that displays outdated packages.   [![It hasn't been updated in recent three years][Y]](https://github.com/firstrow/go-outdated)   [![godoc][D]](https://godoc.org/github.com/firstrow/go-outdated)   [![Archived][Archived]](https://github.com/firstrow/go-outdated)
- [ChainJacking](https://github.com/Checkmarx/chainjacking) **star:29** Find which of your Go lang direct GitHub dependencies is susceptible to ChainJacking attack.
- [usestdlibvars](https://github.com/sashamelentyev/usestdlibvars) **star:29** A linter that detect the possibility to use variables/constants from the Go standard library.   [![There was an update last month][G]](https://github.com/sashamelentyev/usestdlibvars)   [![godoc][D]](https://godoc.org/github.com/sashamelentyev/usestdlibvars)
- [asty](https://github.com/asty-org/asty) **star:23** Converts golang AST to JSON and JSON to AST.   [![godoc][D]](https://godoc.org/github.com/asty-org/asty)
- [tarp](https://github.com/verygoodsoftwarenotvirus/tarp) **star:15** tarp finds functions and methods without direct unit tests in Go source code.   [![It hasn't been updated in recent three years][Y]](https://github.com/verygoodsoftwarenotvirus/tarp)   [![godoc][D]](https://godoc.org/github.com/verygoodsoftwarenotvirus/tarp)   [![Archived][Archived]](https://github.com/verygoodsoftwarenotvirus/tarp)
- [golang-ifood-sdk](https://github.com/arxdsilva/golang-ifood-sdk) **star:10** iFood API SDK.   [![godoc][D]](https://godoc.org/github.com/arxdsilva/golang-ifood-sdk)

**[⬆ back to top](#contents)**

## Editor Plugins

_Plugin for text editors and IDEs._

- [vim-go](https://github.com/fatih/vim-go) **star:14944** Go development plugin for Vim.
- [gocode](https://github.com/nsf/gocode) **star:4986** Autocompletion daemon for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/nsf/gocode)
- [GoSublime](https://github.com/DisposaBoy/GoSublime) **star:3433** Golang plugin collection for the text editor SublimeText 3 providing code completion and other IDE-like features.   [![godoc][D]](https://godoc.org/github.com/DisposaBoy/GoSublime)
- [vscode-go](https://github.com/golang/vscode-go) **star:2968** Extension for Visual Studio Code (VS Code) which provides support for the Go language.   [![There was an update last month][G]](https://github.com/golang/vscode-go)
- [go-plus](https://github.com/joefitzgerald/go-plus) **star:1511** Go (Golang) Package For Atom That Adds Autocomplete, Formatting, Syntax Checking, Linting and Vetting.   [![Archived][Archived]](https://github.com/joefitzgerald/go-plus)
- [go-mode](https://github.com/dominikh/go-mode.el) **star:1268** Go mode for GNU/Emacs.
- [coc-go language server extension for Vim/Neovim](https://github.com/josa42/coc-go) **star:492** This plugin adds [gopls](https://github.com/golang/tools/blob/master/gopls/README.md) features to Vim/Neovim.   [![There was an update last month][G]](https://github.com/josa42/coc-go)
- [goimports-reviser](https://github.com/incu6us/goimports-reviser) **star:205** Formatting tool for imports.   [![There was an update last month][G]](https://github.com/incu6us/goimports-reviser)   [![godoc][D]](https://godoc.org/github.com/incu6us/goimports-reviser)
- [goprofiling](https://marketplace.visualstudio.com/items?itemName=MaxMedia.go-prof)  This extension adds benchmark profiling support for the Go language to VS Code.
- [Watch](https://github.com/eaburns/Watch) **star:196** Runs a command in an acme win on file changes.   [![godoc][D]](https://godoc.org/github.com/eaburns/Watch)
- [vim-compiler-go](https://github.com/rjohnsondev/vim-compiler-go) **star:88** Vim plugin to highlight syntax errors on save.   [![It hasn't been updated in recent three years][Y]](https://github.com/rjohnsondev/vim-compiler-go)
- [go-language-server](https://github.com/theia-ide/go-language-server) **star:32** A wrapper to turn the VSCode go extension into a language server supporting the language-server-protocol.   [![It hasn't been updated in recent three years][Y]](https://github.com/theia-ide/go-language-server)   [![Archived][Archived]](https://github.com/theia-ide/go-language-server)
- [gounit-vim](https://github.com/hexdigest/gounit-vim) **star:24** Vim plugin for generating Go tests based on the function's or method's signature.   [![It hasn't been updated in recent three years][Y]](https://github.com/hexdigest/gounit-vim)
- [theia-go-extension](https://github.com/theia-ide/theia-go-extension) **star:17** Go language support for the Theia IDE.   [![It hasn't been updated in recent three years][Y]](https://github.com/theia-ide/theia-go-extension)   [![Archived][Archived]](https://github.com/theia-ide/theia-go-extension)
- [Go Doc](https://github.com/msyrus/vscode-go-doc) **star:5** A Visual Studio Code extension for showing definition in output and generating go doc.
- [Go plugin for JetBrains IDEs](https://plugins.jetbrains.com/plugin/9568-go)  Go plugin for JetBrains IDEs.

**[⬆ back to top](#contents)**

## Go Generate Tools

- [gotests](https://github.com/cweill/gotests) **star:4237** Generate Go tests from your source code.   [![godoc][D]](https://godoc.org/github.com/cweill/gotests)
- [genny](https://github.com/cheekybits/genny) **star:1658** Elegant generics for Go.   [![godoc][D]](https://godoc.org/github.com/cheekybits/genny)
- [re2dfa](https://github.com/opennota/re2dfa) **star:195** Transform regular expressions into finite state machines and output Go source code.   [![It hasn't been updated in recent three years][Y]](https://github.com/opennota/re2dfa)   [![godoc][D]](https://godoc.org/github.com/opennota/re2dfa)   [![Archived][Archived]](https://github.com/opennota/re2dfa)
- [TOML-to-Go](https://xuri.me/toml-to-go)  Translates TOML into a Go type in the browser instantly.
- [xgen](https://github.com/xuri/xgen) **star:186** XSD (XML Schema Definition) parser and Go/C/Java/Rust/TypeScript code generator.   [![godoc][D]](https://godoc.org/github.com/xuri/xgen)
- [hasgo](https://github.com/DylanMeeus/hasgo) **star:121** Generate Haskell inspired functions for your slices.   [![godoc][D]](https://godoc.org/github.com/DylanMeeus/hasgo)
- [gonerics](https://github.com/bouk/gonerics) **star:116** Idiomatic Generics in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/bouk/gonerics)   [![godoc][D]](https://godoc.org/github.com/bouk/gonerics)
- [gocontracts](https://github.com/Parquery/gocontracts) **star:87** brings design-by-contract to Go by synchronizing the code with the documentation.   [![It hasn't been updated in recent three years][Y]](https://github.com/Parquery/gocontracts)   [![godoc][D]](https://godoc.org/github.com/Parquery/gocontracts)
- [gounit](https://github.com/hexdigest/gounit) **star:64** Generate Go tests using your own templates.   [![It hasn't been updated in recent three years][Y]](https://github.com/hexdigest/gounit)   [![godoc][D]](https://godoc.org/github.com/hexdigest/gounit)
- [generic](https://github.com/usk81/generic) **star:44** flexible data type for Go.   [![godoc][D]](https://godoc.org/github.com/usk81/generic)
- [godal](https://github.com/mafulong/godal) **star:14** Generate orm models corresponding to golang by specifying sql ddl file, which can be used by gorm.   [![godoc][D]](https://godoc.org/github.com/mafulong/godal)

**[⬆ back to top](#contents)**

## Go Tools

- [go-swagger](https://github.com/go-swagger/go-swagger) **star:8022** Swagger 2.0 implementation for go. Swagger is a simple yet powerful representation of your RESTful API.   [![godoc][D]](https://godoc.org/github.com/go-swagger/go-swagger)
- [OctoLinker](https://github.com/OctoLinker/browser-extension) **star:5045** Navigate through go files efficiently with the OctoLinker browser extension for GitHub.   [![There was an update last month][G]](https://github.com/OctoLinker/browser-extension)
- [go-callvis](https://github.com/TrueFurby/go-callvis) **star:4396** Visualize call graph of your Go program using dot format.   [![godoc][D]](https://godoc.org/github.com/TrueFurby/go-callvis)
- [depth](https://github.com/KyleBanks/depth) **star:790** Visualize dependency trees of any package by analyzing imports.   [![godoc][D]](https://godoc.org/github.com/KyleBanks/depth)
- [richgo](https://github.com/kyoh86/richgo) **star:733** Enrich `go test` outputs with text decorations.   [![godoc][D]](https://godoc.org/github.com/kyoh86/richgo)
- [rts](https://github.com/galeone/rts) **star:235** RTS: response to struct. Generates Go structs from server responses.   [![godoc][D]](https://godoc.org/github.com/galeone/rts)
- [godbg](https://github.com/tylerwince/godbg) **star:186** Implementation of Rusts `dbg!` macro for quick and easy debugging during development.   [![It hasn't been updated in recent three years][Y]](https://github.com/tylerwince/godbg)   [![godoc][D]](https://godoc.org/github.com/tylerwince/godbg)
- [gomodrun](https://github.com/dustinblackman/gomodrun/)  Go tool that executes and caches binaries included in go.mod files.
- [gotemplate.io](https://gotemplate.io/)  Online tool to preview `text/template` templates live.
- [typex](https://github.com/dtgorski/typex) **star:152** Examine Go types and their transitive dependencies, alternatively export results as TypeScript value objects (or types) declaration.   [![godoc][D]](https://godoc.org/github.com/dtgorski/typex)
- [roumon](https://github.com/becheran/roumon) **star:119** Monitor current state of all active goroutines via a command line interface.   [![godoc][D]](https://godoc.org/github.com/becheran/roumon)
- [gothanks](https://github.com/psampaz/gothanks) **star:113** GoThanks automatically stars your go.mod github dependencies, sending this way some love to their maintainers.   [![godoc][D]](https://godoc.org/github.com/psampaz/gothanks)
- [colorgo](https://github.com/songgao/colorgo) **star:111** Wrapper around `go` command for colorized `go build` output.   [![godoc][D]](https://godoc.org/github.com/songgao/colorgo)
- [go-james](https://github.com/pieterclaerhout/go-james) **star:55** Go project skeleton creator, builds and tests your projects without the manual setup.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-james)
- [igo](https://github.com/rocketlaunchr/igo) **star:55** An igo to go transpiler (new language features for Go language!)   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/igo)
- [go-pkg-complete](https://github.com/skelterjohn/go-pkg-complete) **star:41** Bash completion for go and wgo.   [![It hasn't been updated in recent three years][Y]](https://github.com/skelterjohn/go-pkg-complete)
- [generator-go-lang](https://github.com/axelspringer/generator-go-lang) **star:25** A [Yeoman](https://yeoman.io) generator to get new Go projects started.   [![Archived][Archived]](https://github.com/axelspringer/generator-go-lang)
- [gotestdox](https://github.com/bitfield/gotestdox) **star:18** Show Go test results as readable sentences.   [![godoc][D]](https://godoc.org/github.com/bitfield/gotestdox)
- [docs](https://github.com/go-oas/docs) **star:14** Automatically generate RESTful API documentation for GO projects - aligned with Open API Specification standard.   [![godoc][D]](https://godoc.org/github.com/go-oas/docs)
- [modver](https://github.com/bobg/modver) **star:3** Compare two versions of a Go module to check the version-number change required (major, minor, or patchlevel), according to [semver](https://semver.org/) rules.   [![There was an update last month][G]](https://github.com/bobg/modver)   [![godoc][D]](https://godoc.org/github.com/bobg/modver)

**[⬆ back to top](#contents)**

## Software Packages

_Software written in Go._

**[⬆ back to top](#contents)**

### DevOps Tools

- [kubernetes](https://github.com/kubernetes/kubernetes) **star:92568** Container Cluster Manager from Google.   [![There was an update last month][G]](https://github.com/kubernetes/kubernetes)   [![godoc][D]](https://godoc.org/github.com/kubernetes/kubernetes)
- [Moby](https://github.com/moby/moby) **star:64173** Collaborative project for the container ecosystem to assemble container-based systems.   [![There was an update last month][G]](https://github.com/moby/moby)   [![godoc][D]](https://godoc.org/github.com/moby/moby)
- [traefik](https://github.com/containous/traefik) **star:39874** Reverse proxy and load balancer with support for multiple backends.   [![There was an update last month][G]](https://github.com/containous/traefik)   [![godoc][D]](https://godoc.org/github.com/containous/traefik)
- [Gitea](https://github.com/go-gitea/gitea) **star:32569** Fork of Gogs, entirely community driven.   [![There was an update last month][G]](https://github.com/go-gitea/gitea)   [![godoc][D]](https://godoc.org/github.com/go-gitea/gitea)   [![Contains Chinese documents][CN]](https://github.com/go-gitea/gitea)
- [gitea-github-migrator](https://git.jonasfranz.software/JonasFranzDEV/gitea-github-migrator)  Migrate all your GitHub repositories, issues, milestones and labels to your Gitea instance.
- [Vegeta](https://github.com/tsenart/vegeta) **star:20242** HTTP load testing tool and library. It's over 9000!   [![godoc][D]](https://godoc.org/github.com/tsenart/vegeta)
- [Hey](https://github.com/rakyll/hey) **star:14347** Hey is a tiny program that sends some load to a web application.   [![godoc][D]](https://godoc.org/github.com/rakyll/hey)
- [Packer](https://github.com/mitchellh/packer) **star:13956** Packer is a tool for creating identical machine images for multiple platforms from a single source configuration.   [![There was an update last month][G]](https://github.com/mitchellh/packer)   [![godoc][D]](https://godoc.org/github.com/mitchellh/packer)
- [webhook](https://github.com/adnanh/webhook) **star:8240** Tool which allows user to create HTTP endpoints (hooks) that execute commands on the server.   [![There was an update last month][G]](https://github.com/adnanh/webhook)   [![godoc][D]](https://godoc.org/github.com/adnanh/webhook)
- [Wide](https://wide.b3log.org/login)  Web-based IDE for Teams using Golang.
- [GVM](https://github.com/moovweb/gvm) **star:7824** GVM provides an interface to manage Go versions.
- [ko](https://github.com/google/ko) **star:5057** Command line tool for building and deploying Go applications on Kubernetes   [![There was an update last month][G]](https://github.com/google/ko)   [![godoc][D]](https://godoc.org/github.com/google/ko)
- [Ddosify](https://github.com/ddosify/ddosify) **star:4941** High-performance load testing tool, written in Golang.   [![godoc][D]](https://godoc.org/github.com/ddosify/ddosify)
- [gaia](https://github.com/gaia-pipeline/gaia) **star:4830** Build powerful pipelines in any programming language.   [![There was an update last month][G]](https://github.com/gaia-pipeline/gaia)   [![godoc][D]](https://godoc.org/github.com/gaia-pipeline/gaia)
- [gox](https://github.com/mitchellh/gox) **star:4356** Dead simple, no frills Go cross compile tool.   [![godoc][D]](https://godoc.org/github.com/mitchellh/gox)
- [Mizu](https://github.com/up9inc/mizu) **star:3937** API traffic viewer for Kubernetes enabling you to view all API communication between microservices, multiprotocol support: HTTP1.1, HTTP/2, AMQP, Kafka, Redis.
- [bombardier](https://github.com/codesenberg/bombardier) **star:3767** Fast cross-platform HTTP benchmarking tool.   [![godoc][D]](https://godoc.org/github.com/codesenberg/bombardier)
- [bosun](https://github.com/bosun-monitor/bosun) **star:3304** Time Series Alerting Framework.   [![godoc][D]](https://godoc.org/github.com/bosun-monitor/bosun)
- [Pomerium](https://github.com/pomerium/pomerium) **star:3249** Pomerium is an identity-aware access proxy.   [![There was an update last month][G]](https://github.com/pomerium/pomerium)   [![godoc][D]](https://godoc.org/github.com/pomerium/pomerium)
- [script](https://github.com/bitfield/script) **star:2986** Making it easy to write shell-like scripts in Go for DevOps and system administration tasks.   [![godoc][D]](https://godoc.org/github.com/bitfield/script)
- [kala](https://github.com/ajvb/kala) **star:1867** Simplistic, modern, and performant job scheduler.   [![There was an update last month][G]](https://github.com/ajvb/kala)   [![godoc][D]](https://godoc.org/github.com/ajvb/kala)
- [fac](https://github.com/mkchoi212/fac) **star:1777** Command-line user interface to fix git merge conflicts.   [![godoc][D]](https://godoc.org/github.com/mkchoi212/fac)
- [goxc](https://github.com/laher/goxc) **star:1683** build tool for Go, with a focus on cross-compiling and packaging.   [![It hasn't been updated in recent three years][Y]](https://github.com/laher/goxc)   [![godoc][D]](https://godoc.org/github.com/laher/goxc)   [![Archived][Archived]](https://github.com/laher/goxc)
- [StatusOK](https://github.com/sanathp/statusok) **star:1565** Monitor your Website and REST APIs.Get Notified through Slack, E-mail when your server is down or response time is more than expected.   [![godoc][D]](https://godoc.org/github.com/sanathp/statusok)
- [s5cmd](https://github.com/peak/s5cmd) **star:1287** Blazing fast S3 and local filesystem execution tool.   [![godoc][D]](https://godoc.org/github.com/peak/s5cmd)
- [s3gof3r](https://github.com/rlmcpherson/s3gof3r) **star:1125** Small utility/library optimized for high speed transfer of large objects into and out of Amazon S3.   [![godoc][D]](https://godoc.org/github.com/rlmcpherson/s3gof3r)
- [ghorg](https://github.com/gabrie30/ghorg) **star:1089** Quickly clone an entire org/users repositories into one directory - Supports GitHub, GitLab, Gitea, and Bitbucket.   [![There was an update last month][G]](https://github.com/gabrie30/ghorg)   [![godoc][D]](https://godoc.org/github.com/gabrie30/ghorg)
- [go-selfupdate](https://github.com/sanbornm/go-selfupdate) **star:1062** Enable your Go applications to self update.   [![godoc][D]](https://godoc.org/github.com/sanbornm/go-selfupdate)
- [Fleet device management](https://github.com/fleetdm/fleet) **star:936** Lightweight, programmable telemetry for servers and workstations.   [![There was an update last month][G]](https://github.com/fleetdm/fleet)   [![godoc][D]](https://godoc.org/github.com/fleetdm/fleet)
- [skm](https://github.com/TimothyYe/skm) **star:829** SKM is a simple and powerful SSH Keys Manager, it helps you to manage your multiple SSH keys easily!   [![There was an update last month][G]](https://github.com/TimothyYe/skm)   [![godoc][D]](https://godoc.org/github.com/TimothyYe/skm)
- [Scaleway-cli](https://github.com/scaleway/scaleway-cli) **star:776** Manage BareMetal Servers from Command Line (as easily as with Docker).   [![There was an update last month][G]](https://github.com/scaleway/scaleway-cli)   [![godoc][D]](https://godoc.org/github.com/scaleway/scaleway-cli)
- [uTask](https://github.com/ovh/utask) **star:743** Automation engine that models and executes business processes declared in yaml.   [![godoc][D]](https://godoc.org/github.com/ovh/utask)
- [kwatch](https://github.com/abahmed/kwatch) **star:683** Monitor & detect crashes in your Kubernetes(K8s) cluster instantly.   [![There was an update last month][G]](https://github.com/abahmed/kwatch)   [![godoc][D]](https://godoc.org/github.com/abahmed/kwatch)
- [cassowary](https://github.com/rogerwelin/cassowary) **star:619** Modern cross-platform HTTP load-testing tool written in Go.   [![godoc][D]](https://godoc.org/github.com/rogerwelin/cassowary)   [![Contains Chinese documents][CN]](https://github.com/rogerwelin/cassowary)
- [kool](https://github.com/kool-dev/kool) **star:611** Command line tool for managing Docker environments as an easy way.   [![godoc][D]](https://godoc.org/github.com/kool-dev/kool)
- [aurora](https://github.com/xuri/aurora) **star:567** Cross-platform web-based Beanstalkd queue server console.
- [govvv](https://github.com/ahmetalpbalkan/govvv) **star:530** “go build” wrapper to easily add version information into Go binaries.   [![godoc][D]](https://godoc.org/github.com/ahmetalpbalkan/govvv)
- [Pewpew](https://github.com/bengadbois/pewpew) **star:358** Flexible HTTP command line stress tester.   [![godoc][D]](https://godoc.org/github.com/bengadbois/pewpew)
- [jcli](https://github.com/jenkins-zh/jenkins-cli) **star:338** Jenkins CLI allows you manage your Jenkins as an easy way.   [![There was an update last month][G]](https://github.com/jenkins-zh/jenkins-cli)   [![godoc][D]](https://godoc.org/github.com/jenkins-zh/jenkins-cli)   [![Contains Chinese documents][CN]](https://github.com/jenkins-zh/jenkins-cli)
- [gonative](https://github.com/inconshreveable/gonative) **star:333** Tool which creates a build of Go that can cross compile to all platforms while still using the Cgo-enabled versions of the stdlib packages.   [![It hasn't been updated in recent three years][Y]](https://github.com/inconshreveable/gonative)   [![godoc][D]](https://godoc.org/github.com/inconshreveable/gonative)
- [trubka](https://github.com/xitonix/trubka) **star:327** A CLI tool to manage and troubleshoot Apache Kafka clusters with the ability of generically publishing/consuming protocol buffer and plain text events to/from Kafka.   [![godoc][D]](https://godoc.org/github.com/xitonix/trubka)
- [Mora](https://github.com/emicklei/mora) **star:306** REST server for accessing MongoDB documents and meta data.   [![godoc][D]](https://godoc.org/github.com/emicklei/mora)
- [lstags](https://github.com/ivanilves/lstags) **star:295** Tool and API to sync Docker images across different registries.   [![godoc][D]](https://godoc.org/github.com/ivanilves/lstags)
- [Balerter](https://github.com/balerter/balerter) **star:277** A self-hosted script-based alerting manager.   [![godoc][D]](https://godoc.org/github.com/balerter/balerter)
- [manssh](https://github.com/xwjdsh/manssh) **star:272** manssh is a command line tool for managing your ssh alias config easily.   [![godoc][D]](https://godoc.org/github.com/xwjdsh/manssh)
- [easyssh-proxy](https://github.com/appleboy/easyssh-proxy) **star:260** Golang package for easy remote execution through SSH and SCP downloading via `ProxyCommand`.   [![godoc][D]](https://godoc.org/github.com/appleboy/easyssh-proxy)
- [dogo](https://github.com/liudng/dogo) **star:252** Monitoring changes in the source file and automatically compile and run (restart).   [![It hasn't been updated in recent three years][Y]](https://github.com/liudng/dogo)   [![godoc][D]](https://godoc.org/github.com/liudng/dogo)   [![Contains Chinese documents][CN]](https://github.com/liudng/dogo)
- [godbg](https://github.com/sirnewton01/godbg) **star:226** Web-based gdb front-end application.   [![It hasn't been updated in recent three years][Y]](https://github.com/sirnewton01/godbg)
- [Gogs](https://gogs.io/)  A Self Hosted Git Service in the Go Programming Language.
- [terraform-provider-openapi](https://github.com/dikhan/terraform-provider-openapi) **star:219** Terraform provider plugin that dynamically configures itself at runtime based on an OpenAPI document (formerly known as swagger file) containing the definitions of the APIs exposed.   [![There was an update last month][G]](https://github.com/dikhan/terraform-provider-openapi)   [![godoc][D]](https://godoc.org/github.com/dikhan/terraform-provider-openapi)
- [Blast](https://github.com/dave/blast) **star:210** A simple tool for API load testing and batch jobs.   [![It hasn't been updated in recent three years][Y]](https://github.com/dave/blast)   [![godoc][D]](https://godoc.org/github.com/dave/blast)
- [gobrew](https://github.com/cryptojuice/gobrew) **star:192** gobrew lets you easily switch between multiple versions of go.
- [abbreviate](https://github.com/dnnrly/abbreviate) **star:187** abbreviate is a tool turning long strings in to shorter ones with configurable separators, for example to embed branch names in to deployment stack IDs.   [![godoc][D]](https://godoc.org/github.com/dnnrly/abbreviate)
- [kcli](https://github.com/cswank/kcli) **star:186** Command line tool for inspecting kafka topics/partitions/messages.   [![godoc][D]](https://godoc.org/github.com/cswank/kcli)
- [ostent](https://github.com/ostrost/ostent) **star:175** collects and displays system metrics and optionally relays to Graphite and/or InfluxDB.   [![godoc][D]](https://godoc.org/github.com/ostrost/ostent)
- [grapes](https://github.com/yaronsumel/grapes) **star:158** Lightweight tool designed to distribute commands over ssh with ease.   [![godoc][D]](https://godoc.org/github.com/yaronsumel/grapes)
- [winrm-cli](https://github.com/masterzen/winrm-cli) **star:143** Cli tool to remotely execute commands on Windows machines.   [![godoc][D]](https://godoc.org/github.com/masterzen/winrm-cli)
- [Dockerfile-Generator](https://github.com/ozankasikci/dockerfile-generator) **star:137** A go library and an executable that produces valid Dockerfiles using various input channels.   [![godoc][D]](https://godoc.org/github.com/ozankasikci/dockerfile-generator)
- [s3-proxy](https://github.com/oxyno-zeta/s3-proxy) **star:131** S3 Proxy with GET, PUT and DELETE methods and authentication (OpenID Connect and Basic Auth).   [![There was an update last month][G]](https://github.com/oxyno-zeta/s3-proxy)   [![godoc][D]](https://godoc.org/github.com/oxyno-zeta/s3-proxy)
- [drone-scp](https://github.com/appleboy/drone-scp) **star:110** Copy files and artifacts via SSH using a binary, docker or Drone CI.   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-scp)
- [go-furnace](https://github.com/go-furnace/go-furnace) **star:93** Hosting solution written in Go. Deploy your Application with ease on AWS, GCP or DigitalOcean.   [![godoc][D]](https://godoc.org/github.com/go-furnace/go-furnace)
- [Mantil](https://github.com/mantil-io/mantil) **star:93** Go specific framework for building serverless applications on AWS that enables you to focus on pure Go code while Mantil takes care of the infrastructure.   [![There was an update last month][G]](https://github.com/mantil-io/mantil)   [![godoc][D]](https://godoc.org/github.com/mantil-io/mantil)
- [go-rocket-update](https://github.com/mouuff/go-rocket-update) **star:73** A simple way to make self updating Go applications - Supports Github and Gitlab.   [![godoc][D]](https://godoc.org/github.com/mouuff/go-rocket-update)
- [Dropship](https://github.com/chrismckenzie/dropship) **star:62** Tool for deploying code via cdn.   [![It hasn't been updated in recent three years][Y]](https://github.com/chrismckenzie/dropship)   [![godoc][D]](https://godoc.org/github.com/chrismckenzie/dropship)
- [drone-jenkins](https://github.com/appleboy/drone-jenkins) **star:35** Trigger downstream Jenkins jobs using a binary, docker or Drone CI.   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-jenkins)
- [docker-go-mingw](https://github.com/x1unix/docker-go-mingw) **star:34** Docker image for building Go binaries for Windows with MinGW toolchain.
- [Rodent](https://github.com/alouche/rodent) **star:33** Rodent helps you manage Go versions, projects and track dependencies.   [![It hasn't been updated in recent three years][Y]](https://github.com/alouche/rodent)
- [awsenv](https://github.com/soniah/awsenv) **star:30** Small binary that loads Amazon (AWS) environment variables for a profile.   [![It hasn't been updated in recent three years][Y]](https://github.com/soniah/awsenv)   [![godoc][D]](https://godoc.org/github.com/soniah/awsenv)
- [lwc](https://github.com/timdp/lwc) **star:27** A live-updating version of the UNIX wc command.   [![godoc][D]](https://godoc.org/github.com/timdp/lwc)
- [httpref](https://github.com/dnnrly/httpref) **star:25** httpref is a handy CLI reference for HTTP methods, status codes, headers, and TCP and UDP ports.   [![There was an update last month][G]](https://github.com/dnnrly/httpref)   [![godoc][D]](https://godoc.org/github.com/dnnrly/httpref)
- [DepCharge](https://github.com/centerorbit/depcharge) **star:23** Helps orchestrating the execution of commands across the many dependencies in larger projects.   [![godoc][D]](https://godoc.org/github.com/centerorbit/depcharge)
- [sg](https://github.com/ChristopherRabotin/sg) **star:8** Benchmarks a set of HTTP endpoints (like ab), with possibility to use the response code and data between each call for specific server stress based on its previous response.   [![It hasn't been updated in recent three years][Y]](https://github.com/ChristopherRabotin/sg)   [![godoc][D]](https://godoc.org/github.com/ChristopherRabotin/sg)
- [aptly](https://github.com/smira/aptly) **star:6** aptly is a Debian repository management tool.   [![It hasn't been updated in recent three years][Y]](https://github.com/smira/aptly)   [![godoc][D]](https://godoc.org/github.com/smira/aptly)
- [wait-for](https://github.com/dnnrly/wait-for) **star:4** Wait for something to happen (from the command line) before continuing. Easy orchestration of Docker services and other things.   [![godoc][D]](https://godoc.org/github.com/dnnrly/wait-for)

**[⬆ back to top](#contents)**

### Other Software

- [croc](https://github.com/schollz/croc) **star:20840** Easily and securely send files or folders from one computer to another.   [![godoc][D]](https://godoc.org/github.com/schollz/croc)
- [Docker](https://www.docker.com/)  Open platform for distributed applications for developers and sysadmins.
- [restic](https://github.com/restic/restic) **star:18167** De-duplicating backup program.   [![There was an update last month][G]](https://github.com/restic/restic)   [![godoc][D]](https://godoc.org/github.com/restic/restic)
- [Gor](https://github.com/buger/gor) **star:16199** Http traffic replication tool, for replaying traffic from production to stage/dev environments in real-time.   [![There was an update last month][G]](https://github.com/buger/gor)   [![godoc][D]](https://godoc.org/github.com/buger/gor)
- [Seaweed File System](https://github.com/chrislusf/seaweedfs) **star:15511** Fast, Simple and Scalable Distributed File System with O(1) disk seek.   [![There was an update last month][G]](https://github.com/chrislusf/seaweedfs)   [![godoc][D]](https://godoc.org/github.com/chrislusf/seaweedfs)
- [Comcast](https://github.com/tylertreat/Comcast) **star:9712** Simulate bad network connections.   [![godoc][D]](https://godoc.org/github.com/tylertreat/Comcast)
- [toxiproxy](https://github.com/shopify/toxiproxy) **star:8558** Proxy to simulate network and system conditions for automated tests.   [![There was an update last month][G]](https://github.com/shopify/toxiproxy)   [![godoc][D]](https://godoc.org/github.com/shopify/toxiproxy)
- [tsuru](https://tsuru.io/)  Extensible and open source Platform as a Service software.
- [confd](https://github.com/kelseyhightower/confd) **star:7905** Manage local application configuration files using templates and data from etcd or consul.   [![There was an update last month][G]](https://github.com/kelseyhightower/confd)   [![godoc][D]](https://godoc.org/github.com/kelseyhightower/confd)
- [LiteIDE](https://github.com/visualfc/liteide) **star:6982** LiteIDE is a simple, open source, cross-platform Go IDE.   [![Contains Chinese documents][CN]](https://github.com/visualfc/liteide)
- [drive](https://github.com/odeke-em/drive) **star:6452** Google Drive client for the commandline.   [![There was an update last month][G]](https://github.com/odeke-em/drive)   [![godoc][D]](https://godoc.org/github.com/odeke-em/drive)
- [nes](https://github.com/fogleman/nes) **star:5104** Nintendo Entertainment System (NES) emulator written in Go.   [![godoc][D]](https://godoc.org/github.com/fogleman/nes)
- [Duplicacy](https://github.com/gilbertchen/duplicacy) **star:4262** A cross-platform network and cloud backup tool based on the idea of lock-free deduplication.   [![There was an update last month][G]](https://github.com/gilbertchen/duplicacy)   [![godoc][D]](https://godoc.org/github.com/gilbertchen/duplicacy)
- [scc](https://github.com/boyter/scc) **star:3846** Sloc Cloc and Code, a very fast accurate code counter with complexity calculations and COCOMO estimates.   [![godoc][D]](https://godoc.org/github.com/boyter/scc)
- [myLG](https://github.com/mehrdadrad/mylg) **star:2601** Command Line Network Diagnostic tool written in Go.   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/mylg)
- [GoBoy](https://github.com/Humpheh/goboy) **star:2473** Nintendo Game Boy Color emulator written in Go.   [![godoc][D]](https://godoc.org/github.com/Humpheh/goboy)
- [Stack Up](https://github.com/pressly/sup) **star:2359** Stack Up, a super simple deployment tool - just Unix - think of it like 'make' for a network of servers.   [![godoc][D]](https://godoc.org/github.com/pressly/sup)
- [lgo](https://github.com/yunabe/lgo) **star:2263** Interactive Go programming with Jupyter. It supports code completion, code inspection and 100% Go compatibility.   [![godoc][D]](https://godoc.org/github.com/yunabe/lgo)
- [limetext](https://limetext.github.io)  Lime Text is a powerful and elegant text editor primarily developed in Go that aims to be a Free and open-source software successor to Sublime Text.
- [Circuit](https://github.com/gocircuit/circuit) **star:1964** Circuit is a programmable platform-as-a-service (PaaS) and/or Infrastructure-as-a-Service (IaaS), for management, discovery, synchronization and orchestration of services and hosts comprising cloud applications.   [![godoc][D]](https://godoc.org/github.com/gocircuit/circuit)
- [blocky](https://github.com/0xERR0R/blocky) **star:1891** Fast and lightweight DNS proxy as ad-blocker for local network with many features.   [![There was an update last month][G]](https://github.com/0xERR0R/blocky)   [![godoc][D]](https://godoc.org/github.com/0xERR0R/blocky)
- [snap](https://github.com/intelsdi-x/snap) **star:1800** Powerful telemetry framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/intelsdi-x/snap)   [![godoc][D]](https://godoc.org/github.com/intelsdi-x/snap)
- [Documize](https://github.com/documize/community) **star:1699** Modern wiki software that integrates data from SaaS tools.
- [borg](https://github.com/crufter/borg) **star:1560** Terminal based search engine for bash snippets.   [![It hasn't been updated in recent three years][Y]](https://github.com/crufter/borg)   [![godoc][D]](https://godoc.org/github.com/crufter/borg)
- [Plik](https://github.com/root-gg/plik) **star:1071** Plik is a temporary file upload system (Wetransfer like) in Go.   [![godoc][D]](https://godoc.org/github.com/root-gg/plik)
- [shell2http](https://github.com/msoap/shell2http) **star:987** Executing shell commands via http server (for prototyping or remote control).   [![godoc][D]](https://godoc.org/github.com/msoap/shell2http)
- [vFlow](https://github.com/VerizonDigital/vflow) **star:927** High-performance, scalable and reliable IPFIX, sFlow and Netflow collector.   [![There was an update last month][G]](https://github.com/VerizonDigital/vflow)   [![godoc][D]](https://godoc.org/github.com/VerizonDigital/vflow)
- [Go Package Store](https://github.com/shurcooL/Go-Package-Store) **star:890** App that displays updates for the Go packages in your GOPATH.   [![godoc][D]](https://godoc.org/github.com/shurcooL/Go-Package-Store)
- [peg](https://github.com/pointlander/peg) **star:873** Peg, Parsing Expression Grammar, is an implementation of a Packrat parser generator.   [![godoc][D]](https://godoc.org/github.com/pointlander/peg)
- [Leaps](https://github.com/jeffail/leaps) **star:729** Pair programming service using Operational Transforms.   [![godoc][D]](https://godoc.org/github.com/jeffail/leaps)
- [gfile](https://github.com/Antonito/gfile) **star:683** Securely transfer files between two computers, without any third party, over WebRTC.   [![godoc][D]](https://godoc.org/github.com/Antonito/gfile)
- [Guora](https://github.com/meloalright/guora) **star:609** A self-hosted Quora like web application written in Go.   [![godoc][D]](https://godoc.org/github.com/meloalright/guora)   [![Contains Chinese documents][CN]](https://github.com/meloalright/guora)
- [Gebug](https://github.com/moshebe/gebug) **star:602** A tool that makes debugging of Dockerized Go applications super easy by enabling Debugger and Hot-Reload features, seamlessly.   [![There was an update last month][G]](https://github.com/moshebe/gebug)   [![godoc][D]](https://godoc.org/github.com/moshebe/gebug)
- [gocc](https://github.com/goccmack/gocc) **star:540** Gocc is a compiler kit for Go written in Go.   [![godoc][D]](https://godoc.org/github.com/goccmack/gocc)
- [mockingjay](https://github.com/quii/mockingjay-server) **star:522** Fake HTTP servers and consumer driven contracts from one configuration file. You can also make the server randomly misbehave to help do more realistic performance tests.   [![godoc][D]](https://godoc.org/github.com/quii/mockingjay-server)
- [sake](https://github.com/alajmo/sake) **star:470** sake is a command runner for local and remote hosts.   [![There was an update last month][G]](https://github.com/alajmo/sake)   [![godoc][D]](https://godoc.org/github.com/alajmo/sake)
- [go-peerflix](https://github.com/Sioro-Neoku/go-peerflix) **star:454** Video streaming torrent client.   [![godoc][D]](https://godoc.org/github.com/Sioro-Neoku/go-peerflix)
- [goblin](https://goblin.reaper.im)  Golang binaries in a curl, built by goblins.
- [Gokapi](https://github.com/Forceu/gokapi) **star:408** Lightweight server to share files, which expire after a set amount of downloads or days. Similar to Firefox Send, but without public upload.   [![godoc][D]](https://godoc.org/github.com/Forceu/gokapi)
- [GoLand](https://jetbrains.com/go)  Full featured cross-platform Go IDE.
- [ipe](https://github.com/dimiro1/ipe) **star:357** Open source Pusher server implementation compatible with Pusher client libraries written in GO.   [![godoc][D]](https://godoc.org/github.com/dimiro1/ipe)   [![Archived][Archived]](https://github.com/dimiro1/ipe)
- [ide](https://github.com/thestrukture/ide) **star:353** Browser accessible IDE. Designed for Go with Go.   [![godoc][D]](https://godoc.org/github.com/thestrukture/ide)
- [woke](https://github.com/get-woke/woke) **star:350** Detect non-inclusive language in your source code.   [![There was an update last month][G]](https://github.com/get-woke/woke)   [![godoc][D]](https://godoc.org/github.com/get-woke/woke)
- [tcpprobe](https://github.com/mehrdadrad/tcpprobe) **star:329** TCP tool for network performance and path monitoring, including socket statistics.   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/tcpprobe)
- [wellington](https://github.com/wellington/wellington) **star:299** Sass project management tool, extends the language with sprite functions (like Compass).   [![godoc][D]](https://godoc.org/github.com/wellington/wellington)
- [Cherry](https://github.com/rafael-santiago/cherry) **star:282** Tiny webchat server in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafael-santiago/cherry)   [![godoc][D]](https://godoc.org/github.com/rafael-santiago/cherry)
- [Neo-cowsay](https://github.com/Code-Hex/Neo-cowsay) **star:227** 🐮 cowsay is reborn. for a New Era.   [![godoc][D]](https://godoc.org/github.com/Code-Hex/Neo-cowsay)
- [tcpdog](https://github.com/mehrdadrad/tcpdog) **star:204** eBPF based TCP observability.   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/tcpdog)
- [joincap](https://github.com/assafmo/joincap) **star:177** Command-line utility for merging multiple pcap files together.   [![godoc][D]](https://godoc.org/github.com/assafmo/joincap)
- [Juju](https://jujucharms.com/)  Cloud-agnostic service deployment and orchestration - supports EC2, Azure, Openstack, MAAS and more.
- [Orbit](https://github.com/gulien/orbit) **star:172** A simple tool for running commands and generating files from templates.   [![godoc][D]](https://godoc.org/github.com/gulien/orbit)
- [Better Go Playground](https://goplay.tools)  Go playground with syntax highlight, code completion and other features.
- [vaku](https://github.com/lingrino/vaku) **star:139** CLI & API for folder-based functions in Vault like copy, move, and search.   [![There was an update last month][G]](https://github.com/lingrino/vaku)   [![godoc][D]](https://godoc.org/github.com/lingrino/vaku)
- [stew](https://github.com/marwanhawari/stew) **star:107** An independent package manager for compiled binaries.   [![godoc][D]](https://godoc.org/github.com/marwanhawari/stew)
- [syncthing](https://syncthing.net/)  Open, decentralized file synchronization tool and protocol.
- [dp](https://github.com/scryinfo/dp) **star:86** Through SDK for data exchange with blockchain, developers can get easy access to DAPP development.   [![godoc][D]](https://godoc.org/github.com/scryinfo/dp)
- [boxed](https://github.com/tejo/boxed) **star:78** Dropbox based blog engine.   [![It hasn't been updated in recent three years][Y]](https://github.com/tejo/boxed)   [![godoc][D]](https://godoc.org/github.com/tejo/boxed)
- [crawley](https://github.com/s0rg/crawley) **star:73** Web scraper/crawler for cli.   [![There was an update last month][G]](https://github.com/s0rg/crawley)   [![godoc][D]](https://godoc.org/github.com/s0rg/crawley)
- [naclpipe](https://github.com/unix4fun/naclpipe) **star:23** Simple NaCL EC25519 based crypto pipe tool written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/unix4fun/naclpipe)   [![godoc][D]](https://godoc.org/github.com/unix4fun/naclpipe)
- [term-quiz](https://github.com/crazcalm/term-quiz) **star:23** Quizzes for your terminal.   [![It hasn't been updated in recent three years][Y]](https://github.com/crazcalm/term-quiz)   [![godoc][D]](https://godoc.org/github.com/crazcalm/term-quiz)
- [Snitch](https://github.com/lucasgomide/snitch) **star:16** Simple way to notify your team and many tools when someone has deployed any application via Tsuru.   [![It hasn't been updated in recent three years][Y]](https://github.com/lucasgomide/snitch)   [![godoc][D]](https://godoc.org/github.com/lucasgomide/snitch)
- [GoDocTooltip](https://github.com/diankong/GoDocTooltip) **star:13** Chrome extension for Go Doc sites, which shows function description as tooltip at function list.
- [hoofli](https://github.com/dnnrly/hoofli) **star:4** Generate PlantUML diagrams from Chrome or Firefox network inspections.   [![godoc][D]](https://godoc.org/github.com/dnnrly/hoofli)
- [hugo](https://gohugo.io/)  Fast and Modern Static Website Engine.
- [protoncheck](https://github.com/servusdei2018/protoncheck) **star:4** ProtonMail module for waybar/polybar/yabar/i3blocks.   [![godoc][D]](https://godoc.org/github.com/servusdei2018/protoncheck)   [![Archived][Archived]](https://github.com/servusdei2018/protoncheck)

**[⬆ back to top](#contents)**

# Resources

_Where to discover new Go libraries._

**[⬆ back to top](#contents)**

## Benchmarks

- [go-web-framework-benchmark](https://github.com/smallnest/go-web-framework-benchmark) **star:1754** Go web framework benchmark.   [![There was an update last month][G]](https://github.com/smallnest/go-web-framework-benchmark)   [![godoc][D]](https://godoc.org/github.com/smallnest/go-web-framework-benchmark)
- [go-http-routing-benchmark](https://github.com/julienschmidt/go-http-routing-benchmark) **star:1597** Go HTTP request router benchmark and comparison.   [![There was an update last month][G]](https://github.com/julienschmidt/go-http-routing-benchmark)   [![godoc][D]](https://godoc.org/github.com/julienschmidt/go-http-routing-benchmark)
- [go_serialization_benchmarks](https://github.com/alecthomas/go_serialization_benchmarks) **star:1366** Benchmarks of Go serialization methods.   [![godoc][D]](https://godoc.org/github.com/alecthomas/go_serialization_benchmarks)
- [skynet](https://github.com/atemerev/skynet) **star:1020** Skynet 1M threads microbenchmark.
- [speedtest-resize](https://github.com/fawick/speedtest-resize) **star:223** Compare various Image resize algorithms for the Go language.   [![godoc][D]](https://godoc.org/github.com/fawick/speedtest-resize)
- [go-benchmarks](https://github.com/tylertreat/go-benchmarks) **star:146** Few miscellaneous Go microbenchmarks. Compare some language features to alternative approaches.   [![It hasn't been updated in recent three years][Y]](https://github.com/tylertreat/go-benchmarks)   [![godoc][D]](https://godoc.org/github.com/tylertreat/go-benchmarks)
- [gospeed](https://github.com/feyeleanor/GoSpeed) **star:110** Go micro-benchmarks for calculating the speed of language constructs.   [![godoc][D]](https://godoc.org/github.com/feyeleanor/GoSpeed)
- [autobench](https://github.com/davecheney/autobench) **star:94** Framework to compare the performance between different Go versions.   [![It hasn't been updated in recent three years][Y]](https://github.com/davecheney/autobench)   [![godoc][D]](https://godoc.org/github.com/davecheney/autobench)
- [golang-sql-benchmark](https://github.com/tyler-smith/golang-sql-benchmark) **star:61** Collection of benchmarks for popular Go database/SQL utilities.   [![godoc][D]](https://godoc.org/github.com/tyler-smith/golang-sql-benchmark)
- [gocostmodel](https://github.com/PuerkitoBio/gocostmodel) **star:58** Benchmarks of common basic operations for the Go language.   [![godoc][D]](https://godoc.org/github.com/PuerkitoBio/gocostmodel)
- [kvbench](https://github.com/jimrobinson/kvbench) **star:25** Key/Value database benchmark.   [![It hasn't been updated in recent three years][Y]](https://github.com/jimrobinson/kvbench)   [![godoc][D]](https://godoc.org/github.com/jimrobinson/kvbench)
- [go-benchmark-app](https://github.com/mrLSD/go-benchmark-app) **star:24** Powerful HTTP-benchmark tool mixed with Аb, Wrk, Siege tools. Gathering statistics and various parameters for benchmarks and comparison results.   [![It hasn't been updated in recent three years][Y]](https://github.com/mrLSD/go-benchmark-app)   [![godoc][D]](https://godoc.org/github.com/mrLSD/go-benchmark-app)
- [go-ml-benchmarks](https://github.com/nikolaydubina/go-ml-benchmarks) **star:24** benchmarks for machine learning inference in Go.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-ml-benchmarks)
- [go-json-benchmark](https://github.com/zerosnake0/go-json-benchmark) **star:7** Go JSON benchmark.   [![godoc][D]](https://godoc.org/github.com/zerosnake0/go-json-benchmark)

**[⬆ back to top](#contents)**

## Conferences

- [Capital Go](http://www.capitalgolang.com)  Washington, D.C., USA.
- [dotGo](https://www.dotgo.eu)  Paris, France.
- [GoCon](https://gocon.connpass.com/)  Tokyo, Japan.
- [GoDays](https://www.godays.io/)  Berlin, Germany.
- [GoLab](https://golab.io/)  Florence, Italy.
- [GopherChina](https://gopherchina.org)  Shanghai, China.
- [GopherCon](https://www.gophercon.com/)  Denver, USA.
- [GopherCon Australia](https://gophercon.com.au/)  Sydney, Australia.
- [GopherCon Brazil](https://gopherconbr.org)  Florianópolis, Brazil.
- [GopherCon Europe](https://gophercon.eu/)  Berlin, Germany.
- [GopherCon India](https://www.gophercon.in/)  Pune, India.
- [GopherCon Israel](https://www.gophercon.org.il/)  Tel Aviv, Israel.
- [GopherCon Russia](https://www.gophercon-russia.ru)  Moscow, Russia.
- [GopherCon Singapore](https://gophercon.sg)  Mapletree Business City, Singapore.
- [GopherCon UK](https://www.gophercon.co.uk/)  London, UK.
- [GopherCon Vietnam](https://gophercon.vn/)  Ho Chi Minh City, Vietnam.
- [GoWest Conference](https://www.gowestconf.com/)  Lehi, USA.

**[⬆ back to top](#contents)**

## E-Books

### E-books for purchase

- [100 Go Mistakes: How to Avoid Them](https://www.manning.com/books/100-go-mistakes-how-to-avoid-them)
- [Build an Orchestrator in Go](https://www.manning.com/books/build-an-orchestrator-in-go)
- [Continuous Delivery in Go](https://www.manning.com/books/continuous-delivery-in-go)  This practical guide to continuous delivery shows you how to rapidly establish an automated pipeline that will improve your testing, code quality, and final product.
- [For the Love of Go](https://bitfieldconsulting.com/books/love)  An introductory book for Go beginners.
- [Know Go: Generics](https://bitfieldconsulting.com/books/generics)  A guide to understanding and using generics in Go.
- [The Power of Go: Tests](https://bitfieldconsulting.com/books/tests)  A guide to testing in Go.
- [The Power of Go: Tools](https://bitfieldconsulting.com/books/tools)  A guide to writing command-line tools in Go.
- [Writing A Compiler In Go](https://compilerbook.com)
- [Writing An Interpreter In Go](https://interpreterbook.com)  Book that introduces dozens of techniques for writing idiomatic, expressive, and efficient Go code that avoids common pitfalls.

### Free e-books

- [A Go Developer's Notebook](https://leanpub.com/GoNotebook/read)
- [An Introduction to Programming in Go](http://www.golang-book.com/)
- [Build Web Application with Golang](https://astaxie.gitbooks.io/build-web-application-with-golang/content/en/)
- [Building Web Apps With Go](https://codegangsta.gitbooks.io/building-web-apps-with-go/content/)
- [Go 101](https://go101.org)  A book focusing on Go syntax/semantics and all kinds of details.
- [Go Bootcamp](http://golangbootcamp.com)
- [GoBooks](https://github.com/dariubs/GoBooks) **star:13030** A curated list of Go books.
- [How To Code in Go eBook](https://www.digitalocean.com/community/books/how-to-code-in-go-ebook)  A 600 page introduction to Go aimed at first time developers.
- [Go Succinctly](https://github.com/thedevsir/gosuccinctly) **star:22** in Persian.   [![It hasn't been updated in recent three years][Y]](https://github.com/thedevsir/gosuccinctly)   [![godoc][D]](https://godoc.org/github.com/thedevsir/gosuccinctly)
- [Learning Go](https://www.miek.nl/downloads/Go/Learning-Go-latest.pdf)
- [Network Programming With Go](https://jan.newmarch.name/golang/)
- [Practical Go Lessons](https://www.practical-go-lessons.com/)
- [Spaceship Go A Journey to the Standard Library](https://blasrodri.github.io/spaceship-go-gh-pages/)
- [The Go Programming Language](https://www.gopl.io/)
- [The Golang Standard Library by Example (Chinese)](https://github.com/polaris1119/The-Golang-Standard-Library-by-Example)
- [Web Application with Go the Anti-Textbook](https://github.com/thewhitetulip/web-dev-golang-anti-textbook/)

**[⬆ back to top](#contents)**

## Gophers

- [Free Gophers Pack](https://github.com/MariaLetta/free-gophers-pack) **star:2562** Gopher graphics pack by Maria Letta with illustrations and emotional characters in vector and raster.   [![godoc][D]](https://godoc.org/github.com/MariaLetta/free-gophers-pack)
- [gopher-logos](https://github.com/GolangUA/gopher-logos) **star:106** adorable gopher logos.
- [Go-gopher-Vector](https://github.com/keygx/Go-gopher-Vector) **star:56** Go gopher Vector Data [.ai, .svg].   [![It hasn't been updated in recent three years][Y]](https://github.com/keygx/Go-gopher-Vector)
- [gopher-stickers](https://github.com/tenntenn/gopher-stickers)
- [gophericons](https://github.com/shalakhin/gophericons)
- [gophers](https://github.com/egonelbre/gophers) **star:2917** Free gophers.   [![godoc][D]](https://godoc.org/github.com/egonelbre/gophers)
- [gophers](https://github.com/ashleymcnamara/gophers) **star:2707** Gopher artworks by Ashley McNamara.   [![It hasn't been updated in recent three years][Y]](https://github.com/ashleymcnamara/gophers)   [![godoc][D]](https://godoc.org/github.com/ashleymcnamara/gophers)
- [gopherize.me](https://github.com/matryer/gopherize.me) **star:598** Gopherize yourself.
- [gophers](https://github.com/sillecelik/go-gopher) **star:106** Gopher amigurumi toy pattern.
- [gophers](https://github.com/rogeralsing/gophers) **star:57** random gopher graphics.
- [gophers](https://github.com/scraly/gophers) **star:18** Gophers by Aurélie Vache.

**[⬆ back to top](#contents)**

## Meetups

- [Basel Go Meetup](https://www.meetup.com/Basel-Go-Meetup/)
- [Belfast Gophers](https://www.meetup.com/Belfast-Gophers/)
- [Belgrade Golang Meetup](https://www.meetup.com/golang-serbia/)
- [Berlin Golang](https://www.meetup.com/golang-users-berlin/)
- [Brisbane Gophers](https://www.meetup.com/Brisbane-Golang-Meetup/)
- [Canberra Gophers](https://www.meetup.com/Canberra-Gophers/)
- [Go Language NYC](https://www.meetup.com/golanguagenewyork/)
- [Go London User Group](https://www.meetup.com/Go-London-User-Group/)
- [Go Remote Meetup](https://www.meetup.com/Go-Remote-Meetup/)
- [Go Toronto](https://www.meetup.com/go-toronto/)
- [Go User Group Atlanta](https://www.meetup.com/Go-Users-Group-Atlanta/)
- [GoBandung](https://www.meetup.com/GoBandung/)
- [GoBridge, San Francisco, CA](https://www.meetup.com/gobridge/)
- [GoCracow - Krakow, Poland](https://www.meetup.com/GoCracow/)
- [GoJakarta](https://www.meetup.com/GoJakarta/)
- [Golang Amsterdam](https://www.meetup.com/golang-amsterdam/)
- [Golang Argentina](https://www.meetup.com/Golang-Argentina/)
- [Golang Athens](https://www.meetup.com/Athens-Gophers/)
- [Golang Baltimore, MD](https://www.meetup.com/BaltimoreGolang/)
- [Golang Bangalore](https://www.meetup.com/Golang-Bangalore/)
- [Golang Belo Horizonte - Brazil](https://www.meetup.com/go-belo-horizonte/)
- [Golang Boston](https://www.meetup.com/bostongo/)
- [Golang Bulgaria](https://www.meetup.com/Golang-Bulgaria/)
- [Golang Cardiff, UK](https://www.meetup.com/Cardiff-Go-Meetup/)
- [Golang Copenhagen](https://www.meetup.com/Go-Cph/)
- [Golang Curitiba - Brazil](https://www.meetup.com/GolangCWB/)
- [Golang DC, Arlington, VA](https://www.meetup.com/Golang-DC/)
- [Golang Dorset, UK](https://www.meetup.com/golang-dorset/)
- [Golang Estonia](https://www.meetup.com/Golang-Estonia/)
- [Golang Gurgaon, India](https://www.meetup.com/Gurgaon-Go-Meetup/)
- [Golang Hamburg - Germany](https://www.meetup.com/Go-User-Group-Hamburg/)
- [Golang Israel](https://www.meetup.com/Go-Israel/)
- [Golang Kathmandu](https://www.meetup.com/Golang-Kathmandu/)
- [Golang Korea](https://www.meetup.com/GDG-Golang-Korea/)
- [Golang Lima - Peru](https://www.meetup.com/Golang-Peru/)
- [Golang Lyon](https://www.meetup.com/Golang-Lyon/)
- [Golang Marseille](https://www.meetup.com/fr-FR/Golang-Marseille/)
- [Golang Melbourne](https://www.meetup.com/golang-mel/)
- [Golang Mountain View](https://www.meetup.com/Golang-Mountain-View/)
- [Golang North East](https://www.meetup.com/en-AU/Golang-North-East/)
- [Golang Paris](https://www.meetup.com/Golang-Paris/)
- [Golang Poland](https://www.meetup.com/Golang-Poland/)
- [Golang Pune](https://www.meetup.com/Golang-Pune/)
- [Golang Singapore](https://www.meetup.com/golangsg/)
- [Golang Stockholm](https://www.meetup.com/Go-Stockholm/)
- [Golang Sydney, AU](https://www.meetup.com/golang-syd/)
- [Golang São Paulo - Brazil](https://www.meetup.com/golangbr/)
- [Golang Taipei](https://www.meetup.com/golang-taipei-meetup/)
- [Golang Thessaloniki](https://www.meetup.com/thessaloniki-golang-meetup/)
- [Golang Turkey](https://kommunity.com/goturkiye)
- [Golang Vancouver, BC](https://www.meetup.com/golangvan/)
- [Golang Vienna, Austria](https://www.meetup.com/viennago/)
- [Golang Казань](https://www.meetup.com/GolangKazan/)
- [Golang Москва](https://www.meetup.com/Golang-Moscow/)
- [Golang Питер](https://www.meetup.com/Golang-Peter/)
- [GoSF - San Francisco, CA](https://www.meetup.com/golangsf)
- [Istanbul Golang](https://www.meetup.com/Istanbul-Golang/)
- [Seattle Go Programmers](https://www.meetup.com/golang/)
- [Ukrainian Golang User Groups](https://www.meetup.com/uagolang/)
- [Utah Go User Group](https://www.meetup.com/utahgophers/)
- [Women Who Go - San Francisco, CA](https://www.meetup.com/Women-Who-Go/)

*Add the group of your city/country here (send **PR**)*

**[⬆ back to top](#contents)**

## Style Guides

- [bahlo/go-styleguide](https://github.com/bahlo/go-styleguide)
- [CockroachDB](https://github.com/cockroachdb/cockroach/blob/master/docs/style.md)
- [GitLab](https://docs.gitlab.com/ee/development/go_guide/)
- [Hyperledger](https://github.com/hyperledger/fabric/blob/release-1.4/docs/source/style-guides/go-style.rst)
- [Magnetico](https://github.com/boramalper/magnetico/wiki/magnetico-Design-Specification)
- [Sourcegraph](https://about.sourcegraph.com/handbook/engineering/go_style_guide)
- [Thanos](https://thanos.io/tip/contributing/coding-style-guide.md/)
- [Trybe](https://github.com/betrybe/playbook-go/blob/main/README_EN.md)
- [Uber](https://github.com/uber-go/guide/blob/master/style.md)

**[⬆ back to top](#contents)**

## Social Media

### Twitter

- [@golang](https://twitter.com/golang)
- [@golang_news](https://twitter.com/golang_news)
- [@golangch](https://twitter.com/golangch)
- [@golangflow](https://twitter.com/golangflow)
- [@golangweekly](https://twitter.com/golangweekly)

**[⬆ back to top](#contents)**

### Reddit

- [r/golang](https://www.reddit.com/r/golang/)

**[⬆ back to top](#contents)**

## Websites

- [awesome-awesomeness](https://github.com/bayandin/awesome-awesomeness) **star:29390** List of other amazingly awesome lists.
- [Awesome Remote Job](https://github.com/lukasz-madon/awesome-remote-job) **star:23166** Curated list of awesome remote jobs. A lot of them are looking for Go hackers.
- [Awesome Golang Workshops](https://github.com/amit-davidson/awesome-golang-workshops) **star:474** A curated list of awesome golang workshops.
- [golang-graphics](https://github.com/mholt/golang-graphics) **star:138** Collection of Go images, graphics, and art.   [![It hasn't been updated in recent three years][Y]](https://github.com/mholt/golang-graphics)   [![Archived][Archived]](https://github.com/mholt/golang-graphics)
- [golang-nuts](https://groups.google.com/forum/#!forum/golang-nuts)  Go mailing list.
- [Google Plus Community](https://plus.google.com/communities/114112804251407510571)  The Google+ community for #golang enthusiasts.
- [Gopher Community Chat](https://invite.slack.golangbridge.org)  Join Our New Slack Community For Gophers ([Understand how it came](https://blog.gopheracademy.com/gophers-slack-community/)).
- [Gophercises](https://gophercises.com/)  Free coding exercises for budding gophers.
- [gowalker.org](https://gowalker.org)  Go Project API documentation.
- [json2go](https://m-zajac.github.io/json2go)  Advanced JSON to Go struct conversion - online tool.
- [justforfunc](https://www.youtube.com/c/justforfunc)  Youtube channel dedicated to Go programming language tips and tricks, hosted by  Francesc Campoy [@francesc](https://twitter.com/francesc).
- [Learn Go Programming](https://blog.learngoprogramming.com)  Learn Go concepts with illustrations.
- [gocryforhelp](https://github.com/ninedraft/gocryforhelp) **star:40** Collection of Go projects that needs help. Good place to start your open-source way in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ninedraft/gocryforhelp)
- [godoc.org](https://godoc.org/)  Documentation for open source Go packages.
- [Golang Developer Jobs](https://golangjob.xyz)  Developer Jobs exclusively for Golang related Roles.
- [Golang Flow](https://golangflow.io)  Post Updates, News, Packages and more.
- [Golang News](https://golangnews.com)  Links and news about Go programming.
- [Golang Resources](https://golangresources.com)  A curation of the best articles, exercises, talks and videos to learn Go.
- [awesome-go-extra](https://github.com/xwjdsh/awesome-go-extra) **star:19** Parse awesome-go README file and generate a new README file with repo info.   [![godoc][D]](https://godoc.org/github.com/xwjdsh/awesome-go-extra)   [![Contains Chinese documents][CN]](https://github.com/xwjdsh/awesome-go-extra)
- [Code with Mukesh](https://codewithmukesh.com/blog/category/golang)  Software Engineer and Blogs @ codewithmukesh.com.
- [Coding Mystery](https://codingmystery.com)  Solve exciting escape-room-inspired programming challenges using Go.
- [CodinGame](https://www.codingame.com/)  Learn Go by solving interactive tasks using small games as practical examples.
- [Go Blog](https://blog.golang.org)  The official Go blog.
- [Go Code Club](https://www.youtube.com/watch?v=nvoIPQYdx9g&list=PLEcwzBXTPUE_YQR7R0BRtHBYJ0LN3Y0i3)  A group of Gophers read and discuss a different Go project every week.
- [Go Community on Hashnode](https://hashnode.com/n/go)  Community of Gophers on Hashnode.
- [Go Forum](https://forum.golangbridge.org)  Forum to discuss Go.
- [Go Projects](https://github.com/golang/go/wiki/Projects)  List of projects on the Go community wiki.
- [Go Proverbs](https://go-proverbs.github.io/)  Go Proverbs by Rob Pike.
- [Go Report Card](https://goreportcard.com)  A report card for your Go package.
- [go.dev](https://go.dev/)  A hub for Go developers.
- [Awesome Go @LibHunt](https://go.libhunt.com)  Your go-to Go Toolbox.
- [Made with Golang](https://madewithgolang.com/?ref=awesome-go)
- [r/Golang](https://www.reddit.com/r/golang)  News about Go.
- [studygolang](https://studygolang.com)  The community of studygolang in China.
- [Trending Go repositories on GitHub today](https://github.com/trending?l=go)  Good place to find new Go libraries.
- [TutorialEdge - Golang](https://tutorialedge.net/course/golang/)

**[⬆ back to top](#contents)**

### Tutorials

- [Build web application with Golang](https://github.com/astaxie/build-web-application-with-golang) **star:40957** Golang ebook intro how to build a web app with golang.   [![godoc][D]](https://godoc.org/github.com/astaxie/build-web-application-with-golang)   [![Contains Chinese documents][CN]](https://github.com/astaxie/build-web-application-with-golang)
- [Building and Testing a REST API in Go with Gorilla Mux and PostgreSQL](https://semaphoreci.com/community/tutorials/building-and-testing-a-rest-api-in-go-with-gorilla-mux-and-postgresql)  We’ll write an API with the help of the powerful Gorilla Mux.
- [Building Go Web Applications and Microservices Using Gin](https://semaphoreci.com/community/tutorials/building-go-web-applications-and-microservices-using-gin)  Get familiar with Gin and find out how it can help you reduce boilerplate code and build a request handling pipeline.
- [Caching Slow Database Queries](https://medium.com/@rocketlaunchr.cloud/caching-slow-database-queries-1085d308a0c9)  How to cache slow database queries.
- [Canceling MySQL](https://medium.com/@rocketlaunchr.cloud/canceling-mysql-in-go-827ed8f83b30)  How to cancel MySQL queries.
- [50 Shades of Go](https://devs.cloudimmunity.com/gotchas-and-common-mistakes-in-go-golang/)  Traps, Gotchas, and Common Mistakes for New Golang Devs.
- [A Guide to Golang E-Commerce](https://snipcart.com/blog/golang-ecommerce-ponzu-cms-demo?utm_term=golang-ecommerce-ponzu-cms-demo)  Building a Golang site for e-commerce (demo included).
- [A Tour of Go](https://tour.golang.org/)  Interactive tour of Go.
- [CodeCrafters Golang Track](https://app.codecrafters.io/tracks/go) — Achieve mastery in advanced Go by building your own Redis, Docker, Git, and SQLite. Featuring goroutines, systems programming, file I/O, and more.
- [Go Cheat Sheet](https://github.com/a8m/go-lang-cheat-sheet) **star:6959** Go's reference card.
- [Go database/sql tutorial](http://go-database-sql.org/)  Introduction to database/sql.
- [Go Language Tutorial](https://www.javatpoint.com/go-tutorial)  Learn Go language Tutorial.
- [Go Tutorial](https://www.tutorialspoint.com/go/index.htm)  Learn Go programming.
- [Ethereum Development with Go](https://github.com/miguelmota/ethereum-development-with-go-book) **star:1467** A little e-book on Ethereum Development with Go.   [![godoc][D]](https://godoc.org/github.com/miguelmota/ethereum-development-with-go-book)   [![Contains Chinese documents][CN]](https://github.com/miguelmota/ethereum-development-with-go-book)   [![Archived][Archived]](https://github.com/miguelmota/ethereum-development-with-go-book)
- [Games With Go](https://www.youtube.com/watch?v=9D4yH7e_ea8&list=PLDZujg-VgQlZUy1iCqBbe5faZLMkA3g2x)  A video series teaching programming and game development.
- [Go By Example](https://gobyexample.com/)  Hands-on introduction to Go using annotated example programs.
- [Design Patterns in Go](https://github.com/shubhamzanwar/design-patterns) **star:85** Collection of programming design patterns implemented in Go.   [![godoc][D]](https://godoc.org/github.com/shubhamzanwar/design-patterns)
- [Debugged.it Go patterns](https://github.com/haveyoudebuggedit/go-patterns) **star:5** Advanced Go patterns with ready-to-run examples.   [![godoc][D]](https://godoc.org/github.com/haveyoudebuggedit/go-patterns)
- [Go WebAssembly Tutorial - Building a Simple Calculator](https://tutorialedge.net/golang/go-webassembly-tutorial/)
- [go-patterns](https://github.com/tmrts/go-patterns) **star:20171** Curated list of Go design patterns, recipes and idioms.   [![godoc][D]](https://godoc.org/github.com/tmrts/go-patterns)
- [Learn Go with TDD](https://github.com/quii/learn-go-with-tests) **star:18489** Learn Go with test-driven development.   [![There was an update last month][G]](https://github.com/quii/learn-go-with-tests)   [![godoc][D]](https://godoc.org/github.com/quii/learn-go-with-tests)   [![Contains Chinese documents][CN]](https://github.com/quii/learn-go-with-tests)
- [Learning Go by examples](https://dev.to/aurelievache/learning-go-by-examples-introduction-448n)  Serie of article in order to learn Golang language by concrete applications as example.
- [package main](https://www.youtube.com/packagemain)  YouTube channel about Programming in Go.
- [Programming with Google Go](https://www.coursera.org/specializations/google-golang)  Coursera Specialization to learn about Go from scratch.
- [Saving a Third of Our Memory by Re-ordering Go Struct Fields](https://qvault.io/golang/struct-field-ordering-memory/)  How inefficient field ordering in Go structs.
- [Learn Go with 1000+ Exercises](https://github.com/inancgumus/learngo) **star:15255** Learn Go with thousands of examples, exercises, and quizzes.   [![There was an update last month][G]](https://github.com/inancgumus/learngo)   [![godoc][D]](https://godoc.org/github.com/inancgumus/learngo)
- [go-clean-template](https://github.com/evrone/go-clean-template) **star:3695** Clean Architecture template for Golang services.   [![godoc][D]](https://godoc.org/github.com/evrone/go-clean-template)
- [Golang for Node.js Developers](https://github.com/miguelmota/golang-for-nodejs-developers) **star:3146** Examples of Golang compared to Node.js for learning.   [![godoc][D]](https://godoc.org/github.com/miguelmota/golang-for-nodejs-developers)
- [Golang Tutorial Guide](https://www.freecodecamp.org/news/golang-tutorial-list-free-courses-learn-go-programming-language/)  A List of Free Courses to Learn the Go Programming Language.
- [Golangbot](https://golangbot.com/learn-golang-series/)  Tutorials to get started with programming in Go.
- [GopherCoding](https://gophercoding.com/)  Collection of code snippets and tutorials to help tackle every day issues.
- [GopherSnippets](https://gophersnippets.com/)  Code snippets with tests and testable examples for the Go programming language.
- [Gosamples](https://gosamples.dev/)  Collection of code snippets that let you solve everyday code problems.
- [Hackr.io](https://hackr.io/tutorials/learn-golang)  Learn Go from the best online golang tutorials submitted & voted by the golang programming community.
- [How to Benchmark: dbq vs sqlx vs GORM](https://medium.com/@rocketlaunchr.cloud/how-to-benchmark-dbq-vs-sqlx-vs-gorm-e814caacecb5)  Learn how to benchmark in Go. As a case-study, we will benchmark dbq, sqlx and GORM.
- [How To Deploy a Go Web Application with Docker](https://semaphoreci.com/community/tutorials/how-to-deploy-a-go-web-application-with-docker)  Learn how to use Docker for Go development and how to build production Docker images.
- [How to Use Godog for Behavior-driven Development in Go](https://semaphoreci.com/community/tutorials/how-to-use-godog-for-behavior-driven-development-in-go)  Get started with Godog — a Behavior-driven development framework for building and testing Go applications.
- [goapp](https://github.com/bnkamalesh/goapp) **star:520** An opinionated guideline to structure & develop a Go web application/service.   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/goapp)
- [The world’s easiest introduction to WebAssembly with Golang](https://medium.com/@martinolsansky/webassembly-with-golang-is-fun-b243c0e34f02)
- [Working with Go](https://github.com/mkaz/working-with-go) **star:1162** Intro to go for experienced programmers.   [![Archived][Archived]](https://github.com/mkaz/working-with-go)
- [Your basic Go](https://yourbasic.org/golang)  Huge collection of tutorials and how to's.

**[⬆ back to top](#contents)**

